--------------------------------------------------------------------------------
-- Copyright (c) 1995-2005 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version: H.42
--  \   \         Application: netgen
--  /   /         Filename: cpu_translate.vhd
-- /___/   /\     Timestamp: MON 21 NOV 17:22:21 2005
-- \   \  /  \ 
--  \___\/\___\
--             
-- Command	: -intstyle ise -rpw 100 -tpw 0 -ar Structure -xon true -w -ofmt vhdl -sim cpu.ngd cpu_translate.vhd 
-- Device	: 2v1000ff896-5
-- Input file	: cpu.ngd
-- Output file	: cpu_translate.vhd
-- # of Entities	: 1
-- Design Name	: cpu
-- Xilinx	: C:/Xilinx
--             
-- Purpose:    
--     This VHDL netlist is a verification model and uses simulation 
--     primitives which may not represent the true implementation of the 
--     device, however the netlist is functionally correct and should not 
--     be modified. This file cannot be synthesized and should only be used 
--     with supported simulation tools.
--             
-- Reference:  
--     Development System Reference Guide, Chapter 23
--     Synthesis and Verification Design Guide, Chapter 6
--             
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library SIMPRIM;
use SIMPRIM.VCOMPONENTS.ALL;
use SIMPRIM.VPACKAGE.ALL;

entity cpu is
  port (
    CLK : in STD_LOGIC := 'X'; 
    CEHA1X : out STD_LOGIC; 
    LBOA : out STD_LOGIC; 
    XRWA : out STD_LOGIC; 
    OEAX : out STD_LOGIC; 
    CEA2 : out STD_LOGIC; 
    ADVLDA : out STD_LOGIC; 
    ZZA : out STD_LOGIC; 
    CLKMA0 : out STD_LOGIC; 
    CLKMA1 : out STD_LOGIC; 
    CELA1X : out STD_LOGIC; 
    CEA : out STD_LOGIC; 
    CEA2X : out STD_LOGIC; 
    IOA : inout STD_LOGIC_VECTOR ( 31 downto 0 ); 
    AA : out STD_LOGIC_VECTOR ( 19 downto 0 ); 
    BWA : out STD_LOGIC_VECTOR ( 3 downto 0 ); 
    LED : out STD_LOGIC_VECTOR ( 7 downto 0 ) 
  );
end cpu;

architecture Structure of cpu is
  signal XRWA_OBUF : STD_LOGIC; 
  signal CEA2_OBUF : STD_LOGIC; 
  signal CLKMA0_OBUF : STD_LOGIC; 
  signal CEA2X_OBUF : STD_LOGIC; 
  signal s_request : STD_LOGIC; 
  signal h_response_buf_1 : STD_LOGIC; 
  signal reset : STD_LOGIC; 
  signal XNor_stage_cyo28 : STD_LOGIC; 
  signal N90 : STD_LOGIC; 
  signal h_put_address_buf_17_rt : STD_LOGIC; 
  signal h_put_address_buf_18_rt : STD_LOGIC; 
  signal N33 : STD_LOGIC; 
  signal N32 : STD_LOGIC; 
  signal XNor_stage_cyo27 : STD_LOGIC; 
  signal Ker121 : STD_LOGIC; 
  signal s_left_conflict_3 : STD_LOGIC; 
  signal XNor_stage_cyo45 : STD_LOGIC; 
  signal N50 : STD_LOGIC; 
  signal N5212 : STD_LOGIC; 
  signal N5251 : STD_LOGIC; 
  signal XNor_stage_cyo26 : STD_LOGIC; 
  signal MUX_BLOCK_N0 : STD_LOGIC; 
  signal AA_19_OBUF : STD_LOGIC; 
  signal AA_18_OBUF : STD_LOGIC; 
  signal AA_17_OBUF : STD_LOGIC; 
  signal AA_16_OBUF : STD_LOGIC; 
  signal AA_15_OBUF : STD_LOGIC; 
  signal AA_14_OBUF : STD_LOGIC; 
  signal AA_13_OBUF : STD_LOGIC; 
  signal AA_12_OBUF : STD_LOGIC; 
  signal AA_11_OBUF : STD_LOGIC; 
  signal AA_10_OBUF : STD_LOGIC; 
  signal AA_9_OBUF : STD_LOGIC; 
  signal AA_8_OBUF : STD_LOGIC; 
  signal AA_7_OBUF : STD_LOGIC; 
  signal AA_6_OBUF : STD_LOGIC; 
  signal AA_5_OBUF : STD_LOGIC; 
  signal AA_4_OBUF : STD_LOGIC; 
  signal AA_3_OBUF : STD_LOGIC; 
  signal AA_2_OBUF : STD_LOGIC; 
  signal AA_1_OBUF : STD_LOGIC; 
  signal AA_0_OBUF : STD_LOGIC; 
  signal LED_7_OBUF : STD_LOGIC; 
  signal LED_6_OBUF : STD_LOGIC; 
  signal LED_5_OBUF : STD_LOGIC; 
  signal LED_4_OBUF : STD_LOGIC; 
  signal LED_3_OBUF : STD_LOGIC; 
  signal LED_2_OBUF : STD_LOGIC; 
  signal LED_1_OBUF : STD_LOGIC; 
  signal LED_0_OBUF : STD_LOGIC; 
  signal XNor_stage_cyo60 : STD_LOGIC; 
  signal N66 : STD_LOGIC; 
  signal XNor_stage_cyo59 : STD_LOGIC; 
  signal N65 : STD_LOGIC; 
  signal XNor_stage_cyo58 : STD_LOGIC; 
  signal N64 : STD_LOGIC; 
  signal XNor_stage_cyo57 : STD_LOGIC; 
  signal N63 : STD_LOGIC; 
  signal XNor_stage_cyo56 : STD_LOGIC; 
  signal N62 : STD_LOGIC; 
  signal XNor_stage_cyo55 : STD_LOGIC; 
  signal N61 : STD_LOGIC; 
  signal XNor_stage_cyo54 : STD_LOGIC; 
  signal N60 : STD_LOGIC; 
  signal XNor_stage_cyo53 : STD_LOGIC; 
  signal N59 : STD_LOGIC; 
  signal XNor_stage_cyo52 : STD_LOGIC; 
  signal N58 : STD_LOGIC; 
  signal XNor_stage_cyo51 : STD_LOGIC; 
  signal N57 : STD_LOGIC; 
  signal XNor_stage_cyo50 : STD_LOGIC; 
  signal N56 : STD_LOGIC; 
  signal XNor_stage_cyo49 : STD_LOGIC; 
  signal N55 : STD_LOGIC; 
  signal XNor_stage_cyo48 : STD_LOGIC; 
  signal N54 : STD_LOGIC; 
  signal XNor_stage_cyo47 : STD_LOGIC; 
  signal N53 : STD_LOGIC; 
  signal XNor_stage_cyo46 : STD_LOGIC; 
  signal N52 : STD_LOGIC; 
  signal GE_stage_cyo1 : STD_LOGIC; 
  signal XNor_stage_cyo31 : STD_LOGIC; 
  signal N37 : STD_LOGIC; 
  signal GE_stage_cyo : STD_LOGIC; 
  signal N35 : STD_LOGIC; 
  signal XNor_stage_cyo30 : STD_LOGIC; 
  signal N34 : STD_LOGIC; 
  signal XNor_stage_cyo29 : STD_LOGIC; 
  signal h_Mtrien_IOA : STD_LOGIC; 
  signal h_n0006 : STD_LOGIC; 
  signal XNor_stage_cyo61 : STD_LOGIC; 
  signal N80 : STD_LOGIC; 
  signal N67 : STD_LOGIC; 
  signal N51 : STD_LOGIC; 
  signal N68 : STD_LOGIC; 
  signal N38 : STD_LOGIC; 
  signal XNor_stage_cyo32 : STD_LOGIC; 
  signal N39 : STD_LOGIC; 
  signal XNor_stage_cyo33 : STD_LOGIC; 
  signal N40 : STD_LOGIC; 
  signal XNor_stage_cyo34 : STD_LOGIC; 
  signal N41 : STD_LOGIC; 
  signal XNor_stage_cyo35 : STD_LOGIC; 
  signal N42 : STD_LOGIC; 
  signal XNor_stage_cyo36 : STD_LOGIC; 
  signal N43 : STD_LOGIC; 
  signal XNor_stage_cyo37 : STD_LOGIC; 
  signal N44 : STD_LOGIC; 
  signal XNor_stage_cyo38 : STD_LOGIC; 
  signal N45 : STD_LOGIC; 
  signal XNor_stage_cyo39 : STD_LOGIC; 
  signal N46 : STD_LOGIC; 
  signal XNor_stage_cyo40 : STD_LOGIC; 
  signal N47 : STD_LOGIC; 
  signal XNor_stage_cyo41 : STD_LOGIC; 
  signal N48 : STD_LOGIC; 
  signal XNor_stage_cyo42 : STD_LOGIC; 
  signal N49 : STD_LOGIC; 
  signal N31 : STD_LOGIC; 
  signal MUX_BLOCK_N1 : STD_LOGIC; 
  signal XNor_stage_cyo43 : STD_LOGIC; 
  signal N3 : STD_LOGIC; 
  signal cpu_h_n0007_0_cyo : STD_LOGIC; 
  signal cpu_h_n0007_1_cyo : STD_LOGIC; 
  signal cpu_h_n0007_2_cyo : STD_LOGIC; 
  signal cpu_h_n0007_3_cyo : STD_LOGIC; 
  signal cpu_h_n0007_4_cyo : STD_LOGIC; 
  signal cpu_h_n0007_5_cyo : STD_LOGIC; 
  signal cpu_h_n0007_6_cyo : STD_LOGIC; 
  signal cpu_h_n0007_7_cyo : STD_LOGIC; 
  signal cpu_h_n0007_8_cyo : STD_LOGIC; 
  signal cpu_h_n0007_9_cyo : STD_LOGIC; 
  signal cpu_h_n0007_10_cyo : STD_LOGIC; 
  signal cpu_h_n0007_11_cyo : STD_LOGIC; 
  signal cpu_h_n0007_12_cyo : STD_LOGIC; 
  signal cpu_h_n0007_13_cyo : STD_LOGIC; 
  signal cpu_h_n0007_14_cyo : STD_LOGIC; 
  signal cpu_h_n0007_15_cyo : STD_LOGIC; 
  signal cpu_h_n0007_16_cyo : STD_LOGIC; 
  signal cpu_h_n0007_17_cyo : STD_LOGIC; 
  signal cpu_h_n0007_18_cyo : STD_LOGIC; 
  signal XNor_stage_cyo44 : STD_LOGIC; 
  signal N4 : STD_LOGIC; 
  signal XNor_stage_cyo : STD_LOGIC; 
  signal N5 : STD_LOGIC; 
  signal XNor_stage_cyo1 : STD_LOGIC; 
  signal N6 : STD_LOGIC; 
  signal XNor_stage_cyo2 : STD_LOGIC; 
  signal N7 : STD_LOGIC; 
  signal XNor_stage_cyo3 : STD_LOGIC; 
  signal N8 : STD_LOGIC; 
  signal XNor_stage_cyo4 : STD_LOGIC; 
  signal N9 : STD_LOGIC; 
  signal XNor_stage_cyo5 : STD_LOGIC; 
  signal N10 : STD_LOGIC; 
  signal XNor_stage_cyo6 : STD_LOGIC; 
  signal N11 : STD_LOGIC; 
  signal XNor_stage_cyo7 : STD_LOGIC; 
  signal N12 : STD_LOGIC; 
  signal XNor_stage_cyo8 : STD_LOGIC; 
  signal N13 : STD_LOGIC; 
  signal XNor_stage_cyo9 : STD_LOGIC; 
  signal N14 : STD_LOGIC; 
  signal XNor_stage_cyo10 : STD_LOGIC; 
  signal N15 : STD_LOGIC; 
  signal XNor_stage_cyo11 : STD_LOGIC; 
  signal N16 : STD_LOGIC; 
  signal XNor_stage_cyo12 : STD_LOGIC; 
  signal N17 : STD_LOGIC; 
  signal XNor_stage_cyo13 : STD_LOGIC; 
  signal N18 : STD_LOGIC; 
  signal XNor_stage_cyo14 : STD_LOGIC; 
  signal N19 : STD_LOGIC; 
  signal XNor_stage_cyo15 : STD_LOGIC; 
  signal N20 : STD_LOGIC; 
  signal XNor_stage_cyo16 : STD_LOGIC; 
  signal N21 : STD_LOGIC; 
  signal XNor_stage_cyo17 : STD_LOGIC; 
  signal N22 : STD_LOGIC; 
  signal XNor_stage_cyo18 : STD_LOGIC; 
  signal N23 : STD_LOGIC; 
  signal XNor_stage_cyo19 : STD_LOGIC; 
  signal N24 : STD_LOGIC; 
  signal XNor_stage_cyo20 : STD_LOGIC; 
  signal N25 : STD_LOGIC; 
  signal XNor_stage_cyo21 : STD_LOGIC; 
  signal N26 : STD_LOGIC; 
  signal XNor_stage_cyo22 : STD_LOGIC; 
  signal N27 : STD_LOGIC; 
  signal XNor_stage_cyo23 : STD_LOGIC; 
  signal N28 : STD_LOGIC; 
  signal XNor_stage_cyo24 : STD_LOGIC; 
  signal N29 : STD_LOGIC; 
  signal XNor_stage_cyo25 : STD_LOGIC; 
  signal N30 : STD_LOGIC; 
  signal N5428 : STD_LOGIC; 
  signal N5267 : STD_LOGIC; 
  signal N2 : STD_LOGIC; 
  signal N471 : STD_LOGIC; 
  signal N411 : STD_LOGIC; 
  signal N121 : STD_LOGIC; 
  signal N241 : STD_LOGIC; 
  signal N231 : STD_LOGIC; 
  signal N451 : STD_LOGIC; 
  signal N111 : STD_LOGIC; 
  signal N101 : STD_LOGIC; 
  signal a_N373 : STD_LOGIC; 
  signal a_N371 : STD_LOGIC; 
  signal a_N379 : STD_LOGIC; 
  signal a_N85 : STD_LOGIC; 
  signal a_N195 : STD_LOGIC; 
  signal a_N115 : STD_LOGIC; 
  signal a_n0001 : STD_LOGIC; 
  signal a_alu_n0000_27_cyo : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_8_Q : STD_LOGIC; 
  signal a_alu_n0000_30_cyo : STD_LOGIC; 
  signal a_N31 : STD_LOGIC; 
  signal a_N34 : STD_LOGIC; 
  signal a_N30 : STD_LOGIC; 
  signal a_N33 : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_12_Q : STD_LOGIC; 
  signal a_alu_n0000_29_cyo : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_9_Q : STD_LOGIC; 
  signal a_N32 : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_11_Q : STD_LOGIC; 
  signal a_alu_n0000_28_cyo : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_10_Q : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_41_Q : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_42_Q : STD_LOGIC; 
  signal a_N98 : STD_LOGIC; 
  signal a_alu_n0000_16_cyo : STD_LOGIC; 
  signal a_N19 : STD_LOGIC; 
  signal a_alu_n0000_15_cyo : STD_LOGIC; 
  signal a_N18 : STD_LOGIC; 
  signal a_alu_n0000_14_cyo : STD_LOGIC; 
  signal a_N17 : STD_LOGIC; 
  signal a_alu_n0000_13_cyo : STD_LOGIC; 
  signal a_N16 : STD_LOGIC; 
  signal a_alu_n0000_12_cyo : STD_LOGIC; 
  signal a_N15 : STD_LOGIC; 
  signal a_alu_n0000_11_cyo : STD_LOGIC; 
  signal a_N14 : STD_LOGIC; 
  signal a_alu_n0000_10_cyo : STD_LOGIC; 
  signal a_N13 : STD_LOGIC; 
  signal a_alu_n0000_9_cyo : STD_LOGIC; 
  signal a_N12 : STD_LOGIC; 
  signal a_alu_n0000_8_cyo : STD_LOGIC; 
  signal a_N11 : STD_LOGIC; 
  signal a_alu_n0000_7_cyo : STD_LOGIC; 
  signal a_N10 : STD_LOGIC; 
  signal a_alu_n0000_6_cyo : STD_LOGIC; 
  signal a_N9 : STD_LOGIC; 
  signal a_alu_n0000_5_cyo : STD_LOGIC; 
  signal a_N8 : STD_LOGIC; 
  signal a_alu_n0000_4_cyo : STD_LOGIC; 
  signal a_N7 : STD_LOGIC; 
  signal a_alu_n0000_3_cyo : STD_LOGIC; 
  signal a_N6 : STD_LOGIC; 
  signal a_alu_n0000_2_cyo : STD_LOGIC; 
  signal a_N5 : STD_LOGIC; 
  signal a_alu_n0000_1_cyo : STD_LOGIC; 
  signal a_N4 : STD_LOGIC; 
  signal a_N511 : STD_LOGIC; 
  signal a_N50 : STD_LOGIC; 
  signal a_N49 : STD_LOGIC; 
  signal a_N48 : STD_LOGIC; 
  signal a_N47 : STD_LOGIC; 
  signal a_N46 : STD_LOGIC; 
  signal N5550 : STD_LOGIC; 
  signal a_N196 : STD_LOGIC; 
  signal a_N143 : STD_LOGIC; 
  signal a_N182 : STD_LOGIC; 
  signal a_N811 : STD_LOGIC; 
  signal a_N183 : STD_LOGIC; 
  signal a_N372 : STD_LOGIC; 
  signal a_N257 : STD_LOGIC; 
  signal a_N87 : STD_LOGIC; 
  signal a_N114 : STD_LOGIC; 
  signal a_N113 : STD_LOGIC; 
  signal a_N96 : STD_LOGIC; 
  signal a_N86 : STD_LOGIC; 
  signal a_N380 : STD_LOGIC; 
  signal a_N126 : STD_LOGIC; 
  signal a_N291 : STD_LOGIC; 
  signal a_N281 : STD_LOGIC; 
  signal a_N52 : STD_LOGIC; 
  signal N5818 : STD_LOGIC; 
  signal a_N251 : STD_LOGIC; 
  signal N5538 : STD_LOGIC; 
  signal a_N231 : STD_LOGIC; 
  signal a_N221 : STD_LOGIC; 
  signal a_N211 : STD_LOGIC; 
  signal a_N201 : STD_LOGIC; 
  signal a_N191 : STD_LOGIC; 
  signal a_N181 : STD_LOGIC; 
  signal a_N171 : STD_LOGIC; 
  signal a_N161 : STD_LOGIC; 
  signal a_N151 : STD_LOGIC; 
  signal a_N141 : STD_LOGIC; 
  signal a_N131 : STD_LOGIC; 
  signal a_N1811 : STD_LOGIC; 
  signal N5414 : STD_LOGIC; 
  signal a_N76 : STD_LOGIC; 
  signal a_N91 : STD_LOGIC; 
  signal a_N81 : STD_LOGIC; 
  signal a_N123 : STD_LOGIC; 
  signal a_N61 : STD_LOGIC; 
  signal a_N178 : STD_LOGIC; 
  signal a_N41 : STD_LOGIC; 
  signal a_N35 : STD_LOGIC; 
  signal a_N2 : STD_LOGIC; 
  signal a_N110 : STD_LOGIC; 
  signal a_N01 : STD_LOGIC; 
  signal a_alu_n0000_26_cyo : STD_LOGIC; 
  signal a_N29 : STD_LOGIC; 
  signal a_alu_n0000_25_cyo : STD_LOGIC; 
  signal a_N28 : STD_LOGIC; 
  signal a_alu_n0000_24_cyo : STD_LOGIC; 
  signal a_N27 : STD_LOGIC; 
  signal a_alu_n0000_23_cyo : STD_LOGIC; 
  signal a_N26 : STD_LOGIC; 
  signal a_alu_n0000_22_cyo : STD_LOGIC; 
  signal a_N25 : STD_LOGIC; 
  signal a_alu_n0000_21_cyo : STD_LOGIC; 
  signal a_N24 : STD_LOGIC; 
  signal a_alu_n0000_20_cyo : STD_LOGIC; 
  signal a_N23 : STD_LOGIC; 
  signal a_alu_n0000_19_cyo : STD_LOGIC; 
  signal a_N22 : STD_LOGIC; 
  signal a_alu_n0000_18_cyo : STD_LOGIC; 
  signal a_N21 : STD_LOGIC; 
  signal a_alu_n0000_17_cyo : STD_LOGIC; 
  signal a_N20 : STD_LOGIC; 
  signal a_N180 : STD_LOGIC; 
  signal N5438 : STD_LOGIC; 
  signal N5546 : STD_LOGIC; 
  signal N5330 : STD_LOGIC; 
  signal N5271 : STD_LOGIC; 
  signal N5329 : STD_LOGIC; 
  signal N5258 : STD_LOGIC; 
  signal N5332 : STD_LOGIC; 
  signal N5326 : STD_LOGIC; 
  signal N5327 : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_26_Q : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_28_Q : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_30_Q : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_54_Q : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_52_Q : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_50_Q : STD_LOGIC; 
  signal N5207 : STD_LOGIC; 
  signal N5474 : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_42_Q : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_44_Q : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_46_Q : STD_LOGIC; 
  signal N5394 : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_46_Q : STD_LOGIC; 
  signal a_N53 : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_2_Q : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_4_Q : STD_LOGIC; 
  signal N5805 : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_62_Q : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_4_Q : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_60_Q : STD_LOGIC; 
  signal a_N116 : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_56_Q : STD_LOGIC; 
  signal a_N55 : STD_LOGIC; 
  signal N5532 : STD_LOGIC; 
  signal N5296 : STD_LOGIC; 
  signal N5263 : STD_LOGIC; 
  signal N5260 : STD_LOGIC; 
  signal N5456 : STD_LOGIC; 
  signal N5261 : STD_LOGIC; 
  signal N5841 : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_23_Q : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_25_Q : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_27_Q : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_29_Q : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_58_Q : STD_LOGIC; 
  signal N5807 : STD_LOGIC; 
  signal N5425 : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_49_Q : STD_LOGIC; 
  signal N5411 : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_41_Q : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_43_Q : STD_LOGIC; 
  signal a_N142 : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_43_Q : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_45_Q : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_47_Q : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_1_Q : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_3_Q : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_5_Q : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_7_Q : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_61_Q : STD_LOGIC; 
  signal N5437 : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_59_Q : STD_LOGIC; 
  signal a_N256 : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_55_Q : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_40_Q : STD_LOGIC; 
  signal a_N194 : STD_LOGIC; 
  signal a_N54 : STD_LOGIC; 
  signal a_N57 : STD_LOGIC; 
  signal a_N59 : STD_LOGIC; 
  signal a_N611 : STD_LOGIC; 
  signal a_N144 : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_15_Q : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_13_Q : STD_LOGIC; 
  signal a_N64 : STD_LOGIC; 
  signal a_N370 : STD_LOGIC; 
  signal a_N255 : STD_LOGIC; 
  signal a_N179 : STD_LOGIC; 
  signal a_N58 : STD_LOGIC; 
  signal N5466 : STD_LOGIC; 
  signal a_N60 : STD_LOGIC; 
  signal a_N62 : STD_LOGIC; 
  signal a_alu_n0000_0_cyo : STD_LOGIC; 
  signal a_N3 : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_57_Q : STD_LOGIC; 
  signal s_right_conflict_N0 : STD_LOGIC; 
  signal s_left_conflict_N0 : STD_LOGIC; 
  signal s_left_conflict : STD_LOGIC; 
  signal s_right_conflict : STD_LOGIC; 
  signal N511 : STD_LOGIC; 
  signal N5815 : STD_LOGIC; 
  signal N5816 : STD_LOGIC; 
  signal N5823 : STD_LOGIC; 
  signal N5824 : STD_LOGIC; 
  signal N5820 : STD_LOGIC; 
  signal N5821 : STD_LOGIC; 
  signal N5826 : STD_LOGIC; 
  signal N5827 : STD_LOGIC; 
  signal N5829 : STD_LOGIC; 
  signal N5830 : STD_LOGIC; 
  signal N5518 : STD_LOGIC; 
  signal N5809 : STD_LOGIC; 
  signal N5224 : STD_LOGIC; 
  signal N5378 : STD_LOGIC; 
  signal N5540 : STD_LOGIC; 
  signal N1111 : STD_LOGIC; 
  signal N123 : STD_LOGIC; 
  signal Ker21_1 : STD_LOGIC; 
  signal N5079 : STD_LOGIC; 
  signal N5083 : STD_LOGIC; 
  signal Ker21_12 : STD_LOGIC; 
  signal N5362 : STD_LOGIC; 
  signal N5337 : STD_LOGIC; 
  signal N135 : STD_LOGIC; 
  signal N137 : STD_LOGIC; 
  signal N5294 : STD_LOGIC; 
  signal N504 : STD_LOGIC; 
  signal N5264 : STD_LOGIC; 
  signal N512 : STD_LOGIC; 
  signal Ker21_14 : STD_LOGIC; 
  signal s_left_conflict1 : STD_LOGIC; 
  signal N508 : STD_LOGIC; 
  signal N5317 : STD_LOGIC; 
  signal s_right_conflict1 : STD_LOGIC; 
  signal N5221 : STD_LOGIC; 
  signal N530 : STD_LOGIC; 
  signal h_get_word_buf_27_1 : STD_LOGIC; 
  signal N5333 : STD_LOGIC; 
  signal N529 : STD_LOGIC; 
  signal N5266 : STD_LOGIC; 
  signal N494 : STD_LOGIC; 
  signal Ker21_13 : STD_LOGIC; 
  signal N506 : STD_LOGIC; 
  signal N498 : STD_LOGIC; 
  signal N5215 : STD_LOGIC; 
  signal N5458 : STD_LOGIC; 
  signal N502 : STD_LOGIC; 
  signal N5302 : STD_LOGIC; 
  signal N5213 : STD_LOGIC; 
  signal N510 : STD_LOGIC; 
  signal N5305 : STD_LOGIC; 
  signal N5315 : STD_LOGIC; 
  signal N5368 : STD_LOGIC; 
  signal N237 : STD_LOGIC; 
  signal N5356 : STD_LOGIC; 
  signal N5476 : STD_LOGIC; 
  signal s_left_conflict_7 : STD_LOGIC; 
  signal N247 : STD_LOGIC; 
  signal N5314 : STD_LOGIC; 
  signal N5352 : STD_LOGIC; 
  signal N5360 : STD_LOGIC; 
  signal N238 : STD_LOGIC; 
  signal N5396 : STD_LOGIC; 
  signal N5364 : STD_LOGIC; 
  signal N5372 : STD_LOGIC; 
  signal CHOICE3797 : STD_LOGIC; 
  signal N5311 : STD_LOGIC; 
  signal N2311 : STD_LOGIC; 
  signal N248 : STD_LOGIC; 
  signal N230 : STD_LOGIC; 
  signal N5312 : STD_LOGIC; 
  signal N5400 : STD_LOGIC; 
  signal N5472 : STD_LOGIC; 
  signal N5376 : STD_LOGIC; 
  signal N5388 : STD_LOGIC; 
  signal N5432 : STD_LOGIC; 
  signal N5441 : STD_LOGIC; 
  signal N5318 : STD_LOGIC; 
  signal N270 : STD_LOGIC; 
  signal Ker21_11 : STD_LOGIC; 
  signal N5380 : STD_LOGIC; 
  signal N5306 : STD_LOGIC; 
  signal N242 : STD_LOGIC; 
  signal N5384 : STD_LOGIC; 
  signal N5308 : STD_LOGIC; 
  signal N243 : STD_LOGIC; 
  signal CHOICE3790 : STD_LOGIC; 
  signal N5392 : STD_LOGIC; 
  signal N5320 : STD_LOGIC; 
  signal N5309 : STD_LOGIC; 
  signal N5468 : STD_LOGIC; 
  signal N5206 : STD_LOGIC; 
  signal CHOICE3951 : STD_LOGIC; 
  signal CHOICE4359 : STD_LOGIC; 
  signal CHOICE3827 : STD_LOGIC; 
  signal N5366 : STD_LOGIC; 
  signal CHOICE4208 : STD_LOGIC; 
  signal CHOICE4180 : STD_LOGIC; 
  signal CHOICE3981 : STD_LOGIC; 
  signal N5254 : STD_LOGIC; 
  signal N5429 : STD_LOGIC; 
  signal N5412 : STD_LOGIC; 
  signal N5498 : STD_LOGIC; 
  signal N5390 : STD_LOGIC; 
  signal CHOICE4471 : STD_LOGIC; 
  signal N5402 : STD_LOGIC; 
  signal CHOICE3881 : STD_LOGIC; 
  signal N5409 : STD_LOGIC; 
  signal CHOICE3806 : STD_LOGIC; 
  signal N5787 : STD_LOGIC; 
  signal N5382 : STD_LOGIC; 
  signal N5085 : STD_LOGIC; 
  signal N5370 : STD_LOGIC; 
  signal N5354 : STD_LOGIC; 
  signal CHOICE4080 : STD_LOGIC; 
  signal CHOICE3974 : STD_LOGIC; 
  signal CHOICE3808 : STD_LOGIC; 
  signal CHOICE4244 : STD_LOGIC; 
  signal N5530 : STD_LOGIC; 
  signal N5563 : STD_LOGIC; 
  signal CHOICE4448 : STD_LOGIC; 
  signal CHOICE4529 : STD_LOGIC; 
  signal N5350 : STD_LOGIC; 
  signal CHOICE4344 : STD_LOGIC; 
  signal CHOICE3999 : STD_LOGIC; 
  signal N5507 : STD_LOGIC; 
  signal CHOICE4503 : STD_LOGIC; 
  signal CHOICE4268 : STD_LOGIC; 
  signal CHOICE4135 : STD_LOGIC; 
  signal N5374 : STD_LOGIC; 
  signal CHOICE4078 : STD_LOGIC; 
  signal N5335 : STD_LOGIC; 
  signal CHOICE4016 : STD_LOGIC; 
  signal CHOICE4047 : STD_LOGIC; 
  signal h_put_address_buf_16_rt : STD_LOGIC; 
  signal CHOICE3985 : STD_LOGIC; 
  signal CHOICE4515 : STD_LOGIC; 
  signal CHOICE4247 : STD_LOGIC; 
  signal CHOICE4054 : STD_LOGIC; 
  signal CHOICE3816 : STD_LOGIC; 
  signal CHOICE3900 : STD_LOGIC; 
  signal CHOICE4084 : STD_LOGIC; 
  signal N5087 : STD_LOGIC; 
  signal CHOICE3901 : STD_LOGIC; 
  signal CHOICE4358 : STD_LOGIC; 
  signal CHOICE4026 : STD_LOGIC; 
  signal N5554 : STD_LOGIC; 
  signal CHOICE4258 : STD_LOGIC; 
  signal N5346 : STD_LOGIC; 
  signal CHOICE3942 : STD_LOGIC; 
  signal CHOICE4230 : STD_LOGIC; 
  signal CHOICE3897 : STD_LOGIC; 
  signal CHOICE3890 : STD_LOGIC; 
  signal N5813 : STD_LOGIC; 
  signal CHOICE4129 : STD_LOGIC; 
  signal N5509 : STD_LOGIC; 
  signal CHOICE4035 : STD_LOGIC; 
  signal N5785 : STD_LOGIC; 
  signal CHOICE3858 : STD_LOGIC; 
  signal CHOICE4302 : STD_LOGIC; 
  signal N5210 : STD_LOGIC; 
  signal N5324 : STD_LOGIC; 
  signal CHOICE4199 : STD_LOGIC; 
  signal CHOICE3920 : STD_LOGIC; 
  signal CHOICE4500 : STD_LOGIC; 
  signal CHOICE4252 : STD_LOGIC; 
  signal CHOICE4058 : STD_LOGIC; 
  signal CHOICE4131 : STD_LOGIC; 
  signal CHOICE4220 : STD_LOGIC; 
  signal CHOICE4092 : STD_LOGIC; 
  signal N5801 : STD_LOGIC; 
  signal N5791 : STD_LOGIC; 
  signal N5431 : STD_LOGIC; 
  signal CHOICE3837 : STD_LOGIC; 
  signal N5511 : STD_LOGIC; 
  signal CHOICE4524 : STD_LOGIC; 
  signal N5529 : STD_LOGIC; 
  signal CHOICE3909 : STD_LOGIC; 
  signal CHOICE4390 : STD_LOGIC; 
  signal CHOICE3984 : STD_LOGIC; 
  signal CHOICE3839 : STD_LOGIC; 
  signal h_response_buf_0_6 : STD_LOGIC; 
  signal CHOICE4143 : STD_LOGIC; 
  signal CHOICE4407 : STD_LOGIC; 
  signal CHOICE4007 : STD_LOGIC; 
  signal CHOICE4412 : STD_LOGIC; 
  signal N5343 : STD_LOGIC; 
  signal CHOICE4338 : STD_LOGIC; 
  signal CHOICE4442 : STD_LOGIC; 
  signal CHOICE3923 : STD_LOGIC; 
  signal CHOICE4027 : STD_LOGIC; 
  signal CHOICE3962 : STD_LOGIC; 
  signal CHOICE4368 : STD_LOGIC; 
  signal CHOICE4000 : STD_LOGIC; 
  signal CHOICE3943 : STD_LOGIC; 
  signal N5443 : STD_LOGIC; 
  signal CHOICE4349 : STD_LOGIC; 
  signal CHOICE3965 : STD_LOGIC; 
  signal CHOICE3939 : STD_LOGIC; 
  signal N5321 : STD_LOGIC; 
  signal N5514 : STD_LOGIC; 
  signal CHOICE4280 : STD_LOGIC; 
  signal CHOICE3847 : STD_LOGIC; 
  signal h_response_buf_0_5 : STD_LOGIC; 
  signal CHOICE4494 : STD_LOGIC; 
  signal CHOICE4429 : STD_LOGIC; 
  signal CHOICE4441 : STD_LOGIC; 
  signal CHOICE3932 : STD_LOGIC; 
  signal CHOICE4297 : STD_LOGIC; 
  signal CHOICE4125 : STD_LOGIC; 
  signal CHOICE4491 : STD_LOGIC; 
  signal CHOICE3874 : STD_LOGIC; 
  signal CHOICE4057 : STD_LOGIC; 
  signal CHOICE4398 : STD_LOGIC; 
  signal CHOICE4270 : STD_LOGIC; 
  signal CHOICE4196 : STD_LOGIC; 
  signal N5386 : STD_LOGIC; 
  signal N5252 : STD_LOGIC; 
  signal CHOICE4218 : STD_LOGIC; 
  signal CHOICE4173 : STD_LOGIC; 
  signal CHOICE4122 : STD_LOGIC; 
  signal CHOICE3878 : STD_LOGIC; 
  signal CHOICE3916 : STD_LOGIC; 
  signal h_put_address_buf_15_rt : STD_LOGIC; 
  signal CHOICE3863 : STD_LOGIC; 
  signal CHOICE4320 : STD_LOGIC; 
  signal CHOICE4395 : STD_LOGIC; 
  signal N5793 : STD_LOGIC; 
  signal CHOICE3993 : STD_LOGIC; 
  signal CHOICE4004 : STD_LOGIC; 
  signal CHOICE4181 : STD_LOGIC; 
  signal CHOICE4023 : STD_LOGIC; 
  signal CHOICE4335 : STD_LOGIC; 
  signal N5565 : STD_LOGIC; 
  signal N5288 : STD_LOGIC; 
  signal CHOICE4139 : STD_LOGIC; 
  signal N5274 : STD_LOGIC; 
  signal CHOICE4453 : STD_LOGIC; 
  signal N5799 : STD_LOGIC; 
  signal N5323 : STD_LOGIC; 
  signal CHOICE4318 : STD_LOGIC; 
  signal CHOICE4396 : STD_LOGIC; 
  signal N5534 : STD_LOGIC; 
  signal CHOICE4308 : STD_LOGIC; 
  signal CHOICE4406 : STD_LOGIC; 
  signal N5286 : STD_LOGIC; 
  signal CHOICE3958 : STD_LOGIC; 
  signal CHOICE4294 : STD_LOGIC; 
  signal N5505 : STD_LOGIC; 
  signal CHOICE4872 : STD_LOGIC; 
  signal CHOICE5114 : STD_LOGIC; 
  signal CHOICE4769 : STD_LOGIC; 
  signal N5503 : STD_LOGIC; 
  signal CHOICE5016 : STD_LOGIC; 
  signal CHOICE5406 : STD_LOGIC; 
  signal CHOICE5333 : STD_LOGIC; 
  signal CHOICE4653 : STD_LOGIC; 
  signal s_left_conflict_4 : STD_LOGIC; 
  signal CHOICE4577 : STD_LOGIC; 
  signal N5257 : STD_LOGIC; 
  signal h_get_word_buf_29_3 : STD_LOGIC; 
  signal CHOICE5056 : STD_LOGIC; 
  signal h_get_word_buf_28_1 : STD_LOGIC; 
  signal h_get_word_buf_9_1 : STD_LOGIC; 
  signal CHOICE5312 : STD_LOGIC; 
  signal CHOICE5204 : STD_LOGIC; 
  signal CHOICE5192 : STD_LOGIC; 
  signal N5278 : STD_LOGIC; 
  signal CHOICE4766 : STD_LOGIC; 
  signal N5478 : STD_LOGIC; 
  signal CHOICE4712 : STD_LOGIC; 
  signal N5797 : STD_LOGIC; 
  signal N5470 : STD_LOGIC; 
  signal CHOICE4706 : STD_LOGIC; 
  signal CHOICE4579 : STD_LOGIC; 
  signal CHOICE5014 : STD_LOGIC; 
  signal CHOICE5175 : STD_LOGIC; 
  signal N5272 : STD_LOGIC; 
  signal CHOICE5383 : STD_LOGIC; 
  signal CHOICE4924 : STD_LOGIC; 
  signal CHOICE5276 : STD_LOGIC; 
  signal CHOICE4853 : STD_LOGIC; 
  signal CHOICE4544 : STD_LOGIC; 
  signal CHOICE4621 : STD_LOGIC; 
  signal CHOICE5066 : STD_LOGIC; 
  signal CHOICE4828 : STD_LOGIC; 
  signal CHOICE5179 : STD_LOGIC; 
  signal CHOICE4914 : STD_LOGIC; 
  signal CHOICE4611 : STD_LOGIC; 
  signal N5417 : STD_LOGIC; 
  signal CHOICE5273 : STD_LOGIC; 
  signal CHOICE4805 : STD_LOGIC; 
  signal CHOICE4547 : STD_LOGIC; 
  signal N5117 : STD_LOGIC; 
  signal CHOICE5448 : STD_LOGIC; 
  signal N5450 : STD_LOGIC; 
  signal CHOICE4734 : STD_LOGIC; 
  signal CHOICE4758 : STD_LOGIC; 
  signal h_response_buf_1_1 : STD_LOGIC; 
  signal a_shift_2_1 : STD_LOGIC; 
  signal CHOICE5041 : STD_LOGIC; 
  signal h_response_buf_1_1_0 : STD_LOGIC; 
  signal CHOICE5086 : STD_LOGIC; 
  signal CHOICE4664 : STD_LOGIC; 
  signal CHOICE5360 : STD_LOGIC; 
  signal s_left_conflict_2 : STD_LOGIC; 
  signal CHOICE5132 : STD_LOGIC; 
  signal CHOICE4674 : STD_LOGIC; 
  signal CHOICE4717 : STD_LOGIC; 
  signal CHOICE4553 : STD_LOGIC; 
  signal CHOICE5469 : STD_LOGIC; 
  signal CHOICE5320 : STD_LOGIC; 
  signal N5521 : STD_LOGIC; 
  signal CHOICE4683 : STD_LOGIC; 
  signal CHOICE5292 : STD_LOGIC; 
  signal CHOICE4780 : STD_LOGIC; 
  signal N5420 : STD_LOGIC; 
  signal N5440 : STD_LOGIC; 
  signal CHOICE5134 : STD_LOGIC; 
  signal CHOICE5444 : STD_LOGIC; 
  signal CHOICE4938 : STD_LOGIC; 
  signal CHOICE5036 : STD_LOGIC; 
  signal CHOICE5020 : STD_LOGIC; 
  signal CHOICE5159 : STD_LOGIC; 
  signal CHOICE5464 : STD_LOGIC; 
  signal CHOICE4790 : STD_LOGIC; 
  signal CHOICE5157 : STD_LOGIC; 
  signal CHOICE5442 : STD_LOGIC; 
  signal CHOICE4558 : STD_LOGIC; 
  signal CHOICE4637 : STD_LOGIC; 
  signal CHOICE5147 : STD_LOGIC; 
  signal N5120 : STD_LOGIC; 
  signal CHOICE5365 : STD_LOGIC; 
  signal CHOICE5457 : STD_LOGIC; 
  signal CHOICE5308 : STD_LOGIC; 
  signal CHOICE5177 : STD_LOGIC; 
  signal a_shift_0_1 : STD_LOGIC; 
  signal CHOICE4968 : STD_LOGIC; 
  signal CHOICE4878 : STD_LOGIC; 
  signal CHOICE5436 : STD_LOGIC; 
  signal h_get_word_buf_8_1 : STD_LOGIC; 
  signal N5114 : STD_LOGIC; 
  signal N5280 : STD_LOGIC; 
  signal N5283 : STD_LOGIC; 
  signal CHOICE4958 : STD_LOGIC; 
  signal CHOICE4900 : STD_LOGIC; 
  signal CHOICE4928 : STD_LOGIC; 
  signal CHOICE4703 : STD_LOGIC; 
  signal CHOICE5340 : STD_LOGIC; 
  signal CHOICE5345 : STD_LOGIC; 
  signal CHOICE5252 : STD_LOGIC; 
  signal CHOICE4584 : STD_LOGIC; 
  signal h_response_buf_1_3 : STD_LOGIC; 
  signal N5303 : STD_LOGIC; 
  signal s_left_conflict_5 : STD_LOGIC; 
  signal N5281 : STD_LOGIC; 
  signal CHOICE5210 : STD_LOGIC; 
  signal CHOICE4568 : STD_LOGIC; 
  signal CHOICE4825 : STD_LOGIC; 
  signal N5803 : STD_LOGIC; 
  signal CHOICE5126 : STD_LOGIC; 
  signal CHOICE4685 : STD_LOGIC; 
  signal CHOICE4982 : STD_LOGIC; 
  signal CHOICE4849 : STD_LOGIC; 
  signal CHOICE5377 : STD_LOGIC; 
  signal N5561 : STD_LOGIC; 
  signal N5225 : STD_LOGIC; 
  signal h_response_buf_0_4 : STD_LOGIC; 
  signal s_right_conflict_2 : STD_LOGIC; 
  signal CHOICE4884 : STD_LOGIC; 
  signal CHOICE5429 : STD_LOGIC; 
  signal CHOICE5432 : STD_LOGIC; 
  signal CHOICE4650 : STD_LOGIC; 
  signal CHOICE5281 : STD_LOGIC; 
  signal CHOICE5112 : STD_LOGIC; 
  signal CHOICE5286 : STD_LOGIC; 
  signal N5284 : STD_LOGIC; 
  signal CHOICE4867 : STD_LOGIC; 
  signal N5255 : STD_LOGIC; 
  signal CHOICE4871 : STD_LOGIC; 
  signal CHOICE5079 : STD_LOGIC; 
  signal CHOICE4972 : STD_LOGIC; 
  signal CHOICE4659 : STD_LOGIC; 
  signal CHOICE5130 : STD_LOGIC; 
  signal N5358 : STD_LOGIC; 
  signal N5795 : STD_LOGIC; 
  signal N5275 : STD_LOGIC; 
  signal CHOICE4941 : STD_LOGIC; 
  signal CHOICE5246 : STD_LOGIC; 
  signal CHOICE4885 : STD_LOGIC; 
  signal CHOICE4743 : STD_LOGIC; 
  signal CHOICE4630 : STD_LOGIC; 
  signal N5216 : STD_LOGIC; 
  signal N5415 : STD_LOGIC; 
  signal CHOICE5167 : STD_LOGIC; 
  signal CHOICE5161 : STD_LOGIC; 
  signal CHOICE5396 : STD_LOGIC; 
  signal h_response_buf_0_3 : STD_LOGIC; 
  signal N5222 : STD_LOGIC; 
  signal s_left_conflict_6 : STD_LOGIC; 
  signal CHOICE4985 : STD_LOGIC; 
  signal CHOICE5401 : STD_LOGIC; 
  signal CHOICE4727 : STD_LOGIC; 
  signal N5516 : STD_LOGIC; 
  signal CHOICE5412 : STD_LOGIC; 
  signal N5512 : STD_LOGIC; 
  signal N5418 : STD_LOGIC; 
  signal CHOICE4632 : STD_LOGIC; 
  signal CHOICE4893 : STD_LOGIC; 
  signal CHOICE5171 : STD_LOGIC; 
  signal CHOICE5241 : STD_LOGIC; 
  signal N5091 : STD_LOGIC; 
  signal N5219 : STD_LOGIC; 
  signal CHOICE4926 : STD_LOGIC; 
  signal CHOICE4597 : STD_LOGIC; 
  signal CHOICE5216 : STD_LOGIC; 
  signal CHOICE5220 : STD_LOGIC; 
  signal CHOICE5122 : STD_LOGIC; 
  signal N5789 : STD_LOGIC; 
  signal CHOICE5008 : STD_LOGIC; 
  signal CHOICE5058 : STD_LOGIC; 
  signal N5445 : STD_LOGIC; 
  signal CHOICE5261 : STD_LOGIC; 
  signal N5520 : STD_LOGIC; 
  signal CHOICE4600 : STD_LOGIC; 
  signal CHOICE4786 : STD_LOGIC; 
  signal CHOICE5029 : STD_LOGIC; 
  signal CHOICE4690 : STD_LOGIC; 
  signal CHOICE4800 : STD_LOGIC; 
  signal CHOICE4899 : STD_LOGIC; 
  signal s_right_conflict_3 : STD_LOGIC; 
  signal N5552 : STD_LOGIC; 
  signal CHOICE4970 : STD_LOGIC; 
  signal N5344 : STD_LOGIC; 
  signal CHOICE5070 : STD_LOGIC; 
  signal CHOICE5202 : STD_LOGIC; 
  signal N5297 : STD_LOGIC; 
  signal CHOICE5393 : STD_LOGIC; 
  signal CHOICE4738 : STD_LOGIC; 
  signal s_right_conflict_4 : STD_LOGIC; 
  signal CHOICE4832 : STD_LOGIC; 
  signal CHOICE4606 : STD_LOGIC; 
  signal CHOICE5102 : STD_LOGIC; 
  signal CHOICE5324 : STD_LOGIC; 
  signal CHOICE5091 : STD_LOGIC; 
  signal CHOICE4934 : STD_LOGIC; 
  signal CHOICE4736 : STD_LOGIC; 
  signal CHOICE4978 : STD_LOGIC; 
  signal CHOICE5116 : STD_LOGIC; 
  signal CHOICE5318 : STD_LOGIC; 
  signal CHOICE5064 : STD_LOGIC; 
  signal CHOICE5391 : STD_LOGIC; 
  signal CHOICE5006 : STD_LOGIC; 
  signal N5277 : STD_LOGIC; 
  signal N5398 : STD_LOGIC; 
  signal N5003 : STD_LOGIC; 
  signal N5004 : STD_LOGIC; 
  signal N5005 : STD_LOGIC; 
  signal N5006 : STD_LOGIC; 
  signal N5007 : STD_LOGIC; 
  signal N5008 : STD_LOGIC; 
  signal N5009 : STD_LOGIC; 
  signal N5010 : STD_LOGIC; 
  signal N5011 : STD_LOGIC; 
  signal N5012 : STD_LOGIC; 
  signal N5013 : STD_LOGIC; 
  signal N5014 : STD_LOGIC; 
  signal N5015 : STD_LOGIC; 
  signal N5016 : STD_LOGIC; 
  signal N5017 : STD_LOGIC; 
  signal N5018 : STD_LOGIC; 
  signal N5019 : STD_LOGIC; 
  signal N5020 : STD_LOGIC; 
  signal N5021 : STD_LOGIC; 
  signal N5022 : STD_LOGIC; 
  signal N5023 : STD_LOGIC; 
  signal N5024 : STD_LOGIC; 
  signal N5025 : STD_LOGIC; 
  signal N5026 : STD_LOGIC; 
  signal N5027 : STD_LOGIC; 
  signal N5028 : STD_LOGIC; 
  signal N5029 : STD_LOGIC; 
  signal N5030 : STD_LOGIC; 
  signal N5031 : STD_LOGIC; 
  signal N5032 : STD_LOGIC; 
  signal h_put_address_buf_1_rt : STD_LOGIC; 
  signal h_put_address_buf_2_rt : STD_LOGIC; 
  signal h_put_address_buf_3_rt : STD_LOGIC; 
  signal h_put_address_buf_4_rt : STD_LOGIC; 
  signal h_put_address_buf_5_rt : STD_LOGIC; 
  signal h_put_address_buf_6_rt : STD_LOGIC; 
  signal h_put_address_buf_7_rt : STD_LOGIC; 
  signal h_put_address_buf_8_rt : STD_LOGIC; 
  signal h_put_address_buf_9_rt : STD_LOGIC; 
  signal h_put_address_buf_10_rt : STD_LOGIC; 
  signal h_put_address_buf_11_rt : STD_LOGIC; 
  signal h_put_address_buf_12_rt : STD_LOGIC; 
  signal h_put_address_buf_13_rt : STD_LOGIC; 
  signal h_put_address_buf_14_rt : STD_LOGIC; 
  signal N5204 : STD_LOGIC; 
  signal N5218 : STD_LOGIC; 
  signal N5405 : STD_LOGIC; 
  signal N5403 : STD_LOGIC; 
  signal Ker121_11 : STD_LOGIC; 
  signal Ker121_1 : STD_LOGIC; 
  signal N5548 : STD_LOGIC; 
  signal N5544 : STD_LOGIC; 
  signal N5811 : STD_LOGIC; 
  signal N5406 : STD_LOGIC; 
  signal N5408 : STD_LOGIC; 
  signal N5423 : STD_LOGIC; 
  signal N5426 : STD_LOGIC; 
  signal N5203 : STD_LOGIC; 
  signal N5209 : STD_LOGIC; 
  signal N5422 : STD_LOGIC; 
  signal N5113 : STD_LOGIC; 
  signal N5116 : STD_LOGIC; 
  signal N5119 : STD_LOGIC; 
  signal N5122 : STD_LOGIC; 
  signal N5123 : STD_LOGIC; 
  signal N5125 : STD_LOGIC; 
  signal N5126 : STD_LOGIC; 
  signal N5128 : STD_LOGIC; 
  signal N5129 : STD_LOGIC; 
  signal N5131 : STD_LOGIC; 
  signal N5132 : STD_LOGIC; 
  signal N5134 : STD_LOGIC; 
  signal N5135 : STD_LOGIC; 
  signal N5137 : STD_LOGIC; 
  signal N5138 : STD_LOGIC; 
  signal N5140 : STD_LOGIC; 
  signal N5141 : STD_LOGIC; 
  signal N5143 : STD_LOGIC; 
  signal N5144 : STD_LOGIC; 
  signal N5146 : STD_LOGIC; 
  signal N5147 : STD_LOGIC; 
  signal N5149 : STD_LOGIC; 
  signal N5150 : STD_LOGIC; 
  signal N5152 : STD_LOGIC; 
  signal N5153 : STD_LOGIC; 
  signal N5155 : STD_LOGIC; 
  signal N5156 : STD_LOGIC; 
  signal N5158 : STD_LOGIC; 
  signal N5159 : STD_LOGIC; 
  signal N5161 : STD_LOGIC; 
  signal N5162 : STD_LOGIC; 
  signal N5164 : STD_LOGIC; 
  signal N5165 : STD_LOGIC; 
  signal N5167 : STD_LOGIC; 
  signal N5168 : STD_LOGIC; 
  signal N5170 : STD_LOGIC; 
  signal N5171 : STD_LOGIC; 
  signal N5173 : STD_LOGIC; 
  signal N5174 : STD_LOGIC; 
  signal N5176 : STD_LOGIC; 
  signal N5177 : STD_LOGIC; 
  signal N5179 : STD_LOGIC; 
  signal N5180 : STD_LOGIC; 
  signal N5182 : STD_LOGIC; 
  signal N5183 : STD_LOGIC; 
  signal N5185 : STD_LOGIC; 
  signal N5186 : STD_LOGIC; 
  signal N5188 : STD_LOGIC; 
  signal N5189 : STD_LOGIC; 
  signal N5191 : STD_LOGIC; 
  signal N5192 : STD_LOGIC; 
  signal N5194 : STD_LOGIC; 
  signal N5195 : STD_LOGIC; 
  signal N5197 : STD_LOGIC; 
  signal N5198 : STD_LOGIC; 
  signal N5200 : STD_LOGIC; 
  signal N5201 : STD_LOGIC; 
  signal a_shift_4_1 : STD_LOGIC; 
  signal h_get_word_buf_26_1 : STD_LOGIC; 
  signal h_get_word_buf_29_1 : STD_LOGIC; 
  signal h_response_buf_0_1 : STD_LOGIC; 
  signal Ker21 : STD_LOGIC; 
  signal h_get_word_buf_26_2 : STD_LOGIC; 
  signal h_response_buf_1_2 : STD_LOGIC; 
  signal h_response_buf_0_2 : STD_LOGIC; 
  signal h_get_word_buf_29_2 : STD_LOGIC; 
  signal N5913 : STD_LOGIC; 
  signal N5914 : STD_LOGIC; 
  signal N5915 : STD_LOGIC; 
  signal N5916 : STD_LOGIC; 
  signal N5917 : STD_LOGIC; 
  signal N5918 : STD_LOGIC; 
  signal N5919 : STD_LOGIC; 
  signal N5920 : STD_LOGIC; 
  signal N5921 : STD_LOGIC; 
  signal N5922 : STD_LOGIC; 
  signal N5923 : STD_LOGIC; 
  signal N5924 : STD_LOGIC; 
  signal N5925 : STD_LOGIC; 
  signal N5926 : STD_LOGIC; 
  signal N5927 : STD_LOGIC; 
  signal N5928 : STD_LOGIC; 
  signal N5929 : STD_LOGIC; 
  signal N5930 : STD_LOGIC; 
  signal N5931 : STD_LOGIC; 
  signal N5932 : STD_LOGIC; 
  signal N5933 : STD_LOGIC; 
  signal N5934 : STD_LOGIC; 
  signal N5935 : STD_LOGIC; 
  signal N5936 : STD_LOGIC; 
  signal N5937 : STD_LOGIC; 
  signal N5938 : STD_LOGIC; 
  signal N5939 : STD_LOGIC; 
  signal N5940 : STD_LOGIC; 
  signal N5941 : STD_LOGIC; 
  signal N5942 : STD_LOGIC; 
  signal N5943 : STD_LOGIC; 
  signal N5944 : STD_LOGIC; 
  signal N5945 : STD_LOGIC; 
  signal N5946 : STD_LOGIC; 
  signal N5947 : STD_LOGIC; 
  signal N5948 : STD_LOGIC; 
  signal N5949 : STD_LOGIC; 
  signal N5950 : STD_LOGIC; 
  signal N5951 : STD_LOGIC; 
  signal N5952 : STD_LOGIC; 
  signal N5953 : STD_LOGIC; 
  signal N5954 : STD_LOGIC; 
  signal N5955 : STD_LOGIC; 
  signal N5956 : STD_LOGIC; 
  signal N5957 : STD_LOGIC; 
  signal N5958 : STD_LOGIC; 
  signal N5959 : STD_LOGIC; 
  signal N5960 : STD_LOGIC; 
  signal N5961 : STD_LOGIC; 
  signal N5962 : STD_LOGIC; 
  signal N5963 : STD_LOGIC; 
  signal N5964 : STD_LOGIC; 
  signal N5965 : STD_LOGIC; 
  signal N5966 : STD_LOGIC; 
  signal N5967 : STD_LOGIC; 
  signal N5968 : STD_LOGIC; 
  signal N5969 : STD_LOGIC; 
  signal N5970 : STD_LOGIC; 
  signal N5971 : STD_LOGIC; 
  signal N5972 : STD_LOGIC; 
  signal N5973 : STD_LOGIC; 
  signal N5974 : STD_LOGIC; 
  signal N5975 : STD_LOGIC; 
  signal N5976 : STD_LOGIC; 
  signal N5977 : STD_LOGIC; 
  signal N5978 : STD_LOGIC; 
  signal N5979 : STD_LOGIC; 
  signal N5980 : STD_LOGIC; 
  signal N5981 : STD_LOGIC; 
  signal N5982 : STD_LOGIC; 
  signal N5983 : STD_LOGIC; 
  signal N5984 : STD_LOGIC; 
  signal N5985 : STD_LOGIC; 
  signal N5986 : STD_LOGIC; 
  signal N5987 : STD_LOGIC; 
  signal N5988 : STD_LOGIC; 
  signal N5989 : STD_LOGIC; 
  signal N5990 : STD_LOGIC; 
  signal N5991 : STD_LOGIC; 
  signal N5992 : STD_LOGIC; 
  signal N5993 : STD_LOGIC; 
  signal N5994 : STD_LOGIC; 
  signal N5995 : STD_LOGIC; 
  signal N5996 : STD_LOGIC; 
  signal N5997 : STD_LOGIC; 
  signal N5998 : STD_LOGIC; 
  signal N5999 : STD_LOGIC; 
  signal N6000 : STD_LOGIC; 
  signal N6001 : STD_LOGIC; 
  signal N6002 : STD_LOGIC; 
  signal N6003 : STD_LOGIC; 
  signal N6004 : STD_LOGIC; 
  signal N6005 : STD_LOGIC; 
  signal N6006 : STD_LOGIC; 
  signal N6007 : STD_LOGIC; 
  signal N6008 : STD_LOGIC; 
  signal N6009 : STD_LOGIC; 
  signal N6010 : STD_LOGIC; 
  signal N6011 : STD_LOGIC; 
  signal N6012 : STD_LOGIC; 
  signal N6013 : STD_LOGIC; 
  signal N6014 : STD_LOGIC; 
  signal N6015 : STD_LOGIC; 
  signal N6016 : STD_LOGIC; 
  signal N6017 : STD_LOGIC; 
  signal N6018 : STD_LOGIC; 
  signal N6019 : STD_LOGIC; 
  signal N6020 : STD_LOGIC; 
  signal N6021 : STD_LOGIC; 
  signal N6022 : STD_LOGIC; 
  signal N6023 : STD_LOGIC; 
  signal N6024 : STD_LOGIC; 
  signal N6025 : STD_LOGIC; 
  signal N6026 : STD_LOGIC; 
  signal N6027 : STD_LOGIC; 
  signal N6028 : STD_LOGIC; 
  signal N6029 : STD_LOGIC; 
  signal N6030 : STD_LOGIC; 
  signal N6031 : STD_LOGIC; 
  signal N6032 : STD_LOGIC; 
  signal N6033 : STD_LOGIC; 
  signal N6034 : STD_LOGIC; 
  signal N6035 : STD_LOGIC; 
  signal N6036 : STD_LOGIC; 
  signal N6037 : STD_LOGIC; 
  signal N6038 : STD_LOGIC; 
  signal N6039 : STD_LOGIC; 
  signal N6040 : STD_LOGIC; 
  signal N6041 : STD_LOGIC; 
  signal N6042 : STD_LOGIC; 
  signal N6043 : STD_LOGIC; 
  signal N6044 : STD_LOGIC; 
  signal N6045 : STD_LOGIC; 
  signal N6046 : STD_LOGIC; 
  signal N6047 : STD_LOGIC; 
  signal N6048 : STD_LOGIC; 
  signal N6049 : STD_LOGIC; 
  signal N6050 : STD_LOGIC; 
  signal N6051 : STD_LOGIC; 
  signal N6052 : STD_LOGIC; 
  signal N6053 : STD_LOGIC; 
  signal N6054 : STD_LOGIC; 
  signal N6055 : STD_LOGIC; 
  signal N6056 : STD_LOGIC; 
  signal N6057 : STD_LOGIC; 
  signal N6058 : STD_LOGIC; 
  signal N6059 : STD_LOGIC; 
  signal N6060 : STD_LOGIC; 
  signal N6061 : STD_LOGIC; 
  signal N6062 : STD_LOGIC; 
  signal N6063 : STD_LOGIC; 
  signal N6064 : STD_LOGIC; 
  signal N6065 : STD_LOGIC; 
  signal N6066 : STD_LOGIC; 
  signal N6067 : STD_LOGIC; 
  signal N6068 : STD_LOGIC; 
  signal N6069 : STD_LOGIC; 
  signal N6070 : STD_LOGIC; 
  signal N6071 : STD_LOGIC; 
  signal N6072 : STD_LOGIC; 
  signal N6073 : STD_LOGIC; 
  signal N6074 : STD_LOGIC; 
  signal N6075 : STD_LOGIC; 
  signal N6076 : STD_LOGIC; 
  signal N6077 : STD_LOGIC; 
  signal N6078 : STD_LOGIC; 
  signal N6079 : STD_LOGIC; 
  signal N6080 : STD_LOGIC; 
  signal N6081 : STD_LOGIC; 
  signal N6082 : STD_LOGIC; 
  signal N6083 : STD_LOGIC; 
  signal N6084 : STD_LOGIC; 
  signal N6085 : STD_LOGIC; 
  signal N6086 : STD_LOGIC; 
  signal N6087 : STD_LOGIC; 
  signal N6088 : STD_LOGIC; 
  signal N6089 : STD_LOGIC; 
  signal N6090 : STD_LOGIC; 
  signal N6091 : STD_LOGIC; 
  signal N6092 : STD_LOGIC; 
  signal N6093 : STD_LOGIC; 
  signal N6094 : STD_LOGIC; 
  signal N6095 : STD_LOGIC; 
  signal N6096 : STD_LOGIC; 
  signal N6097 : STD_LOGIC; 
  signal N6098 : STD_LOGIC; 
  signal N6099 : STD_LOGIC; 
  signal N6100 : STD_LOGIC; 
  signal N6101 : STD_LOGIC; 
  signal N6102 : STD_LOGIC; 
  signal N6103 : STD_LOGIC; 
  signal N6104 : STD_LOGIC; 
  signal N6105 : STD_LOGIC; 
  signal N6106 : STD_LOGIC; 
  signal N6107 : STD_LOGIC; 
  signal N6108 : STD_LOGIC; 
  signal N6109 : STD_LOGIC; 
  signal N6110 : STD_LOGIC; 
  signal N6111 : STD_LOGIC; 
  signal N6112 : STD_LOGIC; 
  signal N6113 : STD_LOGIC; 
  signal N6114 : STD_LOGIC; 
  signal N6115 : STD_LOGIC; 
  signal N6116 : STD_LOGIC; 
  signal N6117 : STD_LOGIC; 
  signal N6118 : STD_LOGIC; 
  signal N6119 : STD_LOGIC; 
  signal N6120 : STD_LOGIC; 
  signal N6121 : STD_LOGIC; 
  signal N6122 : STD_LOGIC; 
  signal N6123 : STD_LOGIC; 
  signal N6124 : STD_LOGIC; 
  signal N6125 : STD_LOGIC; 
  signal N6126 : STD_LOGIC; 
  signal N6127 : STD_LOGIC; 
  signal N6128 : STD_LOGIC; 
  signal N6129 : STD_LOGIC; 
  signal N6130 : STD_LOGIC; 
  signal N6131 : STD_LOGIC; 
  signal N6132 : STD_LOGIC; 
  signal N6133 : STD_LOGIC; 
  signal N6134 : STD_LOGIC; 
  signal N6135 : STD_LOGIC; 
  signal N6136 : STD_LOGIC; 
  signal N6137 : STD_LOGIC; 
  signal N6138 : STD_LOGIC; 
  signal N6139 : STD_LOGIC; 
  signal N6140 : STD_LOGIC; 
  signal N6141 : STD_LOGIC; 
  signal N6142 : STD_LOGIC; 
  signal N6143 : STD_LOGIC; 
  signal N6144 : STD_LOGIC; 
  signal N6145 : STD_LOGIC; 
  signal N6146 : STD_LOGIC; 
  signal N6147 : STD_LOGIC; 
  signal N6148 : STD_LOGIC; 
  signal N6149 : STD_LOGIC; 
  signal N6150 : STD_LOGIC; 
  signal N6151 : STD_LOGIC; 
  signal N6152 : STD_LOGIC; 
  signal N6153 : STD_LOGIC; 
  signal N6154 : STD_LOGIC; 
  signal N6155 : STD_LOGIC; 
  signal N6156 : STD_LOGIC; 
  signal N6157 : STD_LOGIC; 
  signal N6158 : STD_LOGIC; 
  signal N6159 : STD_LOGIC; 
  signal N6160 : STD_LOGIC; 
  signal N6161 : STD_LOGIC; 
  signal N6162 : STD_LOGIC; 
  signal N6163 : STD_LOGIC; 
  signal N6164 : STD_LOGIC; 
  signal N6165 : STD_LOGIC; 
  signal N6166 : STD_LOGIC; 
  signal N6167 : STD_LOGIC; 
  signal N6168 : STD_LOGIC; 
  signal N6169 : STD_LOGIC; 
  signal N6170 : STD_LOGIC; 
  signal N6171 : STD_LOGIC; 
  signal N6172 : STD_LOGIC; 
  signal N6173 : STD_LOGIC; 
  signal N6174 : STD_LOGIC; 
  signal N6175 : STD_LOGIC; 
  signal N6176 : STD_LOGIC; 
  signal N6177 : STD_LOGIC; 
  signal N6178 : STD_LOGIC; 
  signal N6179 : STD_LOGIC; 
  signal N6180 : STD_LOGIC; 
  signal N6181 : STD_LOGIC; 
  signal N6182 : STD_LOGIC; 
  signal N6183 : STD_LOGIC; 
  signal N6184 : STD_LOGIC; 
  signal N6185 : STD_LOGIC; 
  signal N6186 : STD_LOGIC; 
  signal N6187 : STD_LOGIC; 
  signal N6188 : STD_LOGIC; 
  signal N6189 : STD_LOGIC; 
  signal N6190 : STD_LOGIC; 
  signal N6191 : STD_LOGIC; 
  signal N6192 : STD_LOGIC; 
  signal N6193 : STD_LOGIC; 
  signal N6194 : STD_LOGIC; 
  signal N6195 : STD_LOGIC; 
  signal N6196 : STD_LOGIC; 
  signal N6197 : STD_LOGIC; 
  signal N6198 : STD_LOGIC; 
  signal N6199 : STD_LOGIC; 
  signal N6200 : STD_LOGIC; 
  signal N6201 : STD_LOGIC; 
  signal N6202 : STD_LOGIC; 
  signal N6203 : STD_LOGIC; 
  signal N6204 : STD_LOGIC; 
  signal N6205 : STD_LOGIC; 
  signal N6206 : STD_LOGIC; 
  signal N6207 : STD_LOGIC; 
  signal N6208 : STD_LOGIC; 
  signal N6209 : STD_LOGIC; 
  signal N6210 : STD_LOGIC; 
  signal N6211 : STD_LOGIC; 
  signal N6212 : STD_LOGIC; 
  signal N6213 : STD_LOGIC; 
  signal N6214 : STD_LOGIC; 
  signal N6215 : STD_LOGIC; 
  signal N6216 : STD_LOGIC; 
  signal N6217 : STD_LOGIC; 
  signal N6218 : STD_LOGIC; 
  signal N6219 : STD_LOGIC; 
  signal N6220 : STD_LOGIC; 
  signal N6221 : STD_LOGIC; 
  signal N6222 : STD_LOGIC; 
  signal N6223 : STD_LOGIC; 
  signal N6224 : STD_LOGIC; 
  signal N6225 : STD_LOGIC; 
  signal N6226 : STD_LOGIC; 
  signal N6227 : STD_LOGIC; 
  signal N6228 : STD_LOGIC; 
  signal N6229 : STD_LOGIC; 
  signal N6230 : STD_LOGIC; 
  signal N6231 : STD_LOGIC; 
  signal N6232 : STD_LOGIC; 
  signal N6233 : STD_LOGIC; 
  signal N6234 : STD_LOGIC; 
  signal N6235 : STD_LOGIC; 
  signal N6236 : STD_LOGIC; 
  signal N6237 : STD_LOGIC; 
  signal N6238 : STD_LOGIC; 
  signal N6239 : STD_LOGIC; 
  signal N6240 : STD_LOGIC; 
  signal N6241 : STD_LOGIC; 
  signal N6242 : STD_LOGIC; 
  signal N6243 : STD_LOGIC; 
  signal N6244 : STD_LOGIC; 
  signal N6245 : STD_LOGIC; 
  signal N6246 : STD_LOGIC; 
  signal N6247 : STD_LOGIC; 
  signal N6248 : STD_LOGIC; 
  signal N6249 : STD_LOGIC; 
  signal N6250 : STD_LOGIC; 
  signal N6251 : STD_LOGIC; 
  signal N6252 : STD_LOGIC; 
  signal N6253 : STD_LOGIC; 
  signal N6254 : STD_LOGIC; 
  signal N6255 : STD_LOGIC; 
  signal N6256 : STD_LOGIC; 
  signal N6257 : STD_LOGIC; 
  signal N6258 : STD_LOGIC; 
  signal N6259 : STD_LOGIC; 
  signal N6260 : STD_LOGIC; 
  signal N6261 : STD_LOGIC; 
  signal N6262 : STD_LOGIC; 
  signal N6263 : STD_LOGIC; 
  signal N6264 : STD_LOGIC; 
  signal N6265 : STD_LOGIC; 
  signal N6266 : STD_LOGIC; 
  signal N6267 : STD_LOGIC; 
  signal N6268 : STD_LOGIC; 
  signal N6269 : STD_LOGIC; 
  signal N6270 : STD_LOGIC; 
  signal N6271 : STD_LOGIC; 
  signal N6272 : STD_LOGIC; 
  signal N6273 : STD_LOGIC; 
  signal N6274 : STD_LOGIC; 
  signal N6275 : STD_LOGIC; 
  signal N6276 : STD_LOGIC; 
  signal N6277 : STD_LOGIC; 
  signal N6278 : STD_LOGIC; 
  signal N6279 : STD_LOGIC; 
  signal N6280 : STD_LOGIC; 
  signal N6281 : STD_LOGIC; 
  signal N6282 : STD_LOGIC; 
  signal N6283 : STD_LOGIC; 
  signal N6284 : STD_LOGIC; 
  signal N6285 : STD_LOGIC; 
  signal N6286 : STD_LOGIC; 
  signal N6287 : STD_LOGIC; 
  signal N6288 : STD_LOGIC; 
  signal N6289 : STD_LOGIC; 
  signal N6290 : STD_LOGIC; 
  signal N6291 : STD_LOGIC; 
  signal N6292 : STD_LOGIC; 
  signal N6293 : STD_LOGIC; 
  signal N6294 : STD_LOGIC; 
  signal N6295 : STD_LOGIC; 
  signal N6296 : STD_LOGIC; 
  signal N6297 : STD_LOGIC; 
  signal N6298 : STD_LOGIC; 
  signal N6299 : STD_LOGIC; 
  signal N6300 : STD_LOGIC; 
  signal N6301 : STD_LOGIC; 
  signal N6302 : STD_LOGIC; 
  signal N6303 : STD_LOGIC; 
  signal N6304 : STD_LOGIC; 
  signal N6305 : STD_LOGIC; 
  signal N6306 : STD_LOGIC; 
  signal N6307 : STD_LOGIC; 
  signal N6308 : STD_LOGIC; 
  signal N6309 : STD_LOGIC; 
  signal N6310 : STD_LOGIC; 
  signal N6311 : STD_LOGIC; 
  signal N6312 : STD_LOGIC; 
  signal N6313 : STD_LOGIC; 
  signal N6314 : STD_LOGIC; 
  signal N6315 : STD_LOGIC; 
  signal N6316 : STD_LOGIC; 
  signal N6317 : STD_LOGIC; 
  signal N6318 : STD_LOGIC; 
  signal N6319 : STD_LOGIC; 
  signal N6320 : STD_LOGIC; 
  signal N6321 : STD_LOGIC; 
  signal N6322 : STD_LOGIC; 
  signal N6323 : STD_LOGIC; 
  signal N6324 : STD_LOGIC; 
  signal N6325 : STD_LOGIC; 
  signal N6326 : STD_LOGIC; 
  signal N6327 : STD_LOGIC; 
  signal N6328 : STD_LOGIC; 
  signal N6329 : STD_LOGIC; 
  signal N6330 : STD_LOGIC; 
  signal N6331 : STD_LOGIC; 
  signal N6332 : STD_LOGIC; 
  signal N6333 : STD_LOGIC; 
  signal N6334 : STD_LOGIC; 
  signal N6335 : STD_LOGIC; 
  signal N6336 : STD_LOGIC; 
  signal N6337 : STD_LOGIC; 
  signal N6338 : STD_LOGIC; 
  signal N6339 : STD_LOGIC; 
  signal N6340 : STD_LOGIC; 
  signal N6341 : STD_LOGIC; 
  signal N6342 : STD_LOGIC; 
  signal N6343 : STD_LOGIC; 
  signal N6344 : STD_LOGIC; 
  signal N6345 : STD_LOGIC; 
  signal N6346 : STD_LOGIC; 
  signal N6347 : STD_LOGIC; 
  signal N6348 : STD_LOGIC; 
  signal N6349 : STD_LOGIC; 
  signal N6350 : STD_LOGIC; 
  signal N6351 : STD_LOGIC; 
  signal N6352 : STD_LOGIC; 
  signal N6353 : STD_LOGIC; 
  signal N6354 : STD_LOGIC; 
  signal N6355 : STD_LOGIC; 
  signal N6356 : STD_LOGIC; 
  signal N6357 : STD_LOGIC; 
  signal a_Ker1511_G_O : STD_LOGIC; 
  signal a_Ker1711_G_O : STD_LOGIC; 
  signal XNor_stagelut28_O : STD_LOGIC; 
  signal a_Ker41_G_O : STD_LOGIC; 
  signal a_Ker1611_G_O : STD_LOGIC; 
  signal a_Ker1311_G_O : STD_LOGIC; 
  signal a_Ker5211_G_O : STD_LOGIC; 
  signal XNor_stagelut30_O : STD_LOGIC; 
  signal XNor_stagelut60_O : STD_LOGIC; 
  signal XNor_stagelut29_O : STD_LOGIC; 
  signal XNor_stagelut27_O : STD_LOGIC; 
  signal XNor_stagelut26_O : STD_LOGIC; 
  signal XNor_stagelut25_O : STD_LOGIC; 
  signal XNor_stagelut24_O : STD_LOGIC; 
  signal XNor_stagelut23_O : STD_LOGIC; 
  signal XNor_stagelut22_O : STD_LOGIC; 
  signal a_Ker5011_G_O : STD_LOGIC; 
  signal XNor_stagelut20_O : STD_LOGIC; 
  signal XNor_stagelut19_O : STD_LOGIC; 
  signal XNor_stagelut18_O : STD_LOGIC; 
  signal XNor_stagelut17_O : STD_LOGIC; 
  signal XNor_stagelut16_O : STD_LOGIC; 
  signal XNor_stagelut15_O : STD_LOGIC; 
  signal XNor_stagelut14_O : STD_LOGIC; 
  signal h_n00001_O : STD_LOGIC; 
  signal XNor_stagelut11_O : STD_LOGIC; 
  signal XNor_stagelut10_O : STD_LOGIC; 
  signal XNor_stagelut9_O : STD_LOGIC; 
  signal XNor_stagelut8_O : STD_LOGIC; 
  signal XNor_stagelut7_O : STD_LOGIC; 
  signal XNor_stagelut6_O : STD_LOGIC; 
  signal XNor_stagelut5_O : STD_LOGIC; 
  signal XNor_stagelut4_O : STD_LOGIC; 
  signal XNor_stagelut3_O : STD_LOGIC; 
  signal XNor_stagelut2_O : STD_LOGIC; 
  signal XNor_stagelut1_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_45_1_G_O : STD_LOGIC; 
  signal XNor_stagelut31_O : STD_LOGIC; 
  signal GE_stagelut1_O : STD_LOGIC; 
  signal XNor_stagelut61_O : STD_LOGIC; 
  signal XNor_stagelut59_O : STD_LOGIC; 
  signal a_get_word_17_104_O : STD_LOGIC; 
  signal XNor_stagelut12_O : STD_LOGIC; 
  signal a_Ker96_G_O : STD_LOGIC; 
  signal XNor_stagelut58_O : STD_LOGIC; 
  signal XNor_stagelut13_O : STD_LOGIC; 
  signal XNor_stagelut_O : STD_LOGIC; 
  signal XNor_stagelut32_O : STD_LOGIC; 
  signal XNor_stagelut33_O : STD_LOGIC; 
  signal XNor_stagelut34_O : STD_LOGIC; 
  signal XNor_stagelut35_O : STD_LOGIC; 
  signal XNor_stagelut36_O : STD_LOGIC; 
  signal XNor_stagelut37_O : STD_LOGIC; 
  signal XNor_stagelut38_O : STD_LOGIC; 
  signal XNor_stagelut39_O : STD_LOGIC; 
  signal XNor_stagelut40_O : STD_LOGIC; 
  signal XNor_stagelut41_O : STD_LOGIC; 
  signal XNor_stagelut42_O : STD_LOGIC; 
  signal XNor_stagelut43_O : STD_LOGIC; 
  signal XNor_stagelut44_O : STD_LOGIC; 
  signal XNor_stagelut45_O : STD_LOGIC; 
  signal XNor_stagelut46_O : STD_LOGIC; 
  signal XNor_stagelut47_O : STD_LOGIC; 
  signal XNor_stagelut48_O : STD_LOGIC; 
  signal XNor_stagelut49_O : STD_LOGIC; 
  signal XNor_stagelut50_O : STD_LOGIC; 
  signal XNor_stagelut51_O : STD_LOGIC; 
  signal XNor_stagelut52_O : STD_LOGIC; 
  signal XNor_stagelut53_O : STD_LOGIC; 
  signal XNor_stagelut54_O : STD_LOGIC; 
  signal XNor_stagelut55_O : STD_LOGIC; 
  signal XNor_stagelut56_O : STD_LOGIC; 
  signal XNor_stagelut57_O : STD_LOGIC; 
  signal s_get_right_word_0_1_SW1_O : STD_LOGIC; 
  signal a_get_word_0_2861_G_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_6_SW01_G_O : STD_LOGIC; 
  signal a_get_word_0_641_G_O : STD_LOGIC; 
  signal s_get_right_word_7_1_SW1_O : STD_LOGIC; 
  signal a_Ker17811_G_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_60_1_G_O : STD_LOGIC; 
  signal a_Ker18011_G_O : STD_LOGIC; 
  signal a_Ker5411_G_O : STD_LOGIC; 
  signal s_get_right_word_8_1_SW1_O : STD_LOGIC; 
  signal a_get_word_1_941_G_O : STD_LOGIC; 
  signal a_Ker811_G_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_26_11_G_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_5_1_G_O : STD_LOGIC; 
  signal a_Ker2511_G_O : STD_LOGIC; 
  signal a_Ker12311_G_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_47_1_G_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_28_11_G_O : STD_LOGIC; 
  signal a_Ker5111_G_O : STD_LOGIC; 
  signal a_Ker4911_G_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_46_1_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_1_1_SW0_O : STD_LOGIC; 
  signal a_Ker5311_G_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_25_11_G_O : STD_LOGIC; 
  signal a_alu_n0000_0_lut_O : STD_LOGIC; 
  signal a_alu_n0000_1_lut_O : STD_LOGIC; 
  signal a_alu_n0000_2_lut_O : STD_LOGIC; 
  signal a_alu_n0000_3_lut_O : STD_LOGIC; 
  signal a_alu_n0000_4_lut_O : STD_LOGIC; 
  signal a_alu_n0000_5_lut_O : STD_LOGIC; 
  signal a_alu_n0000_6_lut_O : STD_LOGIC; 
  signal a_alu_n0000_7_lut_O : STD_LOGIC; 
  signal a_alu_n0000_8_lut_O : STD_LOGIC; 
  signal a_alu_n0000_9_lut_O : STD_LOGIC; 
  signal a_alu_n0000_10_lut_O : STD_LOGIC; 
  signal a_alu_n0000_11_lut_O : STD_LOGIC; 
  signal a_alu_n0000_12_lut_O : STD_LOGIC; 
  signal a_alu_n0000_13_lut_O : STD_LOGIC; 
  signal a_alu_n0000_14_lut_O : STD_LOGIC; 
  signal a_alu_n0000_15_lut_O : STD_LOGIC; 
  signal a_alu_n0000_16_lut_O : STD_LOGIC; 
  signal a_alu_n0000_17_lut_O : STD_LOGIC; 
  signal a_alu_n0000_18_lut_O : STD_LOGIC; 
  signal a_alu_n0000_19_lut_O : STD_LOGIC; 
  signal a_alu_n0000_20_lut_O : STD_LOGIC; 
  signal a_alu_n0000_21_lut_O : STD_LOGIC; 
  signal a_alu_n0000_22_lut_O : STD_LOGIC; 
  signal a_alu_n0000_23_lut_O : STD_LOGIC; 
  signal a_alu_n0000_24_lut_O : STD_LOGIC; 
  signal a_alu_n0000_25_lut_O : STD_LOGIC; 
  signal a_alu_n0000_26_lut_O : STD_LOGIC; 
  signal a_alu_n0000_27_lut_O : STD_LOGIC; 
  signal a_alu_n0000_28_lut_O : STD_LOGIC; 
  signal a_alu_n0000_29_lut_O : STD_LOGIC; 
  signal a_alu_n0000_30_lut_O : STD_LOGIC; 
  signal a_alu_n0000_31_lut_O : STD_LOGIC; 
  signal a_get_word_19_681_G_O : STD_LOGIC; 
  signal a_get_word_28_621_G_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_27_11_G_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_44_SW2_G_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_7_SW01_G_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_30_11_G_O : STD_LOGIC; 
  signal a_get_word_7_611_G_O : STD_LOGIC; 
  signal a_Ker18311_G_O : STD_LOGIC; 
  signal a_get_word_5_1311_G_O : STD_LOGIC; 
  signal a_get_word_0_1241_G_O : STD_LOGIC; 
  signal a_get_word_21_921_G_O : STD_LOGIC; 
  signal a_Ker4811_G_O : STD_LOGIC; 
  signal a_get_word_2_1321_G_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_29_11_G_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_43_1_G_O : STD_LOGIC; 
  signal a_Ker2111_G_O : STD_LOGIC; 
  signal a_Ker2011_G_O : STD_LOGIC; 
  signal a_Ker1911_G_O : STD_LOGIC; 
  signal a_Ker1421_G_O : STD_LOGIC; 
  signal a_Ker4611_G_O : STD_LOGIC; 
  signal s_get_right_word_1_1_SW1_O : STD_LOGIC; 
  signal a_Ker5711_G_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_40_rn_0111_G_O : STD_LOGIC; 
  signal h_response_1_1111_G_O : STD_LOGIC; 
  signal a_Ker5511_G_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_23_11_G_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_58_G_O : STD_LOGIC; 
  signal a_get_word_16_721_G_O : STD_LOGIC; 
  signal a_get_word_7_215_SW11_G_O : STD_LOGIC; 
  signal s_get_right_word_9_1_SW1_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_57_G_O : STD_LOGIC; 
  signal a_get_word_18_138_SW11_G_O : STD_LOGIC; 
  signal a_get_word_6_1331_G_O : STD_LOGIC; 
  signal a_get_word_15_561_G_O : STD_LOGIC; 
  signal a_get_word_16_160_SW11_G_O : STD_LOGIC; 
  signal a_get_word_17_150_SW11_G_O : STD_LOGIC; 
  signal a_Ker11511_G_O : STD_LOGIC; 
  signal a_get_word_7_150_SW11_G_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_4_11_G_O : STD_LOGIC; 
  signal a_get_word_8_611_G_O : STD_LOGIC; 
  signal a_get_word_18_681_G_O : STD_LOGIC; 
  signal a_Ker1441_G_O : STD_LOGIC; 
  signal a_get_word_18_138_SW0_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_42_SW01_G_O : STD_LOGIC; 
  signal a_get_word_23_5_SW1_O : STD_LOGIC; 
  signal a_get_word_4_1331_G_O : STD_LOGIC; 
  signal s_get_right_word_2_1_SW1_O : STD_LOGIC; 
  signal a_get_word_19_138_SW11_G_O : STD_LOGIC; 
  signal a_get_word_31_1401_G_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_46_SW21_G_O : STD_LOGIC; 
  signal a_get_word_31_82_O : STD_LOGIC; 
  signal a_get_word_28_141_SW1_SW0_O : STD_LOGIC; 
  signal a_get_word_21_64_SW0_O : STD_LOGIC; 
  signal a_get_word_1_1471_G_O : STD_LOGIC; 
  signal s_get_right_word_3_1_SW1_O : STD_LOGIC; 
  signal a_Ker1411_G_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_3_291_G_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_59_1_G_O : STD_LOGIC; 
  signal s_put_address_4_SW2_O : STD_LOGIC; 
  signal Ker23_SW1_O : STD_LOGIC; 
  signal a_get_word_13_92_SW01_G_O : STD_LOGIC; 
  signal a_Ker2211_G_O : STD_LOGIC; 
  signal a_get_word_17_83_G_O : STD_LOGIC; 
  signal a_Ker1821_G_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_4_1_G_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_2_SW01_G_O : STD_LOGIC; 
  signal s_get_left_word_3_1_SW0_O : STD_LOGIC; 
  signal a_get_word_30_48_G_O : STD_LOGIC; 
  signal a_Ker18229_G_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_55_29_G_O : STD_LOGIC; 
  signal s_get_right_word_6_1_SW1_O : STD_LOGIC; 
  signal a_put_right_word_0_SW0_SW1_O : STD_LOGIC; 
  signal a_get_word_16_93_G_O : STD_LOGIC; 
  signal a_put_right_word_8_SW0_SW1_O : STD_LOGIC; 
  signal a_put_right_word_7_SW0_SW1_O : STD_LOGIC; 
  signal s_get_right_word_11_1_SW1_O : STD_LOGIC; 
  signal s_get_right_word_12_1_SW1_O : STD_LOGIC; 
  signal s_get_right_word_13_1_SW1_O : STD_LOGIC; 
  signal a_get_word_13_155_SW0_G_O : STD_LOGIC; 
  signal s_get_right_word_15_1_SW1_O : STD_LOGIC; 
  signal s_get_right_word_14_1_SW1_O : STD_LOGIC; 
  signal a_put_right_word_15_SW0_SW1_O : STD_LOGIC; 
  signal a_Ker621_G_O : STD_LOGIC; 
  signal a_put_right_word_13_SW0_SW1_O : STD_LOGIC; 
  signal a_put_right_word_16_SW1_O : STD_LOGIC; 
  signal a_get_word_14_196_SW0_O : STD_LOGIC; 
  signal a_put_right_word_9_SW0_SW1_O : STD_LOGIC; 
  signal a_get_word_30_202_O : STD_LOGIC; 
  signal a_get_word_21_140_O : STD_LOGIC; 
  signal a_put_right_word_12_SW0_SW0_O : STD_LOGIC; 
  signal a_Ker85_G_O : STD_LOGIC; 
  signal a_get_word_31_110_G_O : STD_LOGIC; 
  signal a_get_word_14_135_O : STD_LOGIC; 
  signal a_Ker21_G_O : STD_LOGIC; 
  signal a_Ker25529_G_O : STD_LOGIC; 
  signal a_Ker611_G_O : STD_LOGIC; 
  signal a_get_word_29_202_O : STD_LOGIC; 
  signal a_get_word_24_152_O : STD_LOGIC; 
  signal s_right_conflict_Sclr_INV23_O : STD_LOGIC; 
  signal a_Ker25629_G_O : STD_LOGIC; 
  signal a_Ker581_G_O : STD_LOGIC; 
  signal a_get_word_23_161_O : STD_LOGIC; 
  signal a_get_word_22_21_O : STD_LOGIC; 
  signal a_get_word_26_52_O : STD_LOGIC; 
  signal a_get_word_16_258_SW0_O : STD_LOGIC; 
  signal a_get_word_22_34_O : STD_LOGIC; 
  signal a_put_right_word_16_SW3_SW0_O : STD_LOGIC; 
  signal a_get_word_20_34_O : STD_LOGIC; 
  signal a_Ker91_G_O : STD_LOGIC; 
  signal a_get_word_29_48_G_O : STD_LOGIC; 
  signal a_get_word_20_214_SW0_O : STD_LOGIC; 
  signal a_Ker61_G_O : STD_LOGIC; 
  signal a_get_word_24_8_O : STD_LOGIC; 
  signal a_Ker82_G_O : STD_LOGIC; 
  signal a_get_word_12_173_G_O : STD_LOGIC; 
  signal a_Ker11_G_O : STD_LOGIC; 
  signal a_get_word_26_152_O : STD_LOGIC; 
  signal a_get_word_15_179_SW0_O : STD_LOGIC; 
  signal a_get_word_7_219_SW0_O : STD_LOGIC; 
  signal a_get_word_14_90_O : STD_LOGIC; 
  signal a_get_word_27_143_SW0_O : STD_LOGIC; 
  signal a_get_word_3_187_SW0_O : STD_LOGIC; 
  signal GE_stagelut_O : STD_LOGIC; 
  signal a_get_word_23_61_O : STD_LOGIC; 
  signal a_get_word_30_243_SW0_O : STD_LOGIC; 
  signal a_get_word_28_248_SW0_O : STD_LOGIC; 
  signal a_get_word_27_14_SW0_O : STD_LOGIC; 
  signal a_get_word_24_52_O : STD_LOGIC; 
  signal a_get_word_31_187_SW0_O : STD_LOGIC; 
  signal a_get_word_22_214_SW0_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_41_G_O : STD_LOGIC; 
  signal a_get_word_12_61_O : STD_LOGIC; 
  signal a_get_word_15_155_SW0_O : STD_LOGIC; 
  signal s_left_conflict_Sclr_INV23_O : STD_LOGIC; 
  signal a_get_word_23_38_SW0_O : STD_LOGIC; 
  signal a_get_word_28_207_O : STD_LOGIC; 
  signal a_get_word_25_152_O : STD_LOGIC; 
  signal a_get_word_29_76_O : STD_LOGIC; 
  signal a_get_word_25_8_O : STD_LOGIC; 
  signal a_get_word_25_52_O : STD_LOGIC; 
  signal s_get_right_word_10_1_SW1_O : STD_LOGIC; 
  signal s_get_right_word_5_1_SW1_O : STD_LOGIC; 
  signal a_get_word_26_8_O : STD_LOGIC; 
  signal a_Ker471_G_O : STD_LOGIC; 
  signal a_get_word_29_243_SW0_O : STD_LOGIC; 
  signal a_get_word_21_222_SW1_G_O : STD_LOGIC; 
  signal a_Ker25729_G_O : STD_LOGIC; 
  signal a_get_word_20_21_O : STD_LOGIC; 
  signal a_Ker641_G_O : STD_LOGIC; 
  signal a_Ker31_G_O : STD_LOGIC; 
  signal a_get_word_1_300_SW1_O : STD_LOGIC; 
  signal a_get_word_5_159_O : STD_LOGIC; 
  signal a_get_word_3_156_O : STD_LOGIC; 
  signal a_Ker1161_G_O : STD_LOGIC; 
  signal a_get_word_19_201_O : STD_LOGIC; 
  signal a_get_word_16_220_O : STD_LOGIC; 
  signal a_get_word_8_190_O : STD_LOGIC; 
  signal a_shift_4_1_1_O : STD_LOGIC; 
  signal a_get_word_13_155_SW1_O : STD_LOGIC; 
  signal a_Ker1141_G_O : STD_LOGIC; 
  signal a_get_word_5_29_O : STD_LOGIC; 
  signal a_Ker1261_G_O : STD_LOGIC; 
  signal a_get_word_10_61_O : STD_LOGIC; 
  signal a_get_word_19_71_O : STD_LOGIC; 
  signal a_get_word_9_61_O : STD_LOGIC; 
  signal a_get_word_0_206_O : STD_LOGIC; 
  signal a_get_word_13_67_SW0_O : STD_LOGIC; 
  signal a_get_word_8_46_O : STD_LOGIC; 
  signal a_get_word_11_61_O : STD_LOGIC; 
  signal a_get_word_1_226_O : STD_LOGIC; 
  signal a_put_right_word_3_SW0_SW0_O : STD_LOGIC; 
  signal a_put_right_word_4_SW0_SW0_O : STD_LOGIC; 
  signal a_get_word_2_187_SW0_O : STD_LOGIC; 
  signal a_put_right_word_5_SW0_SW0_O : STD_LOGIC; 
  signal a_put_right_word_6_SW0_SW0_O : STD_LOGIC; 
  signal a_get_word_5_190_SW0_G_O : STD_LOGIC; 
  signal a_get_word_2_156_O : STD_LOGIC; 
  signal a_put_right_word_14_SW0_SW0_O : STD_LOGIC; 
  signal a_get_word_4_176_O : STD_LOGIC; 
  signal a_get_word_31_315_SW0_O : STD_LOGIC; 
  signal h_response_buf_1_G_O : STD_LOGIC; 
  signal a_put_right_word_10_SW0_SW0_O : STD_LOGIC; 
  signal a_get_word_16_90_O : STD_LOGIC; 
  signal a_get_word_7_77_O : STD_LOGIC; 
  signal a_put_right_word_11_SW0_SW0_O : STD_LOGIC; 
  signal a_get_word_18_201_O : STD_LOGIC; 
  signal a_get_word_6_29_O : STD_LOGIC; 
  signal a_get_word_17_210_O : STD_LOGIC; 
  signal a_get_word_9_136_O : STD_LOGIC; 
  signal a_get_word_11_136_O : STD_LOGIC; 
  signal a_get_word_27_114_O : STD_LOGIC; 
  signal a_Ker87_G_O : STD_LOGIC; 
  signal a_get_word_21_222_SW0_G_O : STD_LOGIC; 
  signal a_get_word_21_68_O : STD_LOGIC; 
  signal a_get_word_3_29_O : STD_LOGIC; 
  signal a_put_left_word_0_1_G_O : STD_LOGIC; 
  signal a_get_word_10_190_O : STD_LOGIC; 
  signal a_get_word_16_51_SW0_O : STD_LOGIC; 
  signal a_get_word_11_190_O : STD_LOGIC; 
  signal a_Ker86_G_O : STD_LOGIC; 
  signal s_get_right_word_4_1_SW1_O : STD_LOGIC; 
  signal a_get_word_4_29_O : STD_LOGIC; 
  signal a_get_word_8_136_O : STD_LOGIC; 
  signal a_get_word_9_190_O : STD_LOGIC; 
  signal a_Ker591_G_O : STD_LOGIC; 
  signal a_Ker1941_O : STD_LOGIC; 
  signal a_get_word_6_176_O : STD_LOGIC; 
  signal a_Ker23_SW2_O : STD_LOGIC; 
  signal a_get_word_3_132_O : STD_LOGIC; 
  signal XNor_stagelut21_O : STD_LOGIC; 
  signal a_get_word_0_73_O : STD_LOGIC; 
  signal a_get_word_19_239_SW0_O : STD_LOGIC; 
  signal a_get_word_2_29_O : STD_LOGIC; 
  signal a_Ker601_G_O : STD_LOGIC; 
  signal h_response_buf_1_1_G_O : STD_LOGIC; 
  signal h_response_buf_1_2_G_O : STD_LOGIC; 
  signal Ker24_SW0_O : STD_LOGIC; 
  signal a_shift_1_1_SW0_O : STD_LOGIC; 
  signal a_Ker1131_G_O : STD_LOGIC; 
  signal a_Ker179_G_O : STD_LOGIC; 
  signal a_get_word_17_150_SW0_G_O : STD_LOGIC; 
  signal a_get_word_15_41_O : STD_LOGIC; 
  signal a_Ker1511_F_O : STD_LOGIC; 
  signal a_Ker1711_F_O : STD_LOGIC; 
  signal a_Ker41_F_O : STD_LOGIC; 
  signal a_Ker1611_F_O : STD_LOGIC; 
  signal a_Ker1311_F_O : STD_LOGIC; 
  signal a_Ker5211_F_O : STD_LOGIC; 
  signal a_Ker5011_F_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_45_1_F_O : STD_LOGIC; 
  signal a_Ker96_F_O : STD_LOGIC; 
  signal a_get_word_0_2861_F_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_6_SW01_F_O : STD_LOGIC; 
  signal a_get_word_0_641_F_O : STD_LOGIC; 
  signal a_Ker17811_F_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_60_1_F_O : STD_LOGIC; 
  signal a_Ker18011_F_O : STD_LOGIC; 
  signal a_Ker5411_F_O : STD_LOGIC; 
  signal a_get_word_1_941_F_O : STD_LOGIC; 
  signal a_Ker811_F_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_26_11_F_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_5_1_F_O : STD_LOGIC; 
  signal a_Ker2511_F_O : STD_LOGIC; 
  signal a_Ker12311_F_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_47_1_F_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_28_11_F_O : STD_LOGIC; 
  signal a_Ker5111_F_O : STD_LOGIC; 
  signal a_Ker4911_F_O : STD_LOGIC; 
  signal a_Ker5311_F_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_25_11_F_O : STD_LOGIC; 
  signal a_get_word_19_681_F_O : STD_LOGIC; 
  signal a_get_word_28_621_F_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_27_11_F_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_44_SW2_F_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_7_SW01_F_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_30_11_F_O : STD_LOGIC; 
  signal a_get_word_7_611_F_O : STD_LOGIC; 
  signal a_Ker18311_F_O : STD_LOGIC; 
  signal a_get_word_5_1311_F_O : STD_LOGIC; 
  signal a_get_word_0_1241_F_O : STD_LOGIC; 
  signal a_get_word_21_921_F_O : STD_LOGIC; 
  signal a_Ker4811_F_O : STD_LOGIC; 
  signal a_get_word_2_1321_F_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_29_11_F_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_43_1_F_O : STD_LOGIC; 
  signal a_Ker2111_F_O : STD_LOGIC; 
  signal a_Ker2011_F_O : STD_LOGIC; 
  signal a_Ker1911_F_O : STD_LOGIC; 
  signal a_Ker1421_F_O : STD_LOGIC; 
  signal a_Ker4611_F_O : STD_LOGIC; 
  signal a_Ker5711_F_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_40_rn_0111_F_O : STD_LOGIC; 
  signal h_response_1_1111_F_O : STD_LOGIC; 
  signal a_Ker5511_F_O : STD_LOGIC; 
  signal a_get_word_31_233_SW11_F_O : STD_LOGIC; 
  signal a_get_word_12_90_SW11_F_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_23_11_F_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_58_F_O : STD_LOGIC; 
  signal a_get_word_16_721_F_O : STD_LOGIC; 
  signal a_get_word_7_215_SW11_F_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_57_F_O : STD_LOGIC; 
  signal a_get_word_18_138_SW11_F_O : STD_LOGIC; 
  signal a_get_word_6_1331_F_O : STD_LOGIC; 
  signal a_get_word_15_561_F_O : STD_LOGIC; 
  signal a_get_word_16_160_SW11_F_O : STD_LOGIC; 
  signal a_get_word_17_150_SW11_F_O : STD_LOGIC; 
  signal a_Ker11511_F_O : STD_LOGIC; 
  signal a_get_word_7_150_SW11_F_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_4_11_F_O : STD_LOGIC; 
  signal a_get_word_8_611_F_O : STD_LOGIC; 
  signal a_get_word_18_681_F_O : STD_LOGIC; 
  signal a_Ker1441_F_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_42_SW01_F_O : STD_LOGIC; 
  signal a_get_word_4_1331_F_O : STD_LOGIC; 
  signal a_get_word_19_138_SW11_F_O : STD_LOGIC; 
  signal a_get_word_31_1401_F_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_46_SW21_F_O : STD_LOGIC; 
  signal a_get_word_1_1471_F_O : STD_LOGIC; 
  signal a_Ker1411_F_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_3_291_F_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_59_1_F_O : STD_LOGIC; 
  signal a_get_word_13_92_SW01_F_O : STD_LOGIC; 
  signal a_Ker2211_F_O : STD_LOGIC; 
  signal a_get_word_17_83_F_O : STD_LOGIC; 
  signal a_Ker1821_F_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_4_1_F_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_2_SW01_F_O : STD_LOGIC; 
  signal a_get_word_30_48_F_O : STD_LOGIC; 
  signal a_Ker18229_F_O : STD_LOGIC; 
  signal a_Mshift_n0003_Sh_55_29_F_O : STD_LOGIC; 
  signal a_get_word_16_93_F_O : STD_LOGIC; 
  signal a_get_word_13_155_SW0_F_O : STD_LOGIC; 
  signal a_Ker621_F_O : STD_LOGIC; 
  signal a_Ker85_F_O : STD_LOGIC; 
  signal a_get_word_31_110_F_O : STD_LOGIC; 
  signal a_Ker21_F_O : STD_LOGIC; 
  signal a_Ker25529_F_O : STD_LOGIC; 
  signal a_Ker611_F_O : STD_LOGIC; 
  signal a_Ker25629_F_O : STD_LOGIC; 
  signal a_Ker581_F_O : STD_LOGIC; 
  signal a_Ker91_F_O : STD_LOGIC; 
  signal a_get_word_29_48_F_O : STD_LOGIC; 
  signal a_Ker61_F_O : STD_LOGIC; 
  signal a_Ker82_F_O : STD_LOGIC; 
  signal a_get_word_12_173_F_O : STD_LOGIC; 
  signal a_Ker11_F_O : STD_LOGIC; 
  signal a_Mshift_n0002_Sh_41_F_O : STD_LOGIC; 
  signal a_Ker471_F_O : STD_LOGIC; 
  signal a_get_word_21_222_SW1_F_O : STD_LOGIC; 
  signal a_Ker25729_F_O : STD_LOGIC; 
  signal a_Ker641_F_O : STD_LOGIC; 
  signal a_Ker31_F_O : STD_LOGIC; 
  signal a_Ker1161_F_O : STD_LOGIC; 
  signal a_Ker1141_F_O : STD_LOGIC; 
  signal a_Ker1261_F_O : STD_LOGIC; 
  signal a_get_word_5_190_SW0_F_O : STD_LOGIC; 
  signal h_response_buf_1_F_O : STD_LOGIC; 
  signal a_Ker87_F_O : STD_LOGIC; 
  signal a_get_word_21_222_SW0_F_O : STD_LOGIC; 
  signal a_put_left_word_0_1_F_O : STD_LOGIC; 
  signal a_Ker86_F_O : STD_LOGIC; 
  signal a_Ker591_F_O : STD_LOGIC; 
  signal a_Ker601_F_O : STD_LOGIC; 
  signal h_response_buf_1_1_F_O : STD_LOGIC; 
  signal h_response_buf_1_2_F_O : STD_LOGIC; 
  signal a_Ker1131_F_O : STD_LOGIC; 
  signal a_Ker179_F_O : STD_LOGIC; 
  signal a_get_word_17_150_SW0_F_O : STD_LOGIC; 
  signal CLK_BUFGP_IBUFG : STD_LOGIC; 
  signal GSR : STD_LOGIC; 
  signal GTS : STD_LOGIC; 
  signal IOA_0_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_1_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_2_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_3_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_4_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_10_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_5_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_11_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_6_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_12_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_7_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_13_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_8_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_14_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_9_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_15_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_20_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_16_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_21_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_17_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_22_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_18_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_23_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_19_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_24_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_25_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_30_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_26_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_31_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_27_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_28_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal IOA_29_IOBUF_OBUFT_GTS_AND : STD_LOGIC; 
  signal LED_4_OBUF_GTS_TRI : STD_LOGIC; 
  signal LED_5_OBUF_GTS_TRI : STD_LOGIC; 
  signal LED_7_OBUF_GTS_TRI : STD_LOGIC; 
  signal LED_6_OBUF_GTS_TRI : STD_LOGIC; 
  signal LED_0_OBUF_GTS_TRI : STD_LOGIC; 
  signal BWA_0_OBUF_GTS_TRI : STD_LOGIC; 
  signal LED_2_OBUF_GTS_TRI : STD_LOGIC; 
  signal LED_3_OBUF_GTS_TRI : STD_LOGIC; 
  signal LED_1_OBUF_GTS_TRI : STD_LOGIC; 
  signal BWA_1_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_5_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_4_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_10_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_2_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_6_OBUF_GTS_TRI : STD_LOGIC; 
  signal CEA_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_8_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_15_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_9_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_1_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_3_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_7_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_11_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_17_OBUF_GTS_TRI : STD_LOGIC; 
  signal CEA2X_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_18_OBUF_GTS_TRI : STD_LOGIC; 
  signal CLKMA1_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_12_OBUF_GTS_TRI : STD_LOGIC; 
  signal BWA_2_OBUF_GTS_TRI : STD_LOGIC; 
  signal BWA_3_OBUF_GTS_TRI : STD_LOGIC; 
  signal CELA1X_OBUF_GTS_TRI : STD_LOGIC; 
  signal ADVLDA_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_13_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_14_OBUF_GTS_TRI : STD_LOGIC; 
  signal ZZA_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_16_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_19_OBUF_GTS_TRI : STD_LOGIC; 
  signal AA_0_OBUF_GTS_TRI : STD_LOGIC; 
  signal CLKMA0_OBUF_GTS_TRI : STD_LOGIC; 
  signal CEHA1X_OBUF_GTS_TRI : STD_LOGIC; 
  signal LBOA_OBUF_GTS_TRI : STD_LOGIC; 
  signal XRWA_OBUF_GTS_TRI : STD_LOGIC; 
  signal OEAX_OBUF_GTS_TRI : STD_LOGIC; 
  signal CEA2_OBUF_GTS_TRI : STD_LOGIC; 
  signal VCC : STD_LOGIC; 
  signal GND : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_31_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_30_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_29_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_28_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_27_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_26_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_25_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_24_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_23_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_22_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_21_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_20_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_19_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_18_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_17_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_16_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_15_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_14_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_13_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_12_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_11_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_10_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_9_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_8_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOA_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOPA_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOPA_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOPA_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOPA_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOPB_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOPB_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOPB_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_inst_ramb_0_DOPB_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_31_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_30_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_29_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_28_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_27_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_26_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_25_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_24_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_23_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_22_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_21_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_20_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_19_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_18_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_17_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_16_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_15_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_14_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_13_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_12_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_11_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_10_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_9_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_8_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_7_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_6_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_5_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_4_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOA_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOPA_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOPA_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOPA_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOPA_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOPB_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOPB_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOPB_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_s_Mram_reg_ren_inst_ramb_1_DOPB_0_UNCONNECTED : STD_LOGIC; 
  signal NlwInverterSignal_IOA_0_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_0_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_1_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_1_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_2_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_2_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_3_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_3_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_4_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_4_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_10_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_10_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_5_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_5_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_11_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_11_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_6_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_6_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_12_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_12_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_7_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_7_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_13_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_13_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_8_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_8_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_14_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_14_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_9_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_9_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_15_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_15_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_20_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_20_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_16_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_16_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_21_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_21_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_17_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_17_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_22_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_22_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_18_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_18_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_23_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_23_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_19_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_19_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_24_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_24_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_25_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_25_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_30_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_30_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_26_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_26_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_31_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_31_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_27_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_27_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_28_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_28_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_29_IOBUF_OBUFT_GTS_AND_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_IOA_29_IOBUF_OBUFT_GTS_AND_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_LED_4_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_LED_5_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_LED_7_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_LED_6_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_LED_0_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_BWA_0_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_LED_2_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_LED_3_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_LED_1_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_BWA_1_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_5_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_4_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_10_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_2_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_6_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_CEA_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_8_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_15_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_9_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_1_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_3_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_7_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_11_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_17_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_CEA2X_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_18_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_CLKMA1_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_12_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_BWA_2_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_BWA_3_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_CELA1X_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_ADVLDA_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_13_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_14_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_ZZA_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_16_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_19_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_AA_0_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_CLKMA0_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_CEHA1X_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_LBOA_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_XRWA_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_OEAX_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal NlwInverterSignal_CEA2_OBUF_GTS_TRI_CTL : STD_LOGIC; 
  signal a_put_left_word : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal h_get_address : STD_LOGIC_VECTOR ( 19 downto 0 ); 
  signal a_get_word : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal a_put_right_word : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal h_response_buf : STD_LOGIC_VECTOR ( 1 downto 0 ); 
  signal h_get_word_buf : STD_LOGIC_VECTOR ( 29 downto 0 ); 
  signal h_request : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal h_get_address_buf : STD_LOGIC_VECTOR ( 19 downto 0 ); 
  signal a_funct : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal a_shift : STD_LOGIC_VECTOR ( 4 downto 0 ); 
  signal h_response : STD_LOGIC_VECTOR ( 1 downto 1 ); 
  signal h_put_word_buf : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal s_put_address : STD_LOGIC_VECTOR ( 4 downto 0 ); 
  signal s_get_left_word : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal s_get_right_word : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal h_n0007 : STD_LOGIC_VECTOR ( 19 downto 1 ); 
  signal h_address_buf : STD_LOGIC_VECTOR ( 19 downto 0 ); 
  signal h_response_buf_2 : STD_LOGIC_VECTOR ( 1 downto 0 ); 
  signal h_request_buf : STD_LOGIC_VECTOR ( 1 downto 0 ); 
  signal h_put_address_buf : STD_LOGIC_VECTOR ( 19 downto 0 ); 
  signal h_n0020 : STD_LOGIC_VECTOR ( 1 downto 1 ); 
  signal h_Mtridata_IOA : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal a_n0000 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal s_get_right_word_buf : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal s_get_left_word_buf : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal s_put_word_buf : STD_LOGIC_VECTOR ( 31 downto 0 ); 
begin
  XST_VCC : X_ONE
    port map (
      O => CEA2_OBUF
    );
  LED_0_2 : X_LUT3
    generic map(
      INIT => X"EF"
    )
    port map (
      ADR0 => N80,
      ADR1 => h_get_word_buf(27),
      ADR2 => a_get_word(0),
      O => LED_0_OBUF
    );
  h_get_address_buf_13 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(13),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(13),
      CE => VCC,
      SET => GND
    );
  h_get_address_buf_18 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(18),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(18),
      CE => VCC,
      SET => GND
    );
  XNor_stagecy_rn_27 : X_MUX2
    port map (
      IB => XNor_stage_cyo27,
      IA => s_get_right_word(28),
      SEL => N32,
      O => XNor_stage_cyo28
    );
  a_get_word_3_94 : X_LUT4
    generic map(
      INIT => X"C840"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_shift(3),
      ADR2 => a_N47,
      ADR3 => a_N2,
      O => CHOICE4928
    );
  XST_GND : X_ZERO
    port map (
      O => CEA2X_OBUF
    );
  h_get_address_buf_14 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(14),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(14),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_28_mmx_out_h_get_word_buf_28_mmx_out1 : X_LUT4
    generic map(
      INIT => X"020A"
    )
    port map (
      ADR0 => h_get_word_buf(28),
      ADR1 => h_get_word_buf(27),
      ADR2 => GE_stage_cyo1,
      ADR3 => GE_stage_cyo,
      O => MUX_BLOCK_N1
    );
  h_get_address_buf_15 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(15),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(15),
      CE => VCC,
      SET => GND
    );
  h_get_address_buf_16 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(16),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(16),
      CE => VCC,
      SET => GND
    );
  h_get_address_buf_17 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(17),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(17),
      CE => VCC,
      SET => GND
    );
  XNor_stagecy_rn_28 : X_MUX2
    port map (
      IB => XNor_stage_cyo28,
      IA => s_get_right_word(29),
      SEL => N33,
      O => XNor_stage_cyo29
    );
  a_put_left_word_20_1 : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(20),
      ADR2 => N5122,
      ADR3 => N6342,
      O => a_put_left_word(20)
    );
  LED_5_1 : X_LUT4
    generic map(
      INIT => X"FF75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => h_get_word_buf(26),
      ADR2 => h_get_word_buf(29),
      ADR3 => h_get_word_buf(28),
      O => N80
    );
  s_put_address_4_Q : X_LUT4
    generic map(
      INIT => X"10B0"
    )
    port map (
      ADR0 => h_get_word_buf(29),
      ADR1 => N5815,
      ADR2 => h_response_buf_1,
      ADR3 => N5816,
      O => s_put_address(4)
    );
  h_address_buf_5 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6183,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(5),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  LED_4_2 : X_LUT3
    generic map(
      INIT => X"EF"
    )
    port map (
      ADR0 => N80,
      ADR1 => h_get_word_buf(27),
      ADR2 => a_get_word(4),
      O => LED_4_OBUF
    );
  XNor_stagecy_rn_43 : X_MUX2
    port map (
      IB => XNor_stage_cyo43,
      IA => s_get_left_word(13),
      SEL => N50,
      O => XNor_stage_cyo44
    );
  LED_5_OBUF_3 : X_BUF
    port map (
      I => LED_5_OBUF,
      O => LED_5_OBUF_GTS_TRI
    );
  h_put_address_buf_18_rt_4 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(18),
      O => h_put_address_buf_18_rt,
      ADR1 => GND
    );
  h_XRWA2 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => N90,
      ADR1 => h_get_word_buf(26),
      O => XRWA_OBUF
    );
  h_XRWA1 : X_LUT4
    generic map(
      INIT => X"EFFF"
    )
    port map (
      ADR0 => h_get_word_buf(29),
      ADR1 => h_get_word_buf(28),
      ADR2 => h_get_word_buf(27),
      ADR3 => h_response_buf_1,
      O => N90
    );
  h_n00061_INV_0 : X_INV
    port map (
      I => h_request_buf(0),
      O => h_n0006
    );
  BWA_0_OBUF : X_BUF
    port map (
      I => CEA2X_OBUF,
      O => BWA_0_OBUF_GTS_TRI
    );
  s_get_left_word_15_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(15),
      ADR1 => s_put_word_buf(15),
      ADR2 => Ker21_13,
      ADR3 => s_left_conflict_7,
      O => N5177
    );
  a_put_right_word_0_Q : X_LUT4
    generic map(
      INIT => X"0123"
    )
    port map (
      ADR0 => s_get_right_word_buf(0),
      ADR1 => N121,
      ADR2 => N5266,
      ADR3 => N5267,
      O => a_put_right_word(0)
    );
  a_put_right_word_1_Q : X_LUT4
    generic map(
      INIT => X"0123"
    )
    port map (
      ADR0 => s_get_right_word_buf(1),
      ADR1 => N121,
      ADR2 => N5263,
      ADR3 => N5264,
      O => a_put_right_word(1)
    );
  a_put_right_word_2_Q : X_LUT4
    generic map(
      INIT => X"0123"
    )
    port map (
      ADR0 => s_get_right_word_buf(2),
      ADR1 => N121,
      ADR2 => N5260,
      ADR3 => N5261,
      O => a_put_right_word(2)
    );
  a_put_right_word_3_Q : X_LUT4
    generic map(
      INIT => X"0123"
    )
    port map (
      ADR0 => s_get_right_word_buf(3),
      ADR1 => N121,
      ADR2 => N5257,
      ADR3 => N5258,
      O => a_put_right_word(3)
    );
  a_put_right_word_4_Q : X_LUT4
    generic map(
      INIT => X"0123"
    )
    port map (
      ADR0 => s_get_right_word_buf(4),
      ADR1 => N121,
      ADR2 => N5254,
      ADR3 => N5255,
      O => a_put_right_word(4)
    );
  a_put_right_word_5_Q : X_LUT4
    generic map(
      INIT => X"0123"
    )
    port map (
      ADR0 => s_get_right_word_buf(5),
      ADR1 => N121,
      ADR2 => N5251,
      ADR3 => N5252,
      O => a_put_right_word(5)
    );
  a_put_right_word_6_Q : X_LUT4
    generic map(
      INIT => X"0123"
    )
    port map (
      ADR0 => s_get_right_word_buf(6),
      ADR1 => N121,
      ADR2 => N5332,
      ADR3 => N5333,
      O => a_put_right_word(6)
    );
  a_put_right_word_7_Q : X_LUT4
    generic map(
      INIT => X"0123"
    )
    port map (
      ADR0 => s_get_right_word_buf(7),
      ADR1 => N121,
      ADR2 => N5329,
      ADR3 => N5330,
      O => a_put_right_word(7)
    );
  a_put_right_word_8_Q : X_LUT4
    generic map(
      INIT => X"0123"
    )
    port map (
      ADR0 => s_get_right_word_buf(8),
      ADR1 => N121,
      ADR2 => N5326,
      ADR3 => N5327,
      O => a_put_right_word(8)
    );
  a_put_right_word_9_Q : X_LUT4
    generic map(
      INIT => X"0123"
    )
    port map (
      ADR0 => s_get_right_word_buf(9),
      ADR1 => N121,
      ADR2 => N5323,
      ADR3 => N5324,
      O => a_put_right_word(9)
    );
  a_put_right_word_10_Q : X_LUT4
    generic map(
      INIT => X"0123"
    )
    port map (
      ADR0 => s_get_right_word_buf(10),
      ADR1 => N121,
      ADR2 => N5320,
      ADR3 => N5321,
      O => a_put_right_word(10)
    );
  a_put_right_word_11_Q : X_LUT4
    generic map(
      INIT => X"0123"
    )
    port map (
      ADR0 => s_get_right_word_buf(11),
      ADR1 => N121,
      ADR2 => N5317,
      ADR3 => N5318,
      O => a_put_right_word(11)
    );
  a_put_right_word_12_Q : X_LUT4
    generic map(
      INIT => X"0123"
    )
    port map (
      ADR0 => s_get_right_word_buf(12),
      ADR1 => N121,
      ADR2 => N5314,
      ADR3 => N5315,
      O => a_put_right_word(12)
    );
  a_put_right_word_13_Q : X_LUT4
    generic map(
      INIT => X"0123"
    )
    port map (
      ADR0 => s_get_right_word_buf(13),
      ADR1 => N121,
      ADR2 => N5311,
      ADR3 => N5312,
      O => a_put_right_word(13)
    );
  a_put_right_word_14_Q : X_LUT4
    generic map(
      INIT => X"0123"
    )
    port map (
      ADR0 => s_get_right_word_buf(14),
      ADR1 => N121,
      ADR2 => N5308,
      ADR3 => N5309,
      O => a_put_right_word(14)
    );
  a_put_right_word_15_Q : X_LUT4
    generic map(
      INIT => X"0123"
    )
    port map (
      ADR0 => s_get_right_word_buf(15),
      ADR1 => N121,
      ADR2 => N5305,
      ADR3 => N5306,
      O => a_put_right_word(15)
    );
  a_put_right_word_16_Q : X_LUT4
    generic map(
      INIT => X"FD20"
    )
    port map (
      ADR0 => s_get_right_word(16),
      ADR1 => h_get_word_buf(26),
      ADR2 => N248,
      ADR3 => N247,
      O => a_put_right_word(16)
    );
  a_put_right_word_20_1 : X_LUT4
    generic map(
      INIT => X"FF40"
    )
    port map (
      ADR0 => N121,
      ADR1 => N6252,
      ADR2 => N411,
      ADR3 => N101,
      O => a_put_right_word(20)
    );
  a_get_word_22_2 : X_LUT3
    generic map(
      INIT => X"10"
    )
    port map (
      ADR0 => h_get_word_buf(10),
      ADR1 => N241,
      ADR2 => a_funct(0),
      O => CHOICE4125
    );
  h_address_buf_4 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6182,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(4),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  h_address_buf_1 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6179,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(1),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  a_put_right_word_27_1 : X_LUT4
    generic map(
      INIT => X"FEF4"
    )
    port map (
      ADR0 => s_get_right_word_buf(27),
      ADR1 => N5440,
      ADR2 => N6204,
      ADR3 => N5441,
      O => a_put_right_word(27)
    );
  a_put_right_word_21_1 : X_LUT4
    generic map(
      INIT => X"FF40"
    )
    port map (
      ADR0 => N121,
      ADR1 => N6253,
      ADR2 => N411,
      ADR3 => N101,
      O => a_put_right_word(21)
    );
  LED_4_OBUF_5 : X_BUF
    port map (
      I => LED_4_OBUF,
      O => LED_4_OBUF_GTS_TRI
    );
  LED_7_2 : X_LUT3
    generic map(
      INIT => X"EF"
    )
    port map (
      ADR0 => N80,
      ADR1 => h_get_word_buf(27),
      ADR2 => a_get_word(7),
      O => LED_7_OBUF
    );
  h_address_buf_3 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6181,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(3),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  h_address_buf_2 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6180,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(2),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_address_3_Q : X_LUT4
    generic map(
      INIT => X"10B0"
    )
    port map (
      ADR0 => h_get_word_buf(29),
      ADR1 => N5820,
      ADR2 => h_response_buf_1,
      ADR3 => N5821,
      O => s_put_address(3)
    );
  LED_2_OBUF_6 : X_BUF
    port map (
      I => LED_2_OBUF,
      O => LED_2_OBUF_GTS_TRI
    );
  s_put_address_0_Q : X_LUT4
    generic map(
      INIT => X"10B0"
    )
    port map (
      ADR0 => h_get_word_buf(29),
      ADR1 => N5823,
      ADR2 => h_response_buf_1,
      ADR3 => N5824,
      O => s_put_address(0)
    );
  h_address_buf_10 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6187,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(10),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_25 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6224,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(25),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  h_response_buf_0 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_response_buf_2(0),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_response_buf(0),
      CE => VCC,
      SET => GND
    );
  h_get_address_buf_19 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(19),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(19),
      CE => VCC,
      SET => GND
    );
  s_put_address_1_Q : X_LUT4
    generic map(
      INIT => X"10B0"
    )
    port map (
      ADR0 => h_get_word_buf(29),
      ADR1 => N5826,
      ADR2 => h_response_buf_1,
      ADR3 => N5827,
      O => s_put_address(1)
    );
  s_put_address_2_Q : X_LUT4
    generic map(
      INIT => X"10B0"
    )
    port map (
      ADR0 => h_get_word_buf(29),
      ADR1 => N5829,
      ADR2 => h_response_buf_1,
      ADR3 => N5830,
      O => s_put_address(2)
    );
  h_get_word_buf_29 : X_FF
    generic map(
      INIT => '1'
    )
    port map (
      I => N5032,
      SET => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(29),
      CE => VCC,
      RST => GND
    );
  h_get_word_buf_28 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5031,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(28),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_27 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5030,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(27),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_26 : X_FF
    generic map(
      INIT => '1'
    )
    port map (
      I => N5029,
      SET => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(26),
      CE => VCC,
      RST => GND
    );
  h_get_word_buf_25 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5028,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(25),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_24 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5027,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(24),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_23 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5025,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(23),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_22 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5023,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(22),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_21 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5021,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(21),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_20 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5019,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(20),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_19 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5026,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(19),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_18 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5024,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(18),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_17 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5022,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(17),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_16 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5020,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(16),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_15 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5018,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(15),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_14 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5016,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(14),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_13 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5014,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(13),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_12 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5012,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(12),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_11 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5010,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(11),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_10 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5008,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(10),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_9 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5017,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(9),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_8 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5015,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(8),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_7 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5013,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(7),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_6 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5011,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(6),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_5 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5009,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(5),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_4 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5007,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(4),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_3 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5006,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(3),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_2 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5005,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(2),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_1 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5004,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(1),
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_0 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5003,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf(0),
      CE => VCC,
      SET => GND
    );
  h_get_address_buf_0 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(0),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(0),
      CE => VCC,
      SET => GND
    );
  h_get_address_buf_1 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(1),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(1),
      CE => VCC,
      SET => GND
    );
  h_get_address_buf_2 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(2),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(2),
      CE => VCC,
      SET => GND
    );
  h_get_address_buf_3 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(3),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(3),
      CE => VCC,
      SET => GND
    );
  h_get_address_buf_4 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(4),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(4),
      CE => VCC,
      SET => GND
    );
  h_get_address_buf_5 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(5),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(5),
      CE => VCC,
      SET => GND
    );
  h_get_address_buf_6 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(6),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(6),
      CE => VCC,
      SET => GND
    );
  h_get_address_buf_7 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(7),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(7),
      CE => VCC,
      SET => GND
    );
  h_get_address_buf_8 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(8),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(8),
      CE => VCC,
      SET => GND
    );
  h_get_address_buf_9 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(9),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(9),
      CE => VCC,
      SET => GND
    );
  h_get_address_buf_10 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(10),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(10),
      CE => VCC,
      SET => GND
    );
  h_get_address_buf_11 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(11),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(11),
      CE => VCC,
      SET => GND
    );
  h_get_address_buf_12 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_get_address(12),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_address_buf(12),
      CE => VCC,
      SET => GND
    );
  h_response_buf_1_7 : X_FF
    generic map(
      INIT => '1'
    )
    port map (
      I => h_response(1),
      SET => GSR,
      CLK => CLKMA0_OBUF,
      O => h_response_buf_1,
      CE => VCC,
      RST => GND
    );
  IOA_31_OBUFT : X_TRI
    port map (
      I => h_Mtridata_IOA(31),
      CTL => IOA_31_OBUFT_GTS_AND,
      O => IOA(31)
    );
  GE_stagecy_rn_0 : X_MUX2
    port map (
      IB => XNor_stage_cyo61,
      IA => s_get_right_word(31),
      SEL => N68,
      O => GE_stage_cyo1
    );
  h_address_buf_13 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6177,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(13),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  LED_7_OBUF_8 : X_BUF
    port map (
      I => LED_7_OBUF,
      O => LED_7_OBUF_GTS_TRI
    );
  LED_3_2 : X_LUT3
    generic map(
      INIT => X"EF"
    )
    port map (
      ADR0 => N80,
      ADR1 => h_get_word_buf(27),
      ADR2 => a_get_word(3),
      O => LED_3_OBUF
    );
  LED_2_2 : X_LUT3
    generic map(
      INIT => X"EF"
    )
    port map (
      ADR0 => N80,
      ADR1 => h_get_word_buf(27),
      ADR2 => a_get_word(2),
      O => LED_2_OBUF
    );
  LED_3_OBUF_9 : X_BUF
    port map (
      I => LED_3_OBUF,
      O => LED_3_OBUF_GTS_TRI
    );
  LED_6_2 : X_LUT3
    generic map(
      INIT => X"EF"
    )
    port map (
      ADR0 => N80,
      ADR1 => h_get_word_buf(27),
      ADR2 => a_get_word(6),
      O => LED_6_OBUF
    );
  a_Ker1951 : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_Mshift_n0003_Sh_60_Q,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => N6214,
      O => a_N195
    );
  LED_6_OBUF_10 : X_BUF
    port map (
      I => LED_6_OBUF,
      O => LED_6_OBUF_GTS_TRI
    );
  h_put_address_buf_19 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6190,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(19),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_31 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6286,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(31),
      SET => GND,
      RST => GSR
    );
  h_response_buf_1_11 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_n0020(1),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_response_buf_2(1),
      SET => GND,
      RST => GSR
    );
  h_address_buf_9 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6178,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(9),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  h_address_buf_19 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_19_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(19),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_31 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(31),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(31),
      SET => GND,
      RST => GSR
    );
  h_get_address_19 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(19),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(19),
      SET => GND,
      RST => GSR
    );
  h_request_buf_0 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_request(0),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_request_buf(0),
      SET => GND,
      RST => GSR
    );
  h_request_buf_1 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_request(1),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_request_buf(1),
      SET => GND,
      RST => GSR
    );
  XNor_stagecy_rn_60 : X_MUX2
    port map (
      IB => XNor_stage_cyo60,
      IA => s_get_left_word(30),
      SEL => N67,
      O => XNor_stage_cyo61
    );
  h_Mtrien_IOA_12 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_n0006,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtrien_IOA,
      SET => GND,
      RST => GSR
    );
  cpu_h_n0007_19_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_18_cyo,
      I1 => h_put_address_buf(19),
      O => h_n0007(19)
    );
  LED_1_OBUF_13 : X_BUF
    port map (
      I => LED_1_OBUF,
      O => LED_1_OBUF_GTS_TRI
    );
  h_address_buf_8 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6186,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(8),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  h_address_buf_7 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6185,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(7),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  XNor_stagecy_rn_59 : X_MUX2
    port map (
      IB => XNor_stage_cyo59,
      IA => s_get_left_word(29),
      SEL => N66,
      O => XNor_stage_cyo60
    );
  XNor_stagecy_rn_58 : X_MUX2
    port map (
      IB => XNor_stage_cyo58,
      IA => s_get_left_word(28),
      SEL => N65,
      O => XNor_stage_cyo59
    );
  XNor_stagecy_rn_57 : X_MUX2
    port map (
      IB => XNor_stage_cyo57,
      IA => s_get_left_word(27),
      SEL => N64,
      O => XNor_stage_cyo58
    );
  XNor_stagecy_rn_56 : X_MUX2
    port map (
      IB => XNor_stage_cyo56,
      IA => s_get_left_word(26),
      SEL => N63,
      O => XNor_stage_cyo57
    );
  XNor_stagecy_rn_55 : X_MUX2
    port map (
      IB => XNor_stage_cyo55,
      IA => s_get_left_word(25),
      SEL => N62,
      O => XNor_stage_cyo56
    );
  XNor_stagecy_rn_54 : X_MUX2
    port map (
      IB => XNor_stage_cyo54,
      IA => s_get_left_word(24),
      SEL => N61,
      O => XNor_stage_cyo55
    );
  XNor_stagecy_rn_53 : X_MUX2
    port map (
      IB => XNor_stage_cyo53,
      IA => s_get_left_word(23),
      SEL => N60,
      O => XNor_stage_cyo54
    );
  XNor_stagecy_rn_52 : X_MUX2
    port map (
      IB => XNor_stage_cyo52,
      IA => s_get_left_word(22),
      SEL => N59,
      O => XNor_stage_cyo53
    );
  XNor_stagecy_rn_51 : X_MUX2
    port map (
      IB => XNor_stage_cyo51,
      IA => s_get_left_word(21),
      SEL => N58,
      O => XNor_stage_cyo52
    );
  XNor_stagecy_rn_50 : X_MUX2
    port map (
      IB => XNor_stage_cyo50,
      IA => s_get_left_word(20),
      SEL => N57,
      O => XNor_stage_cyo51
    );
  XNor_stagecy_rn_49 : X_MUX2
    port map (
      IB => XNor_stage_cyo49,
      IA => s_get_left_word(19),
      SEL => N56,
      O => XNor_stage_cyo50
    );
  XNor_stagecy_rn_48 : X_MUX2
    port map (
      IB => XNor_stage_cyo48,
      IA => s_get_left_word(18),
      SEL => N55,
      O => XNor_stage_cyo49
    );
  XNor_stagecy_rn_47 : X_MUX2
    port map (
      IB => XNor_stage_cyo47,
      IA => s_get_left_word(17),
      SEL => N54,
      O => XNor_stage_cyo48
    );
  XNor_stagecy_rn_46 : X_MUX2
    port map (
      IB => XNor_stage_cyo46,
      IA => s_get_left_word(16),
      SEL => N53,
      O => XNor_stage_cyo47
    );
  XNor_stagecy_rn_45 : X_MUX2
    port map (
      IB => XNor_stage_cyo45,
      IA => s_get_left_word(15),
      SEL => N52,
      O => XNor_stage_cyo46
    );
  LED_5_2 : X_LUT3
    generic map(
      INIT => X"EF"
    )
    port map (
      ADR0 => N80,
      ADR1 => h_get_word_buf(27),
      ADR2 => a_get_word(5),
      O => LED_5_OBUF
    );
  h_address_buf_11 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6188,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(11),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  h_address_buf_12 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6189,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(12),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  IOA_30_OBUFT : X_TRI
    port map (
      I => h_Mtridata_IOA(30),
      CTL => IOA_30_OBUFT_GTS_AND,
      O => IOA(30)
    );
  h_address_buf_15 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6194,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(15),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  h_get_address_0 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(0),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(0),
      SET => GND,
      RST => GSR
    );
  h_get_address_1 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(1),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(1),
      SET => GND,
      RST => GSR
    );
  h_get_address_2 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(2),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(2),
      SET => GND,
      RST => GSR
    );
  h_get_address_3 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(3),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(3),
      SET => GND,
      RST => GSR
    );
  h_get_address_4 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(4),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(4),
      SET => GND,
      RST => GSR
    );
  h_get_address_5 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(5),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(5),
      SET => GND,
      RST => GSR
    );
  h_get_address_6 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(6),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(6),
      SET => GND,
      RST => GSR
    );
  h_get_address_7 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(7),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(7),
      SET => GND,
      RST => GSR
    );
  h_get_address_8 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(8),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(8),
      SET => GND,
      RST => GSR
    );
  h_get_address_9 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(9),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(9),
      SET => GND,
      RST => GSR
    );
  h_get_address_10 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(10),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(10),
      SET => GND,
      RST => GSR
    );
  h_get_address_11 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(11),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(11),
      SET => GND,
      RST => GSR
    );
  h_get_address_12 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(12),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(12),
      SET => GND,
      RST => GSR
    );
  h_get_address_13 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(13),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(13),
      SET => GND,
      RST => GSR
    );
  h_get_address_14 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(14),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(14),
      SET => GND,
      RST => GSR
    );
  h_get_address_15 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(15),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(15),
      SET => GND,
      RST => GSR
    );
  h_get_address_16 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(16),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(16),
      SET => GND,
      RST => GSR
    );
  h_get_address_17 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(17),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(17),
      SET => GND,
      RST => GSR
    );
  h_get_address_18 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_address_buf(18),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_get_address(18),
      SET => GND,
      RST => GSR
    );
  h_address_buf_18 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6191,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(18),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_0 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6309,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(0),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_1 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_1_OBUF,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(1),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_2 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_2_OBUF,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(2),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_3 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_3_OBUF,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(3),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_4 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_4_OBUF,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(4),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_5 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_5_OBUF,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(5),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_6 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6184,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(6),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_7 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_7_OBUF,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(7),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_8 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_8_OBUF,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(8),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_9 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_9_OBUF,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(9),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_10 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_10_OBUF,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(10),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_11 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_11_OBUF,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(11),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_12 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_12_OBUF,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(12),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_13 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_13_OBUF,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(13),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_14 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6195,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(14),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_15 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_15_OBUF,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(15),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_16 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6193,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(16),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_17 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6192,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(17),
      SET => GND,
      RST => GSR
    );
  h_put_address_buf_18 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_18_OBUF,
      CE => N90,
      CLK => CLKMA0_OBUF,
      O => h_put_address_buf(18),
      SET => GND,
      RST => GSR
    );
  h_address_buf_17 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_17_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(17),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_0 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(0),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(0),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_1 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(1),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(1),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_2 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(2),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(2),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_3 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(3),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(3),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_4 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(4),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(4),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_5 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(5),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(5),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_6 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(6),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(6),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_7 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(7),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(7),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_8 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(8),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(8),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_9 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(9),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(9),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_10 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(10),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(10),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_11 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(11),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(11),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_12 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(12),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(12),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_13 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(13),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(13),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_14 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(14),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(14),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_15 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(15),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(15),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_16 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(16),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(16),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_17 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(17),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(17),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_18 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(18),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(18),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_19 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(19),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(19),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_20 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(20),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(20),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_21 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(21),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(21),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_22 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(22),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(22),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_23 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(23),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(23),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_24 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(24),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(24),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_25 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(25),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(25),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_26 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(26),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(26),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_27 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(27),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(27),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_28 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(28),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(28),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_29 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(29),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(29),
      SET => GND,
      RST => GSR
    );
  h_Mtridata_IOA_30 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_put_word_buf(30),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_Mtridata_IOA(30),
      SET => GND,
      RST => GSR
    );
  XNor_stagecy_rn_44 : X_MUX2
    port map (
      IB => XNor_stage_cyo44,
      IA => s_get_left_word(14),
      SEL => N51,
      O => XNor_stage_cyo45
    );
  XNor_stagecy_rn_42 : X_MUX2
    port map (
      IB => XNor_stage_cyo42,
      IA => s_get_left_word(12),
      SEL => N49,
      O => XNor_stage_cyo43
    );
  XNor_stagecy_rn_41 : X_MUX2
    port map (
      IB => XNor_stage_cyo41,
      IA => s_get_left_word(11),
      SEL => N48,
      O => XNor_stage_cyo42
    );
  XNor_stagecy_rn_40 : X_MUX2
    port map (
      IB => XNor_stage_cyo40,
      IA => s_get_left_word(10),
      SEL => N47,
      O => XNor_stage_cyo41
    );
  XNor_stagecy_rn_39 : X_MUX2
    port map (
      IB => XNor_stage_cyo39,
      IA => s_get_left_word(9),
      SEL => N46,
      O => XNor_stage_cyo40
    );
  XNor_stagecy_rn_38 : X_MUX2
    port map (
      IB => XNor_stage_cyo38,
      IA => s_get_left_word(8),
      SEL => N45,
      O => XNor_stage_cyo39
    );
  XNor_stagecy_rn_37 : X_MUX2
    port map (
      IB => XNor_stage_cyo37,
      IA => s_get_left_word(7),
      SEL => N44,
      O => XNor_stage_cyo38
    );
  XNor_stagecy_rn_36 : X_MUX2
    port map (
      IB => XNor_stage_cyo36,
      IA => s_get_left_word(6),
      SEL => N43,
      O => XNor_stage_cyo37
    );
  XNor_stagecy_rn_35 : X_MUX2
    port map (
      IB => XNor_stage_cyo35,
      IA => s_get_left_word(5),
      SEL => N42,
      O => XNor_stage_cyo36
    );
  XNor_stagecy_rn_34 : X_MUX2
    port map (
      IB => XNor_stage_cyo34,
      IA => s_get_left_word(4),
      SEL => N41,
      O => XNor_stage_cyo35
    );
  XNor_stagecy_rn_33 : X_MUX2
    port map (
      IB => XNor_stage_cyo33,
      IA => s_get_left_word(3),
      SEL => N40,
      O => XNor_stage_cyo34
    );
  XNor_stagecy_rn_32 : X_MUX2
    port map (
      IB => XNor_stage_cyo32,
      IA => s_get_left_word(2),
      SEL => N39,
      O => XNor_stage_cyo33
    );
  XNor_stagecy_rn_31 : X_MUX2
    port map (
      IB => XNor_stage_cyo31,
      IA => s_get_left_word(1),
      SEL => N38,
      O => XNor_stage_cyo32
    );
  XNor_stagecy_rn_30 : X_MUX2
    port map (
      IB => CEA2_OBUF,
      IA => s_get_left_word(0),
      SEL => N37,
      O => XNor_stage_cyo31
    );
  GE_stagecy : X_MUX2
    port map (
      IB => XNor_stage_cyo30,
      IA => s_get_left_word(31),
      SEL => N35,
      O => GE_stage_cyo
    );
  XNor_stagecy_rn_29 : X_MUX2
    port map (
      IB => XNor_stage_cyo29,
      IA => s_get_right_word(30),
      SEL => N34,
      O => XNor_stage_cyo30
    );
  h_address_buf_6 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_6_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(6),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  h_address_buf_16 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_16_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(16),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_0 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6255,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(0),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_1 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6256,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(1),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_2 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6257,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(2),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_3 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6258,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(3),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_4 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6259,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(4),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_5 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6260,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(5),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_6 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6261,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(6),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_7 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6262,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(7),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_8 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6263,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(8),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_9 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6264,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(9),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_10 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6265,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(10),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_11 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6266,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(11),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_12 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6267,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(12),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_13 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6268,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(13),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_14 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6269,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(14),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_15 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6270,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(15),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_16 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6271,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(16),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_17 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6272,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(17),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_18 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6273,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(18),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_19 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6274,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(19),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_20 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6275,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(20),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_21 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6276,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(21),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_22 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6277,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(22),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_23 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6278,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(23),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_24 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6279,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(24),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_25 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6280,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(25),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_26 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6281,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(26),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_27 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6282,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(27),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_28 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6283,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(28),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_29 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6284,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(29),
      SET => GND,
      RST => GSR
    );
  h_put_word_buf_30 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6285,
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_put_word_buf(30),
      SET => GND,
      RST => GSR
    );
  h_address_buf_14 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_14_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(14),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  h_response_buf_0_14 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_request_buf(1),
      CE => CEA2_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_response_buf_2(0),
      SET => GND,
      RST => GSR
    );
  h_address_buf_0 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => AA_0_OBUF,
      CLK => CLKMA0_OBUF,
      O => h_address_buf(0),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  h_request_1_1 : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => h_get_word_buf(27),
      ADR1 => h_get_word_buf(26),
      ADR2 => h_response_buf_1,
      ADR3 => N2,
      O => h_request(1)
    );
  h_request_0_1 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => h_get_word_buf(27),
      ADR2 => N2,
      ADR3 => h_get_word_buf(26),
      O => h_request(0)
    );
  h_get_word_buf_27_1_15 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5030,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf_27_1,
      CE => VCC,
      SET => GND
    );
  XNor_stagecy_rn_26 : X_MUX2
    port map (
      IB => XNor_stage_cyo26,
      IA => s_get_right_word(27),
      SEL => N31,
      O => XNor_stage_cyo27
    );
  LED_1_2 : X_LUT3
    generic map(
      INIT => X"EF"
    )
    port map (
      ADR0 => N80,
      ADR1 => h_get_word_buf(27),
      ADR2 => a_get_word(1),
      O => LED_1_OBUF
    );
  a_put_left_word_10_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121_1,
      ADR1 => s_get_left_word_buf(10),
      ADR2 => N5162,
      ADR3 => N6354,
      O => a_put_left_word(10)
    );
  a_put_left_word_11_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121_1,
      ADR1 => s_get_left_word_buf(11),
      ADR2 => N5165,
      ADR3 => N6355,
      O => a_put_left_word(11)
    );
  a_put_left_word_12_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121_1,
      ADR1 => s_get_left_word_buf(12),
      ADR2 => N5168,
      ADR3 => N6356,
      O => a_put_left_word(12)
    );
  a_put_left_word_13_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121,
      ADR1 => s_get_left_word_buf(13),
      ADR2 => N5171,
      ADR3 => N6357,
      O => a_put_left_word(13)
    );
  a_put_left_word_14_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121_1,
      ADR1 => s_get_left_word_buf(14),
      ADR2 => N5174,
      ADR3 => N6326,
      O => a_put_left_word(14)
    );
  a_put_left_word_15_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121_11,
      ADR1 => s_get_left_word_buf(15),
      ADR2 => N5177,
      ADR3 => N6324,
      O => a_put_left_word(15)
    );
  a_put_left_word_16_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121,
      ADR1 => s_get_left_word_buf(16),
      ADR2 => N5180,
      ADR3 => N6332,
      O => a_put_left_word(16)
    );
  a_put_left_word_17_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121,
      ADR1 => s_get_left_word_buf(17),
      ADR2 => N5183,
      ADR3 => N6172,
      O => a_put_left_word(17)
    );
  a_put_left_word_18_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121,
      ADR1 => s_get_left_word_buf(18),
      ADR2 => N5186,
      ADR3 => N6317,
      O => a_put_left_word(18)
    );
  a_put_left_word_19_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121,
      ADR1 => s_get_left_word_buf(19),
      ADR2 => N5189,
      ADR3 => N6330,
      O => a_put_left_word(19)
    );
  a_put_left_word_1_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121_11,
      ADR1 => s_get_left_word_buf(1),
      ADR2 => N5192,
      ADR3 => N6313,
      O => a_put_left_word(1)
    );
  a_put_left_word_21_1 : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(21),
      ADR2 => N5125,
      ADR3 => N6343,
      O => a_put_left_word(21)
    );
  a_put_left_word_22_1 : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(22),
      ADR2 => N5128,
      ADR3 => N6344,
      O => a_put_left_word(22)
    );
  a_put_left_word_23_1 : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(23),
      ADR2 => N5131,
      ADR3 => N6345,
      O => a_put_left_word(23)
    );
  a_put_left_word_24_1 : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(24),
      ADR2 => N5134,
      ADR3 => N6346,
      O => a_put_left_word(24)
    );
  a_put_left_word_25_1 : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(25),
      ADR2 => N5137,
      ADR3 => N6347,
      O => a_put_left_word(25)
    );
  a_put_left_word_26_1 : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(26),
      ADR2 => N5140,
      ADR3 => N6348,
      O => a_put_left_word(26)
    );
  a_put_left_word_27_1 : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(27),
      ADR2 => N5143,
      ADR3 => N6349,
      O => a_put_left_word(27)
    );
  a_put_left_word_28_1 : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(28),
      ADR2 => N6350,
      ADR3 => N5147,
      O => a_put_left_word(28)
    );
  a_put_left_word_29_1 : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(29),
      ADR2 => N5149,
      ADR3 => N6351,
      O => a_put_left_word(29)
    );
  a_put_left_word_2_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121_11,
      ADR1 => s_get_left_word_buf(2),
      ADR2 => N5195,
      ADR3 => N6297,
      O => a_put_left_word(2)
    );
  a_put_left_word_30_1 : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(30),
      ADR2 => N5152,
      ADR3 => N6352,
      O => a_put_left_word(30)
    );
  a_put_left_word_31_1 : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(31),
      ADR2 => N5155,
      ADR3 => N6353,
      O => a_put_left_word(31)
    );
  a_put_left_word_3_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121_1,
      ADR1 => s_get_left_word_buf(3),
      ADR2 => N5198,
      ADR3 => N5197,
      O => a_put_left_word(3)
    );
  a_put_left_word_4_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121_11,
      ADR1 => s_get_left_word_buf(4),
      ADR2 => N5201,
      ADR3 => N6239,
      O => a_put_left_word(4)
    );
  a_put_left_word_5_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121_11,
      ADR1 => s_get_left_word_buf(5),
      ADR2 => N5204,
      ADR3 => N6290,
      O => a_put_left_word(5)
    );
  a_put_left_word_6_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121_11,
      ADR1 => s_get_left_word_buf(6),
      ADR2 => N5207,
      ADR3 => N6291,
      O => a_put_left_word(6)
    );
  a_put_left_word_7_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121_11,
      ADR1 => s_get_left_word_buf(7),
      ADR2 => N5210,
      ADR3 => N6292,
      O => a_put_left_word(7)
    );
  a_put_left_word_8_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121_1,
      ADR1 => s_get_left_word_buf(8),
      ADR2 => N5213,
      ADR3 => N6293,
      O => a_put_left_word(8)
    );
  a_put_left_word_9_1 : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121_1,
      ADR1 => s_get_left_word_buf(9),
      ADR2 => N5216,
      ADR3 => N6298,
      O => a_put_left_word(9)
    );
  a_shift_1_1 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => h_get_word_buf_29_3,
      ADR1 => h_get_word_buf(28),
      ADR2 => h_get_word_buf(27),
      ADR3 => N5548,
      O => a_shift(1)
    );
  cpu_h_n0007_0_lut_INV_0 : X_INV
    port map (
      I => h_put_address_buf(0),
      O => N3
    );
  cpu_h_n0007_0_cy : X_MUX2
    port map (
      IB => CEA2X_OBUF,
      IA => CEA2_OBUF,
      SEL => N3,
      O => cpu_h_n0007_0_cyo
    );
  LED_0_OBUF_16 : X_BUF
    port map (
      I => LED_0_OBUF,
      O => LED_0_OBUF_GTS_TRI
    );
  cpu_h_n0007_1_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_0_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_1_rt,
      O => cpu_h_n0007_1_cyo
    );
  cpu_h_n0007_1_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_0_cyo,
      I1 => h_put_address_buf_1_rt,
      O => h_n0007(1)
    );
  cpu_h_n0007_2_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_1_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_2_rt,
      O => cpu_h_n0007_2_cyo
    );
  cpu_h_n0007_2_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_1_cyo,
      I1 => h_put_address_buf_2_rt,
      O => h_n0007(2)
    );
  cpu_h_n0007_3_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_2_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_3_rt,
      O => cpu_h_n0007_3_cyo
    );
  cpu_h_n0007_3_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_2_cyo,
      I1 => h_put_address_buf_3_rt,
      O => h_n0007(3)
    );
  cpu_h_n0007_4_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_3_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_4_rt,
      O => cpu_h_n0007_4_cyo
    );
  cpu_h_n0007_4_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_3_cyo,
      I1 => h_put_address_buf_4_rt,
      O => h_n0007(4)
    );
  cpu_h_n0007_5_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_4_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_5_rt,
      O => cpu_h_n0007_5_cyo
    );
  cpu_h_n0007_5_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_4_cyo,
      I1 => h_put_address_buf_5_rt,
      O => h_n0007(5)
    );
  cpu_h_n0007_6_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_5_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_6_rt,
      O => cpu_h_n0007_6_cyo
    );
  cpu_h_n0007_6_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_5_cyo,
      I1 => h_put_address_buf_6_rt,
      O => h_n0007(6)
    );
  cpu_h_n0007_7_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_6_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_7_rt,
      O => cpu_h_n0007_7_cyo
    );
  cpu_h_n0007_7_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_6_cyo,
      I1 => h_put_address_buf_7_rt,
      O => h_n0007(7)
    );
  cpu_h_n0007_8_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_7_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_8_rt,
      O => cpu_h_n0007_8_cyo
    );
  cpu_h_n0007_8_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_7_cyo,
      I1 => h_put_address_buf_8_rt,
      O => h_n0007(8)
    );
  cpu_h_n0007_9_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_8_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_9_rt,
      O => cpu_h_n0007_9_cyo
    );
  cpu_h_n0007_9_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_8_cyo,
      I1 => h_put_address_buf_9_rt,
      O => h_n0007(9)
    );
  cpu_h_n0007_10_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_9_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_10_rt,
      O => cpu_h_n0007_10_cyo
    );
  cpu_h_n0007_10_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_9_cyo,
      I1 => h_put_address_buf_10_rt,
      O => h_n0007(10)
    );
  cpu_h_n0007_11_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_10_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_11_rt,
      O => cpu_h_n0007_11_cyo
    );
  cpu_h_n0007_11_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_10_cyo,
      I1 => h_put_address_buf_11_rt,
      O => h_n0007(11)
    );
  cpu_h_n0007_12_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_11_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_12_rt,
      O => cpu_h_n0007_12_cyo
    );
  cpu_h_n0007_12_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_11_cyo,
      I1 => h_put_address_buf_12_rt,
      O => h_n0007(12)
    );
  cpu_h_n0007_13_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_12_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_13_rt,
      O => cpu_h_n0007_13_cyo
    );
  cpu_h_n0007_13_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_12_cyo,
      I1 => h_put_address_buf_13_rt,
      O => h_n0007(13)
    );
  cpu_h_n0007_14_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_13_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_14_rt,
      O => cpu_h_n0007_14_cyo
    );
  cpu_h_n0007_14_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_13_cyo,
      I1 => h_put_address_buf_14_rt,
      O => h_n0007(14)
    );
  cpu_h_n0007_15_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_14_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_15_rt,
      O => cpu_h_n0007_15_cyo
    );
  cpu_h_n0007_15_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_14_cyo,
      I1 => h_put_address_buf_15_rt,
      O => h_n0007(15)
    );
  cpu_h_n0007_16_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_15_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_16_rt,
      O => cpu_h_n0007_16_cyo
    );
  cpu_h_n0007_16_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_15_cyo,
      I1 => h_put_address_buf_16_rt,
      O => h_n0007(16)
    );
  cpu_h_n0007_17_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_16_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_17_rt,
      O => cpu_h_n0007_17_cyo
    );
  cpu_h_n0007_17_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_16_cyo,
      I1 => h_put_address_buf_17_rt,
      O => h_n0007(17)
    );
  cpu_h_n0007_18_cy : X_MUX2
    port map (
      IB => cpu_h_n0007_17_cyo,
      IA => CEA2X_OBUF,
      SEL => h_put_address_buf_18_rt,
      O => cpu_h_n0007_18_cyo
    );
  cpu_h_n0007_18_xor : X_XOR2
    port map (
      I0 => cpu_h_n0007_17_cyo,
      I1 => h_put_address_buf_18_rt,
      O => h_n0007(18)
    );
  XNor_stagecy : X_MUX2
    port map (
      IB => CEA2_OBUF,
      IA => s_get_right_word(0),
      SEL => N4,
      O => XNor_stage_cyo
    );
  XNor_stagecy_rn_0 : X_MUX2
    port map (
      IB => XNor_stage_cyo,
      IA => s_get_right_word(1),
      SEL => N5,
      O => XNor_stage_cyo1
    );
  XNor_stagecy_rn_1 : X_MUX2
    port map (
      IB => XNor_stage_cyo1,
      IA => s_get_right_word(2),
      SEL => N6,
      O => XNor_stage_cyo2
    );
  XNor_stagecy_rn_2 : X_MUX2
    port map (
      IB => XNor_stage_cyo2,
      IA => s_get_right_word(3),
      SEL => N7,
      O => XNor_stage_cyo3
    );
  XNor_stagecy_rn_3 : X_MUX2
    port map (
      IB => XNor_stage_cyo3,
      IA => s_get_right_word(4),
      SEL => N8,
      O => XNor_stage_cyo4
    );
  XNor_stagecy_rn_4 : X_MUX2
    port map (
      IB => XNor_stage_cyo4,
      IA => s_get_right_word(5),
      SEL => N9,
      O => XNor_stage_cyo5
    );
  XNor_stagecy_rn_5 : X_MUX2
    port map (
      IB => XNor_stage_cyo5,
      IA => s_get_right_word(6),
      SEL => N10,
      O => XNor_stage_cyo6
    );
  XNor_stagecy_rn_6 : X_MUX2
    port map (
      IB => XNor_stage_cyo6,
      IA => s_get_right_word(7),
      SEL => N11,
      O => XNor_stage_cyo7
    );
  XNor_stagecy_rn_7 : X_MUX2
    port map (
      IB => XNor_stage_cyo7,
      IA => s_get_right_word(8),
      SEL => N12,
      O => XNor_stage_cyo8
    );
  XNor_stagecy_rn_8 : X_MUX2
    port map (
      IB => XNor_stage_cyo8,
      IA => s_get_right_word(9),
      SEL => N13,
      O => XNor_stage_cyo9
    );
  XNor_stagecy_rn_9 : X_MUX2
    port map (
      IB => XNor_stage_cyo9,
      IA => s_get_right_word(10),
      SEL => N14,
      O => XNor_stage_cyo10
    );
  XNor_stagecy_rn_10 : X_MUX2
    port map (
      IB => XNor_stage_cyo10,
      IA => s_get_right_word(11),
      SEL => N15,
      O => XNor_stage_cyo11
    );
  XNor_stagecy_rn_11 : X_MUX2
    port map (
      IB => XNor_stage_cyo11,
      IA => s_get_right_word(12),
      SEL => N16,
      O => XNor_stage_cyo12
    );
  XNor_stagecy_rn_12 : X_MUX2
    port map (
      IB => XNor_stage_cyo12,
      IA => s_get_right_word(13),
      SEL => N17,
      O => XNor_stage_cyo13
    );
  XNor_stagecy_rn_13 : X_MUX2
    port map (
      IB => XNor_stage_cyo13,
      IA => s_get_right_word(14),
      SEL => N18,
      O => XNor_stage_cyo14
    );
  XNor_stagecy_rn_14 : X_MUX2
    port map (
      IB => XNor_stage_cyo14,
      IA => s_get_right_word(15),
      SEL => N19,
      O => XNor_stage_cyo15
    );
  XNor_stagecy_rn_15 : X_MUX2
    port map (
      IB => XNor_stage_cyo15,
      IA => s_get_right_word(16),
      SEL => N20,
      O => XNor_stage_cyo16
    );
  XNor_stagecy_rn_16 : X_MUX2
    port map (
      IB => XNor_stage_cyo16,
      IA => s_get_right_word(17),
      SEL => N21,
      O => XNor_stage_cyo17
    );
  XNor_stagecy_rn_17 : X_MUX2
    port map (
      IB => XNor_stage_cyo17,
      IA => s_get_right_word(18),
      SEL => N22,
      O => XNor_stage_cyo18
    );
  XNor_stagecy_rn_18 : X_MUX2
    port map (
      IB => XNor_stage_cyo18,
      IA => s_get_right_word(19),
      SEL => N23,
      O => XNor_stage_cyo19
    );
  XNor_stagecy_rn_19 : X_MUX2
    port map (
      IB => XNor_stage_cyo19,
      IA => s_get_right_word(20),
      SEL => N24,
      O => XNor_stage_cyo20
    );
  XNor_stagecy_rn_20 : X_MUX2
    port map (
      IB => XNor_stage_cyo20,
      IA => s_get_right_word(21),
      SEL => N25,
      O => XNor_stage_cyo21
    );
  XNor_stagecy_rn_21 : X_MUX2
    port map (
      IB => XNor_stage_cyo21,
      IA => s_get_right_word(22),
      SEL => N26,
      O => XNor_stage_cyo22
    );
  XNor_stagecy_rn_22 : X_MUX2
    port map (
      IB => XNor_stage_cyo22,
      IA => s_get_right_word(23),
      SEL => N27,
      O => XNor_stage_cyo23
    );
  XNor_stagecy_rn_23 : X_MUX2
    port map (
      IB => XNor_stage_cyo23,
      IA => s_get_right_word(24),
      SEL => N28,
      O => XNor_stage_cyo24
    );
  XNor_stagecy_rn_24 : X_MUX2
    port map (
      IB => XNor_stage_cyo24,
      IA => s_get_right_word(25),
      SEL => N29,
      O => XNor_stage_cyo25
    );
  XNor_stagecy_rn_25 : X_MUX2
    port map (
      IB => XNor_stage_cyo25,
      IA => s_get_right_word(26),
      SEL => N30,
      O => XNor_stage_cyo26
    );
  a_Ker291 : X_LUT4
    generic map(
      INIT => X"F080"
    )
    port map (
      ADR0 => h_get_word_buf(10),
      ADR1 => h_get_word_buf(9),
      ADR2 => N6240,
      ADR3 => N241,
      O => a_N291
    );
  a_get_word_6_94 : X_LUT4
    generic map(
      INIT => X"C480"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => N6201,
      ADR2 => a_N60,
      ADR3 => a_N41,
      O => CHOICE5161
    );
  a_put_right_word_17_Q : X_LUT4
    generic map(
      INIT => X"FD20"
    )
    port map (
      ADR0 => N6251,
      ADR1 => h_get_word_buf(26),
      ADR2 => N243,
      ADR3 => N242,
      O => a_put_right_word(17)
    );
  Ker24 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => h_get_word_buf_29_3,
      ADR1 => h_get_word_buf(28),
      ADR2 => h_get_word_buf_27_1,
      ADR3 => N1111,
      O => N241
    );
  Ker23 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => h_response_buf_1_3,
      ADR1 => h_get_word_buf_29_3,
      ADR2 => h_response_buf_0_4,
      ADR3 => N5518,
      O => N231
    );
  s_request_17 : X_LUT4
    generic map(
      INIT => X"0405"
    )
    port map (
      ADR0 => h_get_word_buf(28),
      ADR1 => h_get_word_buf(26),
      ADR2 => N511,
      ADR3 => h_get_word_buf(29),
      O => s_request
    );
  a_get_word_22_42 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(0),
      ADR2 => h_get_word_buf(10),
      ADR3 => N241,
      O => CHOICE4139
    );
  a_get_word_17_233_SW0 : X_LUT4
    generic map(
      INIT => X"FFF8"
    )
    port map (
      ADR0 => a_put_right_word(17),
      ADR1 => N6325,
      ADR2 => N5274,
      ADR3 => a_N76,
      O => N5296
    );
  a_n00011_SW1 : X_LUT3
    generic map(
      INIT => X"FE"
    )
    port map (
      ADR0 => h_get_word_buf(5),
      ADR1 => h_get_word_buf(3),
      ADR2 => h_get_word_buf(2),
      O => N5546
    );
  a_Mshift_n0003_Sh_41_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_N126,
      ADR2 => a_N47,
      O => a_Mshift_n0003_Sh_41_Q
    );
  a_alu_n0000_20_lut_SW0 : X_LUT4
    generic map(
      INIT => X"1FBF"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_get_right_word_buf(20),
      ADR2 => N6321,
      ADR3 => s_put_word_buf(20),
      O => N5532
    );
  a_Mshift_n0003_Sh_43_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_N47,
      ADR2 => a_N2,
      O => a_Mshift_n0003_Sh_43_Q
    );
  a_Mshift_n0003_Sh_44_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_N58,
      ADR2 => a_N41,
      O => a_Mshift_n0003_Sh_44_Q
    );
  s_get_right_word_7_1_SW0 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(7),
      ADR1 => N5380,
      ADR2 => N411,
      ADR3 => N111,
      O => N5329
    );
  a_Ker3701 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_shift(3),
      ADR2 => a_funct(2),
      ADR3 => a_shift(4),
      O => a_N370
    );
  a_alu_n0000_31_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_30_cyo,
      I1 => a_N34,
      O => a_n0000(31)
    );
  a_get_word_12_74 : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => h_get_word_buf(3),
      ADR1 => h_get_word_buf(5),
      ADR2 => N411,
      ADR3 => N121,
      O => CHOICE4503
    );
  h_get_word_buf_28_mmx_out_h_get_word_buf_28_mmx_out : X_LUT4
    generic map(
      INIT => X"2088"
    )
    port map (
      ADR0 => h_get_word_buf(28),
      ADR1 => h_get_word_buf(27),
      ADR2 => GE_stage_cyo1,
      ADR3 => GE_stage_cyo,
      O => MUX_BLOCK_N0
    );
  s_left_conflict_1 : X_SFF
    generic map(
      INIT => '0'
    )
    port map (
      I => CEA2_OBUF,
      SRST => s_left_conflict_N0,
      CLK => CLKMA0_OBUF,
      O => s_left_conflict1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  a_get_word_26_27 : X_LUT4
    generic map(
      INIT => X"0103"
    )
    port map (
      ADR0 => h_get_word_buf(5),
      ADR1 => N121,
      ADR2 => a_N01,
      ADR3 => N411,
      O => CHOICE3999
    );
  a_get_word_7_215_SW0 : X_LUT4
    generic map(
      INIT => X"88F8"
    )
    port map (
      ADR0 => N6322,
      ADR1 => a_N379,
      ADR2 => CHOICE4900,
      ADR3 => a_funct(1),
      O => N5417
    );
  a_Mshift_n0003_Sh_50_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_N91,
      ADR2 => a_N62,
      O => a_Mshift_n0003_Sh_50_Q
    );
  a_get_word_12_90_SW0 : X_LUT4
    generic map(
      INIT => X"F080"
    )
    port map (
      ADR0 => h_get_word_buf(2),
      ADR1 => N411,
      ADR2 => N6311,
      ADR3 => N121,
      O => N5408
    );
  s_get_right_word_8_1_SW0 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf_8_1,
      ADR1 => N5384,
      ADR2 => N411,
      ADR3 => N111,
      O => N5326
    );
  a_get_word_26_103 : X_LUT3
    generic map(
      INIT => X"14"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => a_put_left_word(26),
      ADR2 => a_put_right_word(26),
      O => CHOICE4023
    );
  a_get_word_23_112 : X_LUT3
    generic map(
      INIT => X"14"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => a_put_left_word(23),
      ADR2 => a_put_right_word(23),
      O => CHOICE3897
    );
  a_get_word_12_222_SW0 : X_LUT4
    generic map(
      INIT => X"AAAC"
    )
    port map (
      ADR0 => N5409,
      ADR1 => N5408,
      ADR2 => CHOICE4500,
      ADR3 => CHOICE4494,
      O => N5335
    );
  s_get_left_word_3_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(3),
      ADR1 => s_put_word_buf(3),
      ADR2 => Ker21_14,
      ADR3 => s_left_conflict1,
      O => N5198
    );
  a_get_word_18_218 : X_LUT4
    generic map(
      INIT => X"2232"
    )
    port map (
      ADR0 => CHOICE5086,
      ADR1 => a_funct(1),
      ADR2 => a_n0000(18),
      ADR3 => a_funct(2),
      O => CHOICE5091
    );
  a_get_word_8_164 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(0),
      ADR2 => N6165,
      ADR3 => a_funct(2),
      O => CHOICE4734
    );
  s_right_conflict_1 : X_SFF
    generic map(
      INIT => '0'
    )
    port map (
      I => CEA2_OBUF,
      SRST => s_right_conflict_N0,
      CLK => CLKMA0_OBUF,
      O => s_right_conflict1,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  a_Mshift_n0003_Sh_42_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_N35,
      ADR2 => a_N58,
      O => a_Mshift_n0003_Sh_42_Q
    );
  a_alu_n0000_0_cy : X_MUX2
    port map (
      IB => a_n0001,
      IA => a_put_left_word(0),
      SEL => a_N3,
      O => a_alu_n0000_0_cyo
    );
  a_alu_n0000_0_xor : X_XOR2
    port map (
      I0 => a_n0001,
      I1 => a_N3,
      O => a_n0000(0)
    );
  a_alu_n0000_1_cy : X_MUX2
    port map (
      IB => a_alu_n0000_0_cyo,
      IA => a_put_left_word(1),
      SEL => a_N4,
      O => a_alu_n0000_1_cyo
    );
  a_alu_n0000_1_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_0_cyo,
      I1 => a_N4,
      O => a_n0000(1)
    );
  a_alu_n0000_2_cy : X_MUX2
    port map (
      IB => a_alu_n0000_1_cyo,
      IA => a_put_left_word(2),
      SEL => a_N5,
      O => a_alu_n0000_2_cyo
    );
  a_alu_n0000_2_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_1_cyo,
      I1 => a_N5,
      O => a_n0000(2)
    );
  a_alu_n0000_3_cy : X_MUX2
    port map (
      IB => a_alu_n0000_2_cyo,
      IA => a_put_left_word(3),
      SEL => a_N6,
      O => a_alu_n0000_3_cyo
    );
  a_alu_n0000_3_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_2_cyo,
      I1 => a_N6,
      O => a_n0000(3)
    );
  a_alu_n0000_4_cy : X_MUX2
    port map (
      IB => a_alu_n0000_3_cyo,
      IA => a_put_left_word(4),
      SEL => a_N7,
      O => a_alu_n0000_4_cyo
    );
  a_alu_n0000_4_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_3_cyo,
      I1 => a_N7,
      O => a_n0000(4)
    );
  a_alu_n0000_5_cy : X_MUX2
    port map (
      IB => a_alu_n0000_4_cyo,
      IA => a_put_left_word(5),
      SEL => a_N8,
      O => a_alu_n0000_5_cyo
    );
  a_alu_n0000_5_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_4_cyo,
      I1 => a_N8,
      O => a_n0000(5)
    );
  a_alu_n0000_6_cy : X_MUX2
    port map (
      IB => a_alu_n0000_5_cyo,
      IA => a_put_left_word(6),
      SEL => a_N9,
      O => a_alu_n0000_6_cyo
    );
  a_alu_n0000_6_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_5_cyo,
      I1 => a_N9,
      O => a_n0000(6)
    );
  a_alu_n0000_7_cy : X_MUX2
    port map (
      IB => a_alu_n0000_6_cyo,
      IA => a_put_left_word(7),
      SEL => a_N10,
      O => a_alu_n0000_7_cyo
    );
  a_alu_n0000_7_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_6_cyo,
      I1 => a_N10,
      O => a_n0000(7)
    );
  a_alu_n0000_8_cy : X_MUX2
    port map (
      IB => a_alu_n0000_7_cyo,
      IA => a_put_left_word(8),
      SEL => a_N11,
      O => a_alu_n0000_8_cyo
    );
  a_alu_n0000_8_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_7_cyo,
      I1 => a_N11,
      O => a_n0000(8)
    );
  a_alu_n0000_9_cy : X_MUX2
    port map (
      IB => a_alu_n0000_8_cyo,
      IA => a_put_left_word(9),
      SEL => a_N12,
      O => a_alu_n0000_9_cyo
    );
  a_alu_n0000_9_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_8_cyo,
      I1 => a_N12,
      O => a_n0000(9)
    );
  a_alu_n0000_10_cy : X_MUX2
    port map (
      IB => a_alu_n0000_9_cyo,
      IA => a_put_left_word(10),
      SEL => a_N13,
      O => a_alu_n0000_10_cyo
    );
  a_alu_n0000_10_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_9_cyo,
      I1 => a_N13,
      O => a_n0000(10)
    );
  a_alu_n0000_11_cy : X_MUX2
    port map (
      IB => a_alu_n0000_10_cyo,
      IA => a_put_left_word(11),
      SEL => a_N14,
      O => a_alu_n0000_11_cyo
    );
  a_alu_n0000_11_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_10_cyo,
      I1 => a_N14,
      O => a_n0000(11)
    );
  a_alu_n0000_12_cy : X_MUX2
    port map (
      IB => a_alu_n0000_11_cyo,
      IA => a_put_left_word(12),
      SEL => a_N15,
      O => a_alu_n0000_12_cyo
    );
  a_alu_n0000_12_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_11_cyo,
      I1 => a_N15,
      O => a_n0000(12)
    );
  a_alu_n0000_13_cy : X_MUX2
    port map (
      IB => a_alu_n0000_12_cyo,
      IA => a_put_left_word(13),
      SEL => a_N16,
      O => a_alu_n0000_13_cyo
    );
  a_alu_n0000_13_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_12_cyo,
      I1 => a_N16,
      O => a_n0000(13)
    );
  a_alu_n0000_14_cy : X_MUX2
    port map (
      IB => a_alu_n0000_13_cyo,
      IA => a_put_left_word(14),
      SEL => a_N17,
      O => a_alu_n0000_14_cyo
    );
  a_alu_n0000_14_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_13_cyo,
      I1 => a_N17,
      O => a_n0000(14)
    );
  a_alu_n0000_15_cy : X_MUX2
    port map (
      IB => a_alu_n0000_14_cyo,
      IA => a_put_left_word(15),
      SEL => a_N18,
      O => a_alu_n0000_15_cyo
    );
  a_alu_n0000_15_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_14_cyo,
      I1 => a_N18,
      O => a_n0000(15)
    );
  a_alu_n0000_16_cy : X_MUX2
    port map (
      IB => a_alu_n0000_15_cyo,
      IA => a_put_left_word(16),
      SEL => a_N19,
      O => a_alu_n0000_16_cyo
    );
  a_alu_n0000_16_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_15_cyo,
      I1 => a_N19,
      O => a_n0000(16)
    );
  a_alu_n0000_17_cy : X_MUX2
    port map (
      IB => a_alu_n0000_16_cyo,
      IA => a_put_left_word(17),
      SEL => a_N20,
      O => a_alu_n0000_17_cyo
    );
  a_alu_n0000_17_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_16_cyo,
      I1 => a_N20,
      O => a_n0000(17)
    );
  a_alu_n0000_18_cy : X_MUX2
    port map (
      IB => a_alu_n0000_17_cyo,
      IA => a_put_left_word(18),
      SEL => a_N21,
      O => a_alu_n0000_18_cyo
    );
  a_alu_n0000_18_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_17_cyo,
      I1 => a_N21,
      O => a_n0000(18)
    );
  a_alu_n0000_19_cy : X_MUX2
    port map (
      IB => a_alu_n0000_18_cyo,
      IA => a_put_left_word(19),
      SEL => a_N22,
      O => a_alu_n0000_19_cyo
    );
  a_alu_n0000_19_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_18_cyo,
      I1 => a_N22,
      O => a_n0000(19)
    );
  a_alu_n0000_20_cy : X_MUX2
    port map (
      IB => a_alu_n0000_19_cyo,
      IA => a_put_left_word(20),
      SEL => a_N23,
      O => a_alu_n0000_20_cyo
    );
  a_alu_n0000_20_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_19_cyo,
      I1 => a_N23,
      O => a_n0000(20)
    );
  a_alu_n0000_21_cy : X_MUX2
    port map (
      IB => a_alu_n0000_20_cyo,
      IA => a_put_left_word(21),
      SEL => a_N24,
      O => a_alu_n0000_21_cyo
    );
  a_alu_n0000_21_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_20_cyo,
      I1 => a_N24,
      O => a_n0000(21)
    );
  a_alu_n0000_22_cy : X_MUX2
    port map (
      IB => a_alu_n0000_21_cyo,
      IA => a_put_left_word(22),
      SEL => a_N25,
      O => a_alu_n0000_22_cyo
    );
  a_alu_n0000_22_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_21_cyo,
      I1 => a_N25,
      O => a_n0000(22)
    );
  a_alu_n0000_23_cy : X_MUX2
    port map (
      IB => a_alu_n0000_22_cyo,
      IA => a_put_left_word(23),
      SEL => a_N26,
      O => a_alu_n0000_23_cyo
    );
  a_alu_n0000_23_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_22_cyo,
      I1 => a_N26,
      O => a_n0000(23)
    );
  a_alu_n0000_24_cy : X_MUX2
    port map (
      IB => a_alu_n0000_23_cyo,
      IA => a_put_left_word(24),
      SEL => a_N27,
      O => a_alu_n0000_24_cyo
    );
  a_alu_n0000_24_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_23_cyo,
      I1 => a_N27,
      O => a_n0000(24)
    );
  a_alu_n0000_25_cy : X_MUX2
    port map (
      IB => a_alu_n0000_24_cyo,
      IA => a_put_left_word(25),
      SEL => a_N28,
      O => a_alu_n0000_25_cyo
    );
  a_alu_n0000_25_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_24_cyo,
      I1 => a_N28,
      O => a_n0000(25)
    );
  a_alu_n0000_26_cy : X_MUX2
    port map (
      IB => a_alu_n0000_25_cyo,
      IA => a_put_left_word(26),
      SEL => a_N29,
      O => a_alu_n0000_26_cyo
    );
  a_alu_n0000_26_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_25_cyo,
      I1 => a_N29,
      O => a_n0000(26)
    );
  a_alu_n0000_27_cy : X_MUX2
    port map (
      IB => a_alu_n0000_26_cyo,
      IA => a_put_left_word(27),
      SEL => a_N30,
      O => a_alu_n0000_27_cyo
    );
  a_alu_n0000_27_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_26_cyo,
      I1 => a_N30,
      O => a_n0000(27)
    );
  a_alu_n0000_28_cy : X_MUX2
    port map (
      IB => a_alu_n0000_27_cyo,
      IA => a_put_left_word(28),
      SEL => a_N31,
      O => a_alu_n0000_28_cyo
    );
  a_alu_n0000_28_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_27_cyo,
      I1 => a_N31,
      O => a_n0000(28)
    );
  a_alu_n0000_29_cy : X_MUX2
    port map (
      IB => a_alu_n0000_28_cyo,
      IA => a_put_left_word(29),
      SEL => a_N32,
      O => a_alu_n0000_29_cyo
    );
  a_alu_n0000_29_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_28_cyo,
      I1 => a_N32,
      O => a_n0000(29)
    );
  a_alu_n0000_30_cy : X_MUX2
    port map (
      IB => a_alu_n0000_29_cyo,
      IA => a_put_left_word(30),
      SEL => a_N33,
      O => a_alu_n0000_30_cyo
    );
  a_alu_n0000_30_xor : X_XOR2
    port map (
      I0 => a_alu_n0000_29_cyo,
      I1 => a_N33,
      O => a_n0000(30)
    );
  s_get_right_word_6_1_SW0 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(6),
      ADR1 => N5374,
      ADR2 => N411,
      ADR3 => N111,
      O => N5332
    );
  a_get_word_5_131_F_SW0 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => N6241,
      ADR2 => a_N61,
      O => N5807
    );
  a_put_right_word_19_SW3 : X_LUT4
    generic map(
      INIT => X"C693"
    )
    port map (
      ADR0 => h_get_word_buf(26),
      ADR1 => a_n0001,
      ADR2 => N230,
      ADR3 => N2311,
      O => N5432
    );
  a_Mshift_n0002_Sh_8_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_N57,
      ADR2 => a_N131,
      O => a_Mshift_n0002_Sh_8_Q
    );
  a_Mshift_n0002_Sh_9_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_N141,
      ADR2 => a_N57,
      O => a_Mshift_n0002_Sh_9_Q
    );
  a_Mshift_n0002_Sh_12_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_N49,
      ADR2 => a_N151,
      O => a_Mshift_n0002_Sh_12_Q
    );
  a_Mshift_n0002_Sh_15_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_N171,
      ADR2 => a_N50,
      O => a_Mshift_n0002_Sh_15_Q
    );
  a_get_word_4_190 : X_LUT4
    generic map(
      INIT => X"0070"
    )
    port map (
      ADR0 => h_get_word_buf(3),
      ADR1 => N411,
      ADR2 => a_n0000(4),
      ADR3 => N121,
      O => CHOICE5134
    );
  h_response_buf_1_1_18 : X_FF
    generic map(
      INIT => '1'
    )
    port map (
      I => h_response(1),
      SET => GSR,
      CLK => CLKMA0_OBUF,
      O => h_response_buf_1_1,
      CE => VCC,
      RST => GND
    );
  a_Ker98 : X_LUT4
    generic map(
      INIT => X"F1E0"
    )
    port map (
      ADR0 => h_get_word_buf(9),
      ADR1 => N241,
      ADR2 => N6235,
      ADR3 => N502,
      O => a_N98
    );
  a_get_word_21_65 : X_LUT3
    generic map(
      INIT => X"E0"
    )
    port map (
      ADR0 => h_get_word_buf(9),
      ADR1 => N241,
      ADR2 => N6211,
      O => CHOICE4396
    );
  a_Ker143 : X_LUT4
    generic map(
      INIT => X"E0F1"
    )
    port map (
      ADR0 => h_get_word_buf(9),
      ADR1 => N241,
      ADR2 => a_Mshift_n0002_Sh_13_Q,
      ADR3 => N6296,
      O => a_N143
    );
  a_get_word_13_155_SW1_SW0 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => N6306,
      ADR1 => a_put_right_word(13),
      ADR2 => a_put_left_word(13),
      O => N5540
    );
  a_get_word_19_138_SW0 : X_LUT4
    generic map(
      INIT => X"AA20"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => N6208,
      ADR2 => a_Mshift_n0002_Sh_3_Q,
      ADR3 => CHOICE5006,
      O => N5283
    );
  a_Ker3791 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => N6318,
      O => a_N379
    );
  s_get_right_word_27_1_SW1 : X_LUT4
    generic map(
      INIT => X"0B00"
    )
    port map (
      ADR0 => s_put_word_buf(27),
      ADR1 => s_right_conflict,
      ADR2 => N121,
      ADR3 => N411,
      O => N5441
    );
  h_put_address_buf_17_rt_19 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(17),
      O => h_put_address_buf_17_rt,
      ADR1 => GND
    );
  a_Ker761 : X_LUT4
    generic map(
      INIT => X"4000"
    )
    port map (
      ADR0 => N5337,
      ADR1 => a_funct(1),
      ADR2 => a_shift_4_1,
      ADR3 => a_put_left_word(31),
      O => a_N76
    );
  a_get_word_28_175 : X_LUT4
    generic map(
      INIT => X"F8F0"
    )
    port map (
      ADR0 => a_put_left_word(28),
      ADR1 => a_put_right_word(28),
      ADR2 => N6333,
      ADR3 => a_N379,
      O => CHOICE4208
    );
  a_get_word_31_233_SW11_G : X_LUT4
    generic map(
      INIT => X"FDDD"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => h_response_buf(0),
      ADR2 => N411,
      ADR3 => h_get_word_buf(3),
      O => N6018
    );
  a_put_right_word_19_SW2 : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => N6299,
      O => N5431
    );
  a_get_word_12_90_SW11_G : X_LUT4
    generic map(
      INIT => X"FDDD"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => h_response_buf(0),
      ADR2 => h_get_word_buf(2),
      ADR3 => N411,
      O => N6020
    );
  s_get_right_word_3_1_SW0 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(3),
      ADR1 => N5362,
      ADR2 => N411,
      ADR3 => N111,
      O => N5257
    );
  a_Mshift_n0003_Sh_56_Q_20 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => N6288,
      ADR2 => a_N64,
      O => a_Mshift_n0003_Sh_56_Q
    );
  a_Mshift_n0002_Sh_42_SW1 : X_LUT4
    generic map(
      INIT => X"FF1B"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => N529,
      ADR2 => N6243,
      ADR3 => h_get_word_buf(9),
      O => N5805
    );
  a_Mshift_n0003_Sh_62_1 : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(31),
      ADR1 => N6339,
      ADR2 => a_shift(1),
      ADR3 => a_Mshift_n0003_Sh_30_Q,
      O => a_Mshift_n0003_Sh_62_Q
    );
  a_Mshift_n0003_Sh_55_6 : X_LUT4
    generic map(
      INIT => X"F1E0"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => N241,
      ADR2 => a_Mshift_n0003_Sh_29_Q,
      ADR3 => a_Mshift_n0003_Sh_25_Q,
      O => CHOICE3790
    );
  s_get_right_word_1_1_SW0 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(1),
      ADR1 => N5356,
      ADR2 => N6196,
      ADR3 => N111,
      O => N5263
    );
  a_get_word_0_182_SW0 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => h_get_word_buf(10),
      ADR1 => h_get_word_buf(9),
      ADR2 => a_shift(0),
      ADR3 => h_get_word_buf(8),
      O => N5803
    );
  a_get_word_28_141_SW1 : X_LUT4
    generic map(
      INIT => X"FF45"
    )
    port map (
      ADR0 => N5841,
      ADR1 => CHOICE4180,
      ADR2 => a_funct(2),
      ADR3 => CHOICE4208,
      O => N5530
    );
  s_get_right_word_2_1_SW0 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(2),
      ADR1 => N5360,
      ADR2 => N411,
      ADR3 => N6202,
      O => N5260
    );
  s_put_word_buf_27 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6212,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(27),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_30 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6220,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(30),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_29 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6221,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(29),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_get_right_word_2_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(2),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(2),
      O => s_get_right_word(2)
    );
  s_get_right_word_3_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(3),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(3),
      O => s_get_right_word(3)
    );
  s_Mram_reg_inst_ramb_0 : X_RAMB16_S36_S36
    generic map(
      WRITE_MODE_A => "READ_FIRST",
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_10 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_11 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_12 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_13 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_14 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_15 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_16 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_17 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_18 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_19 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1F => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_20 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_21 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_22 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_23 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_24 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_25 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_26 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_27 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_28 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_29 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2F => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_30 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_31 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_32 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_33 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_34 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_35 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_36 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_37 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_38 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_39 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3F => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_A => X"000000000",
      INIT_B => X"000000000",
      SRVAL_A => X"000000000",
      SRVAL_B => X"000000000"
    )
    port map (
      CLKA => CLKMA0_OBUF,
      CLKB => CLKMA0_OBUF,
      ENA => CEA2_OBUF,
      ENB => CEA2_OBUF,
      SSRA => CEA2X_OBUF,
      SSRB => CEA2X_OBUF,
      WEA => s_request,
      WEB => CEA2X_OBUF,
      GSR => GSR,
      ADDRA(8) => CEA2X_OBUF,
      ADDRA(7) => CEA2X_OBUF,
      ADDRA(6) => CEA2X_OBUF,
      ADDRA(5) => CEA2X_OBUF,
      ADDRA(4) => s_put_address(4),
      ADDRA(3) => s_put_address(3),
      ADDRA(2) => s_put_address(2),
      ADDRA(1) => s_put_address(1),
      ADDRA(0) => s_put_address(0),
      ADDRB(8) => CEA2X_OBUF,
      ADDRB(7) => CEA2X_OBUF,
      ADDRB(6) => CEA2X_OBUF,
      ADDRB(5) => CEA2X_OBUF,
      ADDRB(4) => N5028,
      ADDRB(3) => N5027,
      ADDRB(2) => N5025,
      ADDRB(1) => N5023,
      ADDRB(0) => N5021,
      DIA(31) => a_get_word(31),
      DIA(30) => a_get_word(30),
      DIA(29) => a_get_word(29),
      DIA(28) => a_get_word(28),
      DIA(27) => a_get_word(27),
      DIA(26) => a_get_word(26),
      DIA(25) => a_get_word(25),
      DIA(24) => a_get_word(24),
      DIA(23) => a_get_word(23),
      DIA(22) => a_get_word(22),
      DIA(21) => a_get_word(21),
      DIA(20) => a_get_word(20),
      DIA(19) => a_get_word(19),
      DIA(18) => a_get_word(18),
      DIA(17) => a_get_word(17),
      DIA(16) => a_get_word(16),
      DIA(15) => a_get_word(15),
      DIA(14) => a_get_word(14),
      DIA(13) => a_get_word(13),
      DIA(12) => a_get_word(12),
      DIA(11) => a_get_word(11),
      DIA(10) => a_get_word(10),
      DIA(9) => a_get_word(9),
      DIA(8) => a_get_word(8),
      DIA(7) => a_get_word(7),
      DIA(6) => a_get_word(6),
      DIA(5) => a_get_word(5),
      DIA(4) => a_get_word(4),
      DIA(3) => a_get_word(3),
      DIA(2) => a_get_word(2),
      DIA(1) => a_get_word(1),
      DIA(0) => a_get_word(0),
      DIB(31) => CEA2X_OBUF,
      DIB(30) => CEA2X_OBUF,
      DIB(29) => CEA2X_OBUF,
      DIB(28) => CEA2X_OBUF,
      DIB(27) => CEA2X_OBUF,
      DIB(26) => CEA2X_OBUF,
      DIB(25) => CEA2X_OBUF,
      DIB(24) => CEA2X_OBUF,
      DIB(23) => CEA2X_OBUF,
      DIB(22) => CEA2X_OBUF,
      DIB(21) => CEA2X_OBUF,
      DIB(20) => CEA2X_OBUF,
      DIB(19) => CEA2X_OBUF,
      DIB(18) => CEA2X_OBUF,
      DIB(17) => CEA2X_OBUF,
      DIB(16) => CEA2X_OBUF,
      DIB(15) => CEA2X_OBUF,
      DIB(14) => CEA2X_OBUF,
      DIB(13) => CEA2X_OBUF,
      DIB(12) => CEA2X_OBUF,
      DIB(11) => CEA2X_OBUF,
      DIB(10) => CEA2X_OBUF,
      DIB(9) => CEA2X_OBUF,
      DIB(8) => CEA2X_OBUF,
      DIB(7) => CEA2X_OBUF,
      DIB(6) => CEA2X_OBUF,
      DIB(5) => CEA2X_OBUF,
      DIB(4) => CEA2X_OBUF,
      DIB(3) => CEA2X_OBUF,
      DIB(2) => CEA2X_OBUF,
      DIB(1) => CEA2X_OBUF,
      DIB(0) => CEA2X_OBUF,
      DIPA(3) => CEA2X_OBUF,
      DIPA(2) => CEA2X_OBUF,
      DIPA(1) => CEA2X_OBUF,
      DIPA(0) => CEA2X_OBUF,
      DIPB(3) => CEA2X_OBUF,
      DIPB(2) => CEA2X_OBUF,
      DIPB(1) => CEA2X_OBUF,
      DIPB(0) => CEA2X_OBUF,
      DOA(31) => NLW_s_Mram_reg_inst_ramb_0_DOA_31_UNCONNECTED,
      DOA(30) => NLW_s_Mram_reg_inst_ramb_0_DOA_30_UNCONNECTED,
      DOA(29) => NLW_s_Mram_reg_inst_ramb_0_DOA_29_UNCONNECTED,
      DOA(28) => NLW_s_Mram_reg_inst_ramb_0_DOA_28_UNCONNECTED,
      DOA(27) => NLW_s_Mram_reg_inst_ramb_0_DOA_27_UNCONNECTED,
      DOA(26) => NLW_s_Mram_reg_inst_ramb_0_DOA_26_UNCONNECTED,
      DOA(25) => NLW_s_Mram_reg_inst_ramb_0_DOA_25_UNCONNECTED,
      DOA(24) => NLW_s_Mram_reg_inst_ramb_0_DOA_24_UNCONNECTED,
      DOA(23) => NLW_s_Mram_reg_inst_ramb_0_DOA_23_UNCONNECTED,
      DOA(22) => NLW_s_Mram_reg_inst_ramb_0_DOA_22_UNCONNECTED,
      DOA(21) => NLW_s_Mram_reg_inst_ramb_0_DOA_21_UNCONNECTED,
      DOA(20) => NLW_s_Mram_reg_inst_ramb_0_DOA_20_UNCONNECTED,
      DOA(19) => NLW_s_Mram_reg_inst_ramb_0_DOA_19_UNCONNECTED,
      DOA(18) => NLW_s_Mram_reg_inst_ramb_0_DOA_18_UNCONNECTED,
      DOA(17) => NLW_s_Mram_reg_inst_ramb_0_DOA_17_UNCONNECTED,
      DOA(16) => NLW_s_Mram_reg_inst_ramb_0_DOA_16_UNCONNECTED,
      DOA(15) => NLW_s_Mram_reg_inst_ramb_0_DOA_15_UNCONNECTED,
      DOA(14) => NLW_s_Mram_reg_inst_ramb_0_DOA_14_UNCONNECTED,
      DOA(13) => NLW_s_Mram_reg_inst_ramb_0_DOA_13_UNCONNECTED,
      DOA(12) => NLW_s_Mram_reg_inst_ramb_0_DOA_12_UNCONNECTED,
      DOA(11) => NLW_s_Mram_reg_inst_ramb_0_DOA_11_UNCONNECTED,
      DOA(10) => NLW_s_Mram_reg_inst_ramb_0_DOA_10_UNCONNECTED,
      DOA(9) => NLW_s_Mram_reg_inst_ramb_0_DOA_9_UNCONNECTED,
      DOA(8) => NLW_s_Mram_reg_inst_ramb_0_DOA_8_UNCONNECTED,
      DOA(7) => NLW_s_Mram_reg_inst_ramb_0_DOA_7_UNCONNECTED,
      DOA(6) => NLW_s_Mram_reg_inst_ramb_0_DOA_6_UNCONNECTED,
      DOA(5) => NLW_s_Mram_reg_inst_ramb_0_DOA_5_UNCONNECTED,
      DOA(4) => NLW_s_Mram_reg_inst_ramb_0_DOA_4_UNCONNECTED,
      DOA(3) => NLW_s_Mram_reg_inst_ramb_0_DOA_3_UNCONNECTED,
      DOA(2) => NLW_s_Mram_reg_inst_ramb_0_DOA_2_UNCONNECTED,
      DOA(1) => NLW_s_Mram_reg_inst_ramb_0_DOA_1_UNCONNECTED,
      DOA(0) => NLW_s_Mram_reg_inst_ramb_0_DOA_0_UNCONNECTED,
      DOPA(3) => NLW_s_Mram_reg_inst_ramb_0_DOPA_3_UNCONNECTED,
      DOPA(2) => NLW_s_Mram_reg_inst_ramb_0_DOPA_2_UNCONNECTED,
      DOPA(1) => NLW_s_Mram_reg_inst_ramb_0_DOPA_1_UNCONNECTED,
      DOPA(0) => NLW_s_Mram_reg_inst_ramb_0_DOPA_0_UNCONNECTED,
      DOB(31) => s_get_left_word_buf(31),
      DOB(30) => s_get_left_word_buf(30),
      DOB(29) => s_get_left_word_buf(29),
      DOB(28) => s_get_left_word_buf(28),
      DOB(27) => s_get_left_word_buf(27),
      DOB(26) => s_get_left_word_buf(26),
      DOB(25) => s_get_left_word_buf(25),
      DOB(24) => s_get_left_word_buf(24),
      DOB(23) => s_get_left_word_buf(23),
      DOB(22) => s_get_left_word_buf(22),
      DOB(21) => s_get_left_word_buf(21),
      DOB(20) => s_get_left_word_buf(20),
      DOB(19) => s_get_left_word_buf(19),
      DOB(18) => s_get_left_word_buf(18),
      DOB(17) => s_get_left_word_buf(17),
      DOB(16) => s_get_left_word_buf(16),
      DOB(15) => s_get_left_word_buf(15),
      DOB(14) => s_get_left_word_buf(14),
      DOB(13) => s_get_left_word_buf(13),
      DOB(12) => s_get_left_word_buf(12),
      DOB(11) => s_get_left_word_buf(11),
      DOB(10) => s_get_left_word_buf(10),
      DOB(9) => s_get_left_word_buf(9),
      DOB(8) => s_get_left_word_buf(8),
      DOB(7) => s_get_left_word_buf(7),
      DOB(6) => s_get_left_word_buf(6),
      DOB(5) => s_get_left_word_buf(5),
      DOB(4) => s_get_left_word_buf(4),
      DOB(3) => s_get_left_word_buf(3),
      DOB(2) => s_get_left_word_buf(2),
      DOB(1) => s_get_left_word_buf(1),
      DOB(0) => s_get_left_word_buf(0),
      DOPB(3) => NLW_s_Mram_reg_inst_ramb_0_DOPB_3_UNCONNECTED,
      DOPB(2) => NLW_s_Mram_reg_inst_ramb_0_DOPB_2_UNCONNECTED,
      DOPB(1) => NLW_s_Mram_reg_inst_ramb_0_DOPB_1_UNCONNECTED,
      DOPB(0) => NLW_s_Mram_reg_inst_ramb_0_DOPB_0_UNCONNECTED
    );
  s_Mram_reg_ren_inst_ramb_1 : X_RAMB16_S36_S36
    generic map(
      WRITE_MODE_A => "READ_FIRST",
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_10 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_11 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_12 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_13 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_14 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_15 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_16 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_17 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_18 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_19 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1F => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_20 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_21 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_22 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_23 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_24 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_25 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_26 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_27 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_28 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_29 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2F => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_30 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_31 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_32 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_33 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_34 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_35 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_36 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_37 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_38 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_39 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3F => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_A => X"000000000",
      INIT_B => X"000000000",
      SRVAL_A => X"000000000",
      SRVAL_B => X"000000000"
    )
    port map (
      CLKA => CLKMA0_OBUF,
      CLKB => CLKMA0_OBUF,
      ENA => CEA2_OBUF,
      ENB => CEA2_OBUF,
      SSRA => CEA2X_OBUF,
      SSRB => CEA2X_OBUF,
      WEA => s_request,
      WEB => CEA2X_OBUF,
      GSR => GSR,
      ADDRA(8) => CEA2X_OBUF,
      ADDRA(7) => CEA2X_OBUF,
      ADDRA(6) => CEA2X_OBUF,
      ADDRA(5) => CEA2X_OBUF,
      ADDRA(4) => s_put_address(4),
      ADDRA(3) => s_put_address(3),
      ADDRA(2) => s_put_address(2),
      ADDRA(1) => s_put_address(1),
      ADDRA(0) => s_put_address(0),
      ADDRB(8) => CEA2X_OBUF,
      ADDRB(7) => CEA2X_OBUF,
      ADDRB(6) => CEA2X_OBUF,
      ADDRB(5) => CEA2X_OBUF,
      ADDRB(4) => N5019,
      ADDRB(3) => N5026,
      ADDRB(2) => N5024,
      ADDRB(1) => N5022,
      ADDRB(0) => N5020,
      DIA(31) => a_get_word(31),
      DIA(30) => a_get_word(30),
      DIA(29) => a_get_word(29),
      DIA(28) => a_get_word(28),
      DIA(27) => a_get_word(27),
      DIA(26) => a_get_word(26),
      DIA(25) => a_get_word(25),
      DIA(24) => a_get_word(24),
      DIA(23) => a_get_word(23),
      DIA(22) => a_get_word(22),
      DIA(21) => a_get_word(21),
      DIA(20) => a_get_word(20),
      DIA(19) => a_get_word(19),
      DIA(18) => a_get_word(18),
      DIA(17) => a_get_word(17),
      DIA(16) => a_get_word(16),
      DIA(15) => a_get_word(15),
      DIA(14) => a_get_word(14),
      DIA(13) => a_get_word(13),
      DIA(12) => a_get_word(12),
      DIA(11) => a_get_word(11),
      DIA(10) => a_get_word(10),
      DIA(9) => a_get_word(9),
      DIA(8) => a_get_word(8),
      DIA(7) => a_get_word(7),
      DIA(6) => a_get_word(6),
      DIA(5) => a_get_word(5),
      DIA(4) => a_get_word(4),
      DIA(3) => a_get_word(3),
      DIA(2) => a_get_word(2),
      DIA(1) => a_get_word(1),
      DIA(0) => a_get_word(0),
      DIB(31) => CEA2X_OBUF,
      DIB(30) => CEA2X_OBUF,
      DIB(29) => CEA2X_OBUF,
      DIB(28) => CEA2X_OBUF,
      DIB(27) => CEA2X_OBUF,
      DIB(26) => CEA2X_OBUF,
      DIB(25) => CEA2X_OBUF,
      DIB(24) => CEA2X_OBUF,
      DIB(23) => CEA2X_OBUF,
      DIB(22) => CEA2X_OBUF,
      DIB(21) => CEA2X_OBUF,
      DIB(20) => CEA2X_OBUF,
      DIB(19) => CEA2X_OBUF,
      DIB(18) => CEA2X_OBUF,
      DIB(17) => CEA2X_OBUF,
      DIB(16) => CEA2X_OBUF,
      DIB(15) => CEA2X_OBUF,
      DIB(14) => CEA2X_OBUF,
      DIB(13) => CEA2X_OBUF,
      DIB(12) => CEA2X_OBUF,
      DIB(11) => CEA2X_OBUF,
      DIB(10) => CEA2X_OBUF,
      DIB(9) => CEA2X_OBUF,
      DIB(8) => CEA2X_OBUF,
      DIB(7) => CEA2X_OBUF,
      DIB(6) => CEA2X_OBUF,
      DIB(5) => CEA2X_OBUF,
      DIB(4) => CEA2X_OBUF,
      DIB(3) => CEA2X_OBUF,
      DIB(2) => CEA2X_OBUF,
      DIB(1) => CEA2X_OBUF,
      DIB(0) => CEA2X_OBUF,
      DIPA(3) => CEA2X_OBUF,
      DIPA(2) => CEA2X_OBUF,
      DIPA(1) => CEA2X_OBUF,
      DIPA(0) => CEA2X_OBUF,
      DIPB(3) => CEA2X_OBUF,
      DIPB(2) => CEA2X_OBUF,
      DIPB(1) => CEA2X_OBUF,
      DIPB(0) => CEA2X_OBUF,
      DOA(31) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_31_UNCONNECTED,
      DOA(30) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_30_UNCONNECTED,
      DOA(29) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_29_UNCONNECTED,
      DOA(28) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_28_UNCONNECTED,
      DOA(27) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_27_UNCONNECTED,
      DOA(26) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_26_UNCONNECTED,
      DOA(25) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_25_UNCONNECTED,
      DOA(24) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_24_UNCONNECTED,
      DOA(23) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_23_UNCONNECTED,
      DOA(22) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_22_UNCONNECTED,
      DOA(21) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_21_UNCONNECTED,
      DOA(20) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_20_UNCONNECTED,
      DOA(19) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_19_UNCONNECTED,
      DOA(18) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_18_UNCONNECTED,
      DOA(17) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_17_UNCONNECTED,
      DOA(16) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_16_UNCONNECTED,
      DOA(15) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_15_UNCONNECTED,
      DOA(14) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_14_UNCONNECTED,
      DOA(13) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_13_UNCONNECTED,
      DOA(12) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_12_UNCONNECTED,
      DOA(11) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_11_UNCONNECTED,
      DOA(10) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_10_UNCONNECTED,
      DOA(9) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_9_UNCONNECTED,
      DOA(8) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_8_UNCONNECTED,
      DOA(7) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_7_UNCONNECTED,
      DOA(6) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_6_UNCONNECTED,
      DOA(5) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_5_UNCONNECTED,
      DOA(4) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_4_UNCONNECTED,
      DOA(3) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_3_UNCONNECTED,
      DOA(2) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_2_UNCONNECTED,
      DOA(1) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_1_UNCONNECTED,
      DOA(0) => NLW_s_Mram_reg_ren_inst_ramb_1_DOA_0_UNCONNECTED,
      DOPA(3) => NLW_s_Mram_reg_ren_inst_ramb_1_DOPA_3_UNCONNECTED,
      DOPA(2) => NLW_s_Mram_reg_ren_inst_ramb_1_DOPA_2_UNCONNECTED,
      DOPA(1) => NLW_s_Mram_reg_ren_inst_ramb_1_DOPA_1_UNCONNECTED,
      DOPA(0) => NLW_s_Mram_reg_ren_inst_ramb_1_DOPA_0_UNCONNECTED,
      DOB(31) => s_get_right_word_buf(31),
      DOB(30) => s_get_right_word_buf(30),
      DOB(29) => s_get_right_word_buf(29),
      DOB(28) => s_get_right_word_buf(28),
      DOB(27) => s_get_right_word_buf(27),
      DOB(26) => s_get_right_word_buf(26),
      DOB(25) => s_get_right_word_buf(25),
      DOB(24) => s_get_right_word_buf(24),
      DOB(23) => s_get_right_word_buf(23),
      DOB(22) => s_get_right_word_buf(22),
      DOB(21) => s_get_right_word_buf(21),
      DOB(20) => s_get_right_word_buf(20),
      DOB(19) => s_get_right_word_buf(19),
      DOB(18) => s_get_right_word_buf(18),
      DOB(17) => s_get_right_word_buf(17),
      DOB(16) => s_get_right_word_buf(16),
      DOB(15) => s_get_right_word_buf(15),
      DOB(14) => s_get_right_word_buf(14),
      DOB(13) => s_get_right_word_buf(13),
      DOB(12) => s_get_right_word_buf(12),
      DOB(11) => s_get_right_word_buf(11),
      DOB(10) => s_get_right_word_buf(10),
      DOB(9) => s_get_right_word_buf(9),
      DOB(8) => s_get_right_word_buf(8),
      DOB(7) => s_get_right_word_buf(7),
      DOB(6) => s_get_right_word_buf(6),
      DOB(5) => s_get_right_word_buf(5),
      DOB(4) => s_get_right_word_buf(4),
      DOB(3) => s_get_right_word_buf(3),
      DOB(2) => s_get_right_word_buf(2),
      DOB(1) => s_get_right_word_buf(1),
      DOB(0) => s_get_right_word_buf(0),
      DOPB(3) => NLW_s_Mram_reg_ren_inst_ramb_1_DOPB_3_UNCONNECTED,
      DOPB(2) => NLW_s_Mram_reg_ren_inst_ramb_1_DOPB_2_UNCONNECTED,
      DOPB(1) => NLW_s_Mram_reg_ren_inst_ramb_1_DOPB_1_UNCONNECTED,
      DOPB(0) => NLW_s_Mram_reg_ren_inst_ramb_1_DOPB_0_UNCONNECTED
    );
  s_left_conflict_21 : X_SFF
    generic map(
      INIT => '0'
    )
    port map (
      I => CEA2_OBUF,
      SRST => s_left_conflict_N0,
      CLK => CLKMA0_OBUF,
      O => s_left_conflict,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  s_right_conflict_22 : X_SFF
    generic map(
      INIT => '0'
    )
    port map (
      I => CEA2_OBUF,
      SRST => s_right_conflict_N0,
      CLK => CLKMA0_OBUF,
      O => s_right_conflict,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  s_put_word_buf_31 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6219,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(31),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_28 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6295,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(28),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_26 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6223,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(26),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_get_right_word_4_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(4),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(4),
      O => s_get_right_word(4)
    );
  s_get_right_word_5_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(5),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(5),
      O => s_get_right_word(5)
    );
  s_get_right_word_6_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(6),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(6),
      O => s_get_right_word(6)
    );
  s_get_right_word_7_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(7),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(7),
      O => s_get_right_word(7)
    );
  s_get_right_word_8_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(8),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(8),
      O => s_get_right_word(8)
    );
  s_get_right_word_9_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(9),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(9),
      O => s_get_right_word(9)
    );
  s_get_right_word_10_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(10),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(10),
      O => s_get_right_word(10)
    );
  s_get_right_word_11_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(11),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(11),
      O => s_get_right_word(11)
    );
  s_get_right_word_12_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(12),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(12),
      O => s_get_right_word(12)
    );
  s_get_right_word_13_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(13),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(13),
      O => s_get_right_word(13)
    );
  s_get_right_word_14_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(14),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(14),
      O => s_get_right_word(14)
    );
  s_get_right_word_15_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(15),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(15),
      O => s_get_right_word(15)
    );
  s_get_right_word_16_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(16),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(16),
      O => s_get_right_word(16)
    );
  s_get_right_word_18_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(18),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(18),
      O => s_get_right_word(18)
    );
  s_get_right_word_19_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(19),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(19),
      O => s_get_right_word(19)
    );
  s_get_right_word_23_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(23),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(23),
      O => s_get_right_word(23)
    );
  s_get_right_word_24_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(24),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(24),
      O => s_get_right_word(24)
    );
  s_get_right_word_25_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(25),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(25),
      O => s_get_right_word(25)
    );
  s_get_right_word_26_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(26),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(26),
      O => s_get_right_word(26)
    );
  s_get_right_word_27_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(27),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(27),
      O => s_get_right_word(27)
    );
  s_get_right_word_28_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(28),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(28),
      O => s_get_right_word(28)
    );
  s_get_right_word_29_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(29),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(29),
      O => s_get_right_word(29)
    );
  s_get_right_word_30_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(30),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(30),
      O => s_get_right_word(30)
    );
  s_get_right_word_31_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_get_right_word_buf(31),
      ADR2 => s_put_word_buf(31),
      O => s_get_right_word(31)
    );
  s_get_right_word_1_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(1),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(1),
      O => s_get_right_word(1)
    );
  s_get_right_word_0_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(0),
      ADR1 => s_right_conflict1,
      ADR2 => s_get_right_word_buf(0),
      O => s_get_right_word(0)
    );
  s_put_word_buf_0 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6217,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(0),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_1 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6216,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(1),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_2 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6218,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(2),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_3 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6215,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(3),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_4 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6207,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(4),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_5 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6205,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(5),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_6 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6234,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(6),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_7 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6233,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(7),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_8 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6331,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(8),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_9 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6308,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(9),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_10 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6319,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(10),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_11 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6327,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(11),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_12 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6222,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(12),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_13 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6232,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(13),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_14 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6307,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(14),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_15 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6305,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(15),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_16 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6246,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(16),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_17 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6249,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(17),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_18 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6231,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(18),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_19 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6230,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(19),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_20 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6229,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(20),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_21 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6228,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(21),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_22 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6227,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(22),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_23 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6226,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(23),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_put_word_buf_24 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N6225,
      CLK => CLKMA0_OBUF,
      O => s_put_word_buf(24),
      CE => VCC,
      SET => GND,
      RST => GSR
    );
  s_request_SW0 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => h_get_word_buf(27),
      ADR1 => h_response_buf_1,
      O => N511
    );
  s_put_address_4_SW3 : X_LUT3
    generic map(
      INIT => X"BF"
    )
    port map (
      ADR0 => h_response_buf(0),
      ADR1 => h_get_word_buf(26),
      ADR2 => h_get_word_buf(25),
      O => N5816
    );
  s_put_address_0_SW2 : X_LUT4
    generic map(
      INIT => X"FF1B"
    )
    port map (
      ADR0 => h_get_word_buf(26),
      ADR1 => h_get_word_buf(11),
      ADR2 => h_get_word_buf(16),
      ADR3 => h_response_buf(0),
      O => N5823
    );
  s_put_address_0_SW3 : X_LUT3
    generic map(
      INIT => X"BF"
    )
    port map (
      ADR0 => h_response_buf(0),
      ADR1 => h_get_word_buf(26),
      ADR2 => h_get_word_buf(21),
      O => N5824
    );
  s_put_address_3_SW2 : X_LUT4
    generic map(
      INIT => X"FF1B"
    )
    port map (
      ADR0 => h_get_word_buf(26),
      ADR1 => h_get_word_buf(14),
      ADR2 => h_get_word_buf(19),
      ADR3 => h_response_buf(0),
      O => N5820
    );
  s_put_address_3_SW3 : X_LUT3
    generic map(
      INIT => X"BF"
    )
    port map (
      ADR0 => h_response_buf(0),
      ADR1 => h_get_word_buf(26),
      ADR2 => h_get_word_buf(24),
      O => N5821
    );
  s_put_address_1_SW2 : X_LUT4
    generic map(
      INIT => X"FF1B"
    )
    port map (
      ADR0 => h_get_word_buf(26),
      ADR1 => h_get_word_buf(12),
      ADR2 => h_get_word_buf(17),
      ADR3 => h_response_buf(0),
      O => N5826
    );
  s_put_address_1_SW3 : X_LUT3
    generic map(
      INIT => X"BF"
    )
    port map (
      ADR0 => h_response_buf(0),
      ADR1 => h_get_word_buf(26),
      ADR2 => h_get_word_buf(22),
      O => N5827
    );
  s_put_address_2_SW2 : X_LUT4
    generic map(
      INIT => X"FF1B"
    )
    port map (
      ADR0 => h_get_word_buf(26),
      ADR1 => h_get_word_buf(13),
      ADR2 => h_get_word_buf(18),
      ADR3 => h_response_buf(0),
      O => N5829
    );
  s_put_address_2_SW3 : X_LUT3
    generic map(
      INIT => X"BF"
    )
    port map (
      ADR0 => h_response_buf(0),
      ADR1 => h_get_word_buf(26),
      ADR2 => h_get_word_buf(23),
      O => N5830
    );
  Ker10_SW1 : X_LUT4
    generic map(
      INIT => X"FFDF"
    )
    port map (
      ADR0 => h_get_word_buf(20),
      ADR1 => h_get_word_buf(27),
      ADR2 => h_response_buf_1,
      ADR3 => h_response_buf(0),
      O => N5809
    );
  a_Mshift_n0003_Sh_55_29_SW0 : X_LUT4
    generic map(
      INIT => X"EFFF"
    )
    port map (
      ADR0 => h_get_word_buf(9),
      ADR1 => N241,
      ADR2 => h_get_word_buf(10),
      ADR3 => N6197,
      O => N5346
    );
  s_get_left_word_19_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(19),
      ADR1 => s_put_word_buf(19),
      ADR2 => Ker21_11,
      ADR3 => s_left_conflict_5,
      O => N5189
    );
  s_get_left_word_5_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(5),
      ADR1 => s_put_word_buf(5),
      ADR2 => Ker21_14,
      ADR3 => s_left_conflict_3,
      O => N5204
    );
  s_get_right_word_0_1_SW0 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(0),
      ADR1 => N5352,
      ADR2 => N411,
      ADR3 => N111,
      O => N5266
    );
  s_get_left_word_2_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(2),
      ADR1 => s_put_word_buf(2),
      ADR2 => N6203,
      ADR3 => s_left_conflict_3,
      O => N5195
    );
  a_get_word_18_224_SW0 : X_LUT4
    generic map(
      INIT => X"FFF8"
    )
    port map (
      ADR0 => a_put_right_word(18),
      ADR1 => CHOICE5079,
      ADR2 => N5277,
      ADR3 => a_N76,
      O => N5302
    );
  AA_5_OBUF_23 : X_BUF
    port map (
      I => AA_5_OBUF,
      O => AA_5_OBUF_GTS_TRI
    );
  s_get_left_word_6_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(6),
      ADR1 => s_put_word_buf(6),
      ADR2 => Ker21_14,
      ADR3 => s_left_conflict_3,
      O => N5207
    );
  a_Ker88_SW0 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_N2,
      ADR2 => a_N59,
      O => N512
    );
  s_get_left_word_7_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(7),
      ADR1 => s_put_word_buf(7),
      ADR2 => Ker21_14,
      ADR3 => s_left_conflict_3,
      O => N5210
    );
  a_get_word_27_6 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => a_funct(2),
      ADR2 => a_put_left_word(27),
      ADR3 => a_put_right_word(27),
      O => CHOICE4035
    );
  a_Ker181_SW0 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_N191,
      ADR2 => a_N52,
      O => N506
    );
  a_Ker97_SW0 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_N181,
      ADR2 => a_N511,
      O => N504
    );
  a_Mshift_n0003_Sh_59_SW0 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_Mshift_n0003_Sh_27_Q,
      ADR2 => a_Mshift_n0003_Sh_29_Q,
      O => N494
    );
  AA_4_OBUF_24 : X_BUF
    port map (
      I => AA_4_OBUF,
      O => AA_4_OBUF_GTS_TRI
    );
  AA_10_OBUF_25 : X_BUF
    port map (
      I => AA_10_OBUF,
      O => AA_10_OBUF_GTS_TRI
    );
  a_put_right_word_1_SW0_SW1 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => s_put_word_buf(1),
      ADR1 => s_right_conflict_2,
      O => N5356
    );
  a_put_right_word_2_SW0_SW1 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => s_put_word_buf(2),
      ADR1 => s_right_conflict_2,
      O => N5360
    );
  a_put_right_word_3_SW0_SW1 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => s_put_word_buf(3),
      ADR1 => s_right_conflict_2,
      O => N5364
    );
  a_put_right_word_4_SW0_SW1 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => s_put_word_buf(4),
      ADR1 => s_right_conflict_2,
      O => N5368
    );
  a_put_right_word_5_SW0_SW1 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => s_put_word_buf(5),
      ADR1 => s_right_conflict_4,
      O => N5372
    );
  s_get_right_word_11_1_SW0 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(11),
      ADR1 => N5394,
      ADR2 => N411,
      ADR3 => N111,
      O => N5317
    );
  a_Mshift_n0003_Sh_55_27 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_shift_2_1,
      ADR2 => a_Mshift_n0003_Sh_27_Q,
      ADR3 => a_Mshift_n0003_Sh_23_Q,
      O => CHOICE3797
    );
  a_put_right_word_6_SW0_SW1 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => s_put_word_buf(6),
      ADR1 => s_right_conflict_4,
      O => N5376
    );
  s_get_right_word_12_1_SW0 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(12),
      ADR1 => N5398,
      ADR2 => N411,
      ADR3 => N111,
      O => N5314
    );
  s_get_right_word_13_1_SW0 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(13),
      ADR1 => N5468,
      ADR2 => N411,
      ADR3 => N111,
      O => N5311
    );
  s_get_right_word_27_1_SW0 : X_LUT4
    generic map(
      INIT => X"0080"
    )
    port map (
      ADR0 => s_put_word_buf(27),
      ADR1 => s_right_conflict,
      ADR2 => N411,
      ADR3 => N121,
      O => N5440
    );
  s_get_left_word_8_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(8),
      ADR1 => s_put_word_buf(8),
      ADR2 => Ker21_12,
      ADR3 => s_left_conflict_3,
      O => N5213
    );
  a_Ker3711_SW0 : X_LUT4
    generic map(
      INIT => X"FDFF"
    )
    port map (
      ADR0 => h_get_word_buf(2),
      ADR1 => h_get_word_buf(5),
      ADR2 => N6166,
      ADR3 => N411,
      O => N5337
    );
  s_get_right_word_14_1_SW0 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(14),
      ADR1 => N5470,
      ADR2 => N411,
      ADR3 => N111,
      O => N5308
    );
  s_get_right_word_15_1_SW0 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(15),
      ADR1 => N5476,
      ADR2 => N411,
      ADR3 => N111,
      O => N5305
    );
  s_get_left_word_9_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(9),
      ADR1 => s_put_word_buf(9),
      ADR2 => Ker21_12,
      ADR3 => s_left_conflict_3,
      O => N5216
    );
  a_put_right_word_14_SW0_SW1 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => s_put_word_buf(14),
      ADR1 => s_right_conflict_3,
      O => N5472
    );
  a_put_right_word_19_SW1 : X_LUT4
    generic map(
      INIT => X"FF8C"
    )
    port map (
      ADR0 => h_get_word_buf(19),
      ADR1 => N6304,
      ADR2 => h_get_word_buf(29),
      ADR3 => N231,
      O => N2311
    );
  a_put_right_word_12_SW0_SW1 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => s_put_word_buf(12),
      ADR1 => s_right_conflict_3,
      O => N5400
    );
  a_get_word_3_173_SW0 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_funct(1),
      ADR2 => CHOICE4941,
      ADR3 => a_n0000(3),
      O => N5221
    );
  a_put_right_word_11_SW0_SW1 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => s_put_word_buf(11),
      ADR1 => s_right_conflict_3,
      O => N5396
    );
  a_put_right_word_10_SW0_SW1 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => s_put_word_buf(10),
      ADR1 => s_right_conflict_3,
      O => N5392
    );
  a_put_right_word_16_SW0 : X_LUT4
    generic map(
      INIT => X"F8F0"
    )
    port map (
      ADR0 => h_get_word_buf(16),
      ADR1 => h_get_word_buf(29),
      ADR2 => N231,
      ADR3 => N451,
      O => N247
    );
  a_get_word_7_62 : X_LUT4
    generic map(
      INIT => X"C480"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_shift(3),
      ADR2 => a_N110,
      ADR3 => a_N59,
      O => CHOICE4872
    );
  a_get_word_29_216 : X_LUT4
    generic map(
      INIT => X"A888"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => CHOICE4318,
      ADR2 => a_Mshift_n0003_Sh_61_Q,
      ADR3 => a_N370,
      O => CHOICE4320
    );
  a_alu_n0000_25_lut_SW0 : X_LUT4
    generic map(
      INIT => X"1FBF"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_get_right_word_buf(25),
      ADR2 => N471,
      ADR3 => s_put_word_buf(25),
      O => N5791
    );
  a_get_word_30_16 : X_LUT3
    generic map(
      INIT => X"60"
    )
    port map (
      ADR0 => a_put_left_word(30),
      ADR1 => N6238,
      ADR2 => a_funct(2),
      O => CHOICE4230
    );
  a_get_word_24_31 : X_LUT4
    generic map(
      INIT => X"E040"
    )
    port map (
      ADR0 => a_shift(4),
      ADR1 => CHOICE3909,
      ADR2 => CHOICE3999,
      ADR3 => a_Mshift_n0002_Sh_40_Q,
      O => CHOICE3916
    );
  a_get_word_27_46 : X_LUT4
    generic map(
      INIT => X"4448"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(0),
      ADR2 => a_put_right_word(27),
      ADR3 => a_put_left_word(27),
      O => CHOICE4047
    );
  a_get_word_14_46 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => N6210,
      ADR1 => a_shift(1),
      ADR2 => a_N64,
      ADR3 => a_N81,
      O => CHOICE4338
    );
  a_get_word_23_148 : X_LUT4
    generic map(
      INIT => X"FAF8"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => CHOICE3890,
      ADR2 => CHOICE3881,
      ADR3 => CHOICE3897,
      O => CHOICE3900
    );
  a_get_word_21_228 : X_LUT4
    generic map(
      INIT => X"FFCA"
    )
    port map (
      ADR0 => N5411,
      ADR1 => N5412,
      ADR2 => a_n0000(21),
      ADR3 => a_N76,
      O => CHOICE4429
    );
  a_get_word_24_103 : X_LUT3
    generic map(
      INIT => X"14"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => a_put_left_word(24),
      ADR2 => a_put_right_word(24),
      O => CHOICE3939
    );
  a_get_word_28_16 : X_LUT3
    generic map(
      INIT => X"28"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_left_word(28),
      ADR2 => N6170,
      O => CHOICE4180
    );
  a_get_word_29_126 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_shift(4),
      ADR2 => a_Mshift_n0002_Sh_45_Q,
      ADR3 => CHOICE4297,
      O => CHOICE4302
    );
  a_get_word_25_84 : X_LUT4
    generic map(
      INIT => X"4448"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(0),
      ADR2 => a_put_right_word(25),
      ADR3 => a_put_left_word(25),
      O => CHOICE3974
    );
  s_left_conflict_Sclr_INV71 : X_LUT4
    generic map(
      INIT => X"6FF6"
    )
    port map (
      ADR0 => N5025,
      ADR1 => s_put_address(2),
      ADR2 => N5023,
      ADR3 => s_put_address(1),
      O => CHOICE3858
    );
  s_right_conflict_Sclr_INV12 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => N5019,
      ADR1 => s_put_address(4),
      O => CHOICE3806
    );
  a_get_word_26_139 : X_LUT4
    generic map(
      INIT => X"FAF8"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => CHOICE4016,
      ADR2 => CHOICE4007,
      ADR3 => CHOICE4023,
      O => CHOICE4026
    );
  a_get_word_15_40 : X_LUT4
    generic map(
      INIT => X"8A28"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_left_word(15),
      ADR2 => a_funct(1),
      ADR3 => a_put_right_word(15),
      O => CHOICE4441
    );
  s_get_right_word_5_1_SW0 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(5),
      ADR1 => N5370,
      ADR2 => N411,
      ADR3 => N111,
      O => N5251
    );
  s_left_conflict_Sclr_INV86 : X_LUT3
    generic map(
      INIT => X"FE"
    )
    port map (
      ADR0 => CHOICE3839,
      ADR1 => CHOICE3847,
      ADR2 => CHOICE3858,
      O => s_left_conflict_N0
    );
  a_get_word_15_191_SW0 : X_LUT4
    generic map(
      INIT => X"1054"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(2),
      ADR2 => a_n0000(15),
      ADR3 => N5286,
      O => N5085
    );
  a_get_word_24_139 : X_LUT4
    generic map(
      INIT => X"FAF8"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => CHOICE3932,
      ADR2 => CHOICE3923,
      ADR3 => CHOICE3939,
      O => CHOICE3942
    );
  a_put_right_word_16_SW0_SW0 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => h_get_word_buf(29),
      ADR1 => h_get_word_buf(16),
      O => N5456
    );
  AA_3_OBUF_26 : X_BUF
    port map (
      I => AA_3_OBUF,
      O => AA_3_OBUF_GTS_TRI
    );
  a_get_word_28_221 : X_LUT4
    generic map(
      INIT => X"A888"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => CHOICE4218,
      ADR2 => a_Mshift_n0003_Sh_60_Q,
      ADR3 => a_N370,
      O => CHOICE4220
    );
  a_get_word_23_5 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => N5818,
      ADR1 => h_get_word_buf(8),
      ADR2 => a_Mshift_n0002_Sh_3_Q,
      ADR3 => a_Mshift_n0002_Sh_7_Q,
      O => CHOICE3863
    );
  a_get_word_14_129 : X_LUT3
    generic map(
      INIT => X"20"
    )
    port map (
      ADR0 => N6198,
      ADR1 => a_funct(0),
      ADR2 => a_funct(2),
      O => CHOICE4358
    );
  a_get_word_14_40 : X_LUT4
    generic map(
      INIT => X"8A28"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_right_word(14),
      ADR2 => a_funct(1),
      ADR3 => a_put_left_word(14),
      O => CHOICE4335
    );
  a_get_word_21_95 : X_LUT4
    generic map(
      INIT => X"FAF8"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => CHOICE4396,
      ADR2 => CHOICE4406,
      ADR3 => CHOICE4398,
      O => CHOICE4407
    );
  a_get_word_20_214 : X_LUT3
    generic map(
      INIT => X"F8"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => N5799,
      ADR2 => a_N76,
      O => CHOICE4122
    );
  a_Ker181 : X_LUT4
    generic map(
      INIT => X"F1E0"
    )
    port map (
      ADR0 => h_get_word_buf(9),
      ADR1 => N241,
      ADR2 => N6236,
      ADR3 => N506,
      O => a_N1811
    );
  a_Ker3801 : X_LUT4
    generic map(
      INIT => X"0155"
    )
    port map (
      ADR0 => N121,
      ADR1 => h_get_word_buf(3),
      ADR2 => h_get_word_buf(5),
      ADR3 => N411,
      O => a_N380
    );
  a_get_word_2_173_SW0 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_funct(1),
      ADR2 => CHOICE4985,
      ADR3 => a_n0000(2),
      O => N5218
    );
  AA_7_OBUF_27 : X_BUF
    port map (
      I => AA_7_OBUF,
      O => AA_7_OBUF_GTS_TRI
    );
  s_right_conflict_Sclr_INV44 : X_LUT4
    generic map(
      INIT => X"66F6"
    )
    port map (
      ADR0 => s_put_address(3),
      ADR1 => N5026,
      ADR2 => N5019,
      ADR3 => s_put_address(4),
      O => CHOICE3816
    );
  a_get_word_16_160_SW0 : X_LUT4
    generic map(
      INIT => X"20A8"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(2),
      ADR2 => CHOICE5432,
      ADR3 => N5561,
      O => N5271
    );
  s_get_right_word_10_1_SW0 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(10),
      ADR1 => N5390,
      ADR2 => N411,
      ADR3 => N111,
      O => N5320
    );
  h_get_word_buf_26_1_28 : X_FF
    generic map(
      INIT => '1'
    )
    port map (
      I => N5029,
      SET => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf_26_1,
      CE => VCC,
      RST => GND
    );
  a_get_word_15_155 : X_LUT4
    generic map(
      INIT => X"F111"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => N5813,
      ADR2 => a_Mshift_n0002_Sh_47_Q,
      ADR3 => CHOICE4734,
      O => CHOICE4471
    );
  a_Ker1961 : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_Mshift_n0003_Sh_62_Q,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => N6213,
      O => a_N196
    );
  a_get_word_12_135 : X_LUT3
    generic map(
      INIT => X"60"
    )
    port map (
      ADR0 => a_put_left_word(12),
      ADR1 => a_put_right_word(12),
      ADR2 => CHOICE4358,
      O => CHOICE4515
    );
  a_get_word_14_208_SW0 : X_LUT4
    generic map(
      INIT => X"1054"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(2),
      ADR2 => a_n0000(14),
      ADR3 => N5288,
      O => N5087
    );
  a_get_word_25_103 : X_LUT3
    generic map(
      INIT => X"14"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => a_put_left_word(25),
      ADR2 => a_put_right_word(25),
      O => CHOICE3981
    );
  a_get_word_6_190 : X_LUT4
    generic map(
      INIT => X"0070"
    )
    port map (
      ADR0 => h_get_word_buf(3),
      ADR1 => N411,
      ADR2 => a_n0000(6),
      ADR3 => N121,
      O => CHOICE5179
    );
  a_get_word_22_214 : X_LUT3
    generic map(
      INIT => X"F8"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => N5801,
      ADR2 => a_N76,
      O => CHOICE4173
    );
  AA_15_OBUF_29 : X_BUF
    port map (
      I => AA_15_OBUF,
      O => AA_15_OBUF_GTS_TRI
    );
  a_get_word_13_77_SW0 : X_LUT3
    generic map(
      INIT => X"FE"
    )
    port map (
      ADR0 => h_get_word_buf(10),
      ADR1 => N241,
      ADR2 => a_funct(0),
      O => N5091
    );
  AA_9_OBUF_30 : X_BUF
    port map (
      I => AA_9_OBUF,
      O => AA_9_OBUF_GTS_TRI
    );
  AA_8_OBUF_31 : X_BUF
    port map (
      I => AA_8_OBUF,
      O => AA_8_OBUF_GTS_TRI
    );
  AA_1_OBUF_32 : X_BUF
    port map (
      I => AA_1_OBUF,
      O => AA_1_OBUF_GTS_TRI
    );
  a_get_word_26_31 : X_LUT4
    generic map(
      INIT => X"C480"
    )
    port map (
      ADR0 => a_shift(4),
      ADR1 => CHOICE3999,
      ADR2 => a_Mshift_n0002_Sh_42_Q,
      ADR3 => CHOICE3993,
      O => CHOICE4000
    );
  a_get_word_23_38 : X_LUT4
    generic map(
      INIT => X"AA02"
    )
    port map (
      ADR0 => CHOICE3999,
      ADR1 => N241,
      ADR2 => N5565,
      ADR3 => CHOICE3863,
      O => CHOICE3874
    );
  a_get_word_28_141_SW0 : X_LUT4
    generic map(
      INIT => X"FF40"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_funct(1),
      ADR2 => CHOICE4180,
      ADR3 => CHOICE4208,
      O => N5529
    );
  a_get_word_27_65 : X_LUT3
    generic map(
      INIT => X"14"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => a_put_left_word(27),
      ADR2 => a_put_right_word(27),
      O => CHOICE4054
    );
  AA_17_OBUF_33 : X_BUF
    port map (
      I => AA_17_OBUF,
      O => AA_17_OBUF_GTS_TRI
    );
  h_put_address_buf_16_rt_34 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(16),
      O => h_put_address_buf_16_rt,
      ADR1 => GND
    );
  a_get_word_25_139 : X_LUT4
    generic map(
      INIT => X"FAF8"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => CHOICE3974,
      ADR2 => CHOICE3965,
      ADR3 => CHOICE3981,
      O => CHOICE3984
    );
  a_alu_n0000_22_lut_SW0 : X_LUT4
    generic map(
      INIT => X"1FBF"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_get_right_word_buf(22),
      ADR2 => N471,
      ADR3 => s_put_word_buf(22),
      O => N5785
    );
  h_put_address_buf_15_rt_35 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(15),
      O => h_put_address_buf_15_rt,
      ADR1 => GND
    );
  a_get_word_26_44 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => a_funct(2),
      ADR2 => a_put_left_word(26),
      ADR3 => N6175,
      O => CHOICE4004
    );
  s_right_conflict_Sclr_INV71 : X_LUT4
    generic map(
      INIT => X"6FF6"
    )
    port map (
      ADR0 => N5024,
      ADR1 => s_put_address(2),
      ADR2 => N5022,
      ADR3 => s_put_address(1),
      O => CHOICE3827
    );
  a_alu_n0000_26_lut_SW0 : X_LUT4
    generic map(
      INIT => X"1FBF"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_get_right_word_buf(26),
      ADR2 => N471,
      ADR3 => s_put_word_buf(26),
      O => N5793
    );
  a_get_word_23_53 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => a_funct(2),
      ADR2 => a_put_left_word(23),
      ADR3 => N6171,
      O => CHOICE3878
    );
  s_right_conflict_Sclr_INV86 : X_LUT3
    generic map(
      INIT => X"FE"
    )
    port map (
      ADR0 => CHOICE3808,
      ADR1 => CHOICE3816,
      ADR2 => CHOICE3827,
      O => s_right_conflict_N0
    );
  AA_6_OBUF_36 : X_BUF
    port map (
      I => AA_6_OBUF,
      O => AA_6_OBUF_GTS_TRI
    );
  AA_18_OBUF_37 : X_BUF
    port map (
      I => AA_18_OBUF,
      O => AA_18_OBUF_GTS_TRI
    );
  a_get_word_22_11 : X_LUT4
    generic map(
      INIT => X"1000"
    )
    port map (
      ADR0 => h_get_word_buf(9),
      ADR1 => N241,
      ADR2 => a_N251,
      ADR3 => a_N373,
      O => CHOICE4129
    );
  a_get_word_31_64 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => h_get_word_buf(10),
      ADR1 => N241,
      ADR2 => h_get_word_buf(8),
      ADR3 => h_get_word_buf(9),
      O => CHOICE4766
    );
  a_get_word_18_54 : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => a_N373,
      ADR1 => a_shift(3),
      ADR2 => N6245,
      ADR3 => a_shift(2),
      O => CHOICE5058
    );
  a_get_word_21_64 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => N5538,
      ADR1 => h_get_word_buf(8),
      ADR2 => a_Mshift_n0002_Sh_1_Q,
      ADR3 => a_Mshift_n0002_Sh_5_Q,
      O => CHOICE4395
    );
  AA_11_OBUF_38 : X_BUF
    port map (
      I => AA_11_OBUF,
      O => AA_11_OBUF_GTS_TRI
    );
  a_get_word_30_76 : X_LUT4
    generic map(
      INIT => X"F1E0"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => N241,
      ADR2 => a_N256,
      ADR3 => CHOICE4244,
      O => CHOICE4247
    );
  a_get_word_27_101 : X_LUT4
    generic map(
      INIT => X"FFEA"
    )
    port map (
      ADR0 => CHOICE4035,
      ADR1 => a_N371,
      ADR2 => a_shift(3),
      ADR3 => N5554,
      O => CHOICE4057
    );
  s_left_conflict_Sclr_INV12 : X_LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      ADR0 => N5028,
      ADR1 => s_put_address(4),
      O => CHOICE3837
    );
  a_alu_n0000_21_lut_SW0 : X_LUT4
    generic map(
      INIT => X"1FBF"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_get_right_word_buf(21),
      ADR2 => N471,
      ADR3 => s_put_word_buf(21),
      O => N5534
    );
  a_get_word_26_84 : X_LUT4
    generic map(
      INIT => X"4448"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(0),
      ADR2 => a_put_right_word(26),
      ADR3 => a_put_left_word(26),
      O => CHOICE4016
    );
  CEA2X_OBUF_39 : X_BUF
    port map (
      I => CEA2X_OBUF,
      O => CEA2X_OBUF_GTS_TRI
    );
  a_put_right_word_22_1 : X_LUT4
    generic map(
      INIT => X"FF40"
    )
    port map (
      ADR0 => N121,
      ADR1 => N6254,
      ADR2 => N411,
      ADR3 => N101,
      O => a_put_right_word(22)
    );
  a_get_word_14_173 : X_LUT4
    generic map(
      INIT => X"FFEA"
    )
    port map (
      ADR0 => CHOICE4359,
      ADR1 => CHOICE4734,
      ADR2 => a_Mshift_n0002_Sh_46_Q,
      ADR3 => a_N291,
      O => CHOICE4368
    );
  a_get_word_24_44 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => a_funct(2),
      ADR2 => a_put_left_word(24),
      ADR3 => N6173,
      O => CHOICE3920
    );
  a_get_word_0_152_SW0 : X_LUT4
    generic map(
      INIT => X"FF8F"
    )
    port map (
      ADR0 => h_get_word_buf(5),
      ADR1 => N411,
      ADR2 => N6247,
      ADR3 => N121,
      O => N5116
    );
  a_get_word_30_126 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_shift(4),
      ADR2 => N6316,
      ADR3 => CHOICE4247,
      O => CHOICE4252
    );
  s_get_right_word_9_1_SW0 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf_9_1,
      ADR1 => N5388,
      ADR2 => N411,
      ADR3 => N111,
      O => N5323
    );
  a_get_word_30_170 : X_LUT4
    generic map(
      INIT => X"F8F0"
    )
    port map (
      ADR0 => a_put_left_word(30),
      ADR1 => a_put_right_word(30),
      ADR2 => a_N281,
      ADR3 => a_N379,
      O => CHOICE4258
    );
  a_get_word_23_93 : X_LUT4
    generic map(
      INIT => X"4448"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(0),
      ADR2 => a_put_right_word(23),
      ADR3 => a_put_left_word(23),
      O => CHOICE3890
    );
  a_get_word_21_51 : X_LUT4
    generic map(
      INIT => X"0228"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_left_word(21),
      ADR2 => a_put_right_word(21),
      ADR3 => a_funct(0),
      O => CHOICE4390
    );
  a_get_word_12_46 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => N5294,
      ADR1 => a_shift(1),
      ADR2 => a_N81,
      ADR3 => a_N62,
      O => CHOICE4494
    );
  AA_2_OBUF_40 : X_BUF
    port map (
      I => AA_2_OBUF,
      O => AA_2_OBUF_GTS_TRI
    );
  a_get_word_14_61 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_shift(4),
      ADR2 => a_Mshift_n0003_Sh_62_Q,
      ADR3 => a_Mshift_n0003_Sh_46_Q,
      O => CHOICE4344
    );
  a_get_word_15_81 : X_LUT4
    generic map(
      INIT => X"FAF8"
    )
    port map (
      ADR0 => CHOICE4503,
      ADR1 => CHOICE4442,
      ADR2 => CHOICE4441,
      ADR3 => CHOICE4448,
      O => CHOICE4453
    );
  a_get_word_29_170 : X_LUT4
    generic map(
      INIT => X"F8F0"
    )
    port map (
      ADR0 => a_put_left_word(29),
      ADR1 => a_put_right_word(29),
      ADR2 => a_N281,
      ADR3 => a_N379,
      O => CHOICE4308
    );
  a_get_word_30_216 : X_LUT4
    generic map(
      INIT => X"A888"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => CHOICE4268,
      ADR2 => a_Mshift_n0003_Sh_62_Q,
      ADR3 => a_N370,
      O => CHOICE4270
    );
  a_get_word_24_84 : X_LUT4
    generic map(
      INIT => X"4448"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(0),
      ADR2 => a_put_right_word(24),
      ADR3 => a_put_left_word(24),
      O => CHOICE3932
    );
  a_get_word_20_58 : X_LUT4
    generic map(
      INIT => X"D5C0"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => CHOICE4139,
      ADR2 => CHOICE4084,
      ADR3 => a_n0000(20),
      O => CHOICE4092
    );
  s_left_conflict_Sclr_INV44 : X_LUT4
    generic map(
      INIT => X"66F6"
    )
    port map (
      ADR0 => s_put_address(3),
      ADR1 => N5027,
      ADR2 => N5028,
      ADR3 => s_put_address(4),
      O => CHOICE3847
    );
  CEA_OBUF : X_BUF
    port map (
      I => CEA2X_OBUF,
      O => CEA_OBUF_GTS_TRI
    );
  a_alu_n0000_24_lut_SW0 : X_LUT4
    generic map(
      INIT => X"1FBF"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_get_right_word_buf(24),
      ADR2 => N471,
      ADR3 => s_put_word_buf(24),
      O => N5789
    );
  a_get_word_18_71 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(2),
      ADR1 => a_shift(3),
      ADR2 => a_Mshift_n0002_Sh_10_Q,
      ADR3 => N6294,
      O => CHOICE5066
    );
  a_get_word_29_16 : X_LUT3
    generic map(
      INIT => X"60"
    )
    port map (
      ADR0 => a_put_left_word(29),
      ADR1 => N6176,
      ADR2 => a_funct(2),
      O => CHOICE4280
    );
  a_get_word_0_83_SW0 : X_LUT4
    generic map(
      INIT => X"010F"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => N241,
      ADR2 => CHOICE5252,
      ADR3 => a_Mshift_n0003_Sh_4_Q,
      O => N5450
    );
  a_get_word_22_58 : X_LUT4
    generic map(
      INIT => X"D5C0"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => CHOICE4139,
      ADR2 => CHOICE4135,
      ADR3 => a_n0000(22),
      O => CHOICE4143
    );
  a_get_word_20_11 : X_LUT4
    generic map(
      INIT => X"1000"
    )
    port map (
      ADR0 => h_get_word_buf(9),
      ADR1 => N241,
      ADR2 => a_N231,
      ADR3 => a_N373,
      O => CHOICE4078
    );
  a_get_word_17_233_SW1 : X_LUT4
    generic map(
      INIT => X"FFF8"
    )
    port map (
      ADR0 => a_put_right_word(17),
      ADR1 => CHOICE5333,
      ADR2 => N5275,
      ADR3 => a_N76,
      O => N5297
    );
  a_get_word_31_279 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => a_put_right_word(31),
      ADR1 => a_funct(2),
      ADR2 => a_funct(0),
      ADR3 => a_put_left_word(31),
      O => CHOICE4800
    );
  a_get_word_1_306 : X_LUT4
    generic map(
      INIT => X"EFEA"
    )
    port map (
      ADR0 => CHOICE5401,
      ADR1 => N5344,
      ADR2 => a_n0000(1),
      ADR3 => N5343,
      O => CHOICE5412
    );
  a_get_word_16_237 : X_LUT4
    generic map(
      INIT => X"2232"
    )
    port map (
      ADR0 => CHOICE5464,
      ADR1 => a_funct(1),
      ADR2 => a_n0000(16),
      ADR3 => a_funct(2),
      O => CHOICE5469
    );
  a_get_word_1_51 : X_LUT4
    generic map(
      INIT => X"0228"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_left_word(1),
      ADR2 => a_put_right_word(1),
      ADR3 => a_funct(0),
      O => CHOICE5360
    );
  a_put_right_word_15_SW0_SW0 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => s_put_word_buf(15),
      ADR1 => s_right_conflict_3,
      O => N5474
    );
  a_get_word_9_40 : X_LUT4
    generic map(
      INIT => X"8A28"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_right_word(9),
      ADR2 => a_funct(1),
      ADR3 => a_put_left_word(9),
      O => CHOICE4650
    );
  a_get_word_10_40 : X_LUT4
    generic map(
      INIT => X"8A28"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_right_word(10),
      ADR2 => a_funct(1),
      ADR3 => a_put_left_word(10),
      O => CHOICE4597
    );
  a_get_word_2_173_SW1 : X_LUT4
    generic map(
      INIT => X"1032"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(2),
      ADR2 => a_n0000(2),
      ADR3 => N5420,
      O => N5219
    );
  h_get_word_buf_29_2_41 : X_FF
    generic map(
      INIT => '1'
    )
    port map (
      I => N5032,
      SET => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf_29_2,
      CE => VCC,
      RST => GND
    );
  a_get_word_17_80 : X_LUT4
    generic map(
      INIT => X"E040"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => N6237,
      ADR2 => a_shift(2),
      ADR3 => a_Mshift_n0002_Sh_5_Q,
      O => CHOICE5318
    );
  a_get_word_8_174 : X_LUT4
    generic map(
      INIT => X"FFEA"
    )
    port map (
      ADR0 => CHOICE4727,
      ADR1 => CHOICE4734,
      ADR2 => a_Mshift_n0002_Sh_40_Q,
      ADR3 => a_N291,
      O => CHOICE4736
    );
  a_get_word_0_250 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => a_put_left_word(0),
      ADR1 => a_funct(2),
      ADR2 => a_funct(0),
      ADR3 => a_put_right_word(0),
      O => CHOICE5281
    );
  a_get_word_10_46 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => N5294,
      ADR1 => a_shift(1),
      ADR2 => a_N62,
      ADR3 => a_N91,
      O => CHOICE4600
    );
  a_get_word_9_46 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => N5294,
      ADR1 => a_shift(1),
      ADR2 => a_N611,
      ADR3 => a_N110,
      O => CHOICE4653
    );
  s_get_left_word_16_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(16),
      ADR1 => s_put_word_buf(16),
      ADR2 => Ker21_1,
      ADR3 => s_left_conflict_5,
      O => N5180
    );
  a_get_word_19_218 : X_LUT4
    generic map(
      INIT => X"2232"
    )
    port map (
      ADR0 => CHOICE5036,
      ADR1 => a_funct(1),
      ADR2 => a_n0000(19),
      ADR3 => a_funct(2),
      O => CHOICE5041
    );
  a_get_word_13_54 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => N5294,
      ADR1 => a_shift(1),
      ADR2 => N498,
      ADR3 => a_N61,
      O => CHOICE4828
    );
  a_get_word_31_309_SW0 : X_LUT4
    generic map(
      INIT => X"020A"
    )
    port map (
      ADR0 => N6315,
      ADR1 => N411,
      ADR2 => N121,
      ADR3 => h_get_word_buf(3),
      O => N5113
    );
  a_get_word_31_233_SW0 : X_LUT4
    generic map(
      INIT => X"AA08"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => CHOICE4769,
      ADR2 => a_funct(2),
      ADR3 => CHOICE4758,
      O => N5520
    );
  a_get_word_28_17 : X_LUT4
    generic map(
      INIT => X"8A02"
    )
    port map (
      ADR0 => a_shift(4),
      ADR1 => a_shift(3),
      ADR2 => N5079,
      ADR3 => N6250,
      O => CHOICE4181
    );
  a_put_right_word_0_SW0_SW0 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => s_put_word_buf(0),
      ADR1 => s_right_conflict_2,
      O => N5350
    );
  a_get_word_18_94 : X_LUT4
    generic map(
      INIT => X"FE54"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => CHOICE5066,
      ADR2 => CHOICE5064,
      ADR3 => a_N194,
      O => CHOICE5070
    );
  a_get_word_11_40 : X_LUT4
    generic map(
      INIT => X"8A28"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_right_word(11),
      ADR2 => a_funct(1),
      ADR3 => a_put_left_word(11),
      O => CHOICE4544
    );
  a_put_right_word_1_SW0_SW0 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => s_put_word_buf(1),
      ADR1 => s_right_conflict_2,
      O => N5354
    );
  h_get_word_buf_29_1_42 : X_FF
    generic map(
      INIT => '1'
    )
    port map (
      I => N5032,
      SET => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf_29_1,
      CE => VCC,
      RST => GND
    );
  a_get_word_8_40 : X_LUT4
    generic map(
      INIT => X"8A28"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_right_word(8),
      ADR2 => a_funct(1),
      ADR3 => a_put_left_word(8),
      O => CHOICE4703
    );
  a_get_word_11_46 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => N5294,
      ADR1 => a_shift(1),
      ADR2 => a_N61,
      ADR3 => a_N611,
      O => CHOICE4547
    );
  a_get_word_16_200 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_funct(0),
      ADR2 => a_put_left_word(16),
      O => CHOICE5457
    );
  a_get_word_1_270 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => a_put_left_word(1),
      ADR1 => a_funct(2),
      ADR2 => a_funct(0),
      ADR3 => a_put_right_word(1),
      O => CHOICE5401
    );
  a_get_word_0_51 : X_LUT4
    generic map(
      INIT => X"0228"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_left_word(0),
      ADR2 => a_put_right_word(0),
      ADR3 => a_funct(0),
      O => CHOICE5241
    );
  a_get_word_8_204 : X_LUT4
    generic map(
      INIT => X"2232"
    )
    port map (
      ADR0 => CHOICE4738,
      ADR1 => a_funct(1),
      ADR2 => a_n0000(8),
      ADR3 => a_funct(2),
      O => CHOICE4743
    );
  CLKMA0_OBUF_43 : X_BUF
    port map (
      I => CLKMA0_OBUF,
      O => CLKMA0_OBUF_GTS_TRI
    );
  a_get_word_4_109 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_shift(1),
      ADR2 => a_N87,
      ADR3 => a_N113,
      O => CHOICE5122
    );
  a_get_word_3_173_SW1 : X_LUT4
    generic map(
      INIT => X"1032"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(2),
      ADR2 => a_n0000(3),
      ADR3 => N5445,
      O => N5222
    );
  AA_19_OBUF_44 : X_BUF
    port map (
      I => AA_19_OBUF,
      O => AA_19_OBUF_GTS_TRI
    );
  a_get_word_25_31 : X_LUT4
    generic map(
      INIT => X"C840"
    )
    port map (
      ADR0 => a_shift(4),
      ADR1 => CHOICE3999,
      ADR2 => CHOICE3951,
      ADR3 => a_Mshift_n0002_Sh_41_Q,
      O => CHOICE3958
    );
  a_put_right_word_2_SW0_SW0 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => s_put_word_buf(2),
      ADR1 => s_right_conflict_2,
      O => N5358
    );
  a_get_word_10_90 : X_LUT4
    generic map(
      INIT => X"FAF8"
    )
    port map (
      ADR0 => CHOICE4503,
      ADR1 => CHOICE4600,
      ADR2 => CHOICE4597,
      ADR3 => CHOICE4606,
      O => CHOICE4611
    );
  a_Ker3721 : X_LUT3
    generic map(
      INIT => X"01"
    )
    port map (
      ADR0 => h_get_word_buf(10),
      ADR1 => N241,
      ADR2 => a_funct(0),
      O => a_N372
    );
  a_get_word_17_54 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => CHOICE5391,
      ADR1 => a_N373,
      ADR2 => N6244,
      O => CHOICE5308
    );
  a_get_word_3_109 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_shift(1),
      ADR2 => a_N114,
      ADR3 => a_N86,
      O => CHOICE4934
    );
  a_get_word_2_61 : X_LUT3
    generic map(
      INIT => X"94"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => a_put_left_word(2),
      ADR2 => a_put_right_word(2),
      O => CHOICE4968
    );
  a_get_word_9_90 : X_LUT4
    generic map(
      INIT => X"FAF8"
    )
    port map (
      ADR0 => CHOICE4503,
      ADR1 => CHOICE4653,
      ADR2 => CHOICE4650,
      ADR3 => CHOICE4659,
      O => CHOICE4664
    );
  a_get_word_13_67 : X_LUT4
    generic map(
      INIT => X"AA02"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => N241,
      ADR2 => N5550,
      ADR3 => CHOICE4828,
      O => CHOICE4832
    );
  a_get_word_27_169_SW0 : X_LUT4
    generic map(
      INIT => X"E040"
    )
    port map (
      ADR0 => a_shift(4),
      ADR1 => N5563,
      ADR2 => CHOICE3999,
      ADR3 => a_Mshift_n0002_Sh_43_Q,
      O => N5443
    );
  CELA1X_OBUF : X_BUF
    port map (
      I => CEA2X_OBUF,
      O => CELA1X_OBUF_GTS_TRI
    );
  a_put_right_word_7_SW0_SW0 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => s_put_word_buf(7),
      ADR1 => s_right_conflict_4,
      O => N5378
    );
  a_get_word_11_90 : X_LUT4
    generic map(
      INIT => X"FAF8"
    )
    port map (
      ADR0 => CHOICE4503,
      ADR1 => CHOICE4547,
      ADR2 => CHOICE4544,
      ADR3 => CHOICE4553,
      O => CHOICE4558
    );
  a_get_word_18_224_SW1 : X_LUT4
    generic map(
      INIT => X"FFF8"
    )
    port map (
      ADR0 => a_put_right_word(18),
      ADR1 => N6320,
      ADR2 => N5278,
      ADR3 => a_N76,
      O => N5303
    );
  a_put_right_word_8_SW0_SW0 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => s_put_word_buf(8),
      ADR1 => s_right_conflict_3,
      O => N5382
    );
  a_get_word_17_227 : X_LUT4
    generic map(
      INIT => X"2232"
    )
    port map (
      ADR0 => CHOICE5340,
      ADR1 => a_funct(1),
      ADR2 => a_n0000(17),
      ADR3 => a_funct(2),
      O => CHOICE5345
    );
  s_get_left_word_14_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(14),
      ADR1 => s_put_word_buf(14),
      ADR2 => N6334,
      ADR3 => s_left_conflict_7,
      O => N5174
    );
  a_get_word_31_309_SW1 : X_LUT3
    generic map(
      INIT => X"31"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_funct(1),
      ADR2 => CHOICE4805,
      O => N5114
    );
  a_put_right_word_9_SW0_SW0 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => s_put_word_buf(9),
      ADR1 => s_right_conflict_3,
      O => N5386
    );
  a_Ker3751 : X_LUT3
    generic map(
      INIT => X"01"
    )
    port map (
      ADR0 => h_get_word_buf(9),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      O => CHOICE5391
    );
  AA_16_OBUF_45 : X_BUF
    port map (
      I => AA_16_OBUF,
      O => AA_16_OBUF_GTS_TRI
    );
  a_get_word_6_109 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_shift(1),
      ADR2 => a_N116,
      ADR3 => a_N87,
      O => CHOICE5167
    );
  BWA_1_OBUF : X_BUF
    port map (
      I => CEA2X_OBUF,
      O => BWA_1_OBUF_GTS_TRI
    );
  s_get_right_word_4_1_SW0 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(4),
      ADR1 => N5366,
      ADR2 => N411,
      ADR3 => N111,
      O => N5254
    );
  a_alu_n0000_23_lut_SW0 : X_LUT4
    generic map(
      INIT => X"1FBF"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_get_right_word_buf(23),
      ADR2 => N471,
      ADR3 => s_put_word_buf(23),
      O => N5787
    );
  CLKMA1_OBUF : X_BUF
    port map (
      I => CLKMA0_OBUF,
      O => CLKMA1_OBUF_GTS_TRI
    );
  a_get_word_10_136 : X_LUT3
    generic map(
      INIT => X"60"
    )
    port map (
      ADR0 => a_put_left_word(10),
      ADR1 => a_put_right_word(10),
      ADR2 => CHOICE4358,
      O => CHOICE4621
    );
  a_get_word_5_102 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_N114,
      ADR2 => a_N179,
      O => CHOICE5210
    );
  AA_12_OBUF_46 : X_BUF
    port map (
      I => AA_12_OBUF,
      O => AA_12_OBUF_GTS_TRI
    );
  a_get_word_18_51 : X_LUT4
    generic map(
      INIT => X"0228"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_left_word(18),
      ADR2 => N6167,
      ADR3 => a_funct(0),
      O => CHOICE5056
    );
  AA_14_OBUF_47 : X_BUF
    port map (
      I => AA_14_OBUF,
      O => AA_14_OBUF_GTS_TRI
    );
  a_get_word_19_94 : X_LUT4
    generic map(
      INIT => X"FE54"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => CHOICE5016,
      ADR2 => CHOICE5014,
      ADR3 => a_N183,
      O => CHOICE5020
    );
  a_get_word_3_61 : X_LUT3
    generic map(
      INIT => X"94"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => a_put_left_word(3),
      ADR2 => a_put_right_word(3),
      O => CHOICE4924
    );
  a_get_word_1_177_SW1 : X_LUT3
    generic map(
      INIT => X"CD"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_funct(2),
      ADR2 => N6323,
      O => N5120
    );
  a_get_word_8_90 : X_LUT4
    generic map(
      INIT => X"FAF8"
    )
    port map (
      ADR0 => CHOICE4503,
      ADR1 => CHOICE4706,
      ADR2 => CHOICE4703,
      ADR3 => CHOICE4712,
      O => CHOICE4717
    );
  a_get_word_2_79 : X_LUT3
    generic map(
      INIT => X"A8"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => CHOICE4958,
      ADR2 => CHOICE4968,
      O => CHOICE4970
    );
  a_get_word_4_159 : X_LUT4
    generic map(
      INIT => X"202A"
    )
    port map (
      ADR0 => a_N372,
      ADR1 => N5406,
      ADR2 => a_Mshift_n0002_Sh_4_Q,
      ADR3 => N5405,
      O => CHOICE5130
    );
  a_get_word_0_152_SW1 : X_LUT3
    generic map(
      INIT => X"CD"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_funct(2),
      ADR2 => CHOICE5273,
      O => N5117
    );
  a_get_word_13_92_SW1 : X_LUT3
    generic map(
      INIT => X"A2"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(2),
      ADR2 => N6312,
      O => N5512
    );
  a_get_word_19_181 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_funct(0),
      ADR2 => a_put_left_word(19),
      O => CHOICE5029
    );
  a_get_word_17_62 : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_Mshift_n0003_Sh_57_Q,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_Mshift_n0003_Sh_49_Q,
      O => CHOICE5312
    );
  a_get_word_12_196 : X_LUT4
    generic map(
      INIT => X"D580"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_left_word(12),
      ADR2 => a_put_right_word(12),
      ADR3 => a_n0000(12),
      O => CHOICE4529
    );
  s_get_left_word_17_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(17),
      ADR1 => s_put_word_buf(17),
      ADR2 => Ker21_1,
      ADR3 => s_left_conflict_5,
      O => N5183
    );
  a_get_word_7_202 : X_LUT3
    generic map(
      INIT => X"A8"
    )
    port map (
      ADR0 => CHOICE4899,
      ADR1 => a_put_left_word(7),
      ADR2 => a_put_right_word(7),
      O => CHOICE4900
    );
  a_put_right_word_13_SW0_SW0 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => s_put_word_buf(13),
      ADR1 => s_right_conflict_3,
      O => N5466
    );
  AA_0_OBUF_48 : X_BUF
    port map (
      I => AA_0_OBUF,
      O => AA_0_OBUF_GTS_TRI
    );
  a_get_word_2_109 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_shift(1),
      ADR2 => a_N113,
      ADR3 => a_N85,
      O => CHOICE4978
    );
  a_get_word_31_187 : X_LUT4
    generic map(
      INIT => X"E0F1"
    )
    port map (
      ADR0 => h_get_word_buf(10),
      ADR1 => N241,
      ADR2 => a_Mshift_n0002_Sh_47_Q,
      ADR3 => N5552,
      O => CHOICE4790
    );
  a_get_word_5_79 : X_LUT3
    generic map(
      INIT => X"A8"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => CHOICE5192,
      ADR2 => CHOICE5202,
      O => CHOICE5204
    );
  s_get_left_word_4_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(4),
      ADR1 => s_put_word_buf(4),
      ADR2 => N6335,
      ADR3 => s_left_conflict_7,
      O => N5201
    );
  a_get_word_16_62 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => CHOICE5429,
      ADR1 => CHOICE5391,
      ADR2 => N6341,
      ADR3 => a_put_left_word(0),
      O => CHOICE5432
    );
  a_get_word_3_79 : X_LUT3
    generic map(
      INIT => X"A8"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => CHOICE4914,
      ADR2 => CHOICE4924,
      O => CHOICE4926
    );
  a_get_word_28_92 : X_LUT4
    generic map(
      INIT => X"3320"
    )
    port map (
      ADR0 => a_shift(2),
      ADR1 => a_shift(4),
      ADR2 => a_N257,
      ADR3 => CHOICE4196,
      O => CHOICE4199
    );
  a_get_word_4_94 : X_LUT4
    generic map(
      INIT => X"C840"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_shift(3),
      ADR2 => a_N58,
      ADR3 => a_N41,
      O => CHOICE5116
    );
  a_get_word_10_174 : X_LUT4
    generic map(
      INIT => X"FFEA"
    )
    port map (
      ADR0 => CHOICE4621,
      ADR1 => CHOICE4734,
      ADR2 => N6242,
      ADR3 => a_N291,
      O => CHOICE4630
    );
  BWA_2_OBUF : X_BUF
    port map (
      I => CEA2X_OBUF,
      O => BWA_2_OBUF_GTS_TRI
    );
  a_get_word_4_79 : X_LUT3
    generic map(
      INIT => X"A8"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => CHOICE5102,
      ADR2 => CHOICE5112,
      O => CHOICE5114
    );
  a_get_word_31_51 : X_LUT4
    generic map(
      INIT => X"0448"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_funct(2),
      ADR2 => N6169,
      ADR3 => a_put_left_word(31),
      O => CHOICE4758
    );
  a_get_word_16_55 : X_LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_shift(0),
      O => CHOICE5429
    );
  a_get_word_5_61 : X_LUT3
    generic map(
      INIT => X"94"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => a_put_left_word(5),
      ADR2 => a_put_right_word(5),
      O => CHOICE5202
    );
  BWA_3_OBUF : X_BUF
    port map (
      I => CEA2X_OBUF,
      O => BWA_3_OBUF_GTS_TRI
    );
  a_get_word_11_174 : X_LUT4
    generic map(
      INIT => X"FFEA"
    )
    port map (
      ADR0 => CHOICE4568,
      ADR1 => CHOICE4734,
      ADR2 => a_Mshift_n0002_Sh_43_Q,
      ADR3 => a_N291,
      O => CHOICE4577
    );
  a_get_word_7_101 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => N5811,
      ADR1 => h_get_word_buf(8),
      ADR2 => a_Mshift_n0002_Sh_3_Q,
      ADR3 => N6248,
      O => CHOICE4884
    );
  a_get_word_6_79 : X_LUT3
    generic map(
      INIT => X"A8"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => CHOICE5147,
      ADR2 => CHOICE5157,
      O => CHOICE5159
    );
  a_put_left_word_1_1_SW0 : X_LUT4
    generic map(
      INIT => X"FB00"
    )
    port map (
      ADR0 => h_response_buf(0),
      ADR1 => h_response_buf_1,
      ADR2 => N5191,
      ADR3 => N6199,
      O => N5437
    );
  AA_13_OBUF_49 : X_BUF
    port map (
      I => AA_13_OBUF,
      O => AA_13_OBUF_GTS_TRI
    );
  ADVLDA_OBUF : X_BUF
    port map (
      I => CEA2X_OBUF,
      O => ADVLDA_OBUF_GTS_TRI
    );
  s_get_left_word_13_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(13),
      ADR1 => s_put_word_buf(13),
      ADR2 => Ker21_11,
      ADR3 => s_left_conflict_6,
      O => N5171
    );
  a_get_word_7_101_SW0 : X_LUT3
    generic map(
      INIT => X"FE"
    )
    port map (
      ADR0 => h_get_word_buf(9),
      ADR1 => N241,
      ADR2 => a_funct(0),
      O => N5811
    );
  a_get_word_9_174 : X_LUT4
    generic map(
      INIT => X"FFEA"
    )
    port map (
      ADR0 => CHOICE4674,
      ADR1 => CHOICE4734,
      ADR2 => a_Mshift_n0002_Sh_41_Q,
      ADR3 => a_N291,
      O => CHOICE4683
    );
  a_get_word_5_176_SW0 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_funct(1),
      ADR2 => CHOICE5220,
      ADR3 => a_n0000(5),
      O => N5224
    );
  a_Ker241_SW0 : X_LUT4
    generic map(
      INIT => X"CEDF"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => N5478,
      ADR2 => a_put_left_word(0),
      ADR3 => a_put_left_word(1),
      O => N5402
    );
  a_get_word_10_204 : X_LUT4
    generic map(
      INIT => X"2232"
    )
    port map (
      ADR0 => CHOICE4632,
      ADR1 => a_funct(1),
      ADR2 => a_n0000(10),
      ADR3 => a_funct(2),
      O => CHOICE4637
    );
  a_get_word_7_150_SW0 : X_LUT4
    generic map(
      INIT => X"AA20"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(2),
      ADR2 => CHOICE4871,
      ADR3 => N6329,
      O => N5280
    );
  a_get_word_25_44 : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => a_funct(2),
      ADR2 => a_put_left_word(25),
      ADR3 => N6174,
      O => CHOICE3962
    );
  a_get_word_6_159 : X_LUT4
    generic map(
      INIT => X"0010"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_shift(4),
      ADR2 => a_N251,
      ADR3 => a_shift(3),
      O => CHOICE5175
    );
  a_get_word_7_104 : X_LUT4
    generic map(
      INIT => X"FFA8"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => CHOICE4878,
      ADR2 => CHOICE4872,
      ADR3 => CHOICE4884,
      O => CHOICE4885
    );
  a_get_word_11_204 : X_LUT4
    generic map(
      INIT => X"2232"
    )
    port map (
      ADR0 => CHOICE4579,
      ADR1 => a_funct(1),
      ADR2 => a_n0000(11),
      ADR3 => a_funct(2),
      O => CHOICE4584
    );
  s_get_left_word_18_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(18),
      ADR1 => s_put_word_buf(18),
      ADR2 => N6336,
      ADR3 => s_left_conflict_5,
      O => N5186
    );
  a_get_word_2_94 : X_LUT4
    generic map(
      INIT => X"C480"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_shift(3),
      ADR2 => a_N58,
      ADR3 => a_N35,
      O => CHOICE4972
    );
  a_get_word_6_61 : X_LUT3
    generic map(
      INIT => X"94"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => a_put_left_word(6),
      ADR2 => a_put_right_word(6),
      O => CHOICE5157
    );
  a_get_word_19_54 : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => a_N373,
      ADR1 => a_shift(3),
      ADR2 => a_Mshift_n0002_Sh_3_Q,
      ADR3 => N6200,
      O => CHOICE5008
    );
  a_Ker23_SW1 : X_LUT4
    generic map(
      INIT => X"FDFF"
    )
    port map (
      ADR0 => a_put_left_word(0),
      ADR1 => N6287,
      ADR2 => a_shift(3),
      ADR3 => a_shift(2),
      O => N5405
    );
  h_response_buf_0_1_50 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_response_buf_2(0),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_response_buf_0_1,
      CE => VCC,
      SET => GND
    );
  a_get_word_19_51 : X_LUT4
    generic map(
      INIT => X"0228"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_left_word(19),
      ADR2 => N6168,
      ADR3 => a_funct(0),
      O => CHOICE5006
    );
  a_get_word_4_61 : X_LUT3
    generic map(
      INIT => X"94"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => a_put_left_word(4),
      ADR2 => a_put_right_word(4),
      O => CHOICE5112
    );
  ZZA_OBUF : X_BUF
    port map (
      I => CEA2X_OBUF,
      O => ZZA_OBUF_GTS_TRI
    );
  a_get_word_1_300_SW0 : X_LUT4
    generic map(
      INIT => X"0070"
    )
    port map (
      ADR0 => h_get_word_buf(3),
      ADR1 => N411,
      ADR2 => N6314,
      ADR3 => N121,
      O => N5343
    );
  a_get_word_13_142 : X_LUT3
    generic map(
      INIT => X"A8"
    )
    port map (
      ADR0 => N6328,
      ADR1 => a_put_right_word(13),
      ADR2 => a_put_left_word(13),
      O => CHOICE4849
    );
  a_get_word_9_204 : X_LUT4
    generic map(
      INIT => X"2232"
    )
    port map (
      ADR0 => CHOICE4685,
      ADR1 => a_funct(1),
      ADR2 => a_n0000(9),
      ADR3 => a_funct(2),
      O => CHOICE4690
    );
  h_response_buf_1_2_51 : X_FF
    generic map(
      INIT => '1'
    )
    port map (
      I => h_response(1),
      SET => GSR,
      CLK => CLKMA0_OBUF,
      O => h_response_buf_1_2,
      CE => VCC,
      RST => GND
    );
  a_get_word_13_159 : X_LUT4
    generic map(
      INIT => X"FFCA"
    )
    port map (
      ADR0 => N5414,
      ADR1 => N5415,
      ADR2 => a_n0000(13),
      ADR3 => a_N291,
      O => CHOICE4853
    );
  h_get_word_buf_26_2_52 : X_FF
    generic map(
      INIT => '1'
    )
    port map (
      I => N5029,
      SET => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf_26_2,
      CE => VCC,
      RST => GND
    );
  a_get_word_1_64 : X_LUT4
    generic map(
      INIT => X"A820"
    )
    port map (
      ADR0 => a_shift(4),
      ADR1 => a_shift(3),
      ADR2 => N6209,
      ADR3 => a_Mshift_n0003_Sh_57_Q,
      O => CHOICE5365
    );
  a_get_word_0_263 : X_LUT4
    generic map(
      INIT => X"C880"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_funct(2),
      ADR2 => a_put_left_word(0),
      ADR3 => a_put_right_word(0),
      O => CHOICE5286
    );
  a_get_word_16_114 : X_LUT4
    generic map(
      INIT => X"FE54"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => CHOICE5444,
      ADR2 => CHOICE5442,
      ADR3 => CHOICE5436,
      O => CHOICE5448
    );
  a_get_word_5_176_SW1 : X_LUT4
    generic map(
      INIT => X"040E"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_n0000(5),
      ADR2 => a_funct(2),
      ADR3 => N5503,
      O => N5225
    );
  a_Ker241_SW1 : X_LUT4
    generic map(
      INIT => X"FFAE"
    )
    port map (
      ADR0 => h_get_word_buf(9),
      ADR1 => h_get_word_buf(8),
      ADR2 => a_Mshift_n0002_Sh_1_Q,
      ADR3 => N241,
      O => N5403
    );
  CEHA1X_OBUF : X_BUF
    port map (
      I => CEA2X_OBUF,
      O => CEHA1X_OBUF_GTS_TRI
    );
  LBOA_OBUF : X_BUF
    port map (
      I => CEA2_OBUF,
      O => LBOA_OBUF_GTS_TRI
    );
  XRWA_OBUF_53 : X_BUF
    port map (
      I => XRWA_OBUF,
      O => XRWA_OBUF_GTS_TRI
    );
  OEAX_OBUF : X_BUF
    port map (
      I => CEA2X_OBUF,
      O => OEAX_OBUF_GTS_TRI
    );
  CEA2_OBUF_54 : X_BUF
    port map (
      I => CEA2_OBUF,
      O => CEA2_OBUF_GTS_TRI
    );
  h_put_address_buf_1_rt_55 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(1),
      O => h_put_address_buf_1_rt,
      ADR1 => GND
    );
  h_put_address_buf_2_rt_56 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(2),
      O => h_put_address_buf_2_rt,
      ADR1 => GND
    );
  h_put_address_buf_3_rt_57 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(3),
      O => h_put_address_buf_3_rt,
      ADR1 => GND
    );
  h_put_address_buf_4_rt_58 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(4),
      O => h_put_address_buf_4_rt,
      ADR1 => GND
    );
  h_put_address_buf_5_rt_59 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(5),
      O => h_put_address_buf_5_rt,
      ADR1 => GND
    );
  h_put_address_buf_6_rt_60 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(6),
      O => h_put_address_buf_6_rt,
      ADR1 => GND
    );
  h_put_address_buf_7_rt_61 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(7),
      O => h_put_address_buf_7_rt,
      ADR1 => GND
    );
  h_put_address_buf_8_rt_62 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(8),
      O => h_put_address_buf_8_rt,
      ADR1 => GND
    );
  h_put_address_buf_9_rt_63 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(9),
      O => h_put_address_buf_9_rt,
      ADR1 => GND
    );
  h_put_address_buf_10_rt_64 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(10),
      O => h_put_address_buf_10_rt,
      ADR1 => GND
    );
  h_put_address_buf_11_rt_65 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(11),
      O => h_put_address_buf_11_rt,
      ADR1 => GND
    );
  h_put_address_buf_12_rt_66 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(12),
      O => h_put_address_buf_12_rt,
      ADR1 => GND
    );
  h_put_address_buf_13_rt_67 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(13),
      O => h_put_address_buf_13_rt,
      ADR1 => GND
    );
  h_put_address_buf_14_rt_68 : X_LUT2
    generic map(
      INIT => X"A"
    )
    port map (
      ADR0 => h_put_address_buf(14),
      O => h_put_address_buf_14_rt,
      ADR1 => GND
    );
  a_put_right_word_16_SW2 : X_LUT4
    generic map(
      INIT => X"F087"
    )
    port map (
      ADR0 => N5456,
      ADR1 => N451,
      ADR2 => N6206,
      ADR3 => N231,
      O => N5422
    );
  a_put_right_word_16_SW3 : X_LUT4
    generic map(
      INIT => X"F087"
    )
    port map (
      ADR0 => N5458,
      ADR1 => N451,
      ADR2 => a_n0001,
      ADR3 => N231,
      O => N5423
    );
  Ker121_2 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => h_response_buf_0_2,
      ADR1 => h_response_buf_1_2,
      O => Ker121_1
    );
  Ker121_3 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => h_response_buf_0_2,
      ADR1 => h_response_buf_1_2,
      O => Ker121_11
    );
  a_shift_0_1_1 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => h_get_word_buf_29_3,
      ADR1 => h_get_word_buf(28),
      ADR2 => h_get_word_buf(27),
      ADR3 => N6340,
      O => a_shift_0_1
    );
  h_get_word_buf_9_1_69 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5017,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf_9_1,
      CE => VCC,
      SET => GND
    );
  h_response_buf_0_5_70 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_response_buf_2(0),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_response_buf_0_5,
      CE => VCC,
      SET => GND
    );
  h_response_buf_0_6_71 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_response_buf_2(0),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_response_buf_0_6,
      CE => VCC,
      SET => GND
    );
  h_response_buf_0_4_72 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_response_buf_2(0),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_response_buf_0_4,
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_8_1_73 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5015,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf_8_1,
      CE => VCC,
      SET => GND
    );
  s_right_conflict_4_74 : X_SFF
    generic map(
      INIT => '0'
    )
    port map (
      I => CEA2_OBUF,
      SRST => s_right_conflict_N0,
      CLK => CLKMA0_OBUF,
      O => s_right_conflict_4,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  h_get_word_buf_28_1_75 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => N5031,
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf_28_1,
      CE => VCC,
      SET => GND
    );
  s_left_conflict_7_76 : X_SFF
    generic map(
      INIT => '0'
    )
    port map (
      I => CEA2_OBUF,
      SRST => s_left_conflict_N0,
      CLK => CLKMA0_OBUF,
      O => s_left_conflict_7,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  s_left_conflict_5_77 : X_SFF
    generic map(
      INIT => '0'
    )
    port map (
      I => CEA2_OBUF,
      SRST => s_left_conflict_N0,
      CLK => CLKMA0_OBUF,
      O => s_left_conflict_5,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  s_left_conflict_6_78 : X_SFF
    generic map(
      INIT => '0'
    )
    port map (
      I => CEA2_OBUF,
      SRST => s_left_conflict_N0,
      CLK => CLKMA0_OBUF,
      O => s_left_conflict_6,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  h_response_buf_1_3_79 : X_FF
    generic map(
      INIT => '1'
    )
    port map (
      I => h_response(1),
      SET => GSR,
      CLK => CLKMA0_OBUF,
      O => h_response_buf_1_3,
      CE => VCC,
      RST => GND
    );
  s_left_conflict_4_80 : X_SFF
    generic map(
      INIT => '0'
    )
    port map (
      I => CEA2_OBUF,
      SRST => s_left_conflict_N0,
      CLK => CLKMA0_OBUF,
      O => s_left_conflict_4,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  h_response_buf_0_3_81 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_response_buf_2(0),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_response_buf_0_3,
      CE => VCC,
      SET => GND
    );
  h_get_word_buf_29_3_82 : X_FF
    generic map(
      INIT => '1'
    )
    port map (
      I => N5032,
      SET => GSR,
      CLK => CLKMA0_OBUF,
      O => h_get_word_buf_29_3,
      CE => VCC,
      RST => GND
    );
  s_left_conflict_3_83 : X_SFF
    generic map(
      INIT => '0'
    )
    port map (
      I => CEA2_OBUF,
      SRST => s_left_conflict_N0,
      CLK => CLKMA0_OBUF,
      O => s_left_conflict_3,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  Ker121_1_84 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => h_response_buf_0_2,
      ADR1 => h_response_buf_1_2,
      O => Ker121
    );
  s_left_conflict_2_85 : X_SFF
    generic map(
      INIT => '0'
    )
    port map (
      I => CEA2_OBUF,
      SRST => s_left_conflict_N0,
      CLK => CLKMA0_OBUF,
      O => s_left_conflict_2,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  s_right_conflict_3_86 : X_SFF
    generic map(
      INIT => '0'
    )
    port map (
      I => CEA2_OBUF,
      SRST => s_right_conflict_N0,
      CLK => CLKMA0_OBUF,
      O => s_right_conflict_3,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  s_right_conflict_2_87 : X_SFF
    generic map(
      INIT => '0'
    )
    port map (
      I => CEA2_OBUF,
      SRST => s_right_conflict_N0,
      CLK => CLKMA0_OBUF,
      O => s_right_conflict_2,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND
    );
  h_response_buf_0_2_88 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => h_response_buf_2(0),
      RST => GSR,
      CLK => CLKMA0_OBUF,
      O => h_response_buf_0_2,
      CE => VCC,
      SET => GND
    );
  a_put_right_word_17_SW2 : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => N6302,
      O => N5425
    );
  a_put_right_word_17_SW3 : X_LUT4
    generic map(
      INIT => X"C693"
    )
    port map (
      ADR0 => h_get_word_buf(26),
      ADR1 => a_n0001,
      ADR2 => N242,
      ADR3 => N6303,
      O => N5426
    );
  a_put_right_word_18_SW2 : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => N6300,
      O => N5428
    );
  a_put_right_word_18_SW3 : X_LUT4
    generic map(
      INIT => X"C693"
    )
    port map (
      ADR0 => h_get_word_buf(26),
      ADR1 => a_n0001,
      ADR2 => N237,
      ADR3 => N6301,
      O => N5429
    );
  a_get_word_1_177_SW0 : X_LUT4
    generic map(
      INIT => X"FF8F"
    )
    port map (
      ADR0 => h_get_word_buf(5),
      ADR1 => N411,
      ADR2 => CHOICE5393,
      ADR3 => N121,
      O => N5119
    );
  a_put_left_word_1_1_SW1 : X_LUT4
    generic map(
      INIT => X"FB00"
    )
    port map (
      ADR0 => h_response_buf(0),
      ADR1 => h_response_buf_1,
      ADR2 => N6289,
      ADR3 => a_shift(0),
      O => N5438
    );
  a_put_left_word_20_1_SW0 : X_LUT4
    generic map(
      INIT => X"CECC"
    )
    port map (
      ADR0 => s_put_word_buf(20),
      ADR1 => h_response_buf_0_6,
      ADR2 => Ker21_11,
      ADR3 => s_left_conflict_5,
      O => N5122
    );
  a_put_left_word_21_1_SW0 : X_LUT4
    generic map(
      INIT => X"CECC"
    )
    port map (
      ADR0 => s_put_word_buf(21),
      ADR1 => h_response_buf_0_5,
      ADR2 => Ker21_1,
      ADR3 => s_left_conflict_4,
      O => N5125
    );
  a_put_left_word_22_1_SW0 : X_LUT4
    generic map(
      INIT => X"CECC"
    )
    port map (
      ADR0 => s_put_word_buf(22),
      ADR1 => h_response_buf_0_6,
      ADR2 => Ker21_11,
      ADR3 => s_left_conflict_6,
      O => N5128
    );
  a_put_left_word_23_1_SW0 : X_LUT4
    generic map(
      INIT => X"CECC"
    )
    port map (
      ADR0 => s_put_word_buf(23),
      ADR1 => h_response_buf_0_5,
      ADR2 => Ker21,
      ADR3 => s_left_conflict_2,
      O => N5131
    );
  a_put_left_word_24_1_SW0 : X_LUT4
    generic map(
      INIT => X"CECC"
    )
    port map (
      ADR0 => s_put_word_buf(24),
      ADR1 => h_response_buf_0_3,
      ADR2 => N6310,
      ADR3 => s_left_conflict_2,
      O => N5134
    );
  a_put_left_word_25_1_SW0 : X_LUT4
    generic map(
      INIT => X"CECC"
    )
    port map (
      ADR0 => s_put_word_buf(25),
      ADR1 => h_response_buf_0_3,
      ADR2 => Ker21,
      ADR3 => s_left_conflict_2,
      O => N5137
    );
  a_put_left_word_26_1_SW0 : X_LUT4
    generic map(
      INIT => X"CECC"
    )
    port map (
      ADR0 => s_put_word_buf(26),
      ADR1 => h_response_buf_0_3,
      ADR2 => Ker21,
      ADR3 => s_left_conflict_2,
      O => N5140
    );
  a_put_left_word_27_1_SW0 : X_LUT4
    generic map(
      INIT => X"CECC"
    )
    port map (
      ADR0 => s_put_word_buf(27),
      ADR1 => h_response_buf_0_5,
      ADR2 => Ker21,
      ADR3 => s_left_conflict_4,
      O => N5143
    );
  a_put_left_word_28_1_SW1 : X_LUT4
    generic map(
      INIT => X"CECF"
    )
    port map (
      ADR0 => s_put_word_buf(28),
      ADR1 => h_response_buf_0_5,
      ADR2 => N6338,
      ADR3 => s_left_conflict_4,
      O => N5147
    );
  a_put_left_word_29_1_SW0 : X_LUT4
    generic map(
      INIT => X"CECC"
    )
    port map (
      ADR0 => s_put_word_buf(29),
      ADR1 => h_response_buf_0_5,
      ADR2 => Ker21_1,
      ADR3 => s_left_conflict_4,
      O => N5149
    );
  a_put_left_word_30_1_SW0 : X_LUT4
    generic map(
      INIT => X"CECC"
    )
    port map (
      ADR0 => s_put_word_buf(30),
      ADR1 => h_response_buf_0_6,
      ADR2 => Ker21_13,
      ADR3 => s_left_conflict_7,
      O => N5152
    );
  a_put_left_word_31_1_SW0 : X_LUT4
    generic map(
      INIT => X"CECC"
    )
    port map (
      ADR0 => s_put_word_buf(31),
      ADR1 => h_response_buf_0_6,
      ADR2 => Ker21_13,
      ADR3 => s_left_conflict_7,
      O => N5155
    );
  s_get_left_word_0_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(0),
      ADR1 => s_put_word_buf(0),
      ADR2 => N2,
      ADR3 => s_left_conflict1,
      O => N5158
    );
  s_get_left_word_0_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(0),
      ADR1 => s_put_word_buf(0),
      ADR2 => N2,
      ADR3 => s_left_conflict1,
      O => N5159
    );
  s_get_left_word_10_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(10),
      ADR1 => s_put_word_buf(10),
      ADR2 => Ker21_12,
      ADR3 => s_left_conflict_3,
      O => N5162
    );
  s_get_left_word_11_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(11),
      ADR1 => s_put_word_buf(11),
      ADR2 => Ker21_12,
      ADR3 => s_left_conflict_3,
      O => N5165
    );
  s_get_left_word_12_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(12),
      ADR1 => s_put_word_buf(12),
      ADR2 => N6337,
      ADR3 => s_left_conflict_6,
      O => N5168
    );
  a_Ker1511 : X_MUX2
    port map (
      IA => N5913,
      IB => N5914,
      SEL => a_shift(1),
      O => a_N151
    );
  a_Ker1711 : X_MUX2
    port map (
      IA => N5915,
      IB => N5916,
      SEL => a_shift(1),
      O => a_N171
    );
  a_Ker41 : X_MUX2
    port map (
      IA => N5917,
      IB => N5918,
      SEL => a_shift(0),
      O => a_N41
    );
  a_Ker1611 : X_MUX2
    port map (
      IA => N5919,
      IB => N5920,
      SEL => a_shift(1),
      O => a_N161
    );
  a_Ker1311 : X_MUX2
    port map (
      IA => N5921,
      IB => N5922,
      SEL => a_shift(1),
      O => a_N131
    );
  a_Ker5211 : X_MUX2
    port map (
      IA => N5923,
      IB => N5924,
      SEL => a_shift(1),
      O => a_N52
    );
  a_Ker5011 : X_MUX2
    port map (
      IA => N5925,
      IB => N5926,
      SEL => a_shift(1),
      O => a_N50
    );
  a_Mshift_n0002_Sh_45_1 : X_MUX2
    port map (
      IA => N5927,
      IB => N5928,
      SEL => a_shift(3),
      O => a_Mshift_n0002_Sh_45_Q
    );
  a_Ker96 : X_MUX2
    port map (
      IA => N5929,
      IB => N5930,
      SEL => a_shift(0),
      O => a_N96
    );
  a_get_word_0_2861 : X_MUX2
    port map (
      IA => N5931,
      IB => N5932,
      SEL => a_n0000(0),
      O => CHOICE5292
    );
  a_Mshift_n0002_Sh_6_SW01 : X_MUX2
    port map (
      IA => N5933,
      IB => N5934,
      SEL => a_shift(0),
      O => N529
    );
  a_get_word_0_641 : X_MUX2
    port map (
      IA => N5935,
      IB => N5936,
      SEL => a_shift(3),
      O => CHOICE5246
    );
  a_Ker17811 : X_MUX2
    port map (
      IA => N5937,
      IB => N5938,
      SEL => a_shift(1),
      O => a_N178
    );
  a_Mshift_n0003_Sh_60_1 : X_MUX2
    port map (
      IA => N5939,
      IB => N5940,
      SEL => a_shift_2_1,
      O => a_Mshift_n0003_Sh_60_Q
    );
  a_Ker18011 : X_MUX2
    port map (
      IA => N5941,
      IB => N5942,
      SEL => a_shift(1),
      O => a_N180
    );
  a_Ker5411 : X_MUX2
    port map (
      IA => N5943,
      IB => N5944,
      SEL => a_shift(1),
      O => a_N54
    );
  a_get_word_1_941 : X_MUX2
    port map (
      IA => N5945,
      IB => N5946,
      SEL => a_shift_2_1,
      O => CHOICE5377
    );
  a_Ker811 : X_MUX2
    port map (
      IA => N5947,
      IB => N5948,
      SEL => a_shift(0),
      O => a_N811
    );
  a_Mshift_n0003_Sh_26_11 : X_MUX2
    port map (
      IA => N5949,
      IB => N5950,
      SEL => a_shift_0_1,
      O => a_Mshift_n0003_Sh_26_Q
    );
  a_Mshift_n0002_Sh_5_1 : X_MUX2
    port map (
      IA => N5951,
      IB => N5952,
      SEL => a_shift(0),
      O => a_Mshift_n0002_Sh_5_Q
    );
  a_Ker2511 : X_MUX2
    port map (
      IA => N5953,
      IB => N5954,
      SEL => a_shift(2),
      O => a_N251
    );
  a_Ker12311 : X_MUX2
    port map (
      IA => N5955,
      IB => N5956,
      SEL => a_shift(1),
      O => a_N123
    );
  a_Mshift_n0002_Sh_47_1 : X_MUX2
    port map (
      IA => N5957,
      IB => N5958,
      SEL => a_shift(3),
      O => a_Mshift_n0002_Sh_47_Q
    );
  a_Mshift_n0003_Sh_28_11 : X_MUX2
    port map (
      IA => N5959,
      IB => N5960,
      SEL => a_shift_0_1,
      O => a_Mshift_n0003_Sh_28_Q
    );
  a_Ker5111 : X_MUX2
    port map (
      IA => N5961,
      IB => N5962,
      SEL => a_shift(1),
      O => a_N511
    );
  a_Ker4911 : X_MUX2
    port map (
      IA => N5963,
      IB => N5964,
      SEL => a_shift(1),
      O => a_N49
    );
  a_Ker5311 : X_MUX2
    port map (
      IA => N5965,
      IB => N5966,
      SEL => a_shift(1),
      O => a_N53
    );
  a_Mshift_n0003_Sh_25_11 : X_MUX2
    port map (
      IA => N5967,
      IB => N5968,
      SEL => a_shift(0),
      O => a_Mshift_n0003_Sh_25_Q
    );
  a_get_word_19_681 : X_MUX2
    port map (
      IA => N5969,
      IB => N5970,
      SEL => a_shift(3),
      O => CHOICE5014
    );
  a_get_word_28_621 : X_MUX2
    port map (
      IA => N5971,
      IB => N5972,
      SEL => a_shift(3),
      O => CHOICE4196
    );
  a_Mshift_n0003_Sh_27_11 : X_MUX2
    port map (
      IA => N5973,
      IB => N5974,
      SEL => a_shift_0_1,
      O => a_Mshift_n0003_Sh_27_Q
    );
  a_Mshift_n0002_Sh_44_SW2 : X_MUX2
    port map (
      IA => N5975,
      IB => N5976,
      SEL => a_shift(0),
      O => N5079
    );
  a_Mshift_n0002_Sh_7_SW01 : X_MUX2
    port map (
      IA => N5977,
      IB => N5978,
      SEL => a_shift(1),
      O => N510
    );
  a_Mshift_n0003_Sh_30_11 : X_MUX2
    port map (
      IA => N5979,
      IB => N5980,
      SEL => a_shift_0_1,
      O => a_Mshift_n0003_Sh_30_Q
    );
  a_get_word_7_611 : X_MUX2
    port map (
      IA => N5981,
      IB => N5982,
      SEL => a_shift(2),
      O => CHOICE4871
    );
  a_Ker18311 : X_MUX2
    port map (
      IA => N5983,
      IB => N5984,
      SEL => a_shift(3),
      O => a_N183
    );
  a_get_word_5_1311 : X_MUX2
    port map (
      IA => N5985,
      IB => N5986,
      SEL => a_shift(3),
      O => CHOICE5216
    );
  a_get_word_0_1241 : X_MUX2
    port map (
      IA => N5987,
      IB => N5988,
      SEL => a_shift(3),
      O => CHOICE5261
    );
  a_get_word_21_921 : X_MUX2
    port map (
      IA => N5989,
      IB => N5990,
      SEL => a_shift(3),
      O => CHOICE4406
    );
  a_Ker4811 : X_MUX2
    port map (
      IA => N5991,
      IB => N5992,
      SEL => a_shift(1),
      O => a_N48
    );
  a_get_word_2_1321 : X_MUX2
    port map (
      IA => N5993,
      IB => N5994,
      SEL => h_get_word_buf(10),
      O => CHOICE4982
    );
  a_Mshift_n0003_Sh_29_11 : X_MUX2
    port map (
      IA => N5995,
      IB => N5996,
      SEL => a_shift_0_1,
      O => a_Mshift_n0003_Sh_29_Q
    );
  a_Mshift_n0002_Sh_43_1 : X_MUX2
    port map (
      IA => N5997,
      IB => N5998,
      SEL => a_shift(2),
      O => a_Mshift_n0002_Sh_43_Q
    );
  a_Ker2111 : X_MUX2
    port map (
      IA => N5999,
      IB => N6000,
      SEL => a_shift(1),
      O => a_N211
    );
  a_Ker2011 : X_MUX2
    port map (
      IA => N6001,
      IB => N6002,
      SEL => a_shift(1),
      O => a_N201
    );
  a_Ker1911 : X_MUX2
    port map (
      IA => N6003,
      IB => N6004,
      SEL => a_shift(1),
      O => a_N191
    );
  a_Ker1421 : X_MUX2
    port map (
      IA => N6005,
      IB => N6006,
      SEL => a_shift(0),
      O => a_N142
    );
  a_Ker4611 : X_MUX2
    port map (
      IA => N6007,
      IB => N6008,
      SEL => a_shift(1),
      O => a_N46
    );
  a_Ker5711 : X_MUX2
    port map (
      IA => N6009,
      IB => N6010,
      SEL => a_shift(1),
      O => a_N57
    );
  a_Mshift_n0002_Sh_40_rn_0111 : X_MUX2
    port map (
      IA => N6011,
      IB => N6012,
      SEL => a_shift(3),
      O => a_Mshift_n0002_Sh_40_Q
    );
  h_response_1_1111 : X_MUX2
    port map (
      IA => N6013,
      IB => N6014,
      SEL => h_get_word_buf(26),
      O => h_response(1)
    );
  a_Ker5511 : X_MUX2
    port map (
      IA => N6015,
      IB => N6016,
      SEL => a_shift(1),
      O => a_N55
    );
  a_get_word_31_233_SW11 : X_MUX2
    port map (
      IA => N6017,
      IB => N6018,
      SEL => CHOICE4758,
      O => N5521
    );
  a_get_word_12_90_SW11 : X_MUX2
    port map (
      IA => N6019,
      IB => N6020,
      SEL => CHOICE4491,
      O => N5409
    );
  a_Mshift_n0003_Sh_23_11 : X_MUX2
    port map (
      IA => N6021,
      IB => N6022,
      SEL => a_shift(0),
      O => a_Mshift_n0003_Sh_23_Q
    );
  a_Mshift_n0003_Sh_58_Q_89 : X_MUX2
    port map (
      IA => N6023,
      IB => N6024,
      SEL => a_shift(1),
      O => a_Mshift_n0003_Sh_58_Q
    );
  a_get_word_16_721 : X_MUX2
    port map (
      IA => N6025,
      IB => N6026,
      SEL => a_shift(1),
      O => CHOICE5436
    );
  a_get_word_7_215_SW11 : X_MUX2
    port map (
      IA => N6027,
      IB => N6028,
      SEL => CHOICE4900,
      O => N5418
    );
  a_Mshift_n0003_Sh_57_Q_90 : X_MUX2
    port map (
      IA => N6029,
      IB => N6030,
      SEL => a_shift(1),
      O => a_Mshift_n0003_Sh_57_Q
    );
  a_get_word_18_138_SW11 : X_MUX2
    port map (
      IA => N6031,
      IB => N6032,
      SEL => CHOICE5058,
      O => N5278
    );
  a_get_word_6_1331 : X_MUX2
    port map (
      IA => N6033,
      IB => N6034,
      SEL => h_get_word_buf(10),
      O => CHOICE5171
    );
  a_get_word_15_561 : X_MUX2
    port map (
      IA => N6035,
      IB => N6036,
      SEL => a_shift(3),
      O => CHOICE4448
    );
  a_get_word_16_160_SW11 : X_MUX2
    port map (
      IA => N6037,
      IB => N6038,
      SEL => a_funct(2),
      O => N5272
    );
  a_get_word_17_150_SW11 : X_MUX2
    port map (
      IA => N6039,
      IB => N6040,
      SEL => a_funct(2),
      O => N5275
    );
  a_Ker11511 : X_MUX2
    port map (
      IA => N6041,
      IB => N6042,
      SEL => a_shift(1),
      O => a_N115
    );
  a_get_word_7_150_SW11 : X_MUX2
    port map (
      IA => N6043,
      IB => N6044,
      SEL => CHOICE4871,
      O => N5281
    );
  a_Mshift_n0003_Sh_4_11 : X_MUX2
    port map (
      IA => N6045,
      IB => N6046,
      SEL => a_shift(0),
      O => a_Mshift_n0003_Sh_4_Q
    );
  a_get_word_8_611 : X_MUX2
    port map (
      IA => N6047,
      IB => N6048,
      SEL => a_shift(4),
      O => CHOICE4712
    );
  a_get_word_18_681 : X_MUX2
    port map (
      IA => N6049,
      IB => N6050,
      SEL => a_shift(3),
      O => CHOICE5064
    );
  a_Ker1441 : X_MUX2
    port map (
      IA => N6051,
      IB => N6052,
      SEL => a_shift(0),
      O => a_N144
    );
  a_Mshift_n0002_Sh_42_SW01 : X_MUX2
    port map (
      IA => N6053,
      IB => N6054,
      SEL => a_shift(3),
      O => N135
    );
  a_get_word_4_1331 : X_MUX2
    port map (
      IA => N6055,
      IB => N6056,
      SEL => h_get_word_buf(10),
      O => CHOICE5126
    );
  a_get_word_19_138_SW11 : X_MUX2
    port map (
      IA => N6057,
      IB => N6058,
      SEL => CHOICE5008,
      O => N5284
    );
  a_get_word_31_1401 : X_MUX2
    port map (
      IA => N6059,
      IB => N6060,
      SEL => a_shift(3),
      O => CHOICE4786
    );
  a_Mshift_n0002_Sh_46_SW21 : X_MUX2
    port map (
      IA => N6061,
      IB => N6062,
      SEL => a_shift(0),
      O => N5083
    );
  a_get_word_1_1471 : X_MUX2
    port map (
      IA => N6063,
      IB => N6064,
      SEL => a_shift(3),
      O => CHOICE5383
    );
  a_Ker1411 : X_MUX2
    port map (
      IA => N6065,
      IB => N6066,
      SEL => a_shift(1),
      O => a_N141
    );
  a_Mshift_n0002_Sh_3_291 : X_MUX2
    port map (
      IA => N6067,
      IB => N6068,
      SEL => a_shift(1),
      O => a_Mshift_n0002_Sh_3_Q
    );
  a_Mshift_n0003_Sh_59_1 : X_MUX2
    port map (
      IA => N6069,
      IB => N6070,
      SEL => a_shift(2),
      O => a_Mshift_n0003_Sh_59_Q
    );
  a_get_word_13_92_SW01 : X_MUX2
    port map (
      IA => N6071,
      IB => N6072,
      SEL => a_Mshift_n0002_Sh_45_Q,
      O => N5511
    );
  a_Ker2211 : X_MUX2
    port map (
      IA => N6073,
      IB => N6074,
      SEL => a_shift(1),
      O => a_N221
    );
  a_get_word_17_83 : X_MUX2
    port map (
      IA => N6075,
      IB => N6076,
      SEL => a_shift(3),
      O => CHOICE5320
    );
  a_Ker1821 : X_MUX2
    port map (
      IA => N6077,
      IB => N6078,
      SEL => a_shift(1),
      O => a_N181
    );
  a_Mshift_n0002_Sh_4_1 : X_MUX2
    port map (
      IA => N6079,
      IB => N6080,
      SEL => a_shift(0),
      O => a_Mshift_n0002_Sh_4_Q
    );
  a_Mshift_n0002_Sh_2_SW01 : X_MUX2
    port map (
      IA => N6081,
      IB => N6082,
      SEL => a_shift(1),
      O => N137
    );
  a_get_word_30_48 : X_MUX2
    port map (
      IA => N6083,
      IB => N6084,
      SEL => a_shift(0),
      O => CHOICE4244
    );
  a_Ker18229 : X_MUX2
    port map (
      IA => N6085,
      IB => N6086,
      SEL => a_shift(0),
      O => a_N182
    );
  a_Mshift_n0003_Sh_55_29 : X_MUX2
    port map (
      IA => N6087,
      IB => N6088,
      SEL => a_shift(1),
      O => a_Mshift_n0003_Sh_55_Q
    );
  a_get_word_16_93 : X_MUX2
    port map (
      IA => N6089,
      IB => N6090,
      SEL => a_shift(3),
      O => CHOICE5444
    );
  a_get_word_13_155_SW0 : X_MUX2
    port map (
      IA => N6091,
      IB => N6092,
      SEL => a_N379,
      O => N5414
    );
  a_Ker621 : X_MUX2
    port map (
      IA => N6093,
      IB => N6094,
      SEL => a_shift(0),
      O => a_N62
    );
  a_Ker85 : X_MUX2
    port map (
      IA => N6095,
      IB => N6096,
      SEL => a_shift(0),
      O => a_N85
    );
  a_get_word_31_110 : X_MUX2
    port map (
      IA => N6097,
      IB => N6098,
      SEL => s_get_left_word_buf(29),
      O => CHOICE4780
    );
  a_Ker21 : X_MUX2
    port map (
      IA => N6099,
      IB => N6100,
      SEL => a_shift(0),
      O => a_N2
    );
  a_Ker25529 : X_MUX2
    port map (
      IA => N6101,
      IB => N6102,
      SEL => a_shift(0),
      O => a_N255
    );
  a_Ker611 : X_MUX2
    port map (
      IA => N6103,
      IB => N6104,
      SEL => a_shift(0),
      O => a_N611
    );
  a_Ker25629 : X_MUX2
    port map (
      IA => N6105,
      IB => N6106,
      SEL => a_shift(0),
      O => a_N256
    );
  a_Ker581 : X_MUX2
    port map (
      IA => N6107,
      IB => N6108,
      SEL => a_shift(0),
      O => a_N58
    );
  a_Ker91 : X_MUX2
    port map (
      IA => N6109,
      IB => N6110,
      SEL => a_shift(0),
      O => a_N91
    );
  a_get_word_29_48 : X_MUX2
    port map (
      IA => N6111,
      IB => N6112,
      SEL => a_shift(0),
      O => CHOICE4294
    );
  a_Ker61 : X_MUX2
    port map (
      IA => N6113,
      IB => N6114,
      SEL => a_shift(0),
      O => a_N61
    );
  a_Ker82 : X_MUX2
    port map (
      IA => N6115,
      IB => N6116,
      SEL => a_shift(0),
      O => a_N81
    );
  a_get_word_12_173 : X_MUX2
    port map (
      IA => N6117,
      IB => N6118,
      SEL => a_shift(3),
      O => CHOICE4524
    );
  a_Ker11 : X_MUX2
    port map (
      IA => N6119,
      IB => N6120,
      SEL => a_shift(0),
      O => a_N110
    );
  a_Mshift_n0002_Sh_41_Q_91 : X_MUX2
    port map (
      IA => N6121,
      IB => N6122,
      SEL => h_get_word_buf(9),
      O => a_Mshift_n0002_Sh_41_Q
    );
  a_Ker471 : X_MUX2
    port map (
      IA => N6123,
      IB => N6124,
      SEL => a_shift(0),
      O => a_N47
    );
  a_get_word_21_222_SW1 : X_MUX2
    port map (
      IA => N6125,
      IB => N6126,
      SEL => a_put_right_word(21),
      O => N5412
    );
  a_Ker25729 : X_MUX2
    port map (
      IA => N6127,
      IB => N6128,
      SEL => a_shift(0),
      O => a_N257
    );
  a_Ker641 : X_MUX2
    port map (
      IA => N6129,
      IB => N6130,
      SEL => a_shift(0),
      O => a_N64
    );
  a_Ker31 : X_MUX2
    port map (
      IA => N6131,
      IB => N6132,
      SEL => a_shift(0),
      O => a_N35
    );
  a_Ker1161 : X_MUX2
    port map (
      IA => N6133,
      IB => N6134,
      SEL => a_shift(0),
      O => a_N116
    );
  a_Ker1141 : X_MUX2
    port map (
      IA => N6135,
      IB => N6136,
      SEL => a_shift(0),
      O => a_N114
    );
  a_Ker1261 : X_MUX2
    port map (
      IA => N6137,
      IB => N6138,
      SEL => a_shift(0),
      O => a_N126
    );
  a_get_word_5_190_SW0 : X_MUX2
    port map (
      IA => N6139,
      IB => N6140,
      SEL => N5403,
      O => N5503
    );
  h_response_buf_1_Q : X_MUX2
    port map (
      IA => N6141,
      IB => N6142,
      SEL => MUX_BLOCK_N0,
      O => h_request(2)
    );
  a_Ker87 : X_MUX2
    port map (
      IA => N6143,
      IB => N6144,
      SEL => a_shift(0),
      O => a_N87
    );
  a_get_word_21_222_SW0 : X_MUX2
    port map (
      IA => N6145,
      IB => N6146,
      SEL => a_put_right_word(21),
      O => N5411
    );
  a_put_left_word_0_1 : X_MUX2
    port map (
      IA => N6147,
      IB => N6148,
      SEL => N2,
      O => a_put_left_word(0)
    );
  a_Ker86 : X_MUX2
    port map (
      IA => N6149,
      IB => N6150,
      SEL => a_shift(0),
      O => a_N86
    );
  a_Ker591 : X_MUX2
    port map (
      IA => N6151,
      IB => N6152,
      SEL => a_shift(0),
      O => a_N59
    );
  a_Ker601 : X_MUX2
    port map (
      IA => N6153,
      IB => N6154,
      SEL => a_shift(0),
      O => a_N60
    );
  h_response_buf_1_1_92 : X_MUX2
    port map (
      IA => N6155,
      IB => N6156,
      SEL => MUX_BLOCK_N0,
      O => h_response_buf(1)
    );
  h_response_buf_1_2_93 : X_MUX2
    port map (
      IA => N6157,
      IB => N6158,
      SEL => MUX_BLOCK_N0,
      O => h_response_buf_1_1_0
    );
  a_Ker1131 : X_MUX2
    port map (
      IA => N6159,
      IB => N6160,
      SEL => a_shift(0),
      O => a_N113
    );
  a_Ker179 : X_MUX2
    port map (
      IA => N6161,
      IB => N6162,
      SEL => a_shift(0),
      O => a_N179
    );
  a_get_word_17_150_SW0 : X_MUX2
    port map (
      IA => N6163,
      IB => N6164,
      SEL => a_funct(2),
      O => N5274
    );
  a_shift_4_1_LUT2_D_BUF : X_BUF
    port map (
      I => a_shift(4),
      O => N6165
    );
  a_shift_4_1_107 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => h_get_word_buf(10),
      ADR1 => N241,
      O => a_shift(4)
    );
  a_Ker1511_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1511_G_O,
      O => N5914
    );
  a_Ker1511_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(9),
      ADR2 => N5216,
      ADR3 => N5215,
      O => a_Ker1511_G_O
    );
  a_Ker1711_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1711_G_O,
      O => N5916
    );
  a_Ker1711_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(13),
      ADR2 => N5171,
      ADR3 => N5170,
      O => a_Ker1711_G_O
    );
  XNor_stagelut28_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut28_O,
      O => N32
    );
  XNor_stagelut28 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(28),
      ADR2 => s_get_left_word(28),
      ADR3 => s_get_right_word_buf(28),
      O => XNor_stagelut28_O
    );
  a_Ker41_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker41_G_O,
      O => N5918
    );
  a_Ker41_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(19),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(15),
      O => a_Ker41_G_O
    );
  a_Ker1611_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1611_G_O,
      O => N5920
    );
  a_Ker1611_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(11),
      ADR2 => N5165,
      ADR3 => N5164,
      O => a_Ker1611_G_O
    );
  a_Ker1311_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1311_G_O,
      O => N5922
    );
  a_Ker1311_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(5),
      ADR2 => N5204,
      ADR3 => N5203,
      O => a_Ker1311_G_O
    );
  Ker121_LUT2_D_BUF : X_BUF
    port map (
      I => N121,
      O => N6166
    );
  Ker121_108 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => h_response_buf_0_2,
      ADR1 => h_response_buf_1_2,
      O => N121
    );
  a_put_right_word_18_LUT4_D_BUF : X_BUF
    port map (
      I => a_put_right_word(18),
      O => N6167
    );
  a_put_right_word_18_Q : X_LUT4
    generic map(
      INIT => X"FD20"
    )
    port map (
      ADR0 => s_get_right_word(18),
      ADR1 => h_get_word_buf(26),
      ADR2 => N238,
      ADR3 => N237,
      O => a_put_right_word(18)
    );
  a_put_right_word_19_LUT4_D_BUF : X_BUF
    port map (
      I => a_put_right_word(19),
      O => N6168
    );
  a_put_right_word_19_Q : X_LUT4
    generic map(
      INIT => X"FD20"
    )
    port map (
      ADR0 => s_get_right_word(19),
      ADR1 => h_get_word_buf(26),
      ADR2 => N2311,
      ADR3 => N230,
      O => a_put_right_word(19)
    );
  a_put_right_word_31_1_LUT4_D_BUF : X_BUF
    port map (
      I => a_put_right_word(31),
      O => N6169
    );
  a_put_right_word_31_1 : X_LUT4
    generic map(
      INIT => X"FF40"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_right_word(31),
      ADR2 => N411,
      ADR3 => N101,
      O => a_put_right_word(31)
    );
  a_put_right_word_28_1_LUT4_D_BUF : X_BUF
    port map (
      I => a_put_right_word(28),
      O => N6170
    );
  a_put_right_word_28_1 : X_LUT4
    generic map(
      INIT => X"FF40"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_right_word(28),
      ADR2 => N411,
      ADR3 => N101,
      O => a_put_right_word(28)
    );
  a_put_right_word_23_1_LUT4_D_BUF : X_BUF
    port map (
      I => a_put_right_word(23),
      O => N6171
    );
  a_put_right_word_23_1 : X_LUT4
    generic map(
      INIT => X"FF40"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_right_word(23),
      ADR2 => N411,
      ADR3 => N101,
      O => a_put_right_word(23)
    );
  s_get_left_word_17_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5182,
      O => N6172
    );
  s_get_left_word_17_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(17),
      ADR1 => s_put_word_buf(17),
      ADR2 => Ker21_1,
      ADR3 => s_left_conflict_4,
      O => N5182
    );
  a_put_right_word_24_1_LUT4_D_BUF : X_BUF
    port map (
      I => a_put_right_word(24),
      O => N6173
    );
  a_put_right_word_24_1 : X_LUT4
    generic map(
      INIT => X"FF40"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_right_word(24),
      ADR2 => N411,
      ADR3 => N101,
      O => a_put_right_word(24)
    );
  a_put_right_word_25_1_LUT4_D_BUF : X_BUF
    port map (
      I => a_put_right_word(25),
      O => N6174
    );
  a_put_right_word_25_1 : X_LUT4
    generic map(
      INIT => X"FF40"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_right_word(25),
      ADR2 => N411,
      ADR3 => N101,
      O => a_put_right_word(25)
    );
  a_put_right_word_26_1_LUT4_D_BUF : X_BUF
    port map (
      I => a_put_right_word(26),
      O => N6175
    );
  a_put_right_word_26_1 : X_LUT4
    generic map(
      INIT => X"FF40"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_right_word(26),
      ADR2 => N411,
      ADR3 => N101,
      O => a_put_right_word(26)
    );
  a_put_right_word_29_1_LUT4_D_BUF : X_BUF
    port map (
      I => a_put_right_word(29),
      O => N6176
    );
  a_put_right_word_29_1 : X_LUT4
    generic map(
      INIT => X"FF40"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_right_word(29),
      ADR2 => N411,
      ADR3 => N101,
      O => a_put_right_word(29)
    );
  a_Ker5211_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker5211_G_O,
      O => N5924
    );
  a_Ker5211_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(16),
      ADR2 => N5180,
      ADR3 => N5179,
      O => a_Ker5211_G_O
    );
  h_address_13_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_13_OBUF,
      O => N6177
    );
  h_address_13_1 : X_LUT4
    generic map(
      INIT => X"D940"
    )
    port map (
      ADR0 => h_request(2),
      ADR1 => N90,
      ADR2 => h_n0007(13),
      ADR3 => N6232,
      O => AA_13_OBUF
    );
  h_address_9_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_9_OBUF,
      O => N6178
    );
  h_address_9_1 : X_LUT4
    generic map(
      INIT => X"D940"
    )
    port map (
      ADR0 => h_response_buf_1_1_0,
      ADR1 => N90,
      ADR2 => h_n0007(9),
      ADR3 => N6308,
      O => AA_9_OBUF
    );
  XNor_stagelut30_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut30_O,
      O => N34
    );
  XNor_stagelut30 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(30),
      ADR2 => s_get_left_word(30),
      ADR3 => s_get_right_word_buf(30),
      O => XNor_stagelut30_O
    );
  h_address_1_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_1_OBUF,
      O => N6179
    );
  h_address_1_1 : X_LUT4
    generic map(
      INIT => X"D940"
    )
    port map (
      ADR0 => h_response_buf(1),
      ADR1 => N90,
      ADR2 => h_n0007(1),
      ADR3 => a_get_word(1),
      O => AA_1_OBUF
    );
  h_address_2_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_2_OBUF,
      O => N6180
    );
  h_address_2_1 : X_LUT4
    generic map(
      INIT => X"A0D8"
    )
    port map (
      ADR0 => N90,
      ADR1 => h_n0007(2),
      ADR2 => N6218,
      ADR3 => h_response_buf_1_1_0,
      O => AA_2_OBUF
    );
  h_address_3_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_3_OBUF,
      O => N6181
    );
  h_address_3_1 : X_LUT4
    generic map(
      INIT => X"A0D8"
    )
    port map (
      ADR0 => N90,
      ADR1 => h_n0007(3),
      ADR2 => a_get_word(3),
      ADR3 => h_response_buf_1_1_0,
      O => AA_3_OBUF
    );
  h_address_4_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_4_OBUF,
      O => N6182
    );
  h_address_4_1 : X_LUT4
    generic map(
      INIT => X"D940"
    )
    port map (
      ADR0 => h_response_buf(1),
      ADR1 => N90,
      ADR2 => h_n0007(4),
      ADR3 => a_get_word(4),
      O => AA_4_OBUF
    );
  h_address_5_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_5_OBUF,
      O => N6183
    );
  h_address_5_1 : X_LUT4
    generic map(
      INIT => X"A0D8"
    )
    port map (
      ADR0 => N90,
      ADR1 => h_n0007(5),
      ADR2 => N6205,
      ADR3 => h_response_buf_1_1_0,
      O => AA_5_OBUF
    );
  h_address_6_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_6_OBUF,
      O => N6184
    );
  h_address_6_1 : X_LUT4
    generic map(
      INIT => X"D940"
    )
    port map (
      ADR0 => h_response_buf(1),
      ADR1 => N90,
      ADR2 => h_n0007(6),
      ADR3 => a_get_word(6),
      O => AA_6_OBUF
    );
  h_address_7_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_7_OBUF,
      O => N6185
    );
  h_address_7_1 : X_LUT4
    generic map(
      INIT => X"D940"
    )
    port map (
      ADR0 => h_response_buf_1_1_0,
      ADR1 => N90,
      ADR2 => h_n0007(7),
      ADR3 => a_get_word(7),
      O => AA_7_OBUF
    );
  h_address_8_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_8_OBUF,
      O => N6186
    );
  h_address_8_1 : X_LUT4
    generic map(
      INIT => X"D940"
    )
    port map (
      ADR0 => h_response_buf_1_1_0,
      ADR1 => N90,
      ADR2 => h_n0007(8),
      ADR3 => N6331,
      O => AA_8_OBUF
    );
  h_address_10_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_10_OBUF,
      O => N6187
    );
  h_address_10_1 : X_LUT4
    generic map(
      INIT => X"D940"
    )
    port map (
      ADR0 => h_request(2),
      ADR1 => N90,
      ADR2 => h_n0007(10),
      ADR3 => N6319,
      O => AA_10_OBUF
    );
  h_address_11_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_11_OBUF,
      O => N6188
    );
  h_address_11_1 : X_LUT4
    generic map(
      INIT => X"D940"
    )
    port map (
      ADR0 => h_request(2),
      ADR1 => N90,
      ADR2 => h_n0007(11),
      ADR3 => N6327,
      O => AA_11_OBUF
    );
  h_address_12_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_12_OBUF,
      O => N6189
    );
  h_address_12_1 : X_LUT4
    generic map(
      INIT => X"D940"
    )
    port map (
      ADR0 => h_request(2),
      ADR1 => N90,
      ADR2 => h_n0007(12),
      ADR3 => N6222,
      O => AA_12_OBUF
    );
  XNor_stagelut60_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut60_O,
      O => N66
    );
  XNor_stagelut60 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(29),
      ADR2 => s_get_right_word(29),
      ADR3 => s_get_left_word_buf(29),
      O => XNor_stagelut60_O
    );
  XNor_stagelut29_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut29_O,
      O => N33
    );
  XNor_stagelut29 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(29),
      ADR2 => s_get_left_word(29),
      ADR3 => s_get_right_word_buf(29),
      O => XNor_stagelut29_O
    );
  XNor_stagelut27_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut27_O,
      O => N31
    );
  XNor_stagelut27 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(27),
      ADR2 => s_get_left_word(27),
      ADR3 => s_get_right_word_buf(27),
      O => XNor_stagelut27_O
    );
  XNor_stagelut26_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut26_O,
      O => N30
    );
  XNor_stagelut26 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(26),
      ADR2 => s_get_left_word(26),
      ADR3 => s_get_right_word_buf(26),
      O => XNor_stagelut26_O
    );
  XNor_stagelut25_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut25_O,
      O => N29
    );
  XNor_stagelut25 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(25),
      ADR2 => s_get_left_word(25),
      ADR3 => s_get_right_word_buf(25),
      O => XNor_stagelut25_O
    );
  XNor_stagelut24_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut24_O,
      O => N28
    );
  XNor_stagelut24 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(24),
      ADR2 => s_get_left_word(24),
      ADR3 => s_get_right_word_buf(24),
      O => XNor_stagelut24_O
    );
  XNor_stagelut23_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut23_O,
      O => N27
    );
  XNor_stagelut23 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(23),
      ADR2 => s_get_left_word(23),
      ADR3 => s_get_right_word_buf(23),
      O => XNor_stagelut23_O
    );
  XNor_stagelut22_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut22_O,
      O => N26
    );
  XNor_stagelut22 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(22),
      ADR2 => s_get_left_word(22),
      ADR3 => s_get_right_word_buf(22),
      O => XNor_stagelut22_O
    );
  a_Ker5011_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker5011_G_O,
      O => N5926
    );
  a_Ker5011_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(12),
      ADR2 => N5168,
      ADR3 => N5167,
      O => a_Ker5011_G_O
    );
  XNor_stagelut20_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut20_O,
      O => N24
    );
  XNor_stagelut20 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(20),
      ADR2 => s_get_left_word(20),
      ADR3 => s_get_right_word_buf(20),
      O => XNor_stagelut20_O
    );
  XNor_stagelut19_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut19_O,
      O => N23
    );
  XNor_stagelut19 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(19),
      ADR2 => s_get_left_word(19),
      ADR3 => s_get_right_word_buf(19),
      O => XNor_stagelut19_O
    );
  XNor_stagelut18_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut18_O,
      O => N22
    );
  XNor_stagelut18 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(18),
      ADR2 => s_get_left_word(18),
      ADR3 => s_get_right_word_buf(18),
      O => XNor_stagelut18_O
    );
  XNor_stagelut17_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut17_O,
      O => N21
    );
  XNor_stagelut17 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(17),
      ADR2 => s_get_left_word(17),
      ADR3 => s_get_right_word_buf(17),
      O => XNor_stagelut17_O
    );
  XNor_stagelut16_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut16_O,
      O => N20
    );
  XNor_stagelut16 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(16),
      ADR2 => s_get_left_word(16),
      ADR3 => s_get_right_word_buf(16),
      O => XNor_stagelut16_O
    );
  XNor_stagelut15_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut15_O,
      O => N19
    );
  XNor_stagelut15 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(15),
      ADR2 => s_get_left_word(15),
      ADR3 => s_get_right_word_buf(15),
      O => XNor_stagelut15_O
    );
  XNor_stagelut14_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut14_O,
      O => N18
    );
  XNor_stagelut14 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(14),
      ADR2 => s_get_left_word(14),
      ADR3 => s_get_right_word_buf(14),
      O => XNor_stagelut14_O
    );
  h_n00001_LUT3_L_BUF : X_BUF
    port map (
      I => h_n00001_O,
      O => h_n0020(1)
    );
  h_n00001 : X_LUT3
    generic map(
      INIT => X"01"
    )
    port map (
      ADR0 => h_request_buf(0),
      ADR1 => h_request_buf(1),
      ADR2 => h_response_buf_1_1_0,
      O => h_n00001_O
    );
  h_address_19_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_19_OBUF,
      O => N6190
    );
  h_address_19_1 : X_LUT4
    generic map(
      INIT => X"D940"
    )
    port map (
      ADR0 => h_response_buf(1),
      ADR1 => N90,
      ADR2 => h_n0007(19),
      ADR3 => a_get_word(19),
      O => AA_19_OBUF
    );
  h_address_18_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_18_OBUF,
      O => N6191
    );
  h_address_18_1 : X_LUT4
    generic map(
      INIT => X"D940"
    )
    port map (
      ADR0 => h_response_buf(1),
      ADR1 => N90,
      ADR2 => h_n0007(18),
      ADR3 => N6231,
      O => AA_18_OBUF
    );
  h_address_17_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_17_OBUF,
      O => N6192
    );
  h_address_17_1 : X_LUT4
    generic map(
      INIT => X"D940"
    )
    port map (
      ADR0 => h_response_buf(1),
      ADR1 => N90,
      ADR2 => h_n0007(17),
      ADR3 => a_get_word(17),
      O => AA_17_OBUF
    );
  h_address_16_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_16_OBUF,
      O => N6193
    );
  h_address_16_1 : X_LUT4
    generic map(
      INIT => X"D940"
    )
    port map (
      ADR0 => h_response_buf(1),
      ADR1 => N90,
      ADR2 => h_n0007(16),
      ADR3 => a_get_word(16),
      O => AA_16_OBUF
    );
  h_address_15_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_15_OBUF,
      O => N6194
    );
  h_address_15_1 : X_LUT4
    generic map(
      INIT => X"D940"
    )
    port map (
      ADR0 => h_request(2),
      ADR1 => N90,
      ADR2 => h_n0007(15),
      ADR3 => N6305,
      O => AA_15_OBUF
    );
  h_address_14_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_14_OBUF,
      O => N6195
    );
  h_address_14_1 : X_LUT4
    generic map(
      INIT => X"D940"
    )
    port map (
      ADR0 => h_request(2),
      ADR1 => N90,
      ADR2 => h_n0007(14),
      ADR3 => a_get_word(14),
      O => AA_14_OBUF
    );
  XNor_stagelut11_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut11_O,
      O => N15
    );
  XNor_stagelut11 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(11),
      ADR2 => s_get_left_word(11),
      ADR3 => s_get_right_word_buf(11),
      O => XNor_stagelut11_O
    );
  XNor_stagelut10_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut10_O,
      O => N14
    );
  XNor_stagelut10 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(10),
      ADR2 => s_get_left_word(10),
      ADR3 => s_get_right_word_buf(10),
      O => XNor_stagelut10_O
    );
  XNor_stagelut9_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut9_O,
      O => N13
    );
  XNor_stagelut9 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(9),
      ADR2 => s_get_left_word(9),
      ADR3 => s_get_right_word_buf(9),
      O => XNor_stagelut9_O
    );
  XNor_stagelut8_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut8_O,
      O => N12
    );
  XNor_stagelut8 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(8),
      ADR2 => s_get_left_word(8),
      ADR3 => s_get_right_word_buf(8),
      O => XNor_stagelut8_O
    );
  XNor_stagelut7_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut7_O,
      O => N11
    );
  XNor_stagelut7 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(7),
      ADR2 => s_get_left_word(7),
      ADR3 => s_get_right_word_buf(7),
      O => XNor_stagelut7_O
    );
  XNor_stagelut6_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut6_O,
      O => N10
    );
  XNor_stagelut6 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(6),
      ADR2 => s_get_left_word(6),
      ADR3 => s_get_right_word_buf(6),
      O => XNor_stagelut6_O
    );
  XNor_stagelut5_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut5_O,
      O => N9
    );
  XNor_stagelut5 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(5),
      ADR2 => s_get_left_word(5),
      ADR3 => s_get_right_word_buf(5),
      O => XNor_stagelut5_O
    );
  XNor_stagelut4_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut4_O,
      O => N8
    );
  XNor_stagelut4 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(4),
      ADR2 => s_get_left_word(4),
      ADR3 => s_get_right_word_buf(4),
      O => XNor_stagelut4_O
    );
  XNor_stagelut3_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut3_O,
      O => N7
    );
  XNor_stagelut3 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(3),
      ADR2 => s_get_left_word(3),
      ADR3 => s_get_right_word_buf(3),
      O => XNor_stagelut3_O
    );
  XNor_stagelut2_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut2_O,
      O => N6
    );
  XNor_stagelut2 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(2),
      ADR2 => s_get_left_word(2),
      ADR3 => s_get_right_word_buf(2),
      O => XNor_stagelut2_O
    );
  XNor_stagelut1_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut1_O,
      O => N5
    );
  XNor_stagelut1 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(1),
      ADR2 => s_get_left_word(1),
      ADR3 => s_get_right_word_buf(1),
      O => XNor_stagelut1_O
    );
  a_Mshift_n0002_Sh_45_1_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_45_1_G_O,
      O => N5928
    );
  a_Mshift_n0002_Sh_45_1_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_Mshift_n0002_Sh_1_Q,
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_Mshift_n0002_Sh_5_Q,
      O => a_Mshift_n0002_Sh_45_1_G_O
    );
  XNor_stagelut31_LUT2_L_BUF : X_BUF
    port map (
      I => XNor_stagelut31_O,
      O => N37
    );
  XNor_stagelut31 : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => s_get_left_word(0),
      ADR1 => s_get_right_word(0),
      O => XNor_stagelut31_O
    );
  GE_stagelut1_LUT4_L_BUF : X_BUF
    port map (
      I => GE_stagelut1_O,
      O => N68
    );
  GE_stagelut1 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(31),
      ADR2 => s_get_right_word(31),
      ADR3 => s_get_left_word_buf(31),
      O => GE_stagelut1_O
    );
  XNor_stagelut61_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut61_O,
      O => N67
    );
  XNor_stagelut61 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(30),
      ADR2 => s_get_right_word(30),
      ADR3 => s_get_left_word_buf(30),
      O => XNor_stagelut61_O
    );
  XNor_stagelut59_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut59_O,
      O => N65
    );
  XNor_stagelut59 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(28),
      ADR2 => s_get_right_word(28),
      ADR3 => s_get_left_word_buf(28),
      O => XNor_stagelut59_O
    );
  a_get_word_17_104_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_17_104_O,
      O => CHOICE5324
    );
  a_get_word_17_104 : X_LUT4
    generic map(
      INIT => X"FE54"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => CHOICE5320,
      ADR2 => CHOICE5318,
      ADR3 => CHOICE5312,
      O => a_get_word_17_104_O
    );
  XNor_stagelut12_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut12_O,
      O => N16
    );
  XNor_stagelut12 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(12),
      ADR2 => s_get_left_word(12),
      ADR3 => s_get_right_word_buf(12),
      O => XNor_stagelut12_O
    );
  Ker411_LUT4_D_BUF : X_BUF
    port map (
      I => N411,
      O => N6196
    );
  Ker411 : X_LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      ADR0 => h_get_word_buf_29_2,
      ADR1 => h_get_word_buf_27_1,
      ADR2 => h_get_word_buf(28),
      ADR3 => h_get_word_buf_26_2,
      O => N411
    );
  a_funct_0_1_LUT4_D_BUF : X_BUF
    port map (
      I => a_funct(0),
      O => N6197
    );
  a_funct_0_1 : X_LUT4
    generic map(
      INIT => X"FDDD"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => h_response_buf_0_4,
      ADR2 => N411,
      ADR3 => h_get_word_buf(2),
      O => a_funct(0)
    );
  a_funct_1_1_LUT4_D_BUF : X_BUF
    port map (
      I => a_funct(1),
      O => N6198
    );
  a_funct_1_1 : X_LUT4
    generic map(
      INIT => X"FDDD"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => h_response_buf(0),
      ADR2 => N411,
      ADR3 => h_get_word_buf(3),
      O => a_funct(1)
    );
  a_Ker96_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker96_G_O,
      O => N5930
    );
  a_Ker96_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N131,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N171,
      O => a_Ker96_G_O
    );
  XNor_stagelut58_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut58_O,
      O => N64
    );
  XNor_stagelut58 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(27),
      ADR2 => s_get_right_word(27),
      ADR3 => s_get_left_word_buf(27),
      O => XNor_stagelut58_O
    );
  a_shift_0_1_LUT4_D_BUF : X_BUF
    port map (
      I => a_shift(0),
      O => N6199
    );
  a_shift_0_1_109 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => h_get_word_buf_29_3,
      ADR1 => h_get_word_buf(28),
      ADR2 => h_get_word_buf(27),
      ADR3 => N5544,
      O => a_shift(0)
    );
  a_shift_2_1_LUT2_D_BUF : X_BUF
    port map (
      I => a_shift(2),
      O => N6200
    );
  a_shift_2_1_110 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => N241,
      O => a_shift(2)
    );
  a_shift_3_1_LUT2_D_BUF : X_BUF
    port map (
      I => a_shift(3),
      O => N6201
    );
  a_shift_3_1 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => h_get_word_buf(9),
      ADR1 => N241,
      O => a_shift(3)
    );
  XNor_stagelut13_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut13_O,
      O => N17
    );
  XNor_stagelut13 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(13),
      ADR2 => s_get_left_word(13),
      ADR3 => s_get_right_word_buf(13),
      O => XNor_stagelut13_O
    );
  XNor_stagelut_LUT2_L_BUF : X_BUF
    port map (
      I => XNor_stagelut_O,
      O => N4
    );
  XNor_stagelut : X_LUT2
    generic map(
      INIT => X"9"
    )
    port map (
      ADR0 => s_get_right_word(0),
      ADR1 => s_get_left_word(0),
      O => XNor_stagelut_O
    );
  XNor_stagelut32_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut32_O,
      O => N38
    );
  XNor_stagelut32 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(1),
      ADR2 => s_get_right_word(1),
      ADR3 => s_get_left_word_buf(1),
      O => XNor_stagelut32_O
    );
  XNor_stagelut33_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut33_O,
      O => N39
    );
  XNor_stagelut33 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(2),
      ADR2 => s_get_right_word(2),
      ADR3 => s_get_left_word_buf(2),
      O => XNor_stagelut33_O
    );
  XNor_stagelut34_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut34_O,
      O => N40
    );
  XNor_stagelut34 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(3),
      ADR2 => s_get_right_word(3),
      ADR3 => s_get_left_word_buf(3),
      O => XNor_stagelut34_O
    );
  XNor_stagelut35_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut35_O,
      O => N41
    );
  XNor_stagelut35 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(4),
      ADR2 => s_get_right_word(4),
      ADR3 => s_get_left_word_buf(4),
      O => XNor_stagelut35_O
    );
  XNor_stagelut36_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut36_O,
      O => N42
    );
  XNor_stagelut36 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(5),
      ADR2 => s_get_right_word(5),
      ADR3 => s_get_left_word_buf(5),
      O => XNor_stagelut36_O
    );
  XNor_stagelut37_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut37_O,
      O => N43
    );
  XNor_stagelut37 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(6),
      ADR2 => s_get_right_word(6),
      ADR3 => s_get_left_word_buf(6),
      O => XNor_stagelut37_O
    );
  XNor_stagelut38_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut38_O,
      O => N44
    );
  XNor_stagelut38 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(7),
      ADR2 => s_get_right_word(7),
      ADR3 => s_get_left_word_buf(7),
      O => XNor_stagelut38_O
    );
  XNor_stagelut39_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut39_O,
      O => N45
    );
  XNor_stagelut39 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(8),
      ADR2 => s_get_right_word(8),
      ADR3 => s_get_left_word_buf(8),
      O => XNor_stagelut39_O
    );
  XNor_stagelut40_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut40_O,
      O => N46
    );
  XNor_stagelut40 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(9),
      ADR2 => s_get_right_word(9),
      ADR3 => s_get_left_word_buf(9),
      O => XNor_stagelut40_O
    );
  XNor_stagelut41_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut41_O,
      O => N47
    );
  XNor_stagelut41 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(10),
      ADR2 => s_get_right_word(10),
      ADR3 => s_get_left_word_buf(10),
      O => XNor_stagelut41_O
    );
  XNor_stagelut42_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut42_O,
      O => N48
    );
  XNor_stagelut42 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(11),
      ADR2 => s_get_right_word(11),
      ADR3 => s_get_left_word_buf(11),
      O => XNor_stagelut42_O
    );
  XNor_stagelut43_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut43_O,
      O => N49
    );
  XNor_stagelut43 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(12),
      ADR2 => s_get_right_word(12),
      ADR3 => s_get_left_word_buf(12),
      O => XNor_stagelut43_O
    );
  XNor_stagelut44_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut44_O,
      O => N50
    );
  XNor_stagelut44 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(13),
      ADR2 => s_get_right_word(13),
      ADR3 => s_get_left_word_buf(13),
      O => XNor_stagelut44_O
    );
  XNor_stagelut45_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut45_O,
      O => N51
    );
  XNor_stagelut45 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(14),
      ADR2 => s_get_right_word(14),
      ADR3 => s_get_left_word_buf(14),
      O => XNor_stagelut45_O
    );
  XNor_stagelut46_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut46_O,
      O => N52
    );
  XNor_stagelut46 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(15),
      ADR2 => s_get_right_word(15),
      ADR3 => s_get_left_word_buf(15),
      O => XNor_stagelut46_O
    );
  XNor_stagelut47_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut47_O,
      O => N53
    );
  XNor_stagelut47 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(16),
      ADR2 => s_get_right_word(16),
      ADR3 => s_get_left_word_buf(16),
      O => XNor_stagelut47_O
    );
  XNor_stagelut48_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut48_O,
      O => N54
    );
  XNor_stagelut48 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(17),
      ADR2 => s_get_right_word(17),
      ADR3 => s_get_left_word_buf(17),
      O => XNor_stagelut48_O
    );
  XNor_stagelut49_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut49_O,
      O => N55
    );
  XNor_stagelut49 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(18),
      ADR2 => s_get_right_word(18),
      ADR3 => s_get_left_word_buf(18),
      O => XNor_stagelut49_O
    );
  XNor_stagelut50_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut50_O,
      O => N56
    );
  XNor_stagelut50 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(19),
      ADR2 => s_get_right_word(19),
      ADR3 => s_get_left_word_buf(19),
      O => XNor_stagelut50_O
    );
  XNor_stagelut51_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut51_O,
      O => N57
    );
  XNor_stagelut51 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(20),
      ADR2 => s_get_right_word(20),
      ADR3 => s_get_left_word_buf(20),
      O => XNor_stagelut51_O
    );
  XNor_stagelut52_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut52_O,
      O => N58
    );
  XNor_stagelut52 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(21),
      ADR2 => s_get_right_word(21),
      ADR3 => s_get_left_word_buf(21),
      O => XNor_stagelut52_O
    );
  XNor_stagelut53_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut53_O,
      O => N59
    );
  XNor_stagelut53 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(22),
      ADR2 => s_get_right_word(22),
      ADR3 => s_get_left_word_buf(22),
      O => XNor_stagelut53_O
    );
  XNor_stagelut54_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut54_O,
      O => N60
    );
  XNor_stagelut54 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(23),
      ADR2 => s_get_right_word(23),
      ADR3 => s_get_left_word_buf(23),
      O => XNor_stagelut54_O
    );
  XNor_stagelut55_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut55_O,
      O => N61
    );
  XNor_stagelut55 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(24),
      ADR2 => s_get_right_word(24),
      ADR3 => s_get_left_word_buf(24),
      O => XNor_stagelut55_O
    );
  XNor_stagelut56_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut56_O,
      O => N62
    );
  XNor_stagelut56 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(25),
      ADR2 => s_get_right_word(25),
      ADR3 => s_get_left_word_buf(25),
      O => XNor_stagelut56_O
    );
  XNor_stagelut57_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut57_O,
      O => N63
    );
  XNor_stagelut57 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(26),
      ADR2 => s_get_right_word(26),
      ADR3 => s_get_left_word_buf(26),
      O => XNor_stagelut57_O
    );
  Ker111_LUT4_D_BUF : X_BUF
    port map (
      I => N111,
      O => N6202
    );
  Ker111 : X_LUT4
    generic map(
      INIT => X"5756"
    )
    port map (
      ADR0 => h_get_word_buf_29_2,
      ADR1 => h_get_word_buf_27_1,
      ADR2 => h_get_word_buf(28),
      ADR3 => h_get_word_buf_26_2,
      O => N111
    );
  s_get_right_word_0_1_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => s_get_right_word_0_1_SW1_O,
      O => N5267
    );
  s_get_right_word_0_1_SW1 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(0),
      ADR1 => N5350,
      ADR2 => N411,
      ADR3 => N111,
      O => s_get_right_word_0_1_SW1_O
    );
  Ker21_LUT2_D_BUF : X_BUF
    port map (
      I => N2,
      O => N6203
    );
  Ker21_111 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => h_get_word_buf_29_1,
      ADR1 => h_get_word_buf(28),
      O => N2
    );
  Ker10_LUT4_D_BUF : X_BUF
    port map (
      I => N101,
      O => N6204
    );
  Ker10 : X_LUT4
    generic map(
      INIT => X"FF10"
    )
    port map (
      ADR0 => h_get_word_buf(28),
      ADR1 => N5809,
      ADR2 => h_get_word_buf(29),
      ADR3 => N231,
      O => N101
    );
  a_get_word_0_2861_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_0_2861_G_O,
      O => N5932
    );
  a_get_word_0_2861_G : X_LUT4
    generic map(
      INIT => X"FF45"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => CHOICE5286,
      ADR2 => a_funct(2),
      ADR3 => CHOICE5281,
      O => a_get_word_0_2861_G_O
    );
  a_Mshift_n0002_Sh_6_SW01_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_6_SW01_G_O,
      O => N5934
    );
  a_Mshift_n0002_Sh_6_SW01_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(5),
      ADR2 => N5204,
      ADR3 => N5203,
      O => a_Mshift_n0002_Sh_6_SW01_G_O
    );
  a_get_word_0_641_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_0_641_G_O,
      O => N5936
    );
  a_get_word_0_641_G : X_LUT4
    generic map(
      INIT => X"E040"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_N64,
      ADR2 => a_shift(4),
      ADR3 => N508,
      O => a_get_word_0_641_G_O
    );
  s_get_right_word_7_1_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => s_get_right_word_7_1_SW1_O,
      O => N5330
    );
  s_get_right_word_7_1_SW1 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(7),
      ADR1 => N5378,
      ADR2 => N411,
      ADR3 => N111,
      O => s_get_right_word_7_1_SW1_O
    );
  a_Ker17811_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker17811_G_O,
      O => N5938
    );
  a_Ker17811_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(27),
      ADR2 => N5143,
      ADR3 => N5144,
      O => a_Ker17811_G_O
    );
  a_get_word_5_222_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(5),
      O => N6205
    );
  a_get_word_5_222 : X_LUT4
    generic map(
      INIT => X"FEAE"
    )
    port map (
      ADR0 => CHOICE5204,
      ADR1 => N5224,
      ADR2 => CHOICE5216,
      ADR3 => N5225,
      O => a_get_word(5)
    );
  a_Mshift_n0003_Sh_60_1_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_60_1_G_O,
      O => N5940
    );
  a_Mshift_n0003_Sh_60_1_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(31),
      ADR2 => N5155,
      ADR3 => N5156,
      O => a_Mshift_n0003_Sh_60_1_G_O
    );
  a_n00011_LUT4_D_BUF : X_BUF
    port map (
      I => a_n0001,
      O => N6206
    );
  a_n00011 : X_LUT4
    generic map(
      INIT => X"FDDD"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => h_response_buf(0),
      ADR2 => N411,
      ADR3 => N5546,
      O => a_n0001
    );
  a_get_word_4_222_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(4),
      O => N6207
    );
  a_get_word_4_222 : X_LUT4
    generic map(
      INIT => X"FF32"
    )
    port map (
      ADR0 => CHOICE5134,
      ADR1 => a_funct(2),
      ADR2 => CHOICE5132,
      ADR3 => CHOICE5114,
      O => a_get_word(4)
    );
  a_Ker18011_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker18011_G_O,
      O => N5942
    );
  a_Ker18011_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(25),
      ADR2 => N5137,
      ADR3 => N5138,
      O => a_Ker18011_G_O
    );
  a_get_word_18_54_SW0_LUT3_D_BUF : X_BUF
    port map (
      I => N5498,
      O => N6208
    );
  a_get_word_18_54_SW0 : X_LUT3
    generic map(
      INIT => X"BF"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => CHOICE5391,
      ADR2 => a_N373,
      O => N5498
    );
  a_Mshift_n0003_Sh_49_1_LUT3_D_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_49_Q,
      O => N6209
    );
  a_Mshift_n0003_Sh_49_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_N110,
      ADR2 => a_N611,
      O => a_Mshift_n0003_Sh_49_Q
    );
  a_Mshift_n0003_Sh_53_SW1_LUT3_D_BUF : X_BUF
    port map (
      I => N5294,
      O => N6210
    );
  a_Mshift_n0003_Sh_53_SW1 : X_LUT3
    generic map(
      INIT => X"EF"
    )
    port map (
      ADR0 => h_get_word_buf(10),
      ADR1 => N241,
      ADR2 => h_get_word_buf(9),
      O => N5294
    );
  a_Ker5411_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker5411_G_O,
      O => N5944
    );
  a_Ker5411_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(20),
      ADR2 => N5122,
      ADR3 => N5123,
      O => a_Ker5411_G_O
    );
  a_Mshift_n0003_Sh_61_1_LUT4_D_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_61_Q,
      O => N6211
    );
  a_Mshift_n0003_Sh_61_1 : X_LUT4
    generic map(
      INIT => X"CCD8"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_put_left_word(31),
      ADR2 => a_Mshift_n0003_Sh_29_Q,
      ADR3 => a_shift(2),
      O => a_Mshift_n0003_Sh_61_Q
    );
  s_get_right_word_8_1_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => s_get_right_word_8_1_SW1_O,
      O => N5327
    );
  s_get_right_word_8_1_SW1 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf_8_1,
      ADR1 => N5382,
      ADR2 => N411,
      ADR3 => N111,
      O => s_get_right_word_8_1_SW1_O
    );
  a_get_word_1_941_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_1_941_G_O,
      O => N5946
    );
  a_get_word_1_941_G : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_shift(0),
      ADR2 => a_put_left_word(6),
      ADR3 => a_put_left_word(5),
      O => a_get_word_1_941_G_O
    );
  a_get_word_27_180_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(27),
      O => N6212
    );
  a_get_word_27_180 : X_LUT4
    generic map(
      INIT => X"FFF8"
    )
    port map (
      ADR0 => a_N380,
      ADR1 => a_n0000(27),
      ADR2 => CHOICE4058,
      ADR3 => N5443,
      O => a_get_word(27)
    );
  a_Ker811_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker811_G_O,
      O => N5948
    );
  a_Ker811_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N50,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N54,
      O => a_Ker811_G_O
    );
  a_Mshift_n0003_Sh_26_11_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_26_11_G_O,
      O => N5950
    );
  a_Mshift_n0003_Sh_26_11_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(27),
      ADR2 => N5143,
      ADR3 => N5144,
      O => a_Mshift_n0003_Sh_26_11_G_O
    );
  a_Mshift_n0002_Sh_5_1_G_LUT3_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_5_1_G_O,
      O => N5952
    );
  a_Mshift_n0002_Sh_5_1_G : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_put_left_word(4),
      ADR2 => a_put_left_word(2),
      O => a_Mshift_n0002_Sh_5_1_G_O
    );
  a_Ker2511_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker2511_G_O,
      O => N5954
    );
  a_Ker2511_G : X_LUT4
    generic map(
      INIT => X"083B"
    )
    port map (
      ADR0 => a_put_left_word(1),
      ADR1 => a_shift(0),
      ADR2 => a_shift(1),
      ADR3 => N137,
      O => a_Ker2511_G_O
    );
  a_Ker12311_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker12311_G_O,
      O => N5956
    );
  a_Ker12311_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(28),
      ADR2 => N5146,
      ADR3 => N5147,
      O => a_Ker12311_G_O
    );
  a_Mshift_n0002_Sh_47_1_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_47_1_G_O,
      O => N5958
    );
  a_Mshift_n0002_Sh_47_1_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_Mshift_n0002_Sh_3_Q,
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_Mshift_n0002_Sh_7_Q,
      O => a_Mshift_n0002_Sh_47_1_G_O
    );
  a_Mshift_n0003_Sh_54_1_LUT3_D_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_54_Q,
      O => N6213
    );
  a_Mshift_n0003_Sh_54_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_N81,
      ADR2 => a_N64,
      O => a_Mshift_n0003_Sh_54_Q
    );
  a_Mshift_n0003_Sh_52_1_LUT3_D_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_52_Q,
      O => N6214
    );
  a_Mshift_n0003_Sh_52_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_N62,
      ADR2 => a_N81,
      O => a_Mshift_n0003_Sh_52_Q
    );
  a_Mshift_n0003_Sh_28_11_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_28_11_G_O,
      O => N5960
    );
  a_Mshift_n0003_Sh_28_11_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(29),
      ADR2 => N5149,
      ADR3 => N5150,
      O => a_Mshift_n0003_Sh_28_11_G_O
    );
  a_Ker5111_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker5111_G_O,
      O => N5962
    );
  a_Ker5111_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(14),
      ADR2 => N5174,
      ADR3 => N5173,
      O => a_Ker5111_G_O
    );
  a_Ker4911_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker4911_G_O,
      O => N5964
    );
  a_Ker4911_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(10),
      ADR2 => N5162,
      ADR3 => N5161,
      O => a_Ker4911_G_O
    );
  a_Mshift_n0003_Sh_46_1_LUT3_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_46_1_O,
      O => a_Mshift_n0003_Sh_46_Q
    );
  a_Mshift_n0003_Sh_46_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_N41,
      ADR2 => a_N60,
      O => a_Mshift_n0003_Sh_46_1_O
    );
  a_get_word_3_220_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(3),
      O => N6215
    );
  a_get_word_3_220 : X_LUT4
    generic map(
      INIT => X"FEAE"
    )
    port map (
      ADR0 => CHOICE4926,
      ADR1 => N5221,
      ADR2 => CHOICE4938,
      ADR3 => N5222,
      O => a_get_word(3)
    );
  a_get_word_1_321_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(1),
      O => N6216
    );
  a_get_word_1_321 : X_LUT4
    generic map(
      INIT => X"FAF8"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => CHOICE5360,
      ADR2 => CHOICE5412,
      ADR3 => CHOICE5396,
      O => a_get_word(1)
    );
  a_get_word_0_301_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(0),
      O => N6217
    );
  a_get_word_0_301 : X_LUT4
    generic map(
      INIT => X"FAF8"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => CHOICE5241,
      ADR2 => CHOICE5292,
      ADR3 => CHOICE5276,
      O => a_get_word(0)
    );
  a_get_word_2_220_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(2),
      O => N6218
    );
  a_get_word_2_220 : X_LUT4
    generic map(
      INIT => X"FEAE"
    )
    port map (
      ADR0 => CHOICE4970,
      ADR1 => N5218,
      ADR2 => CHOICE4982,
      ADR3 => N5219,
      O => a_get_word(2)
    );
  a_get_word_31_330_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(31),
      O => N6219
    );
  a_get_word_31_330 : X_LUT4
    generic map(
      INIT => X"FAFC"
    )
    port map (
      ADR0 => N5114,
      ADR1 => N5113,
      ADR2 => N5505,
      ADR3 => a_n0000(31),
      O => a_get_word(31)
    );
  a_get_word_30_257_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(30),
      O => N6220
    );
  a_get_word_30_257 : X_LUT4
    generic map(
      INIT => X"FFEA"
    )
    port map (
      ADR0 => CHOICE4270,
      ADR1 => a_n0000(30),
      ADR2 => a_N380,
      ADR3 => N5507,
      O => a_get_word(30)
    );
  a_get_word_29_257_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(29),
      O => N6221
    );
  a_get_word_29_257 : X_LUT4
    generic map(
      INIT => X"FFEA"
    )
    port map (
      ADR0 => CHOICE4320,
      ADR1 => a_n0000(29),
      ADR2 => a_N380,
      ADR3 => N5509,
      O => a_get_word(29)
    );
  a_get_word_12_222_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(12),
      O => N6222
    );
  a_get_word_12_222 : X_LUT4
    generic map(
      INIT => X"FFBA"
    )
    port map (
      ADR0 => CHOICE4524,
      ADR1 => a_funct(1),
      ADR2 => CHOICE4529,
      ADR3 => N5335,
      O => a_get_word(12)
    );
  a_get_word_26_182_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(26),
      O => N6223
    );
  a_get_word_26_182 : X_LUT4
    generic map(
      INIT => X"FFEA"
    )
    port map (
      ADR0 => CHOICE4000,
      ADR1 => a_n0000(26),
      ADR2 => a_N380,
      ADR3 => CHOICE4027,
      O => a_get_word(26)
    );
  a_get_word_25_182_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(25),
      O => N6224
    );
  a_get_word_25_182 : X_LUT4
    generic map(
      INIT => X"FFF8"
    )
    port map (
      ADR0 => a_N380,
      ADR1 => a_n0000(25),
      ADR2 => CHOICE3985,
      ADR3 => CHOICE3958,
      O => a_get_word(25)
    );
  a_get_word_24_182_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(24),
      O => N6225
    );
  a_get_word_24_182 : X_LUT4
    generic map(
      INIT => X"FFF8"
    )
    port map (
      ADR0 => a_N380,
      ADR1 => a_n0000(24),
      ADR2 => CHOICE3943,
      ADR3 => CHOICE3916,
      O => a_get_word(24)
    );
  a_get_word_23_191_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(23),
      O => N6226
    );
  a_get_word_23_191 : X_LUT4
    generic map(
      INIT => X"FFF8"
    )
    port map (
      ADR0 => a_N380,
      ADR1 => a_n0000(23),
      ADR2 => CHOICE3901,
      ADR3 => CHOICE3874,
      O => a_get_word(23)
    );
  a_get_word_22_230_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(22),
      O => N6227
    );
  a_get_word_22_230 : X_LUT4
    generic map(
      INIT => X"DDDC"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => CHOICE4173,
      ADR2 => CHOICE4143,
      ADR3 => CHOICE4131,
      O => a_get_word(22)
    );
  a_get_word_21_243_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(21),
      O => N6228
    );
  a_get_word_21_243 : X_LUT4
    generic map(
      INIT => X"FAF8"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => CHOICE4390,
      ADR2 => CHOICE4429,
      ADR3 => CHOICE4412,
      O => a_get_word(21)
    );
  a_get_word_20_230_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(20),
      O => N6229
    );
  a_get_word_20_230 : X_LUT4
    generic map(
      INIT => X"DDDC"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => CHOICE4122,
      ADR2 => CHOICE4092,
      ADR3 => CHOICE4080,
      O => a_get_word(20)
    );
  a_get_word_19_239_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(19),
      O => N6230
    );
  a_get_word_19_239 : X_LUT4
    generic map(
      INIT => X"FFEA"
    )
    port map (
      ADR0 => CHOICE5041,
      ADR1 => a_put_right_word(19),
      ADR2 => CHOICE5029,
      ADR3 => N5795,
      O => a_get_word(19)
    );
  a_get_word_18_239_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(18),
      O => N6231
    );
  a_get_word_18_239 : X_LUT4
    generic map(
      INIT => X"FECE"
    )
    port map (
      ADR0 => N5302,
      ADR1 => CHOICE5091,
      ADR2 => CHOICE5070,
      ADR3 => N5303,
      O => a_get_word(18)
    );
  a_Mshift_n0002_Sh_1_1_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_1_1_SW0_O,
      O => N5478
    );
  a_Mshift_n0002_Sh_1_1_SW0 : X_LUT4
    generic map(
      INIT => X"FFFB"
    )
    port map (
      ADR0 => h_get_word_buf(9),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_shift(1),
      O => a_Mshift_n0002_Sh_1_1_SW0_O
    );
  a_get_word_13_173_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(13),
      O => N6232
    );
  a_get_word_13_173 : X_LUT4
    generic map(
      INIT => X"EFEC"
    )
    port map (
      ADR0 => N5512,
      ADR1 => CHOICE4853,
      ADR2 => CHOICE4832,
      ADR3 => N5511,
      O => a_get_word(13)
    );
  a_get_word_7_233_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(7),
      O => N6233
    );
  a_get_word_7_233 : X_LUT4
    generic map(
      INIT => X"FCFA"
    )
    port map (
      ADR0 => N5417,
      ADR1 => N5418,
      ADR2 => N5516,
      ADR3 => a_n0000(7),
      O => a_get_word(7)
    );
  a_get_word_6_222_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(6),
      O => N6234
    );
  a_get_word_6_222 : X_LUT4
    generic map(
      INIT => X"FF32"
    )
    port map (
      ADR0 => CHOICE5179,
      ADR1 => a_funct(2),
      ADR2 => CHOICE5177,
      ADR3 => CHOICE5159,
      O => a_get_word(6)
    );
  a_Ker5311_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker5311_G_O,
      O => N5966
    );
  a_Ker5311_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(18),
      ADR2 => N5186,
      ADR3 => N5185,
      O => a_Ker5311_G_O
    );
  a_Mshift_n0003_Sh_25_11_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_25_11_G_O,
      O => N5968
    );
  a_Mshift_n0003_Sh_25_11_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(26),
      ADR2 => N5140,
      ADR3 => N5141,
      O => a_Mshift_n0003_Sh_25_11_G_O
    );
  a_alu_n0000_0_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_0_lut_O,
      O => a_N3
    );
  a_alu_n0000_0_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_left_word(0),
      ADR2 => a_put_right_word(0),
      O => a_alu_n0000_0_lut_O
    );
  a_alu_n0000_1_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_1_lut_O,
      O => a_N4
    );
  a_alu_n0000_1_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_right_word(1),
      ADR2 => a_put_left_word(1),
      O => a_alu_n0000_1_lut_O
    );
  a_alu_n0000_2_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_2_lut_O,
      O => a_N5
    );
  a_alu_n0000_2_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_right_word(2),
      ADR2 => a_put_left_word(2),
      O => a_alu_n0000_2_lut_O
    );
  a_alu_n0000_3_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_3_lut_O,
      O => a_N6
    );
  a_alu_n0000_3_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_left_word(3),
      ADR2 => a_put_right_word(3),
      O => a_alu_n0000_3_lut_O
    );
  a_alu_n0000_4_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_4_lut_O,
      O => a_N7
    );
  a_alu_n0000_4_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_right_word(4),
      ADR2 => a_put_left_word(4),
      O => a_alu_n0000_4_lut_O
    );
  a_alu_n0000_5_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_5_lut_O,
      O => a_N8
    );
  a_alu_n0000_5_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_right_word(5),
      ADR2 => a_put_left_word(5),
      O => a_alu_n0000_5_lut_O
    );
  a_alu_n0000_6_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_6_lut_O,
      O => a_N9
    );
  a_alu_n0000_6_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_right_word(6),
      ADR2 => a_put_left_word(6),
      O => a_alu_n0000_6_lut_O
    );
  a_alu_n0000_7_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_7_lut_O,
      O => a_N10
    );
  a_alu_n0000_7_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_right_word(7),
      ADR2 => a_put_left_word(7),
      O => a_alu_n0000_7_lut_O
    );
  a_alu_n0000_8_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_8_lut_O,
      O => a_N11
    );
  a_alu_n0000_8_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_right_word(8),
      ADR2 => a_put_left_word(8),
      O => a_alu_n0000_8_lut_O
    );
  a_alu_n0000_9_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_9_lut_O,
      O => a_N12
    );
  a_alu_n0000_9_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_right_word(9),
      ADR2 => a_put_left_word(9),
      O => a_alu_n0000_9_lut_O
    );
  a_alu_n0000_10_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_10_lut_O,
      O => a_N13
    );
  a_alu_n0000_10_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_right_word(10),
      ADR2 => a_put_left_word(10),
      O => a_alu_n0000_10_lut_O
    );
  a_alu_n0000_11_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_11_lut_O,
      O => a_N14
    );
  a_alu_n0000_11_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_right_word(11),
      ADR2 => a_put_left_word(11),
      O => a_alu_n0000_11_lut_O
    );
  a_alu_n0000_12_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_12_lut_O,
      O => a_N15
    );
  a_alu_n0000_12_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_right_word(12),
      ADR2 => a_put_left_word(12),
      O => a_alu_n0000_12_lut_O
    );
  a_alu_n0000_13_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_13_lut_O,
      O => a_N16
    );
  a_alu_n0000_13_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_right_word(13),
      ADR2 => a_put_left_word(13),
      O => a_alu_n0000_13_lut_O
    );
  a_alu_n0000_14_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_14_lut_O,
      O => a_N17
    );
  a_alu_n0000_14_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_right_word(14),
      ADR2 => a_put_left_word(14),
      O => a_alu_n0000_14_lut_O
    );
  a_alu_n0000_15_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_15_lut_O,
      O => a_N18
    );
  a_alu_n0000_15_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_right_word(15),
      ADR2 => a_put_left_word(15),
      O => a_alu_n0000_15_lut_O
    );
  a_alu_n0000_16_lut_LUT4_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_16_lut_O,
      O => a_N19
    );
  a_alu_n0000_16_lut : X_LUT4
    generic map(
      INIT => X"C693"
    )
    port map (
      ADR0 => s_get_right_word(16),
      ADR1 => a_put_left_word(16),
      ADR2 => N5423,
      ADR3 => N5422,
      O => a_alu_n0000_16_lut_O
    );
  a_alu_n0000_17_lut_LUT4_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_17_lut_O,
      O => a_N20
    );
  a_alu_n0000_17_lut : X_LUT4
    generic map(
      INIT => X"C963"
    )
    port map (
      ADR0 => s_get_right_word(17),
      ADR1 => a_put_left_word(17),
      ADR2 => N5425,
      ADR3 => N5426,
      O => a_alu_n0000_17_lut_O
    );
  a_alu_n0000_18_lut_LUT4_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_18_lut_O,
      O => a_N21
    );
  a_alu_n0000_18_lut : X_LUT4
    generic map(
      INIT => X"C963"
    )
    port map (
      ADR0 => s_get_right_word(18),
      ADR1 => a_put_left_word(18),
      ADR2 => N5428,
      ADR3 => N5429,
      O => a_alu_n0000_18_lut_O
    );
  a_alu_n0000_19_lut_LUT4_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_19_lut_O,
      O => a_N22
    );
  a_alu_n0000_19_lut : X_LUT4
    generic map(
      INIT => X"C963"
    )
    port map (
      ADR0 => s_get_right_word(19),
      ADR1 => a_put_left_word(19),
      ADR2 => N5431,
      ADR3 => N5432,
      O => a_alu_n0000_19_lut_O
    );
  a_alu_n0000_20_lut_LUT4_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_20_lut_O,
      O => a_N23
    );
  a_alu_n0000_20_lut : X_LUT4
    generic map(
      INIT => X"96A5"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => N101,
      ADR2 => a_put_left_word(20),
      ADR3 => N5532,
      O => a_alu_n0000_20_lut_O
    );
  a_alu_n0000_21_lut_LUT4_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_21_lut_O,
      O => a_N24
    );
  a_alu_n0000_21_lut : X_LUT4
    generic map(
      INIT => X"96A5"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => N101,
      ADR2 => a_put_left_word(21),
      ADR3 => N5534,
      O => a_alu_n0000_21_lut_O
    );
  a_alu_n0000_22_lut_LUT4_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_22_lut_O,
      O => a_N25
    );
  a_alu_n0000_22_lut : X_LUT4
    generic map(
      INIT => X"9969"
    )
    port map (
      ADR0 => a_put_left_word(22),
      ADR1 => a_n0001,
      ADR2 => N5785,
      ADR3 => N101,
      O => a_alu_n0000_22_lut_O
    );
  a_alu_n0000_23_lut_LUT4_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_23_lut_O,
      O => a_N26
    );
  a_alu_n0000_23_lut : X_LUT4
    generic map(
      INIT => X"9969"
    )
    port map (
      ADR0 => a_put_left_word(23),
      ADR1 => a_n0001,
      ADR2 => N5787,
      ADR3 => N101,
      O => a_alu_n0000_23_lut_O
    );
  a_alu_n0000_24_lut_LUT4_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_24_lut_O,
      O => a_N27
    );
  a_alu_n0000_24_lut : X_LUT4
    generic map(
      INIT => X"9969"
    )
    port map (
      ADR0 => a_put_left_word(24),
      ADR1 => a_n0001,
      ADR2 => N5789,
      ADR3 => N101,
      O => a_alu_n0000_24_lut_O
    );
  a_alu_n0000_25_lut_LUT4_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_25_lut_O,
      O => a_N28
    );
  a_alu_n0000_25_lut : X_LUT4
    generic map(
      INIT => X"9969"
    )
    port map (
      ADR0 => a_put_left_word(25),
      ADR1 => a_n0001,
      ADR2 => N5791,
      ADR3 => N101,
      O => a_alu_n0000_25_lut_O
    );
  a_alu_n0000_26_lut_LUT4_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_26_lut_O,
      O => a_N29
    );
  a_alu_n0000_26_lut : X_LUT4
    generic map(
      INIT => X"9969"
    )
    port map (
      ADR0 => a_put_left_word(26),
      ADR1 => a_n0001,
      ADR2 => N5793,
      ADR3 => N101,
      O => a_alu_n0000_26_lut_O
    );
  a_alu_n0000_27_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_27_lut_O,
      O => a_N30
    );
  a_alu_n0000_27_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_left_word(27),
      ADR2 => a_put_right_word(27),
      O => a_alu_n0000_27_lut_O
    );
  a_alu_n0000_28_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_28_lut_O,
      O => a_N31
    );
  a_alu_n0000_28_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_left_word(28),
      ADR2 => a_put_right_word(28),
      O => a_alu_n0000_28_lut_O
    );
  a_alu_n0000_29_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_29_lut_O,
      O => a_N32
    );
  a_alu_n0000_29_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_n0001,
      ADR1 => a_put_left_word(29),
      ADR2 => a_put_right_word(29),
      O => a_alu_n0000_29_lut_O
    );
  a_alu_n0000_30_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_30_lut_O,
      O => a_N33
    );
  a_alu_n0000_30_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_put_left_word(30),
      ADR1 => a_put_right_word(30),
      ADR2 => a_n0001,
      O => a_alu_n0000_30_lut_O
    );
  a_alu_n0000_31_lut_LUT3_L_BUF : X_BUF
    port map (
      I => a_alu_n0000_31_lut_O,
      O => a_N34
    );
  a_alu_n0000_31_lut : X_LUT3
    generic map(
      INIT => X"96"
    )
    port map (
      ADR0 => a_put_left_word(31),
      ADR1 => a_put_right_word(31),
      ADR2 => a_n0001,
      O => a_alu_n0000_31_lut_O
    );
  a_get_word_19_681_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_19_681_G_O,
      O => N5970
    );
  a_get_word_19_681_G : X_LUT4
    generic map(
      INIT => X"E040"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_N131,
      ADR2 => a_shift(2),
      ADR3 => N510,
      O => a_get_word_19_681_G_O
    );
  a_get_word_28_621_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_28_621_G_O,
      O => N5972
    );
  a_get_word_28_621_G : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(2),
      ADR1 => a_shift(0),
      ADR2 => a_N191,
      ADR3 => a_N53,
      O => a_get_word_28_621_G_O
    );
  a_Mshift_n0003_Sh_27_11_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_27_11_G_O,
      O => N5974
    );
  a_Mshift_n0003_Sh_27_11_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(28),
      ADR2 => N5146,
      ADR3 => N5147,
      O => a_Mshift_n0003_Sh_27_11_G_O
    );
  a_Mshift_n0002_Sh_44_SW2_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_44_SW2_G_O,
      O => N5976
    );
  a_Mshift_n0002_Sh_44_SW2_G : X_LUT4
    generic map(
      INIT => X"3237"
    )
    port map (
      ADR0 => N241,
      ADR1 => a_N131,
      ADR2 => h_get_word_buf(8),
      ADR3 => a_N151,
      O => a_Mshift_n0002_Sh_44_SW2_G_O
    );
  a_Mshift_n0002_Sh_7_SW01_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_7_SW01_G_O,
      O => N5978
    );
  a_Mshift_n0002_Sh_7_SW01_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(4),
      ADR2 => N5201,
      ADR3 => N5200,
      O => a_Mshift_n0002_Sh_7_SW01_G_O
    );
  a_Mshift_n0003_Sh_30_11_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_30_11_G_O,
      O => N5980
    );
  a_Mshift_n0003_Sh_30_11_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(31),
      ADR2 => N5155,
      ADR3 => N5156,
      O => a_Mshift_n0003_Sh_30_11_G_O
    );
  a_get_word_7_611_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_7_611_G_O,
      O => N5982
    );
  a_get_word_7_611_G : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => N5346,
      ADR1 => a_shift(1),
      ADR2 => a_Mshift_n0003_Sh_29_Q,
      ADR3 => a_Mshift_n0003_Sh_27_Q,
      O => a_get_word_7_611_G_O
    );
  a_Ker18311_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker18311_G_O,
      O => N5984
    );
  a_Ker18311_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(31),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => N494,
      O => a_Ker18311_G_O
    );
  a_get_word_5_1311_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_5_1311_G_O,
      O => N5986
    );
  a_get_word_5_1311_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_Mshift_n0003_Sh_61_Q,
      ADR1 => h_get_word_buf(10),
      ADR2 => N241,
      ADR3 => N512,
      O => a_get_word_5_1311_G_O
    );
  a_get_word_0_1241_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_0_1241_G_O,
      O => N5988
    );
  a_get_word_0_1241_G : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(4),
      ADR1 => a_shift(1),
      ADR2 => a_N35,
      ADR3 => a_N116,
      O => a_get_word_0_1241_G_O
    );
  a_get_word_21_921_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_21_921_G_O,
      O => N5990
    );
  a_get_word_21_921_G : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_shift(2),
      ADR2 => a_Mshift_n0002_Sh_9_Q,
      ADR3 => a_Mshift_n0002_Sh_13_Q,
      O => a_get_word_21_921_G_O
    );
  a_Mshift_n0002_Sh_10_1_LUT3_D_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_10_Q,
      O => N6235
    );
  a_Mshift_n0002_Sh_10_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_N48,
      ADR2 => a_N141,
      O => a_Mshift_n0002_Sh_10_Q
    );
  a_Mshift_n0002_Sh_11_1_LUT3_D_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_11_Q,
      O => N6236
    );
  a_Mshift_n0002_Sh_11_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_N151,
      ADR2 => a_N48,
      O => a_Mshift_n0002_Sh_11_Q
    );
  a_Mshift_n0002_Sh_13_1_LUT3_D_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_13_Q,
      O => N6237
    );
  a_Mshift_n0002_Sh_13_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_N161,
      ADR2 => a_N49,
      O => a_Mshift_n0002_Sh_13_Q
    );
  a_Ker4811_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker4811_G_O,
      O => N5992
    );
  a_Ker4811_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(8),
      ADR2 => N5213,
      ADR3 => N5212,
      O => a_Ker4811_G_O
    );
  a_get_word_2_1321_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_2_1321_G_O,
      O => N5994
    );
  a_get_word_2_1321_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_Mshift_n0003_Sh_58_Q,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_Mshift_n0003_Sh_50_Q,
      O => a_get_word_2_1321_G_O
    );
  a_put_right_word_30_1_LUT4_D_BUF : X_BUF
    port map (
      I => a_put_right_word(30),
      O => N6238
    );
  a_put_right_word_30_1 : X_LUT4
    generic map(
      INIT => X"FF40"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_right_word(30),
      ADR2 => N411,
      ADR3 => N101,
      O => a_put_right_word(30)
    );
  a_Mshift_n0003_Sh_29_11_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_29_11_G_O,
      O => N5996
    );
  a_Mshift_n0003_Sh_29_11_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(30),
      ADR2 => N5152,
      ADR3 => N5153,
      O => a_Mshift_n0003_Sh_29_11_G_O
    );
  s_get_left_word_4_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5200,
      O => N6239
    );
  s_get_left_word_4_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(4),
      ADR1 => s_put_word_buf(4),
      ADR2 => Ker21_14,
      ADR3 => s_left_conflict_7,
      O => N5200
    );
  a_Mshift_n0002_Sh_43_1_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_43_1_G_O,
      O => N5998
    );
  a_Mshift_n0002_Sh_43_1_G : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_shift(0),
      ADR2 => N510,
      ADR3 => a_N131,
      O => a_Mshift_n0002_Sh_43_1_G_O
    );
  a_Ker2111_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker2111_G_O,
      O => N6000
    );
  a_Ker2111_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(21),
      ADR2 => N5125,
      ADR3 => N5126,
      O => a_Ker2111_G_O
    );
  a_Ker2011_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker2011_G_O,
      O => N6002
    );
  a_Ker2011_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(19),
      ADR2 => N5189,
      ADR3 => N5188,
      O => a_Ker2011_G_O
    );
  a_Ker1911_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1911_G_O,
      O => N6004
    );
  a_Ker1911_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(17),
      ADR2 => N5183,
      ADR3 => N5182,
      O => a_Ker1911_G_O
    );
  a_Ker1421_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1421_G_O,
      O => N6006
    );
  a_Ker1421_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N151,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N191,
      O => a_Ker1421_G_O
    );
  a_Ker4611_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker4611_G_O,
      O => N6008
    );
  a_Ker4611_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(24),
      ADR2 => N5134,
      ADR3 => N5135,
      O => a_Ker4611_G_O
    );
  a_Ker3711_LUT4_D_BUF : X_BUF
    port map (
      I => a_N371,
      O => N6240
    );
  a_Ker3711 : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(0),
      ADR2 => a_funct(2),
      ADR3 => a_put_left_word(31),
      O => a_N371
    );
  s_get_right_word_1_1_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => s_get_right_word_1_1_SW1_O,
      O => N5264
    );
  s_get_right_word_1_1_SW1 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(1),
      ADR1 => N5354,
      ADR2 => N411,
      ADR3 => N111,
      O => s_get_right_word_1_1_SW1_O
    );
  a_Mshift_n0003_Sh_53_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N498,
      O => N6241
    );
  a_Mshift_n0003_Sh_53_SW0 : X_LUT4
    generic map(
      INIT => X"F1E0"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => N241,
      ADR2 => a_Mshift_n0003_Sh_27_Q,
      ADR3 => a_Mshift_n0003_Sh_23_Q,
      O => N498
    );
  a_Ker5711_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker5711_G_O,
      O => N6010
    );
  a_Ker5711_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(6),
      ADR2 => N5207,
      ADR3 => N5206,
      O => a_Ker5711_G_O
    );
  a_Mshift_n0002_Sh_40_rn_0111_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_40_rn_0111_G_O,
      O => N6012
    );
  a_Mshift_n0002_Sh_40_rn_0111_G : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => a_put_left_word(0),
      ADR1 => a_shift(2),
      ADR2 => a_shift(1),
      ADR3 => a_shift(0),
      O => a_Mshift_n0002_Sh_40_rn_0111_G_O
    );
  h_response_1_1111_G_LUT4_L_BUF : X_BUF
    port map (
      I => h_response_1_1111_G_O,
      O => N6014
    );
  h_response_1_1111_G : X_LUT4
    generic map(
      INIT => X"02AA"
    )
    port map (
      ADR0 => h_response_buf_2(1),
      ADR1 => h_get_word_buf(29),
      ADR2 => MUX_BLOCK_N1,
      ADR3 => h_response_buf_1,
      O => h_response_1_1111_G_O
    );
  a_Mshift_n0002_Sh_42_LUT4_D_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_42_Q,
      O => N6242
    );
  a_Mshift_n0002_Sh_42_Q_112 : X_LUT4
    generic map(
      INIT => X"010B"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => N135,
      ADR2 => N241,
      ADR3 => N5805,
      O => a_Mshift_n0002_Sh_42_Q
    );
  a_Ker5511_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker5511_G_O,
      O => N6016
    );
  a_Ker5511_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(22),
      ADR2 => N5128,
      ADR3 => N5129,
      O => a_Ker5511_G_O
    );
  a_Mshift_n0003_Sh_23_11_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_23_11_G_O,
      O => N6022
    );
  a_Mshift_n0003_Sh_23_11_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(24),
      ADR2 => N5134,
      ADR3 => N5135,
      O => a_Mshift_n0003_Sh_23_11_G_O
    );
  a_Mshift_n0003_Sh_58_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_58_G_O,
      O => N6024
    );
  a_Mshift_n0003_Sh_58_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(31),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_Mshift_n0003_Sh_28_Q,
      O => a_Mshift_n0003_Sh_58_G_O
    );
  a_get_word_16_721_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_16_721_G_O,
      O => N6026
    );
  a_get_word_16_721_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => N508,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N91,
      O => a_get_word_16_721_G_O
    );
  a_Mshift_n0002_Sh_6_SW1_LUT3_D_BUF : X_BUF
    port map (
      I => N530,
      O => N6243
    );
  a_Mshift_n0002_Sh_6_SW1 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_put_left_word(3),
      ADR2 => a_put_left_word(4),
      O => N530
    );
  a_get_word_7_215_SW11_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_7_215_SW11_G_O,
      O => N6028
    );
  a_get_word_7_215_SW11_G : X_LUT4
    generic map(
      INIT => X"D555"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_N379,
      ADR2 => a_put_right_word(7),
      ADR3 => a_put_left_word(7),
      O => a_get_word_7_215_SW11_G_O
    );
  s_get_right_word_9_1_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => s_get_right_word_9_1_SW1_O,
      O => N5324
    );
  s_get_right_word_9_1_SW1 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf_9_1,
      ADR1 => N5386,
      ADR2 => N411,
      ADR3 => N111,
      O => s_get_right_word_9_1_SW1_O
    );
  a_Mshift_n0003_Sh_57_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_57_G_O,
      O => N6030
    );
  a_Mshift_n0003_Sh_57_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(31),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_Mshift_n0003_Sh_27_Q,
      O => a_Mshift_n0003_Sh_57_G_O
    );
  a_Mshift_n0002_Sh_1_1_LUT4_D_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_1_Q,
      O => N6244
    );
  a_Mshift_n0002_Sh_1_1 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_shift(0),
      ADR2 => a_put_left_word(0),
      ADR3 => a_put_left_word(1),
      O => a_Mshift_n0002_Sh_1_Q
    );
  a_Mshift_n0002_Sh_2_LUT4_D_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_2_Q,
      O => N6245
    );
  a_Mshift_n0002_Sh_2_Q_113 : X_LUT4
    generic map(
      INIT => X"2705"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_shift(1),
      ADR2 => N137,
      ADR3 => a_put_left_word(1),
      O => a_Mshift_n0002_Sh_2_Q
    );
  a_get_word_18_138_SW11_G_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_18_138_SW11_G_O,
      O => N6032
    );
  a_get_word_18_138_SW11_G : X_LUT3
    generic map(
      INIT => X"A2"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(2),
      ADR2 => CHOICE5056,
      O => a_get_word_18_138_SW11_G_O
    );
  a_get_word_6_1331_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_6_1331_G_O,
      O => N6034
    );
  a_get_word_6_1331_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_Mshift_n0003_Sh_62_Q,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_Mshift_n0003_Sh_54_Q,
      O => a_get_word_6_1331_G_O
    );
  a_get_word_15_561_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_15_561_G_O,
      O => N6036
    );
  a_get_word_15_561_G : X_LUT4
    generic map(
      INIT => X"3222"
    )
    port map (
      ADR0 => CHOICE3797,
      ADR1 => a_shift(4),
      ADR2 => a_shift(1),
      ADR3 => CHOICE3790,
      O => a_get_word_15_561_G_O
    );
  a_get_word_16_160_SW11_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_16_160_SW11_G_O,
      O => N6038
    );
  a_get_word_16_160_SW11_G : X_LUT4
    generic map(
      INIT => X"0228"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_put_left_word(16),
      ADR2 => a_put_right_word(16),
      ADR3 => a_funct(0),
      O => a_get_word_16_160_SW11_G_O
    );
  a_get_word_17_150_SW11_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_17_150_SW11_G_O,
      O => N6040
    );
  a_get_word_17_150_SW11_G : X_LUT4
    generic map(
      INIT => X"0228"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_put_left_word(17),
      ADR2 => a_put_right_word(17),
      ADR3 => a_funct(0),
      O => a_get_word_17_150_SW11_G_O
    );
  a_Ker11511_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker11511_G_O,
      O => N6042
    );
  a_Ker11511_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(26),
      ADR2 => N5140,
      ADR3 => N5141,
      O => a_Ker11511_G_O
    );
  a_get_word_7_150_SW11_G_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_7_150_SW11_G_O,
      O => N6044
    );
  a_get_word_7_150_SW11_G : X_LUT3
    generic map(
      INIT => X"A2"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(2),
      ADR2 => CHOICE4867,
      O => a_get_word_7_150_SW11_G_O
    );
  a_Mshift_n0003_Sh_4_11_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_4_11_G_O,
      O => N6046
    );
  a_Mshift_n0003_Sh_4_11_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(5),
      ADR2 => N5204,
      ADR3 => N5203,
      O => a_Mshift_n0003_Sh_4_11_G_O
    );
  a_get_word_8_611_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_8_611_G_O,
      O => N6048
    );
  a_get_word_8_611_G : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_shift(1),
      ADR2 => N508,
      ADR3 => a_N64,
      O => a_get_word_8_611_G_O
    );
  a_get_word_18_681_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_18_681_G_O,
      O => N6050
    );
  a_get_word_18_681_G : X_LUT4
    generic map(
      INIT => X"E040"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => N529,
      ADR2 => a_shift(2),
      ADR3 => N530,
      O => a_get_word_18_681_G_O
    );
  a_Ker1441_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1441_G_O,
      O => N6052
    );
  a_Ker1441_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N161,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N201,
      O => a_Ker1441_G_O
    );
  a_get_word_18_138_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_18_138_SW0_O,
      O => N5277
    );
  a_get_word_18_138_SW0 : X_LUT4
    generic map(
      INIT => X"AA08"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_Mshift_n0002_Sh_2_Q,
      ADR2 => N5498,
      ADR3 => CHOICE5056,
      O => a_get_word_18_138_SW0_O
    );
  a_Mshift_n0002_Sh_42_SW01_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_42_SW01_G_O,
      O => N6054
    );
  a_Mshift_n0002_Sh_42_SW01_G : X_LUT4
    generic map(
      INIT => X"FA72"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_put_left_word(1),
      ADR2 => N137,
      ADR3 => a_shift(1),
      O => a_Mshift_n0002_Sh_42_SW01_G_O
    );
  a_get_word_23_5_SW1_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_23_5_SW1_O,
      O => N5818
    );
  a_get_word_23_5_SW1 : X_LUT3
    generic map(
      INIT => X"EF"
    )
    port map (
      ADR0 => N241,
      ADR1 => h_get_word_buf(9),
      ADR2 => h_get_word_buf(10),
      O => a_get_word_23_5_SW1_O
    );
  a_get_word_4_1331_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_4_1331_G_O,
      O => N6056
    );
  a_get_word_4_1331_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_Mshift_n0003_Sh_60_Q,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_Mshift_n0003_Sh_52_Q,
      O => a_get_word_4_1331_G_O
    );
  s_get_right_word_2_1_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => s_get_right_word_2_1_SW1_O,
      O => N5261
    );
  s_get_right_word_2_1_SW1 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(2),
      ADR1 => N5358,
      ADR2 => N411,
      ADR3 => N111,
      O => s_get_right_word_2_1_SW1_O
    );
  a_get_word_19_138_SW11_G_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_19_138_SW11_G_O,
      O => N6058
    );
  a_get_word_19_138_SW11_G : X_LUT3
    generic map(
      INIT => X"A2"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(2),
      ADR2 => CHOICE5006,
      O => a_get_word_19_138_SW11_G_O
    );
  a_get_word_16_258_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(16),
      O => N6246
    );
  a_get_word_16_258 : X_LUT4
    generic map(
      INIT => X"FFEA"
    )
    port map (
      ADR0 => CHOICE5469,
      ADR1 => a_put_right_word(16),
      ADR2 => CHOICE5457,
      ADR3 => N5797,
      O => a_get_word(16)
    );
  a_get_word_31_1401_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_31_1401_G_O,
      O => N6060
    );
  a_get_word_31_1401_G : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift_2_1,
      ADR1 => a_shift(0),
      ADR2 => a_N54,
      ADR3 => a_N211,
      O => a_get_word_31_1401_G_O
    );
  a_get_word_0_182_LUT4_D_BUF : X_BUF
    port map (
      I => CHOICE5273,
      O => N6247
    );
  a_get_word_0_182 : X_LUT4
    generic map(
      INIT => X"0010"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => N241,
      ADR2 => a_put_left_word(0),
      ADR3 => N5803,
      O => CHOICE5273
    );
  a_Mshift_n0002_Sh_7_LUT3_D_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_7_Q,
      O => N6248
    );
  a_Mshift_n0002_Sh_7_Q_114 : X_LUT3
    generic map(
      INIT => X"D8"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => N510,
      ADR2 => a_N131,
      O => a_Mshift_n0002_Sh_7_Q
    );
  a_get_word_17_248_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(17),
      O => N6249
    );
  a_get_word_17_248 : X_LUT4
    generic map(
      INIT => X"FCEE"
    )
    port map (
      ADR0 => N5296,
      ADR1 => CHOICE5345,
      ADR2 => N5297,
      ADR3 => CHOICE5324,
      O => a_get_word(17)
    );
  a_Mshift_n0002_Sh_46_SW21_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_46_SW21_G_O,
      O => N6062
    );
  a_Mshift_n0002_Sh_46_SW21_G : X_LUT4
    generic map(
      INIT => X"3237"
    )
    port map (
      ADR0 => N241,
      ADR1 => a_N141,
      ADR2 => h_get_word_buf(8),
      ADR3 => a_N161,
      O => a_Mshift_n0002_Sh_46_SW21_G_O
    );
  a_Ker23_LUT4_D_BUF : X_BUF
    port map (
      I => a_N231,
      O => N6250
    );
  a_Ker23 : X_LUT4
    generic map(
      INIT => X"7520"
    )
    port map (
      ADR0 => a_shift(2),
      ADR1 => N123,
      ADR2 => a_put_left_word(0),
      ADR3 => a_Mshift_n0002_Sh_4_Q,
      O => a_N231
    );
  a_get_word_31_82_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_31_82_O,
      O => CHOICE4769
    );
  a_get_word_31_82 : X_LUT4
    generic map(
      INIT => X"A888"
    )
    port map (
      ADR0 => a_put_left_word(31),
      ADR1 => a_funct(0),
      ADR2 => CHOICE5429,
      ADR3 => CHOICE4766,
      O => a_get_word_31_82_O
    );
  a_get_word_28_141_SW1_SW0_LUT2_L_BUF : X_BUF
    port map (
      I => a_get_word_28_141_SW1_SW0_O,
      O => N5841
    );
  a_get_word_28_141_SW1_SW0 : X_LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_funct(1),
      O => a_get_word_28_141_SW1_SW0_O
    );
  a_get_word_21_64_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_21_64_SW0_O,
      O => N5538
    );
  a_get_word_21_64_SW0 : X_LUT4
    generic map(
      INIT => X"FFEF"
    )
    port map (
      ADR0 => h_get_word_buf(9),
      ADR1 => a_funct(0),
      ADR2 => h_get_word_buf(10),
      ADR3 => N241,
      O => a_get_word_21_64_SW0_O
    );
  a_get_word_1_1471_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_1_1471_G_O,
      O => N6064
    );
  a_get_word_1_1471_G : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(4),
      ADR1 => a_shift(1),
      ADR2 => a_N47,
      ADR3 => a_N126,
      O => a_get_word_1_1471_G_O
    );
  s_get_right_word_3_1_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => s_get_right_word_3_1_SW1_O,
      O => N5258
    );
  s_get_right_word_3_1_SW1 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(3),
      ADR1 => N5364,
      ADR2 => N411,
      ADR3 => N111,
      O => s_get_right_word_3_1_SW1_O
    );
  a_Ker1411_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1411_G_O,
      O => N6066
    );
  a_Ker1411_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(7),
      ADR2 => N5210,
      ADR3 => N5209,
      O => a_Ker1411_G_O
    );
  s_get_right_word_17_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_right_word(17),
      O => N6251
    );
  s_get_right_word_17_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(17),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(17),
      O => s_get_right_word(17)
    );
  s_get_right_word_20_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_right_word(20),
      O => N6252
    );
  s_get_right_word_20_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(20),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(20),
      O => s_get_right_word(20)
    );
  s_get_right_word_21_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_right_word(21),
      O => N6253
    );
  s_get_right_word_21_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(21),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(21),
      O => s_get_right_word(21)
    );
  s_get_right_word_22_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_right_word(22),
      O => N6254
    );
  s_get_right_word_22_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(22),
      ADR1 => s_right_conflict,
      ADR2 => s_get_right_word_buf(22),
      O => s_get_right_word(22)
    );
  s_get_left_word_0_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(0),
      O => N6255
    );
  s_get_left_word_0_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(0),
      ADR1 => s_left_conflict1,
      ADR2 => s_get_left_word_buf(0),
      O => s_get_left_word(0)
    );
  s_get_left_word_1_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(1),
      O => N6256
    );
  s_get_left_word_1_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(1),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(1),
      O => s_get_left_word(1)
    );
  s_get_left_word_2_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(2),
      O => N6257
    );
  s_get_left_word_2_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(2),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(2),
      O => s_get_left_word(2)
    );
  s_get_left_word_3_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(3),
      O => N6258
    );
  s_get_left_word_3_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(3),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(3),
      O => s_get_left_word(3)
    );
  s_get_left_word_4_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(4),
      O => N6259
    );
  s_get_left_word_4_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(4),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(4),
      O => s_get_left_word(4)
    );
  s_get_left_word_5_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(5),
      O => N6260
    );
  s_get_left_word_5_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(5),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(5),
      O => s_get_left_word(5)
    );
  s_get_left_word_6_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(6),
      O => N6261
    );
  s_get_left_word_6_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(6),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(6),
      O => s_get_left_word(6)
    );
  s_get_left_word_7_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(7),
      O => N6262
    );
  s_get_left_word_7_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(7),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(7),
      O => s_get_left_word(7)
    );
  s_get_left_word_8_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(8),
      O => N6263
    );
  s_get_left_word_8_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(8),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(8),
      O => s_get_left_word(8)
    );
  s_get_left_word_9_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(9),
      O => N6264
    );
  s_get_left_word_9_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(9),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(9),
      O => s_get_left_word(9)
    );
  s_get_left_word_10_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(10),
      O => N6265
    );
  s_get_left_word_10_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(10),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(10),
      O => s_get_left_word(10)
    );
  s_get_left_word_11_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(11),
      O => N6266
    );
  s_get_left_word_11_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(11),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(11),
      O => s_get_left_word(11)
    );
  s_get_left_word_12_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(12),
      O => N6267
    );
  s_get_left_word_12_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(12),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(12),
      O => s_get_left_word(12)
    );
  s_get_left_word_13_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(13),
      O => N6268
    );
  s_get_left_word_13_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(13),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(13),
      O => s_get_left_word(13)
    );
  s_get_left_word_14_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(14),
      O => N6269
    );
  s_get_left_word_14_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(14),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(14),
      O => s_get_left_word(14)
    );
  s_get_left_word_15_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(15),
      O => N6270
    );
  s_get_left_word_15_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(15),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(15),
      O => s_get_left_word(15)
    );
  s_get_left_word_16_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(16),
      O => N6271
    );
  s_get_left_word_16_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(16),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(16),
      O => s_get_left_word(16)
    );
  s_get_left_word_17_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(17),
      O => N6272
    );
  s_get_left_word_17_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(17),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(17),
      O => s_get_left_word(17)
    );
  s_get_left_word_18_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(18),
      O => N6273
    );
  s_get_left_word_18_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(18),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(18),
      O => s_get_left_word(18)
    );
  s_get_left_word_19_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(19),
      O => N6274
    );
  s_get_left_word_19_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(19),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(19),
      O => s_get_left_word(19)
    );
  s_get_left_word_20_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(20),
      O => N6275
    );
  s_get_left_word_20_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(20),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(20),
      O => s_get_left_word(20)
    );
  s_get_left_word_21_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(21),
      O => N6276
    );
  s_get_left_word_21_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(21),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(21),
      O => s_get_left_word(21)
    );
  s_get_left_word_22_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(22),
      O => N6277
    );
  s_get_left_word_22_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(22),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(22),
      O => s_get_left_word(22)
    );
  s_get_left_word_23_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(23),
      O => N6278
    );
  s_get_left_word_23_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(23),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(23),
      O => s_get_left_word(23)
    );
  s_get_left_word_24_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(24),
      O => N6279
    );
  s_get_left_word_24_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(24),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(24),
      O => s_get_left_word(24)
    );
  s_get_left_word_25_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(25),
      O => N6280
    );
  s_get_left_word_25_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(25),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(25),
      O => s_get_left_word(25)
    );
  s_get_left_word_26_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(26),
      O => N6281
    );
  s_get_left_word_26_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(26),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(26),
      O => s_get_left_word(26)
    );
  s_get_left_word_27_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(27),
      O => N6282
    );
  s_get_left_word_27_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(27),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(27),
      O => s_get_left_word(27)
    );
  s_get_left_word_28_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(28),
      O => N6283
    );
  s_get_left_word_28_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(28),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(28),
      O => s_get_left_word(28)
    );
  s_get_left_word_29_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(29),
      O => N6284
    );
  s_get_left_word_29_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(29),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(29),
      O => s_get_left_word(29)
    );
  s_get_left_word_30_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(30),
      O => N6285
    );
  s_get_left_word_30_1 : X_LUT3
    generic map(
      INIT => X"B8"
    )
    port map (
      ADR0 => s_put_word_buf(30),
      ADR1 => s_left_conflict,
      ADR2 => s_get_left_word_buf(30),
      O => s_get_left_word(30)
    );
  s_get_left_word_31_1_LUT3_D_BUF : X_BUF
    port map (
      I => s_get_left_word(31),
      O => N6286
    );
  s_get_left_word_31_1 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_get_left_word_buf(31),
      ADR2 => s_put_word_buf(31),
      O => s_get_left_word(31)
    );
  a_Mshift_n0002_Sh_3_291_G_LUT3_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_3_291_G_O,
      O => N6068
    );
  a_Mshift_n0002_Sh_3_291_G : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_put_left_word(1),
      ADR2 => a_put_left_word(0),
      O => a_Mshift_n0002_Sh_3_291_G_O
    );
  a_Mshift_n0003_Sh_59_1_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_59_1_G_O,
      O => N6070
    );
  a_Mshift_n0003_Sh_59_1_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(31),
      ADR2 => N5155,
      ADR3 => N5156,
      O => a_Mshift_n0003_Sh_59_1_G_O
    );
  s_put_address_4_SW2_LUT4_L_BUF : X_BUF
    port map (
      I => s_put_address_4_SW2_O,
      O => N5815
    );
  s_put_address_4_SW2 : X_LUT4
    generic map(
      INIT => X"FF1B"
    )
    port map (
      ADR0 => h_get_word_buf(26),
      ADR1 => h_get_word_buf(15),
      ADR2 => h_get_word_buf(20),
      ADR3 => h_response_buf(0),
      O => s_put_address_4_SW2_O
    );
  Ker23_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => Ker23_SW1_O,
      O => N5518
    );
  Ker23_SW1 : X_LUT4
    generic map(
      INIT => X"3337"
    )
    port map (
      ADR0 => h_get_word_buf_27_1,
      ADR1 => h_get_word_buf(15),
      ADR2 => h_get_word_buf_26_2,
      ADR3 => h_get_word_buf(28),
      O => Ker23_SW1_O
    );
  a_get_word_13_92_SW01_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_13_92_SW01_G_O,
      O => N6072
    );
  a_get_word_13_92_SW01_G : X_LUT4
    generic map(
      INIT => X"AA02"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => N5091,
      ADR2 => a_funct(2),
      ADR3 => CHOICE4825,
      O => a_get_word_13_92_SW01_G_O
    );
  a_Ker2211_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker2211_G_O,
      O => N6074
    );
  a_Ker2211_G : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(23),
      ADR2 => N5131,
      ADR3 => N5132,
      O => a_Ker2211_G_O
    );
  a_get_word_17_83_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_17_83_G_O,
      O => N6076
    );
  a_get_word_17_83_G : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(2),
      ADR1 => a_shift(0),
      ADR2 => a_N57,
      ADR3 => a_N141,
      O => a_get_word_17_83_G_O
    );
  a_Ker23_SW0_LUT2_D_BUF : X_BUF
    port map (
      I => N123,
      O => N6287
    );
  a_Ker23_SW0 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_shift(0),
      O => N123
    );
  a_Ker1821_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1821_G_O,
      O => N6078
    );
  a_Ker1821_G : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(15),
      ADR2 => N5177,
      ADR3 => N5176,
      O => a_Ker1821_G_O
    );
  a_Mshift_n0003_Sh_56_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N508,
      O => N6288
    );
  a_Mshift_n0003_Sh_56_SW0 : X_LUT4
    generic map(
      INIT => X"F1E0"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => N241,
      ADR2 => a_Mshift_n0003_Sh_30_Q,
      ADR3 => a_Mshift_n0003_Sh_26_Q,
      O => N508
    );
  s_get_left_word_1_1_SW1_LUT4_D_BUF : X_BUF
    port map (
      I => N5192,
      O => N6289
    );
  s_get_left_word_1_1_SW1 : X_LUT4
    generic map(
      INIT => X"ACAF"
    )
    port map (
      ADR0 => h_get_address_buf(1),
      ADR1 => s_put_word_buf(1),
      ADR2 => Ker21_13,
      ADR3 => s_left_conflict_7,
      O => N5192
    );
  a_Mshift_n0002_Sh_4_1_G_LUT3_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_4_1_G_O,
      O => N6080
    );
  a_Mshift_n0002_Sh_4_1_G : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_put_left_word(3),
      ADR2 => a_put_left_word(1),
      O => a_Mshift_n0002_Sh_4_1_G_O
    );
  a_Mshift_n0002_Sh_2_SW01_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_2_SW01_G_O,
      O => N6082
    );
  a_Mshift_n0002_Sh_2_SW01_G : X_LUT4
    generic map(
      INIT => X"010B"
    )
    port map (
      ADR0 => s_get_left_word_buf(0),
      ADR1 => N5158,
      ADR2 => N121,
      ADR3 => N5159,
      O => a_Mshift_n0002_Sh_2_SW01_G_O
    );
  s_get_left_word_5_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5203,
      O => N6290
    );
  s_get_left_word_5_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(5),
      ADR1 => s_put_word_buf(5),
      ADR2 => Ker21_14,
      ADR3 => s_left_conflict_3,
      O => N5203
    );
  s_get_left_word_6_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5206,
      O => N6291
    );
  s_get_left_word_6_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(6),
      ADR1 => s_put_word_buf(6),
      ADR2 => Ker21_14,
      ADR3 => s_left_conflict_3,
      O => N5206
    );
  s_get_left_word_3_1_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => s_get_left_word_3_1_SW0_O,
      O => N5197
    );
  s_get_left_word_3_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(3),
      ADR1 => s_put_word_buf(3),
      ADR2 => Ker21_14,
      ADR3 => s_left_conflict_7,
      O => s_get_left_word_3_1_SW0_O
    );
  a_get_word_30_48_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_30_48_G_O,
      O => N6084
    );
  a_get_word_30_48_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N201,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N178,
      O => a_get_word_30_48_G_O
    );
  a_Ker18229_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker18229_G_O,
      O => N6086
    );
  a_Ker18229_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N52,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N46,
      O => a_Ker18229_G_O
    );
  s_get_left_word_7_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5209,
      O => N6292
    );
  s_get_left_word_7_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(7),
      ADR1 => s_put_word_buf(7),
      ADR2 => Ker21_14,
      ADR3 => s_left_conflict_3,
      O => N5209
    );
  s_get_left_word_8_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5212,
      O => N6293
    );
  s_get_left_word_8_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(8),
      ADR1 => s_put_word_buf(8),
      ADR2 => Ker21_12,
      ADR3 => s_left_conflict_6,
      O => N5212
    );
  a_Ker98_SW0_LUT3_D_BUF : X_BUF
    port map (
      I => N502,
      O => N6294
    );
  a_Ker98_SW0 : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_N52,
      ADR2 => a_N181,
      O => N502
    );
  a_Mshift_n0003_Sh_55_29_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_55_29_G_O,
      O => N6088
    );
  a_Mshift_n0003_Sh_55_29_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_Mshift_n0003_Sh_29_Q,
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_Mshift_n0003_Sh_25_Q,
      O => a_Mshift_n0003_Sh_55_29_G_O
    );
  a_get_word_28_261_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(28),
      O => N6295
    );
  a_get_word_28_261 : X_LUT4
    generic map(
      INIT => X"FFEA"
    )
    port map (
      ADR0 => CHOICE4220,
      ADR1 => a_n0000(28),
      ADR2 => a_N380,
      ADR3 => N5514,
      O => a_get_word(28)
    );
  s_get_right_word_6_1_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => s_get_right_word_6_1_SW1_O,
      O => N5333
    );
  s_get_right_word_6_1_SW1 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(6),
      ADR1 => N5376,
      ADR2 => N411,
      ADR3 => N111,
      O => s_get_right_word_6_1_SW1_O
    );
  a_put_right_word_0_SW0_SW1_LUT2_L_BUF : X_BUF
    port map (
      I => a_put_right_word_0_SW0_SW1_O,
      O => N5352
    );
  a_put_right_word_0_SW0_SW1 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => s_put_word_buf(0),
      ADR1 => s_right_conflict_2,
      O => a_put_right_word_0_SW0_SW1_O
    );
  a_get_word_16_93_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_16_93_G_O,
      O => N6090
    );
  a_get_word_16_93_G : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift_2_1,
      ADR1 => a_shift(0),
      ADR2 => a_N131,
      ADR3 => a_N57,
      O => a_get_word_16_93_G_O
    );
  a_put_right_word_8_SW0_SW1_LUT2_L_BUF : X_BUF
    port map (
      I => a_put_right_word_8_SW0_SW1_O,
      O => N5384
    );
  a_put_right_word_8_SW0_SW1 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => s_put_word_buf(8),
      ADR1 => s_right_conflict_4,
      O => a_put_right_word_8_SW0_SW1_O
    );
  a_put_right_word_7_SW0_SW1_LUT2_L_BUF : X_BUF
    port map (
      I => a_put_right_word_7_SW0_SW1_O,
      O => N5380
    );
  a_put_right_word_7_SW0_SW1 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => s_put_word_buf(7),
      ADR1 => s_right_conflict_4,
      O => a_put_right_word_7_SW0_SW1_O
    );
  s_get_right_word_11_1_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => s_get_right_word_11_1_SW1_O,
      O => N5318
    );
  s_get_right_word_11_1_SW1 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(11),
      ADR1 => N5396,
      ADR2 => N411,
      ADR3 => N111,
      O => s_get_right_word_11_1_SW1_O
    );
  s_get_right_word_12_1_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => s_get_right_word_12_1_SW1_O,
      O => N5315
    );
  s_get_right_word_12_1_SW1 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(12),
      ADR1 => N5400,
      ADR2 => N411,
      ADR3 => N111,
      O => s_get_right_word_12_1_SW1_O
    );
  s_get_right_word_13_1_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => s_get_right_word_13_1_SW1_O,
      O => N5312
    );
  s_get_right_word_13_1_SW1 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(13),
      ADR1 => N5466,
      ADR2 => N411,
      ADR3 => N111,
      O => s_get_right_word_13_1_SW1_O
    );
  a_Ker143_SW0_LUT3_D_BUF : X_BUF
    port map (
      I => N270,
      O => N6296
    );
  a_Ker143_SW0 : X_LUT3
    generic map(
      INIT => X"27"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_N53,
      ADR2 => a_N201,
      O => N270
    );
  s_get_left_word_2_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5194,
      O => N6297
    );
  s_get_left_word_2_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(2),
      ADR1 => s_put_word_buf(2),
      ADR2 => N2,
      ADR3 => s_left_conflict1,
      O => N5194
    );
  a_get_word_13_155_SW0_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_13_155_SW0_G_O,
      O => N6092
    );
  a_get_word_13_155_SW0_G : X_LUT4
    generic map(
      INIT => X"AE08"
    )
    port map (
      ADR0 => a_put_right_word(13),
      ADR1 => CHOICE4899,
      ADR2 => a_funct(1),
      ADR3 => a_put_left_word(13),
      O => a_get_word_13_155_SW0_G_O
    );
  s_get_right_word_15_1_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => s_get_right_word_15_1_SW1_O,
      O => N5306
    );
  s_get_right_word_15_1_SW1 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(15),
      ADR1 => N5474,
      ADR2 => N411,
      ADR3 => N111,
      O => s_get_right_word_15_1_SW1_O
    );
  s_get_right_word_14_1_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => s_get_right_word_14_1_SW1_O,
      O => N5309
    );
  s_get_right_word_14_1_SW1 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(14),
      ADR1 => N5472,
      ADR2 => N411,
      ADR3 => N111,
      O => s_get_right_word_14_1_SW1_O
    );
  s_get_left_word_9_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5215,
      O => N6298
    );
  s_get_left_word_9_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(9),
      ADR1 => s_put_word_buf(9),
      ADR2 => Ker21_12,
      ADR3 => s_left_conflict_6,
      O => N5215
    );
  a_put_right_word_15_SW0_SW1_LUT2_L_BUF : X_BUF
    port map (
      I => a_put_right_word_15_SW0_SW1_O,
      O => N5476
    );
  a_put_right_word_15_SW0_SW1 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => s_put_word_buf(15),
      ADR1 => s_right_conflict_3,
      O => a_put_right_word_15_SW0_SW1_O
    );
  a_Ker621_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker621_G_O,
      O => N6094
    );
  a_Ker621_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(25),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(21),
      O => a_Ker621_G_O
    );
  a_put_right_word_19_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N230,
      O => N6299
    );
  a_put_right_word_19_SW0 : X_LUT4
    generic map(
      INIT => X"F8F0"
    )
    port map (
      ADR0 => h_get_word_buf(19),
      ADR1 => h_get_word_buf(29),
      ADR2 => N231,
      ADR3 => N451,
      O => N230
    );
  a_put_right_word_13_SW0_SW1_LUT2_L_BUF : X_BUF
    port map (
      I => a_put_right_word_13_SW0_SW1_O,
      O => N5468
    );
  a_put_right_word_13_SW0_SW1 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => s_put_word_buf(13),
      ADR1 => s_right_conflict_3,
      O => a_put_right_word_13_SW0_SW1_O
    );
  a_put_right_word_18_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N237,
      O => N6300
    );
  a_put_right_word_18_SW0 : X_LUT4
    generic map(
      INIT => X"F8F0"
    )
    port map (
      ADR0 => h_get_word_buf(18),
      ADR1 => h_get_word_buf(29),
      ADR2 => N231,
      ADR3 => N451,
      O => N237
    );
  a_put_right_word_18_SW1_LUT4_D_BUF : X_BUF
    port map (
      I => N238,
      O => N6301
    );
  a_put_right_word_18_SW1 : X_LUT4
    generic map(
      INIT => X"FF8C"
    )
    port map (
      ADR0 => h_get_word_buf(18),
      ADR1 => N451,
      ADR2 => h_get_word_buf(29),
      ADR3 => N231,
      O => N238
    );
  a_put_right_word_17_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N242,
      O => N6302
    );
  a_put_right_word_17_SW0 : X_LUT4
    generic map(
      INIT => X"F8F0"
    )
    port map (
      ADR0 => h_get_word_buf(17),
      ADR1 => h_get_word_buf(29),
      ADR2 => N231,
      ADR3 => N451,
      O => N242
    );
  a_put_right_word_17_SW1_LUT4_D_BUF : X_BUF
    port map (
      I => N243,
      O => N6303
    );
  a_put_right_word_17_SW1 : X_LUT4
    generic map(
      INIT => X"FF8C"
    )
    port map (
      ADR0 => h_get_word_buf(17),
      ADR1 => N451,
      ADR2 => h_get_word_buf(29),
      ADR3 => N231,
      O => N243
    );
  a_put_right_word_16_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => a_put_right_word_16_SW1_O,
      O => N248
    );
  a_put_right_word_16_SW1 : X_LUT4
    generic map(
      INIT => X"FF8C"
    )
    port map (
      ADR0 => h_get_word_buf(16),
      ADR1 => N451,
      ADR2 => h_get_word_buf(29),
      ADR3 => N231,
      O => a_put_right_word_16_SW1_O
    );
  a_get_word_14_196_SW0_LUT2_L_BUF : X_BUF
    port map (
      I => a_get_word_14_196_SW0_O,
      O => N5288
    );
  a_get_word_14_196_SW0 : X_LUT2
    generic map(
      INIT => X"7"
    )
    port map (
      ADR0 => a_put_right_word(14),
      ADR1 => a_put_left_word(14),
      O => a_get_word_14_196_SW0_O
    );
  a_put_right_word_9_SW0_SW1_LUT2_L_BUF : X_BUF
    port map (
      I => a_put_right_word_9_SW0_SW1_O,
      O => N5388
    );
  a_put_right_word_9_SW0_SW1 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => s_put_word_buf(9),
      ADR1 => s_right_conflict_4,
      O => a_put_right_word_9_SW0_SW1_O
    );
  a_get_word_30_202_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_30_202_O,
      O => CHOICE4268
    );
  a_get_word_30_202 : X_LUT4
    generic map(
      INIT => X"0A28"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_right_word(30),
      ADR2 => a_funct(1),
      ADR3 => a_put_left_word(30),
      O => a_get_word_30_202_O
    );
  a_get_word_21_140_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_21_140_O,
      O => CHOICE4412
    );
  a_get_word_21_140 : X_LUT4
    generic map(
      INIT => X"2232"
    )
    port map (
      ADR0 => CHOICE4395,
      ADR1 => a_funct(2),
      ADR2 => CHOICE4407,
      ADR3 => a_shift(4),
      O => a_get_word_21_140_O
    );
  a_put_right_word_12_SW0_SW0_LUT2_L_BUF : X_BUF
    port map (
      I => a_put_right_word_12_SW0_SW0_O,
      O => N5398
    );
  a_put_right_word_12_SW0_SW0 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => s_put_word_buf(12),
      ADR1 => s_right_conflict_3,
      O => a_put_right_word_12_SW0_SW0_O
    );
  a_Ker85_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker85_G_O,
      O => N6096
    );
  a_Ker85_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(7),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(3),
      O => a_Ker85_G_O
    );
  a_get_word_31_110_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_31_110_G_O,
      O => N6098
    );
  a_get_word_31_110_G : X_LUT4
    generic map(
      INIT => X"3010"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => a_shift(0),
      ADR2 => a_shift(1),
      ADR3 => N5150,
      O => a_get_word_31_110_G_O
    );
  Ker451_LUT4_D_BUF : X_BUF
    port map (
      I => N451,
      O => N6304
    );
  Ker451 : X_LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      ADR0 => h_response_buf_1_3,
      ADR1 => h_response_buf_0_4,
      ADR2 => h_get_word_buf(27),
      ADR3 => h_get_word_buf(28),
      O => N451
    );
  a_get_word_14_135_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_14_135_O,
      O => CHOICE4359
    );
  a_get_word_14_135 : X_LUT3
    generic map(
      INIT => X"60"
    )
    port map (
      ADR0 => a_put_left_word(14),
      ADR1 => a_put_right_word(14),
      ADR2 => CHOICE4358,
      O => a_get_word_14_135_O
    );
  a_Ker21_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker21_G_O,
      O => N6100
    );
  a_Ker21_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(18),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(14),
      O => a_Ker21_G_O
    );
  a_get_word_15_205_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(15),
      O => N6305
    );
  a_get_word_15_205 : X_LUT4
    generic map(
      INIT => X"FFF8"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => CHOICE4453,
      ADR2 => CHOICE4471,
      ADR3 => N5085,
      O => a_get_word(15)
    );
  a_Ker25529_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker25529_G_O,
      O => N6102
    );
  a_Ker25529_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N511,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N55,
      O => a_Ker25529_G_O
    );
  a_Ker611_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker611_G_O,
      O => N6104
    );
  a_Ker611_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(24),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(20),
      O => a_Ker611_G_O
    );
  a_get_word_29_202_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_29_202_O,
      O => CHOICE4318
    );
  a_get_word_29_202 : X_LUT4
    generic map(
      INIT => X"0A28"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_right_word(29),
      ADR2 => a_funct(1),
      ADR3 => a_put_left_word(29),
      O => a_get_word_29_202_O
    );
  a_get_word_24_152_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_24_152_O,
      O => CHOICE3943
    );
  a_get_word_24_152 : X_LUT4
    generic map(
      INIT => X"F8F0"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_N370,
      ADR2 => CHOICE3942,
      ADR3 => a_Mshift_n0003_Sh_56_Q,
      O => a_get_word_24_152_O
    );
  s_right_conflict_Sclr_INV23_LUT4_L_BUF : X_BUF
    port map (
      I => s_right_conflict_Sclr_INV23_O,
      O => CHOICE3808
    );
  s_right_conflict_Sclr_INV23 : X_LUT4
    generic map(
      INIT => X"FF6F"
    )
    port map (
      ADR0 => N5020,
      ADR1 => s_put_address(0),
      ADR2 => s_request,
      ADR3 => CHOICE3806,
      O => s_right_conflict_Sclr_INV23_O
    );
  a_Ker25629_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker25629_G_O,
      O => N6106
    );
  a_Ker25629_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N181,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N221,
      O => a_Ker25629_G_O
    );
  a_Ker581_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker581_G_O,
      O => N6108
    );
  a_Ker581_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(17),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(13),
      O => a_Ker581_G_O
    );
  a_get_word_23_161_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_23_161_O,
      O => CHOICE3901
    );
  a_get_word_23_161 : X_LUT4
    generic map(
      INIT => X"F8F0"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_N370,
      ADR2 => CHOICE3900,
      ADR3 => a_Mshift_n0003_Sh_55_Q,
      O => a_get_word_23_161_O
    );
  a_get_word_22_21_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_22_21_O,
      O => CHOICE4131
    );
  a_get_word_22_21 : X_LUT4
    generic map(
      INIT => X"AA80"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => CHOICE4125,
      ADR2 => a_N196,
      ADR3 => CHOICE4129,
      O => a_get_word_22_21_O
    );
  a_get_word_26_52_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_26_52_O,
      O => CHOICE4007
    );
  a_get_word_26_52 : X_LUT4
    generic map(
      INIT => X"FFF8"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_N371,
      ADR2 => a_N76,
      ADR3 => CHOICE4004,
      O => a_get_word_26_52_O
    );
  a_get_word_16_258_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_16_258_SW0_O,
      O => N5797
    );
  a_get_word_16_258_SW0 : X_LUT4
    generic map(
      INIT => X"FEAE"
    )
    port map (
      ADR0 => a_N76,
      ADR1 => N5271,
      ADR2 => CHOICE5448,
      ADR3 => N5272,
      O => a_get_word_16_258_SW0_O
    );
  a_get_word_22_34_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_22_34_O,
      O => CHOICE4135
    );
  a_get_word_22_34 : X_LUT4
    generic map(
      INIT => X"F1E0"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => N241,
      ADR2 => a_N98,
      ADR3 => a_N144,
      O => a_get_word_22_34_O
    );
  a_put_right_word_16_SW3_SW0_LUT3_L_BUF : X_BUF
    port map (
      I => a_put_right_word_16_SW3_SW0_O,
      O => N5458
    );
  a_put_right_word_16_SW3_SW0 : X_LUT3
    generic map(
      INIT => X"8D"
    )
    port map (
      ADR0 => h_get_word_buf(29),
      ADR1 => h_get_word_buf(16),
      ADR2 => h_get_word_buf(26),
      O => a_put_right_word_16_SW3_SW0_O
    );
  a_get_word_20_34_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_20_34_O,
      O => CHOICE4084
    );
  a_get_word_20_34 : X_LUT4
    generic map(
      INIT => X"F1E0"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => N241,
      ADR2 => a_N96,
      ADR3 => a_N142,
      O => a_get_word_20_34_O
    );
  a_Ker01_LUT4_D_BUF : X_BUF
    port map (
      I => a_N01,
      O => N6306
    );
  a_Ker01 : X_LUT4
    generic map(
      INIT => X"FBFF"
    )
    port map (
      ADR0 => h_get_word_buf(2),
      ADR1 => h_get_word_buf(3),
      ADR2 => N121,
      ADR3 => N411,
      O => a_N01
    );
  a_Ker91_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker91_G_O,
      O => N6110
    );
  a_Ker91_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(23),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(19),
      O => a_Ker91_G_O
    );
  a_get_word_29_48_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_29_48_G_O,
      O => N6112
    );
  a_get_word_29_48_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N53,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N115,
      O => a_get_word_29_48_G_O
    );
  a_get_word_14_222_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(14),
      O => N6307
    );
  a_get_word_14_222 : X_LUT4
    generic map(
      INIT => X"FEFC"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => N5087,
      ADR2 => CHOICE4368,
      ADR3 => CHOICE4349,
      O => a_get_word(14)
    );
  a_get_word_20_214_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_20_214_SW0_O,
      O => N5799
    );
  a_get_word_20_214_SW0 : X_LUT4
    generic map(
      INIT => X"96E8"
    )
    port map (
      ADR0 => a_put_right_word(20),
      ADR1 => a_put_left_word(20),
      ADR2 => a_funct(0),
      ADR3 => a_funct(1),
      O => a_get_word_20_214_SW0_O
    );
  a_Ker61_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker61_G_O,
      O => N6114
    );
  a_Ker61_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(26),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(22),
      O => a_Ker61_G_O
    );
  a_get_word_24_8_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_24_8_O,
      O => CHOICE3909
    );
  a_get_word_24_8 : X_LUT4
    generic map(
      INIT => X"FE10"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => N241,
      ADR2 => a_N257,
      ADR3 => a_N142,
      O => a_get_word_24_8_O
    );
  a_Ker82_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker82_G_O,
      O => N6116
    );
  a_Ker82_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(27),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(23),
      O => a_Ker82_G_O
    );
  a_get_word_12_173_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_12_173_G_O,
      O => N6118
    );
  a_get_word_12_173_G : X_LUT4
    generic map(
      INIT => X"FFEA"
    )
    port map (
      ADR0 => a_N291,
      ADR1 => a_N231,
      ADR2 => CHOICE4734,
      ADR3 => CHOICE4515,
      O => a_get_word_12_173_G_O
    );
  a_get_word_9_223_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(9),
      O => N6308
    );
  a_get_word_9_223 : X_LUT4
    generic map(
      INIT => X"FFEA"
    )
    port map (
      ADR0 => CHOICE4683,
      ADR1 => a_funct(0),
      ADR2 => CHOICE4664,
      ADR3 => CHOICE4690,
      O => a_get_word(9)
    );
  a_Ker11_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker11_G_O,
      O => N6120
    );
  a_Ker11_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(22),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(18),
      O => a_Ker11_G_O
    );
  a_get_word_26_152_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_26_152_O,
      O => CHOICE4027
    );
  a_get_word_26_152 : X_LUT4
    generic map(
      INIT => X"F8F0"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_N370,
      ADR2 => CHOICE4026,
      ADR3 => a_Mshift_n0003_Sh_58_Q,
      O => a_get_word_26_152_O
    );
  a_get_word_15_179_SW0_LUT2_L_BUF : X_BUF
    port map (
      I => a_get_word_15_179_SW0_O,
      O => N5286
    );
  a_get_word_15_179_SW0 : X_LUT2
    generic map(
      INIT => X"7"
    )
    port map (
      ADR0 => a_put_right_word(15),
      ADR1 => a_put_left_word(15),
      O => a_get_word_15_179_SW0_O
    );
  a_get_word_7_219_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_7_219_SW0_O,
      O => N5516
    );
  a_get_word_7_219_SW0 : X_LUT4
    generic map(
      INIT => X"FEAE"
    )
    port map (
      ADR0 => a_N291,
      ADR1 => N5280,
      ADR2 => CHOICE4885,
      ADR3 => N5281,
      O => a_get_word_7_219_SW0_O
    );
  h_address_0_1_LUT4_D_BUF : X_BUF
    port map (
      I => AA_0_OBUF,
      O => N6309
    );
  h_address_0_1 : X_LUT4
    generic map(
      INIT => X"90D4"
    )
    port map (
      ADR0 => h_request(2),
      ADR1 => N90,
      ADR2 => a_get_word(0),
      ADR3 => h_put_address_buf(0),
      O => AA_0_OBUF
    );
  a_get_word_14_90_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_14_90_O,
      O => CHOICE4349
    );
  a_get_word_14_90 : X_LUT4
    generic map(
      INIT => X"FAF8"
    )
    port map (
      ADR0 => CHOICE4503,
      ADR1 => CHOICE4338,
      ADR2 => CHOICE4335,
      ADR3 => CHOICE4344,
      O => a_get_word_14_90_O
    );
  a_get_word_27_143_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_27_143_SW0_O,
      O => N5563
    );
  a_get_word_27_143_SW0 : X_LUT4
    generic map(
      INIT => X"F1E0"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => N241,
      ADR2 => a_N811,
      ADR3 => a_N182,
      O => a_get_word_27_143_SW0_O
    );
  a_get_word_3_187_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_3_187_SW0_O,
      O => N5445
    );
  a_get_word_3_187_SW0 : X_LUT4
    generic map(
      INIT => X"1333"
    )
    port map (
      ADR0 => a_N372,
      ADR1 => a_funct(0),
      ADR2 => CHOICE5391,
      ADR3 => a_Mshift_n0002_Sh_3_Q,
      O => a_get_word_3_187_SW0_O
    );
  GE_stagelut_LUT4_L_BUF : X_BUF
    port map (
      I => GE_stagelut_O,
      O => N35
    );
  GE_stagelut : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_left_conflict,
      ADR1 => s_put_word_buf(31),
      ADR2 => s_get_right_word(31),
      ADR3 => s_get_left_word_buf(31),
      O => GE_stagelut_O
    );
  a_get_word_23_61_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_23_61_O,
      O => CHOICE3881
    );
  a_get_word_23_61 : X_LUT4
    generic map(
      INIT => X"FFF8"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_N371,
      ADR2 => a_N76,
      ADR3 => CHOICE3878,
      O => a_get_word_23_61_O
    );
  a_get_word_30_243_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_30_243_SW0_O,
      O => N5507
    );
  a_get_word_30_243_SW0 : X_LUT4
    generic map(
      INIT => X"FF54"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => CHOICE4230,
      ADR2 => CHOICE4252,
      ADR3 => CHOICE4258,
      O => a_get_word_30_243_SW0_O
    );
  a_get_word_28_248_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_28_248_SW0_O,
      O => N5514
    );
  a_get_word_28_248_SW0 : X_LUT4
    generic map(
      INIT => X"F1E0"
    )
    port map (
      ADR0 => CHOICE4199,
      ADR1 => CHOICE4181,
      ADR2 => N5530,
      ADR3 => N5529,
      O => a_get_word_28_248_SW0_O
    );
  a_get_word_27_14_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_27_14_SW0_O,
      O => N5554
    );
  a_get_word_27_14_SW0 : X_LUT4
    generic map(
      INIT => X"EEEC"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_N76,
      ADR2 => CHOICE4054,
      ADR3 => CHOICE4047,
      O => a_get_word_27_14_SW0_O
    );
  a_get_word_24_52_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_24_52_O,
      O => CHOICE3923
    );
  a_get_word_24_52 : X_LUT4
    generic map(
      INIT => X"FFF8"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_N371,
      ADR2 => a_N76,
      ADR3 => CHOICE3920,
      O => a_get_word_24_52_O
    );
  a_get_word_31_187_SW0_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_31_187_SW0_O,
      O => N5552
    );
  a_get_word_31_187_SW0 : X_LUT3
    generic map(
      INIT => X"13"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => CHOICE4786,
      ADR2 => a_N182,
      O => a_get_word_31_187_SW0_O
    );
  a_get_word_22_214_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_22_214_SW0_O,
      O => N5801
    );
  a_get_word_22_214_SW0 : X_LUT4
    generic map(
      INIT => X"96E8"
    )
    port map (
      ADR0 => a_put_right_word(22),
      ADR1 => a_put_left_word(22),
      ADR2 => a_funct(0),
      ADR3 => a_funct(1),
      O => a_get_word_22_214_SW0_O
    );
  a_Mshift_n0002_Sh_41_G_LUT3_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_41_G_O,
      O => N6122
    );
  a_Mshift_n0002_Sh_41_G : X_LUT3
    generic map(
      INIT => X"10"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => N241,
      ADR2 => a_Mshift_n0002_Sh_1_Q,
      O => a_Mshift_n0002_Sh_41_G_O
    );
  a_get_word_12_61_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_12_61_O,
      O => CHOICE4500
    );
  a_get_word_12_61 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_shift(4),
      ADR2 => a_Mshift_n0003_Sh_60_Q,
      ADR3 => a_Mshift_n0003_Sh_44_Q,
      O => a_get_word_12_61_O
    );
  a_get_word_15_155_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_15_155_SW0_O,
      O => N5813
    );
  a_get_word_15_155_SW0 : X_LUT4
    generic map(
      INIT => X"F77F"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_funct(1),
      ADR2 => a_put_left_word(15),
      ADR3 => a_put_right_word(15),
      O => a_get_word_15_155_SW0_O
    );
  Ker21_1_LUT2_D_BUF : X_BUF
    port map (
      I => Ker21,
      O => N6310
    );
  Ker21_1_115 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => h_get_word_buf_29_1,
      ADR1 => h_get_word_buf_28_1,
      O => Ker21
    );
  s_left_conflict_Sclr_INV23_LUT4_L_BUF : X_BUF
    port map (
      I => s_left_conflict_Sclr_INV23_O,
      O => CHOICE3839
    );
  s_left_conflict_Sclr_INV23 : X_LUT4
    generic map(
      INIT => X"FF6F"
    )
    port map (
      ADR0 => N5021,
      ADR1 => s_put_address(0),
      ADR2 => s_request,
      ADR3 => CHOICE3837,
      O => s_left_conflict_Sclr_INV23_O
    );
  a_get_word_23_38_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_23_38_SW0_O,
      O => N5565
    );
  a_get_word_23_38_SW0 : X_LUT4
    generic map(
      INIT => X"FF1B"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => a_N811,
      ADR2 => a_N1811,
      ADR3 => h_get_word_buf(10),
      O => a_get_word_23_38_SW0_O
    );
  a_get_word_28_207_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_28_207_O,
      O => CHOICE4218
    );
  a_get_word_28_207 : X_LUT4
    generic map(
      INIT => X"0A28"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_right_word(28),
      ADR2 => a_funct(1),
      ADR3 => a_put_left_word(28),
      O => a_get_word_28_207_O
    );
  a_get_word_25_152_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_25_152_O,
      O => CHOICE3985
    );
  a_get_word_25_152 : X_LUT4
    generic map(
      INIT => X"F8F0"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_N370,
      ADR2 => CHOICE3984,
      ADR3 => a_Mshift_n0003_Sh_57_Q,
      O => a_get_word_25_152_O
    );
  a_get_word_29_76_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_29_76_O,
      O => CHOICE4297
    );
  a_get_word_29_76 : X_LUT4
    generic map(
      INIT => X"F1E0"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => N241,
      ADR2 => a_N255,
      ADR3 => CHOICE4294,
      O => a_get_word_29_76_O
    );
  a_get_word_25_8_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_25_8_O,
      O => CHOICE3951
    );
  a_get_word_25_8 : X_LUT4
    generic map(
      INIT => X"F1E0"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => N241,
      ADR2 => a_N143,
      ADR3 => a_N255,
      O => a_get_word_25_8_O
    );
  a_get_word_25_52_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_25_52_O,
      O => CHOICE3965
    );
  a_get_word_25_52 : X_LUT4
    generic map(
      INIT => X"FFF8"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_N371,
      ADR2 => a_N76,
      ADR3 => CHOICE3962,
      O => a_get_word_25_52_O
    );
  s_get_right_word_10_1_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => s_get_right_word_10_1_SW1_O,
      O => N5321
    );
  s_get_right_word_10_1_SW1 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(10),
      ADR1 => N5392,
      ADR2 => N411,
      ADR3 => N111,
      O => s_get_right_word_10_1_SW1_O
    );
  s_get_right_word_5_1_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => s_get_right_word_5_1_SW1_O,
      O => N5252
    );
  s_get_right_word_5_1_SW1 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(5),
      ADR1 => N5372,
      ADR2 => N411,
      ADR3 => N111,
      O => s_get_right_word_5_1_SW1_O
    );
  a_get_word_12_40_LUT4_D_BUF : X_BUF
    port map (
      I => CHOICE4491,
      O => N6311
    );
  a_get_word_12_40 : X_LUT4
    generic map(
      INIT => X"C448"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(2),
      ADR2 => a_put_left_word(12),
      ADR3 => a_put_right_word(12),
      O => CHOICE4491
    );
  a_get_word_26_8_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_26_8_O,
      O => CHOICE3993
    );
  a_get_word_26_8 : X_LUT4
    generic map(
      INIT => X"F1E0"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => N241,
      ADR2 => a_N144,
      ADR3 => a_N256,
      O => a_get_word_26_8_O
    );
  a_Ker471_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker471_G_O,
      O => N6124
    );
  a_Ker471_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(16),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(12),
      O => a_Ker471_G_O
    );
  a_get_word_29_243_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_29_243_SW0_O,
      O => N5509
    );
  a_get_word_29_243_SW0 : X_LUT4
    generic map(
      INIT => X"FF54"
    )
    port map (
      ADR0 => a_N01,
      ADR1 => CHOICE4280,
      ADR2 => CHOICE4302,
      ADR3 => CHOICE4308,
      O => a_get_word_29_243_SW0_O
    );
  a_get_word_21_222_SW1_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_21_222_SW1_G_O,
      O => N6126
    );
  a_get_word_21_222_SW1_G : X_LUT4
    generic map(
      INIT => X"D545"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(0),
      ADR2 => a_funct(2),
      ADR3 => a_put_left_word(21),
      O => a_get_word_21_222_SW1_G_O
    );
  a_Ker25729_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker25729_G_O,
      O => N6128
    );
  a_Ker25729_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N171,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N211,
      O => a_Ker25729_G_O
    );
  a_get_word_20_21_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_20_21_O,
      O => CHOICE4080
    );
  a_get_word_20_21 : X_LUT4
    generic map(
      INIT => X"A8A0"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => CHOICE4125,
      ADR2 => CHOICE4078,
      ADR3 => a_N195,
      O => a_get_word_20_21_O
    );
  a_get_word_13_48_LUT4_D_BUF : X_BUF
    port map (
      I => CHOICE4825,
      O => N6312
    );
  a_get_word_13_48 : X_LUT4
    generic map(
      INIT => X"0228"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_funct(0),
      ADR2 => a_put_right_word(13),
      ADR3 => a_put_left_word(13),
      O => CHOICE4825
    );
  a_Ker641_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker641_G_O,
      O => N6130
    );
  a_Ker641_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(29),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(25),
      O => a_Ker641_G_O
    );
  a_Ker31_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker31_G_O,
      O => N6132
    );
  a_Ker31_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(15),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(11),
      O => a_Ker31_G_O
    );
  a_get_word_1_300_SW1_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_1_300_SW1_O,
      O => N5344
    );
  a_get_word_1_300_SW1 : X_LUT3
    generic map(
      INIT => X"31"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_funct(1),
      ADR2 => CHOICE5406,
      O => a_get_word_1_300_SW1_O
    );
  a_get_word_5_159_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_5_159_O,
      O => CHOICE5220
    );
  a_get_word_5_159 : X_LUT4
    generic map(
      INIT => X"10B0"
    )
    port map (
      ADR0 => a_Mshift_n0002_Sh_5_Q,
      ADR1 => N5402,
      ADR2 => a_N372,
      ADR3 => N5403,
      O => a_get_word_5_159_O
    );
  s_get_left_word_1_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5191,
      O => N6313
    );
  s_get_left_word_1_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(1),
      ADR1 => s_put_word_buf(1),
      ADR2 => Ker21_13,
      ADR3 => s_left_conflict_7,
      O => N5191
    );
  a_get_word_3_156_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_3_156_O,
      O => CHOICE4941
    );
  a_get_word_3_156 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => CHOICE5391,
      ADR1 => a_N372,
      ADR2 => a_Mshift_n0002_Sh_3_Q,
      O => a_get_word_3_156_O
    );
  a_Ker1161_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1161_G_O,
      O => N6134
    );
  a_Ker1161_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(13),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(9),
      O => a_Ker1161_G_O
    );
  a_get_word_19_201_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_19_201_O,
      O => CHOICE5036
    );
  a_get_word_19_201 : X_LUT4
    generic map(
      INIT => X"A880"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_left_word(19),
      ADR2 => a_put_right_word(19),
      ADR3 => a_funct(0),
      O => a_get_word_19_201_O
    );
  a_get_word_16_220_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_16_220_O,
      O => CHOICE5464
    );
  a_get_word_16_220 : X_LUT4
    generic map(
      INIT => X"A880"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_left_word(16),
      ADR2 => a_put_right_word(16),
      ADR3 => a_funct(0),
      O => a_get_word_16_220_O
    );
  a_get_word_8_190_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_8_190_O,
      O => CHOICE4738
    );
  a_get_word_8_190 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => a_put_left_word(8),
      ADR1 => a_funct(2),
      ADR2 => a_put_right_word(8),
      O => a_get_word_8_190_O
    );
  a_shift_4_1_1_LUT2_L_BUF : X_BUF
    port map (
      I => a_shift_4_1_1_O,
      O => a_shift_4_1
    );
  a_shift_4_1_1 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => h_get_word_buf(10),
      ADR1 => N241,
      O => a_shift_4_1_1_O
    );
  a_get_word_13_155_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_13_155_SW1_O,
      O => N5415
    );
  a_get_word_13_155_SW1 : X_LUT4
    generic map(
      INIT => X"DD51"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_funct(2),
      ADR2 => CHOICE4849,
      ADR3 => N5540,
      O => a_get_word_13_155_SW1_O
    );
  a_get_word_1_283_LUT4_D_BUF : X_BUF
    port map (
      I => CHOICE5406,
      O => N6314
    );
  a_get_word_1_283 : X_LUT4
    generic map(
      INIT => X"C880"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_funct(2),
      ADR2 => a_put_left_word(1),
      ADR3 => a_put_right_word(1),
      O => CHOICE5406
    );
  a_Ker1141_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1141_G_O,
      O => N6136
    );
  a_Ker1141_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(10),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(6),
      O => a_Ker1141_G_O
    );
  a_get_word_5_29_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_5_29_O,
      O => CHOICE5192
    );
  a_get_word_5_29 : X_LUT4
    generic map(
      INIT => X"0A28"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_put_right_word(5),
      ADR2 => a_funct(1),
      ADR3 => a_put_left_word(5),
      O => a_get_word_5_29_O
    );
  a_Ker1261_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1261_G_O,
      O => N6138
    );
  a_Ker1261_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(14),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(10),
      O => a_Ker1261_G_O
    );
  a_get_word_31_292_LUT4_D_BUF : X_BUF
    port map (
      I => CHOICE4805,
      O => N6315
    );
  a_get_word_31_292 : X_LUT4
    generic map(
      INIT => X"A880"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_funct(0),
      ADR2 => a_put_right_word(31),
      ADR3 => a_put_left_word(31),
      O => CHOICE4805
    );
  a_get_word_10_61_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_10_61_O,
      O => CHOICE4606
    );
  a_get_word_10_61 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_shift(4),
      ADR2 => a_Mshift_n0003_Sh_58_Q,
      ADR3 => a_Mshift_n0003_Sh_42_Q,
      O => a_get_word_10_61_O
    );
  a_Mshift_n0002_Sh_46_LUT4_D_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_46_Q,
      O => N6316
    );
  a_Mshift_n0002_Sh_46_Q_116 : X_LUT4
    generic map(
      INIT => X"E0F1"
    )
    port map (
      ADR0 => h_get_word_buf(9),
      ADR1 => N241,
      ADR2 => a_N251,
      ADR3 => N5083,
      O => a_Mshift_n0002_Sh_46_Q
    );
  a_get_word_19_71_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_19_71_O,
      O => CHOICE5016
    );
  a_get_word_19_71 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(2),
      ADR1 => a_shift(3),
      ADR2 => a_Mshift_n0002_Sh_11_Q,
      ADR3 => N506,
      O => a_get_word_19_71_O
    );
  a_get_word_9_61_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_9_61_O,
      O => CHOICE4659
    );
  a_get_word_9_61 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_shift(4),
      ADR2 => a_Mshift_n0003_Sh_57_Q,
      ADR3 => a_Mshift_n0003_Sh_41_Q,
      O => a_get_word_9_61_O
    );
  a_get_word_0_206_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_0_206_O,
      O => CHOICE5276
    );
  a_get_word_0_206 : X_LUT4
    generic map(
      INIT => X"3335"
    )
    port map (
      ADR0 => N5116,
      ADR1 => N5117,
      ADR2 => CHOICE5261,
      ADR3 => CHOICE5246,
      O => a_get_word_0_206_O
    );
  s_get_left_word_18_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5185,
      O => N6317
    );
  s_get_left_word_18_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(18),
      ADR1 => s_put_word_buf(18),
      ADR2 => Ker21_11,
      ADR3 => s_left_conflict_5,
      O => N5185
    );
  a_get_word_13_67_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_13_67_SW0_O,
      O => N5550
    );
  a_get_word_13_67_SW0 : X_LUT4
    generic map(
      INIT => X"CDEF"
    )
    port map (
      ADR0 => h_get_word_buf(10),
      ADR1 => h_get_word_buf(9),
      ADR2 => N512,
      ADR3 => a_Mshift_n0003_Sh_61_Q,
      O => a_get_word_13_67_SW0_O
    );
  a_funct_2_1_LUT4_D_BUF : X_BUF
    port map (
      I => a_funct(2),
      O => N6318
    );
  a_funct_2_1 : X_LUT4
    generic map(
      INIT => X"FDDD"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => h_response_buf(0),
      ADR2 => N411,
      ADR3 => h_get_word_buf(5),
      O => a_funct(2)
    );
  a_get_word_8_46_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_8_46_O,
      O => CHOICE4706
    );
  a_get_word_8_46 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => N5294,
      ADR1 => a_shift(1),
      ADR2 => a_N91,
      ADR3 => a_N60,
      O => a_get_word_8_46_O
    );
  a_get_word_10_223_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(10),
      O => N6319
    );
  a_get_word_10_223 : X_LUT4
    generic map(
      INIT => X"FFEA"
    )
    port map (
      ADR0 => CHOICE4630,
      ADR1 => a_funct(0),
      ADR2 => CHOICE4611,
      ADR3 => CHOICE4637,
      O => a_get_word(10)
    );
  a_get_word_11_61_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_11_61_O,
      O => CHOICE4553
    );
  a_get_word_11_61 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_shift(4),
      ADR2 => a_Mshift_n0003_Sh_59_Q,
      ADR3 => a_Mshift_n0003_Sh_43_Q,
      O => a_get_word_11_61_O
    );
  a_get_word_18_181_LUT3_D_BUF : X_BUF
    port map (
      I => CHOICE5079,
      O => N6320
    );
  a_get_word_18_181 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_funct(0),
      ADR2 => a_put_left_word(18),
      O => CHOICE5079
    );
  Ker471_LUT3_D_BUF : X_BUF
    port map (
      I => N471,
      O => N6321
    );
  Ker471 : X_LUT3
    generic map(
      INIT => X"08"
    )
    port map (
      ADR0 => N411,
      ADR1 => h_response_buf_1,
      ADR2 => h_response_buf(0),
      O => N471
    );
  a_get_word_1_226_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_1_226_O,
      O => CHOICE5396
    );
  a_get_word_1_226 : X_LUT4
    generic map(
      INIT => X"3237"
    )
    port map (
      ADR0 => CHOICE5383,
      ADR1 => N5120,
      ADR2 => CHOICE5365,
      ADR3 => N5119,
      O => a_get_word_1_226_O
    );
  a_put_right_word_3_SW0_SW0_LUT2_L_BUF : X_BUF
    port map (
      I => a_put_right_word_3_SW0_SW0_O,
      O => N5362
    );
  a_put_right_word_3_SW0_SW0 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => s_put_word_buf(3),
      ADR1 => s_right_conflict_2,
      O => a_put_right_word_3_SW0_SW0_O
    );
  a_put_right_word_4_SW0_SW0_LUT2_L_BUF : X_BUF
    port map (
      I => a_put_right_word_4_SW0_SW0_O,
      O => N5366
    );
  a_put_right_word_4_SW0_SW0 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => s_put_word_buf(4),
      ADR1 => s_right_conflict_2,
      O => a_put_right_word_4_SW0_SW0_O
    );
  a_get_word_2_187_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_2_187_SW0_O,
      O => N5420
    );
  a_get_word_2_187_SW0 : X_LUT4
    generic map(
      INIT => X"1333"
    )
    port map (
      ADR0 => a_N372,
      ADR1 => a_funct(0),
      ADR2 => CHOICE5391,
      ADR3 => a_Mshift_n0002_Sh_2_Q,
      O => a_get_word_2_187_SW0_O
    );
  a_get_word_7_190_LUT2_D_BUF : X_BUF
    port map (
      I => CHOICE4893,
      O => N6322
    );
  a_get_word_7_190 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => a_put_right_word(7),
      ADR1 => a_put_left_word(7),
      O => CHOICE4893
    );
  a_put_right_word_5_SW0_SW0_LUT2_L_BUF : X_BUF
    port map (
      I => a_put_right_word_5_SW0_SW0_O,
      O => N5370
    );
  a_put_right_word_5_SW0_SW0 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => s_put_word_buf(5),
      ADR1 => s_right_conflict_4,
      O => a_put_right_word_5_SW0_SW0_O
    );
  a_put_right_word_6_SW0_SW0_LUT2_L_BUF : X_BUF
    port map (
      I => a_put_right_word_6_SW0_SW0_O,
      O => N5374
    );
  a_put_right_word_6_SW0_SW0 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => s_put_word_buf(6),
      ADR1 => s_right_conflict_4,
      O => a_put_right_word_6_SW0_SW0_O
    );
  a_get_word_5_190_SW0_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_5_190_SW0_G_O,
      O => N6140
    );
  a_get_word_5_190_SW0_G : X_LUT4
    generic map(
      INIT => X"5545"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => N5402,
      ADR2 => a_N372,
      ADR3 => a_Mshift_n0002_Sh_5_Q,
      O => a_get_word_5_190_SW0_G_O
    );
  a_get_word_1_206_LUT4_D_BUF : X_BUF
    port map (
      I => CHOICE5393,
      O => N6323
    );
  a_get_word_1_206 : X_LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      ADR0 => CHOICE5391,
      ADR1 => a_funct(0),
      ADR2 => a_Mshift_n0002_Sh_1_Q,
      ADR3 => a_shift(4),
      O => CHOICE5393
    );
  a_get_word_2_156_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_2_156_O,
      O => CHOICE4985
    );
  a_get_word_2_156 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => CHOICE5391,
      ADR1 => a_N372,
      ADR2 => a_Mshift_n0002_Sh_2_Q,
      O => a_get_word_2_156_O
    );
  a_put_right_word_14_SW0_SW0_LUT2_L_BUF : X_BUF
    port map (
      I => a_put_right_word_14_SW0_SW0_O,
      O => N5470
    );
  a_put_right_word_14_SW0_SW0 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => s_put_word_buf(14),
      ADR1 => s_right_conflict_3,
      O => a_put_right_word_14_SW0_SW0_O
    );
  a_get_word_4_176_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_4_176_O,
      O => CHOICE5132
    );
  a_get_word_4_176 : X_LUT4
    generic map(
      INIT => X"A888"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => CHOICE5130,
      ADR2 => a_funct(0),
      ADR3 => CHOICE5126,
      O => a_get_word_4_176_O
    );
  a_get_word_31_315_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_31_315_SW0_O,
      O => N5505
    );
  a_get_word_31_315_SW0 : X_LUT4
    generic map(
      INIT => X"FEAE"
    )
    port map (
      ADR0 => CHOICE4800,
      ADR1 => N5520,
      ADR2 => CHOICE4790,
      ADR3 => N5521,
      O => a_get_word_31_315_SW0_O
    );
  h_response_buf_1_G_LUT4_L_BUF : X_BUF
    port map (
      I => h_response_buf_1_G_O,
      O => N6142
    );
  h_response_buf_1_G : X_LUT4
    generic map(
      INIT => X"AA8A"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => h_get_word_buf(29),
      ADR2 => h_get_word_buf(26),
      ADR3 => MUX_BLOCK_N1,
      O => h_response_buf_1_G_O
    );
  a_put_right_word_10_SW0_SW0_LUT2_L_BUF : X_BUF
    port map (
      I => a_put_right_word_10_SW0_SW0_O,
      O => N5390
    );
  a_put_right_word_10_SW0_SW0 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => s_put_word_buf(10),
      ADR1 => s_right_conflict_4,
      O => a_put_right_word_10_SW0_SW0_O
    );
  a_get_word_16_90_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_16_90_O,
      O => CHOICE5442
    );
  a_get_word_16_90 : X_LUT4
    generic map(
      INIT => X"E040"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_Mshift_n0002_Sh_12_Q,
      ADR2 => a_shift(2),
      ADR3 => a_Mshift_n0002_Sh_4_Q,
      O => a_get_word_16_90_O
    );
  a_get_word_7_77_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_7_77_O,
      O => CHOICE4878
    );
  a_get_word_7_77 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_shift(1),
      ADR2 => a_N126,
      ADR3 => a_N179,
      O => a_get_word_7_77_O
    );
  a_put_right_word_11_SW0_SW0_LUT2_L_BUF : X_BUF
    port map (
      I => a_put_right_word_11_SW0_SW0_O,
      O => N5394
    );
  a_put_right_word_11_SW0_SW0 : X_LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      ADR0 => s_put_word_buf(11),
      ADR1 => s_right_conflict_4,
      O => a_put_right_word_11_SW0_SW0_O
    );
  a_get_word_18_201_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_18_201_O,
      O => CHOICE5086
    );
  a_get_word_18_201 : X_LUT4
    generic map(
      INIT => X"A880"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_left_word(18),
      ADR2 => a_put_right_word(18),
      ADR3 => a_funct(0),
      O => a_get_word_18_201_O
    );
  a_get_word_6_29_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_6_29_O,
      O => CHOICE5147
    );
  a_get_word_6_29 : X_LUT4
    generic map(
      INIT => X"0A28"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_put_right_word(6),
      ADR2 => a_funct(1),
      ADR3 => a_put_left_word(6),
      O => a_get_word_6_29_O
    );
  a_get_word_17_210_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_17_210_O,
      O => CHOICE5340
    );
  a_get_word_17_210 : X_LUT4
    generic map(
      INIT => X"A880"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_left_word(17),
      ADR2 => a_put_right_word(17),
      ADR3 => a_funct(0),
      O => a_get_word_17_210_O
    );
  a_get_word_9_136_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_9_136_O,
      O => CHOICE4674
    );
  a_get_word_9_136 : X_LUT3
    generic map(
      INIT => X"60"
    )
    port map (
      ADR0 => a_put_left_word(9),
      ADR1 => a_put_right_word(9),
      ADR2 => CHOICE4358,
      O => a_get_word_9_136_O
    );
  a_get_word_11_136_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_11_136_O,
      O => CHOICE4568
    );
  a_get_word_11_136 : X_LUT3
    generic map(
      INIT => X"60"
    )
    port map (
      ADR0 => a_put_left_word(11),
      ADR1 => a_put_right_word(11),
      ADR2 => CHOICE4358,
      O => a_get_word_11_136_O
    );
  a_get_word_27_114_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_27_114_O,
      O => CHOICE4058
    );
  a_get_word_27_114 : X_LUT4
    generic map(
      INIT => X"F8F0"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_N370,
      ADR2 => CHOICE4057,
      ADR3 => a_Mshift_n0003_Sh_59_Q,
      O => a_get_word_27_114_O
    );
  a_Ker87_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker87_G_O,
      O => N6144
    );
  a_Ker87_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(11),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(7),
      O => a_Ker87_G_O
    );
  a_get_word_21_222_SW0_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_21_222_SW0_G_O,
      O => N6146
    );
  a_get_word_21_222_SW0_G : X_LUT4
    generic map(
      INIT => X"8A08"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_put_left_word(21),
      ADR2 => a_funct(1),
      ADR3 => a_funct(0),
      O => a_get_word_21_222_SW0_G_O
    );
  s_get_left_word_15_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5176,
      O => N6324
    );
  s_get_left_word_15_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(15),
      ADR1 => s_put_word_buf(15),
      ADR2 => Ker21_13,
      ADR3 => s_left_conflict_7,
      O => N5176
    );
  a_get_word_21_68_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_21_68_O,
      O => CHOICE4398
    );
  a_get_word_21_68 : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_shift(1),
      ADR2 => N498,
      ADR3 => a_N61,
      O => a_get_word_21_68_O
    );
  a_get_word_3_29_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_3_29_O,
      O => CHOICE4914
    );
  a_get_word_3_29 : X_LUT4
    generic map(
      INIT => X"0A28"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_put_right_word(3),
      ADR2 => a_funct(1),
      ADR3 => a_put_left_word(3),
      O => a_get_word_3_29_O
    );
  a_put_left_word_0_1_G_LUT2_L_BUF : X_BUF
    port map (
      I => a_put_left_word_0_1_G_O,
      O => N6148
    );
  a_put_left_word_0_1_G : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => Ker121,
      ADR1 => h_get_address_buf(0),
      O => a_put_left_word_0_1_G_O
    );
  a_get_word_17_190_LUT3_D_BUF : X_BUF
    port map (
      I => CHOICE5333,
      O => N6325
    );
  a_get_word_17_190 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_funct(0),
      ADR2 => a_put_left_word(17),
      O => CHOICE5333
    );
  a_get_word_10_190_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_10_190_O,
      O => CHOICE4632
    );
  a_get_word_10_190 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => a_put_left_word(10),
      ADR1 => a_funct(2),
      ADR2 => a_put_right_word(10),
      O => a_get_word_10_190_O
    );
  s_get_left_word_14_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5173,
      O => N6326
    );
  s_get_left_word_14_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(14),
      ADR1 => s_put_word_buf(14),
      ADR2 => Ker21_13,
      ADR3 => s_left_conflict_7,
      O => N5173
    );
  a_get_word_11_223_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(11),
      O => N6327
    );
  a_get_word_11_223 : X_LUT4
    generic map(
      INIT => X"FFEC"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => CHOICE4584,
      ADR2 => CHOICE4558,
      ADR3 => CHOICE4577,
      O => a_get_word(11)
    );
  a_get_word_16_51_SW0_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_16_51_SW0_O,
      O => N5561
    );
  a_get_word_16_51_SW0 : X_LUT3
    generic map(
      INIT => X"E9"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_put_left_word(16),
      ADR2 => a_put_right_word(16),
      O => a_get_word_16_51_SW0_O
    );
  a_get_word_11_190_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_11_190_O,
      O => CHOICE4579
    );
  a_get_word_11_190 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => a_put_left_word(11),
      ADR1 => a_funct(2),
      ADR2 => a_put_right_word(11),
      O => a_get_word_11_190_O
    );
  a_Ker86_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker86_G_O,
      O => N6150
    );
  a_Ker86_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(8),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(4),
      O => a_Ker86_G_O
    );
  s_get_right_word_4_1_SW1_LUT4_L_BUF : X_BUF
    port map (
      I => s_get_right_word_4_1_SW1_O,
      O => N5255
    );
  s_get_right_word_4_1_SW1 : X_LUT4
    generic map(
      INIT => X"153F"
    )
    port map (
      ADR0 => h_get_word_buf(4),
      ADR1 => N5368,
      ADR2 => N411,
      ADR3 => N111,
      O => s_get_right_word_4_1_SW1_O
    );
  a_get_word_4_29_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_4_29_O,
      O => CHOICE5102
    );
  a_get_word_4_29 : X_LUT4
    generic map(
      INIT => X"0A28"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_put_right_word(4),
      ADR2 => a_funct(1),
      ADR3 => a_put_left_word(4),
      O => a_get_word_4_29_O
    );
  a_get_word_8_136_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_8_136_O,
      O => CHOICE4727
    );
  a_get_word_8_136 : X_LUT3
    generic map(
      INIT => X"60"
    )
    port map (
      ADR0 => a_put_left_word(8),
      ADR1 => a_put_right_word(8),
      ADR2 => CHOICE4358,
      O => a_get_word_8_136_O
    );
  a_get_word_9_190_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_9_190_O,
      O => CHOICE4685
    );
  a_get_word_9_190 : X_LUT3
    generic map(
      INIT => X"80"
    )
    port map (
      ADR0 => a_put_left_word(9),
      ADR1 => a_funct(2),
      ADR2 => a_put_right_word(9),
      O => a_get_word_9_190_O
    );
  a_Ker591_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker591_G_O,
      O => N6152
    );
  a_Ker591_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(20),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(16),
      O => a_Ker591_G_O
    );
  a_Ker1941_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1941_O,
      O => a_N194
    );
  a_Ker1941 : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_Mshift_n0003_Sh_58_Q,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_Mshift_n0003_Sh_50_Q,
      O => a_Ker1941_O
    );
  a_get_word_6_176_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_6_176_O,
      O => CHOICE5177
    );
  a_get_word_6_176 : X_LUT4
    generic map(
      INIT => X"A888"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => CHOICE5175,
      ADR2 => a_funct(0),
      ADR3 => CHOICE5171,
      O => a_get_word_6_176_O
    );
  a_get_word_7_200_LUT4_D_BUF : X_BUF
    port map (
      I => CHOICE4899,
      O => N6328
    );
  a_get_word_7_200 : X_LUT4
    generic map(
      INIT => X"EAAA"
    )
    port map (
      ADR0 => N121,
      ADR1 => h_get_word_buf(2),
      ADR2 => N411,
      ADR3 => h_get_word_buf(5),
      O => CHOICE4899
    );
  a_Ker23_SW2_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker23_SW2_O,
      O => N5406
    );
  a_Ker23_SW2 : X_LUT4
    generic map(
      INIT => X"FDF0"
    )
    port map (
      ADR0 => a_put_left_word(0),
      ADR1 => N123,
      ADR2 => a_shift(3),
      ADR3 => a_shift(2),
      O => a_Ker23_SW2_O
    );
  a_get_word_7_51_LUT4_D_BUF : X_BUF
    port map (
      I => CHOICE4867,
      O => N6329
    );
  a_get_word_7_51 : X_LUT4
    generic map(
      INIT => X"0448"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_funct(2),
      ADR2 => a_put_left_word(7),
      ADR3 => a_put_right_word(7),
      O => CHOICE4867
    );
  a_get_word_3_132_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_3_132_O,
      O => CHOICE4938
    );
  a_get_word_3_132 : X_LUT4
    generic map(
      INIT => X"FE54"
    )
    port map (
      ADR0 => a_shift(4),
      ADR1 => CHOICE4934,
      ADR2 => CHOICE4928,
      ADR3 => a_N183,
      O => a_get_word_3_132_O
    );
  s_get_left_word_19_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5188,
      O => N6330
    );
  s_get_left_word_19_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(19),
      ADR1 => s_put_word_buf(19),
      ADR2 => Ker21_11,
      ADR3 => s_left_conflict_5,
      O => N5188
    );
  XNor_stagelut21_LUT4_L_BUF : X_BUF
    port map (
      I => XNor_stagelut21_O,
      O => N25
    );
  XNor_stagelut21 : X_LUT4
    generic map(
      INIT => X"D287"
    )
    port map (
      ADR0 => s_right_conflict,
      ADR1 => s_put_word_buf(21),
      ADR2 => s_get_left_word(21),
      ADR3 => s_get_right_word_buf(21),
      O => XNor_stagelut21_O
    );
  a_get_word_0_73_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_0_73_O,
      O => CHOICE5252
    );
  a_get_word_0_73 : X_LUT4
    generic map(
      INIT => X"0E04"
    )
    port map (
      ADR0 => s_get_left_word_buf(1),
      ADR1 => N5437,
      ADR2 => a_shift_2_1,
      ADR3 => N5438,
      O => a_get_word_0_73_O
    );
  a_get_word_19_239_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_19_239_SW0_O,
      O => N5795
    );
  a_get_word_19_239_SW0 : X_LUT4
    generic map(
      INIT => X"FEAE"
    )
    port map (
      ADR0 => a_N76,
      ADR1 => N5283,
      ADR2 => CHOICE5020,
      ADR3 => N5284,
      O => a_get_word_19_239_SW0_O
    );
  a_get_word_8_223_LUT4_D_BUF : X_BUF
    port map (
      I => a_get_word(8),
      O => N6331
    );
  a_get_word_8_223 : X_LUT4
    generic map(
      INIT => X"FEFC"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => CHOICE4743,
      ADR2 => CHOICE4736,
      ADR3 => CHOICE4717,
      O => a_get_word(8)
    );
  s_get_left_word_16_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5179,
      O => N6332
    );
  s_get_left_word_16_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(16),
      ADR1 => s_put_word_buf(16),
      ADR2 => Ker21_1,
      ADR3 => s_left_conflict_4,
      O => N5179
    );
  a_get_word_2_29_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_2_29_O,
      O => CHOICE4958
    );
  a_get_word_2_29 : X_LUT4
    generic map(
      INIT => X"0A28"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_put_right_word(2),
      ADR2 => a_funct(1),
      ADR3 => a_put_left_word(2),
      O => a_get_word_2_29_O
    );
  a_Ker601_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker601_G_O,
      O => N6154
    );
  a_Ker601_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(21),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(17),
      O => a_Ker601_G_O
    );
  a_Ker281_LUT4_D_BUF : X_BUF
    port map (
      I => a_N281,
      O => N6333
    );
  a_Ker281 : X_LUT4
    generic map(
      INIT => X"FEF0"
    )
    port map (
      ADR0 => h_get_word_buf(9),
      ADR1 => N241,
      ADR2 => a_N76,
      ADR3 => a_N371,
      O => a_N281
    );
  h_response_buf_1_1_G_LUT4_L_BUF : X_BUF
    port map (
      I => h_response_buf_1_1_G_O,
      O => N6156
    );
  h_response_buf_1_1_G : X_LUT4
    generic map(
      INIT => X"AA8A"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => h_get_word_buf(29),
      ADR2 => h_get_word_buf(26),
      ADR3 => MUX_BLOCK_N1,
      O => h_response_buf_1_1_G_O
    );
  h_response_buf_1_2_G_LUT4_L_BUF : X_BUF
    port map (
      I => h_response_buf_1_2_G_O,
      O => N6158
    );
  h_response_buf_1_2_G : X_LUT4
    generic map(
      INIT => X"AA8A"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => h_get_word_buf(29),
      ADR2 => h_get_word_buf(26),
      ADR3 => MUX_BLOCK_N1,
      O => h_response_buf_1_2_G_O
    );
  Ker21_5_LUT2_D_BUF : X_BUF
    port map (
      I => Ker21_13,
      O => N6334
    );
  Ker21_5 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => h_get_word_buf_29_1,
      ADR1 => h_get_word_buf_28_1,
      O => Ker21_13
    );
  Ker21_6_LUT2_D_BUF : X_BUF
    port map (
      I => Ker21_14,
      O => N6335
    );
  Ker21_6 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => h_get_word_buf_29_1,
      ADR1 => h_get_word_buf_28_1,
      O => Ker21_14
    );
  Ker21_3_LUT2_D_BUF : X_BUF
    port map (
      I => Ker21_11,
      O => N6336
    );
  Ker21_3 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => h_get_word_buf_29_1,
      ADR1 => h_get_word_buf_28_1,
      O => Ker21_11
    );
  Ker21_4_LUT2_D_BUF : X_BUF
    port map (
      I => Ker21_12,
      O => N6337
    );
  Ker21_4 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => h_get_word_buf_29_1,
      ADR1 => h_get_word_buf_28_1,
      O => Ker21_12
    );
  Ker21_2_LUT2_D_BUF : X_BUF
    port map (
      I => Ker21_1,
      O => N6338
    );
  Ker21_2 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => h_get_word_buf_29_1,
      ADR1 => h_get_word_buf_28_1,
      O => Ker21_1
    );
  a_shift_2_1_1_LUT2_D_BUF : X_BUF
    port map (
      I => a_shift_2_1,
      O => N6339
    );
  a_shift_2_1_1 : X_LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      ADR0 => h_get_word_buf(8),
      ADR1 => N241,
      O => a_shift_2_1
    );
  Ker24_SW0_LUT3_L_BUF : X_BUF
    port map (
      I => Ker24_SW0_O,
      O => N1111
    );
  Ker24_SW0 : X_LUT3
    generic map(
      INIT => X"FD"
    )
    port map (
      ADR0 => h_response_buf_1_1,
      ADR1 => h_get_word_buf_26_1,
      ADR2 => h_response_buf_0_1,
      O => Ker24_SW0_O
    );
  a_shift_1_1_SW0_LUT4_L_BUF : X_BUF
    port map (
      I => a_shift_1_1_SW0_O,
      O => N5548
    );
  a_shift_1_1_SW0 : X_LUT4
    generic map(
      INIT => X"FFEF"
    )
    port map (
      ADR0 => h_get_word_buf(7),
      ADR1 => h_get_word_buf_26_2,
      ADR2 => h_response_buf_1_2,
      ADR3 => h_response_buf_0_2,
      O => a_shift_1_1_SW0_O
    );
  a_shift_0_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5544,
      O => N6340
    );
  a_shift_0_1_SW0 : X_LUT4
    generic map(
      INIT => X"FFEF"
    )
    port map (
      ADR0 => h_get_word_buf(6),
      ADR1 => h_get_word_buf_26_2,
      ADR2 => h_response_buf_1_2,
      ADR3 => h_response_buf_0_1,
      O => N5544
    );
  a_Ker3731_LUT3_D_BUF : X_BUF
    port map (
      I => a_N373,
      O => N6341
    );
  a_Ker3731 : X_LUT3
    generic map(
      INIT => X"0E"
    )
    port map (
      ADR0 => h_get_word_buf(10),
      ADR1 => N241,
      ADR2 => a_funct(0),
      O => a_N373
    );
  a_Ker1131_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1131_G_O,
      O => N6160
    );
  a_Ker1131_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(9),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(5),
      O => a_Ker1131_G_O
    );
  a_Ker179_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker179_G_O,
      O => N6162
    );
  a_Ker179_G : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(12),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(8),
      O => a_Ker179_G_O
    );
  a_get_word_17_150_SW0_G_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_17_150_SW0_G_O,
      O => N6164
    );
  a_get_word_17_150_SW0_G : X_LUT4
    generic map(
      INIT => X"0228"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_put_right_word(17),
      ADR2 => a_put_left_word(17),
      ADR3 => a_funct(0),
      O => a_get_word_17_150_SW0_G_O
    );
  a_get_word_15_41_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_15_41_O,
      O => CHOICE4442
    );
  a_get_word_15_41 : X_LUT3
    generic map(
      INIT => X"A8"
    )
    port map (
      ADR0 => a_put_left_word(31),
      ADR1 => h_get_word_buf(10),
      ADR2 => N241,
      O => a_get_word_15_41_O
    );
  a_put_left_word_20_1_SW1_LUT4_D_BUF : X_BUF
    port map (
      I => N5123,
      O => N6342
    );
  a_put_left_word_20_1_SW1 : X_LUT4
    generic map(
      INIT => X"CECF"
    )
    port map (
      ADR0 => s_put_word_buf(20),
      ADR1 => h_response_buf_0_6,
      ADR2 => Ker21_11,
      ADR3 => s_left_conflict_5,
      O => N5123
    );
  a_put_left_word_21_1_SW1_LUT4_D_BUF : X_BUF
    port map (
      I => N5126,
      O => N6343
    );
  a_put_left_word_21_1_SW1 : X_LUT4
    generic map(
      INIT => X"CECF"
    )
    port map (
      ADR0 => s_put_word_buf(21),
      ADR1 => h_response_buf_0_5,
      ADR2 => Ker21_1,
      ADR3 => s_left_conflict_4,
      O => N5126
    );
  a_put_left_word_22_1_SW1_LUT4_D_BUF : X_BUF
    port map (
      I => N5129,
      O => N6344
    );
  a_put_left_word_22_1_SW1 : X_LUT4
    generic map(
      INIT => X"CECF"
    )
    port map (
      ADR0 => s_put_word_buf(22),
      ADR1 => h_response_buf_0_6,
      ADR2 => Ker21_11,
      ADR3 => s_left_conflict_5,
      O => N5129
    );
  a_put_left_word_23_1_SW1_LUT4_D_BUF : X_BUF
    port map (
      I => N5132,
      O => N6345
    );
  a_put_left_word_23_1_SW1 : X_LUT4
    generic map(
      INIT => X"CECF"
    )
    port map (
      ADR0 => s_put_word_buf(23),
      ADR1 => h_response_buf_0_3,
      ADR2 => Ker21,
      ADR3 => s_left_conflict_2,
      O => N5132
    );
  a_put_left_word_24_1_SW1_LUT4_D_BUF : X_BUF
    port map (
      I => N5135,
      O => N6346
    );
  a_put_left_word_24_1_SW1 : X_LUT4
    generic map(
      INIT => X"CECF"
    )
    port map (
      ADR0 => s_put_word_buf(24),
      ADR1 => h_response_buf_0_3,
      ADR2 => Ker21,
      ADR3 => s_left_conflict_2,
      O => N5135
    );
  a_put_left_word_25_1_SW1_LUT4_D_BUF : X_BUF
    port map (
      I => N5138,
      O => N6347
    );
  a_put_left_word_25_1_SW1 : X_LUT4
    generic map(
      INIT => X"CECF"
    )
    port map (
      ADR0 => s_put_word_buf(25),
      ADR1 => h_response_buf_0_3,
      ADR2 => Ker21,
      ADR3 => s_left_conflict_2,
      O => N5138
    );
  a_put_left_word_26_1_SW1_LUT4_D_BUF : X_BUF
    port map (
      I => N5141,
      O => N6348
    );
  a_put_left_word_26_1_SW1 : X_LUT4
    generic map(
      INIT => X"CECF"
    )
    port map (
      ADR0 => s_put_word_buf(26),
      ADR1 => h_response_buf_0_3,
      ADR2 => Ker21,
      ADR3 => s_left_conflict_2,
      O => N5141
    );
  a_put_left_word_27_1_SW1_LUT4_D_BUF : X_BUF
    port map (
      I => N5144,
      O => N6349
    );
  a_put_left_word_27_1_SW1 : X_LUT4
    generic map(
      INIT => X"CECF"
    )
    port map (
      ADR0 => s_put_word_buf(27),
      ADR1 => h_response_buf_0_3,
      ADR2 => Ker21,
      ADR3 => s_left_conflict_2,
      O => N5144
    );
  a_put_left_word_28_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5146,
      O => N6350
    );
  a_put_left_word_28_1_SW0 : X_LUT4
    generic map(
      INIT => X"CECC"
    )
    port map (
      ADR0 => s_put_word_buf(28),
      ADR1 => h_response_buf_0_5,
      ADR2 => Ker21_1,
      ADR3 => s_left_conflict_4,
      O => N5146
    );
  a_put_left_word_29_1_SW1_LUT4_D_BUF : X_BUF
    port map (
      I => N5150,
      O => N6351
    );
  a_put_left_word_29_1_SW1 : X_LUT4
    generic map(
      INIT => X"CECF"
    )
    port map (
      ADR0 => s_put_word_buf(29),
      ADR1 => h_response_buf_0_5,
      ADR2 => Ker21_1,
      ADR3 => s_left_conflict_4,
      O => N5150
    );
  a_put_left_word_30_1_SW1_LUT4_D_BUF : X_BUF
    port map (
      I => N5153,
      O => N6352
    );
  a_put_left_word_30_1_SW1 : X_LUT4
    generic map(
      INIT => X"CECF"
    )
    port map (
      ADR0 => s_put_word_buf(30),
      ADR1 => h_response_buf_0_6,
      ADR2 => Ker21_13,
      ADR3 => s_left_conflict_7,
      O => N5153
    );
  a_put_left_word_31_1_SW1_LUT4_D_BUF : X_BUF
    port map (
      I => N5156,
      O => N6353
    );
  a_put_left_word_31_1_SW1 : X_LUT4
    generic map(
      INIT => X"CECF"
    )
    port map (
      ADR0 => s_put_word_buf(31),
      ADR1 => h_response_buf_0_6,
      ADR2 => Ker21_13,
      ADR3 => s_left_conflict_7,
      O => N5156
    );
  s_get_left_word_10_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5161,
      O => N6354
    );
  s_get_left_word_10_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(10),
      ADR1 => s_put_word_buf(10),
      ADR2 => Ker21_12,
      ADR3 => s_left_conflict_6,
      O => N5161
    );
  s_get_left_word_11_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5164,
      O => N6355
    );
  s_get_left_word_11_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(11),
      ADR1 => s_put_word_buf(11),
      ADR2 => Ker21_12,
      ADR3 => s_left_conflict_6,
      O => N5164
    );
  s_get_left_word_12_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5167,
      O => N6356
    );
  s_get_left_word_12_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(12),
      ADR1 => s_put_word_buf(12),
      ADR2 => Ker21_12,
      ADR3 => s_left_conflict_6,
      O => N5167
    );
  s_get_left_word_13_1_SW0_LUT4_D_BUF : X_BUF
    port map (
      I => N5170,
      O => N6357
    );
  s_get_left_word_13_1_SW0 : X_LUT4
    generic map(
      INIT => X"ACA0"
    )
    port map (
      ADR0 => h_get_address_buf(13),
      ADR1 => s_put_word_buf(13),
      ADR2 => Ker21_11,
      ADR3 => s_left_conflict_6,
      O => N5170
    );
  a_Ker1511_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1511_F_O,
      O => N5913
    );
  a_Ker1511_F : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(11),
      ADR2 => N5165,
      ADR3 => N5164,
      O => a_Ker1511_F_O
    );
  a_Ker1711_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1711_F_O,
      O => N5915
    );
  a_Ker1711_F : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(15),
      ADR2 => N5177,
      ADR3 => N5176,
      O => a_Ker1711_F_O
    );
  a_Ker41_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker41_F_O,
      O => N5917
    );
  a_Ker41_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(18),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(14),
      O => a_Ker41_F_O
    );
  a_Ker1611_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1611_F_O,
      O => N5919
    );
  a_Ker1611_F : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(13),
      ADR2 => N5171,
      ADR3 => N5170,
      O => a_Ker1611_F_O
    );
  a_Ker1311_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1311_F_O,
      O => N5921
    );
  a_Ker1311_F : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(7),
      ADR2 => N5210,
      ADR3 => N5209,
      O => a_Ker1311_F_O
    );
  a_Ker5211_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker5211_F_O,
      O => N5923
    );
  a_Ker5211_F : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(18),
      ADR2 => N5186,
      ADR3 => N5185,
      O => a_Ker5211_F_O
    );
  a_Ker5011_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker5011_F_O,
      O => N5925
    );
  a_Ker5011_F : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(14),
      ADR2 => N5174,
      ADR3 => N5173,
      O => a_Ker5011_F_O
    );
  a_Mshift_n0002_Sh_45_1_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_45_1_F_O,
      O => N5927
    );
  a_Mshift_n0002_Sh_45_1_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_Mshift_n0002_Sh_9_Q,
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_Mshift_n0002_Sh_13_Q,
      O => a_Mshift_n0002_Sh_45_1_F_O
    );
  a_Ker96_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker96_F_O,
      O => N5929
    );
  a_Ker96_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N57,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N511,
      O => a_Ker96_F_O
    );
  a_get_word_0_2861_F_LUT3_L_BUF : X_BUF
    port map (
      I => a_get_word_0_2861_F_O,
      O => N5931
    );
  a_get_word_0_2861_F : X_LUT3
    generic map(
      INIT => X"F2"
    )
    port map (
      ADR0 => CHOICE5286,
      ADR1 => a_funct(1),
      ADR2 => CHOICE5281,
      O => a_get_word_0_2861_F_O
    );
  a_Mshift_n0002_Sh_6_SW01_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_6_SW01_F_O,
      O => N5933
    );
  a_Mshift_n0002_Sh_6_SW01_F : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(6),
      ADR2 => N5207,
      ADR3 => N5206,
      O => a_Mshift_n0002_Sh_6_SW01_F_O
    );
  a_get_word_0_641_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_0_641_F_O,
      O => N5935
    );
  a_get_word_0_641_F : X_LUT4
    generic map(
      INIT => X"E040"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_N60,
      ADR2 => a_shift(4),
      ADR3 => a_N91,
      O => a_get_word_0_641_F_O
    );
  a_Ker17811_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker17811_F_O,
      O => N5937
    );
  a_Ker17811_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(29),
      ADR2 => N5149,
      ADR3 => N5150,
      O => a_Ker17811_F_O
    );
  a_Mshift_n0003_Sh_60_1_F_LUT3_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_60_1_F_O,
      O => N5939
    );
  a_Mshift_n0003_Sh_60_1_F : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_Mshift_n0003_Sh_28_Q,
      ADR2 => a_Mshift_n0003_Sh_30_Q,
      O => a_Mshift_n0003_Sh_60_1_F_O
    );
  a_Ker18011_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker18011_F_O,
      O => N5941
    );
  a_Ker18011_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(27),
      ADR2 => N5143,
      ADR3 => N5144,
      O => a_Ker18011_F_O
    );
  a_Ker5411_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker5411_F_O,
      O => N5943
    );
  a_Ker5411_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(22),
      ADR2 => N5128,
      ADR3 => N5129,
      O => a_Ker5411_F_O
    );
  a_get_word_1_941_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_1_941_F_O,
      O => N5945
    );
  a_get_word_1_941_F : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_shift(0),
      ADR2 => a_put_left_word(2),
      ADR3 => a_put_left_word(1),
      O => a_get_word_1_941_F_O
    );
  a_Ker811_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker811_F_O,
      O => N5947
    );
  a_Ker811_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N171,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N211,
      O => a_Ker811_F_O
    );
  a_Mshift_n0003_Sh_26_11_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_26_11_F_O,
      O => N5949
    );
  a_Mshift_n0003_Sh_26_11_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(26),
      ADR2 => N5140,
      ADR3 => N5141,
      O => a_Mshift_n0003_Sh_26_11_F_O
    );
  a_Mshift_n0002_Sh_5_1_F_LUT3_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_5_1_F_O,
      O => N5951
    );
  a_Mshift_n0002_Sh_5_1_F : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_put_left_word(5),
      ADR2 => a_put_left_word(3),
      O => a_Mshift_n0002_Sh_5_1_F_O
    );
  a_Ker2511_F_LUT3_L_BUF : X_BUF
    port map (
      I => a_Ker2511_F_O,
      O => N5953
    );
  a_Ker2511_F : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => N529,
      ADR2 => N530,
      O => a_Ker2511_F_O
    );
  a_Ker12311_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker12311_F_O,
      O => N5955
    );
  a_Ker12311_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(30),
      ADR2 => N5152,
      ADR3 => N5153,
      O => a_Ker12311_F_O
    );
  a_Mshift_n0002_Sh_47_1_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_47_1_F_O,
      O => N5957
    );
  a_Mshift_n0002_Sh_47_1_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_Mshift_n0002_Sh_11_Q,
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_Mshift_n0002_Sh_15_Q,
      O => a_Mshift_n0002_Sh_47_1_F_O
    );
  a_Mshift_n0003_Sh_28_11_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_28_11_F_O,
      O => N5959
    );
  a_Mshift_n0003_Sh_28_11_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(28),
      ADR2 => N5146,
      ADR3 => N5147,
      O => a_Mshift_n0003_Sh_28_11_F_O
    );
  a_Ker5111_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker5111_F_O,
      O => N5961
    );
  a_Ker5111_F : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(16),
      ADR2 => N5180,
      ADR3 => N5179,
      O => a_Ker5111_F_O
    );
  a_Ker4911_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker4911_F_O,
      O => N5963
    );
  a_Ker4911_F : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(12),
      ADR2 => N5168,
      ADR3 => N5167,
      O => a_Ker4911_F_O
    );
  a_Ker5311_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker5311_F_O,
      O => N5965
    );
  a_Ker5311_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(20),
      ADR2 => N5122,
      ADR3 => N5123,
      O => a_Ker5311_F_O
    );
  a_Mshift_n0003_Sh_25_11_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_25_11_F_O,
      O => N5967
    );
  a_Mshift_n0003_Sh_25_11_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(25),
      ADR2 => N5137,
      ADR3 => N5138,
      O => a_Mshift_n0003_Sh_25_11_F_O
    );
  a_get_word_19_681_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_19_681_F_O,
      O => N5969
    );
  a_get_word_19_681_F : X_LUT4
    generic map(
      INIT => X"E040"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_N171,
      ADR2 => a_shift(2),
      ADR3 => a_N50,
      O => a_get_word_19_681_F_O
    );
  a_get_word_28_621_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_28_621_F_O,
      O => N5971
    );
  a_get_word_28_621_F : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(2),
      ADR1 => a_shift(0),
      ADR2 => a_N180,
      ADR3 => a_N115,
      O => a_get_word_28_621_F_O
    );
  a_Mshift_n0003_Sh_27_11_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_27_11_F_O,
      O => N5973
    );
  a_Mshift_n0003_Sh_27_11_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(27),
      ADR2 => N5143,
      ADR3 => N5144,
      O => a_Mshift_n0003_Sh_27_11_F_O
    );
  a_Mshift_n0002_Sh_44_SW2_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_44_SW2_F_O,
      O => N5975
    );
  a_Mshift_n0002_Sh_44_SW2_F : X_LUT4
    generic map(
      INIT => X"3237"
    )
    port map (
      ADR0 => N241,
      ADR1 => a_N57,
      ADR2 => h_get_word_buf(8),
      ADR3 => a_N49,
      O => a_Mshift_n0002_Sh_44_SW2_F_O
    );
  a_Mshift_n0002_Sh_7_SW01_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_7_SW01_F_O,
      O => N5977
    );
  a_Mshift_n0002_Sh_7_SW01_F : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(6),
      ADR2 => N5207,
      ADR3 => N5206,
      O => a_Mshift_n0002_Sh_7_SW01_F_O
    );
  a_Mshift_n0003_Sh_30_11_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_30_11_F_O,
      O => N5979
    );
  a_Mshift_n0003_Sh_30_11_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(30),
      ADR2 => N5152,
      ADR3 => N5153,
      O => a_Mshift_n0003_Sh_30_11_F_O
    );
  a_get_word_7_611_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_7_611_F_O,
      O => N5981
    );
  a_get_word_7_611_F : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => N5346,
      ADR1 => a_shift(1),
      ADR2 => a_Mshift_n0003_Sh_25_Q,
      ADR3 => a_Mshift_n0003_Sh_23_Q,
      O => a_get_word_7_611_F_O
    );
  a_Ker18311_F_LUT3_L_BUF : X_BUF
    port map (
      I => a_Ker18311_F_O,
      O => N5983
    );
  a_Ker18311_F : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_N611,
      ADR2 => a_N61,
      O => a_Ker18311_F_O
    );
  a_get_word_5_1311_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_5_1311_F_O,
      O => N5985
    );
  a_get_word_5_1311_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => N5807,
      ADR1 => N241,
      ADR2 => h_get_word_buf(10),
      ADR3 => CHOICE5210,
      O => a_get_word_5_1311_F_O
    );
  a_get_word_0_1241_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_0_1241_F_O,
      O => N5987
    );
  a_get_word_0_1241_F : X_LUT4
    generic map(
      INIT => X"4501"
    )
    port map (
      ADR0 => a_shift(4),
      ADR1 => a_shift(1),
      ADR2 => N5450,
      ADR3 => a_N85,
      O => a_get_word_0_1241_F_O
    );
  a_get_word_21_921_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_21_921_F_O,
      O => N5989
    );
  a_get_word_21_921_F : X_LUT4
    generic map(
      INIT => X"4501"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_shift(2),
      ADR2 => N270,
      ADR3 => N504,
      O => a_get_word_21_921_F_O
    );
  a_Ker4811_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker4811_F_O,
      O => N5991
    );
  a_Ker4811_F : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(10),
      ADR2 => N5162,
      ADR3 => N5161,
      O => a_Ker4811_F_O
    );
  a_get_word_2_1321_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_2_1321_F_O,
      O => N5993
    );
  a_get_word_2_1321_F : X_LUT4
    generic map(
      INIT => X"FE54"
    )
    port map (
      ADR0 => N241,
      ADR1 => CHOICE4978,
      ADR2 => CHOICE4972,
      ADR3 => a_Mshift_n0003_Sh_58_Q,
      O => a_get_word_2_1321_F_O
    );
  a_Mshift_n0003_Sh_29_11_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_29_11_F_O,
      O => N5995
    );
  a_Mshift_n0003_Sh_29_11_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(29),
      ADR2 => N5149,
      ADR3 => N5150,
      O => a_Mshift_n0003_Sh_29_11_F_O
    );
  a_Mshift_n0002_Sh_43_1_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_43_1_F_O,
      O => N5997
    );
  a_Mshift_n0002_Sh_43_1_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_Mshift_n0002_Sh_3_Q,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_Mshift_n0002_Sh_11_Q,
      O => a_Mshift_n0002_Sh_43_1_F_O
    );
  a_Ker2111_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker2111_F_O,
      O => N5999
    );
  a_Ker2111_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(23),
      ADR2 => N5131,
      ADR3 => N5132,
      O => a_Ker2111_F_O
    );
  a_Ker2011_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker2011_F_O,
      O => N6001
    );
  a_Ker2011_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(21),
      ADR2 => N5125,
      ADR3 => N5126,
      O => a_Ker2011_F_O
    );
  a_Ker1911_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1911_F_O,
      O => N6003
    );
  a_Ker1911_F : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(19),
      ADR2 => N5189,
      ADR3 => N5188,
      O => a_Ker1911_F_O
    );
  a_Ker1421_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1421_F_O,
      O => N6005
    );
  a_Ker1421_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N49,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N53,
      O => a_Ker1421_F_O
    );
  a_Ker4611_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker4611_F_O,
      O => N6007
    );
  a_Ker4611_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(26),
      ADR2 => N5140,
      ADR3 => N5141,
      O => a_Ker4611_F_O
    );
  a_Ker5711_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker5711_F_O,
      O => N6009
    );
  a_Ker5711_F : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(8),
      ADR2 => N5213,
      ADR3 => N5212,
      O => a_Ker5711_F_O
    );
  a_Mshift_n0002_Sh_40_rn_0111_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_40_rn_0111_F_O,
      O => N6011
    );
  a_Mshift_n0002_Sh_40_rn_0111_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_Mshift_n0002_Sh_4_Q,
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_Mshift_n0002_Sh_8_Q,
      O => a_Mshift_n0002_Sh_40_rn_0111_F_O
    );
  h_response_1_1111_F_LUT4_L_BUF : X_BUF
    port map (
      I => h_response_1_1111_F_O,
      O => N6013
    );
  h_response_1_1111_F : X_LUT4
    generic map(
      INIT => X"02AA"
    )
    port map (
      ADR0 => h_response_buf_2(1),
      ADR1 => h_get_word_buf(29),
      ADR2 => MUX_BLOCK_N0,
      ADR3 => h_response_buf_1,
      O => h_response_1_1111_F_O
    );
  a_Ker5511_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker5511_F_O,
      O => N6015
    );
  a_Ker5511_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(24),
      ADR2 => N5134,
      ADR3 => N5135,
      O => a_Ker5511_F_O
    );
  a_get_word_31_233_SW11_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_31_233_SW11_F_O,
      O => N6017
    );
  a_get_word_31_233_SW11_F : X_LUT4
    generic map(
      INIT => X"3010"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_funct(2),
      ADR2 => a_funct(1),
      ADR3 => a_put_left_word(31),
      O => a_get_word_31_233_SW11_F_O
    );
  a_get_word_12_90_SW11_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_12_90_SW11_F_O,
      O => N6019
    );
  a_get_word_12_90_SW11_F : X_LUT4
    generic map(
      INIT => X"A888"
    )
    port map (
      ADR0 => CHOICE4503,
      ADR1 => N121,
      ADR2 => N411,
      ADR3 => h_get_word_buf(2),
      O => a_get_word_12_90_SW11_F_O
    );
  a_Mshift_n0003_Sh_23_11_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_23_11_F_O,
      O => N6021
    );
  a_Mshift_n0003_Sh_23_11_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(23),
      ADR2 => N5131,
      ADR3 => N5132,
      O => a_Mshift_n0003_Sh_23_11_F_O
    );
  a_Mshift_n0003_Sh_58_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_58_F_O,
      O => N6023
    );
  a_Mshift_n0003_Sh_58_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_Mshift_n0003_Sh_30_Q,
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_Mshift_n0003_Sh_26_Q,
      O => a_Mshift_n0003_Sh_58_F_O
    );
  a_get_word_16_721_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_16_721_F_O,
      O => N6025
    );
  a_get_word_16_721_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N64,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N60,
      O => a_get_word_16_721_F_O
    );
  a_get_word_7_215_SW11_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_7_215_SW11_F_O,
      O => N6027
    );
  a_get_word_7_215_SW11_F : X_LUT4
    generic map(
      INIT => X"B111"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_funct(1),
      ADR2 => CHOICE4893,
      ADR3 => a_N01,
      O => a_get_word_7_215_SW11_F_O
    );
  a_Mshift_n0003_Sh_57_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_57_F_O,
      O => N6029
    );
  a_Mshift_n0003_Sh_57_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_Mshift_n0003_Sh_29_Q,
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_Mshift_n0003_Sh_25_Q,
      O => a_Mshift_n0003_Sh_57_F_O
    );
  a_get_word_18_138_SW11_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_18_138_SW11_F_O,
      O => N6031
    );
  a_get_word_18_138_SW11_F : X_LUT4
    generic map(
      INIT => X"AA02"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_shift(4),
      ADR2 => a_funct(2),
      ADR3 => CHOICE5056,
      O => a_get_word_18_138_SW11_F_O
    );
  a_get_word_6_1331_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_6_1331_F_O,
      O => N6033
    );
  a_get_word_6_1331_F : X_LUT4
    generic map(
      INIT => X"FE54"
    )
    port map (
      ADR0 => N241,
      ADR1 => CHOICE5161,
      ADR2 => CHOICE5167,
      ADR3 => a_Mshift_n0003_Sh_62_Q,
      O => a_get_word_6_1331_F_O
    );
  a_get_word_15_561_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_15_561_F_O,
      O => N6035
    );
  a_get_word_15_561_F : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(4),
      ADR1 => a_shift(1),
      ADR2 => a_N110,
      ADR3 => a_N59,
      O => a_get_word_15_561_F_O
    );
  a_get_word_16_160_SW11_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_16_160_SW11_F_O,
      O => N6037
    );
  a_get_word_16_160_SW11_F : X_LUT4
    generic map(
      INIT => X"AA02"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => h_get_word_buf(10),
      ADR2 => N241,
      ADR3 => CHOICE5432,
      O => a_get_word_16_160_SW11_F_O
    );
  a_get_word_17_150_SW11_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_17_150_SW11_F_O,
      O => N6039
    );
  a_get_word_17_150_SW11_F : X_LUT4
    generic map(
      INIT => X"AA02"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => h_get_word_buf(10),
      ADR2 => N241,
      ADR3 => CHOICE5308,
      O => a_get_word_17_150_SW11_F_O
    );
  a_Ker11511_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker11511_F_O,
      O => N6041
    );
  a_Ker11511_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(28),
      ADR2 => N5146,
      ADR3 => N5147,
      O => a_Ker11511_F_O
    );
  a_get_word_7_150_SW11_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_7_150_SW11_F_O,
      O => N6043
    );
  a_get_word_7_150_SW11_F : X_LUT4
    generic map(
      INIT => X"AA02"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_shift(4),
      ADR2 => a_funct(2),
      ADR3 => CHOICE4867,
      O => a_get_word_7_150_SW11_F_O
    );
  a_Mshift_n0003_Sh_4_11_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_4_11_F_O,
      O => N6045
    );
  a_Mshift_n0003_Sh_4_11_F : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(4),
      ADR2 => N5201,
      ADR3 => N5200,
      O => a_Mshift_n0003_Sh_4_11_F_O
    );
  a_get_word_8_611_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_8_611_F_O,
      O => N6047
    );
  a_get_word_8_611_F : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(3),
      ADR1 => a_shift(1),
      ADR2 => a_N35,
      ADR3 => a_N116,
      O => a_get_word_8_611_F_O
    );
  a_get_word_18_681_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_18_681_F_O,
      O => N6049
    );
  a_get_word_18_681_F : X_LUT4
    generic map(
      INIT => X"E040"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_N50,
      ADR2 => a_shift(2),
      ADR3 => a_N161,
      O => a_get_word_18_681_F_O
    );
  a_Ker1441_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1441_F_O,
      O => N6051
    );
  a_Ker1441_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N50,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N54,
      O => a_Ker1441_F_O
    );
  a_Mshift_n0002_Sh_42_SW01_F_LUT3_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_42_SW01_F_O,
      O => N6053
    );
  a_Mshift_n0002_Sh_42_SW01_F : X_LUT3
    generic map(
      INIT => X"27"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_N141,
      ADR2 => a_N48,
      O => a_Mshift_n0002_Sh_42_SW01_F_O
    );
  a_get_word_4_1331_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_4_1331_F_O,
      O => N6055
    );
  a_get_word_4_1331_F : X_LUT4
    generic map(
      INIT => X"FE54"
    )
    port map (
      ADR0 => N241,
      ADR1 => CHOICE5116,
      ADR2 => CHOICE5122,
      ADR3 => a_Mshift_n0003_Sh_60_Q,
      O => a_get_word_4_1331_F_O
    );
  a_get_word_19_138_SW11_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_19_138_SW11_F_O,
      O => N6057
    );
  a_get_word_19_138_SW11_F : X_LUT4
    generic map(
      INIT => X"AA02"
    )
    port map (
      ADR0 => a_funct(1),
      ADR1 => a_shift(4),
      ADR2 => a_funct(2),
      ADR3 => CHOICE5006,
      O => a_get_word_19_138_SW11_F_O
    );
  a_get_word_31_1401_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_31_1401_F_O,
      O => N6059
    );
  a_get_word_31_1401_F : X_LUT4
    generic map(
      INIT => X"3222"
    )
    port map (
      ADR0 => CHOICE4780,
      ADR1 => a_shift_2_1,
      ADR2 => a_shift(0),
      ADR3 => a_N123,
      O => a_get_word_31_1401_F_O
    );
  a_Mshift_n0002_Sh_46_SW21_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_46_SW21_F_O,
      O => N6061
    );
  a_Mshift_n0002_Sh_46_SW21_F : X_LUT4
    generic map(
      INIT => X"3237"
    )
    port map (
      ADR0 => N241,
      ADR1 => a_N48,
      ADR2 => h_get_word_buf(8),
      ADR3 => a_N50,
      O => a_Mshift_n0002_Sh_46_SW21_F_O
    );
  a_get_word_1_1471_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_1_1471_F_O,
      O => N6063
    );
  a_get_word_1_1471_F : X_LUT4
    generic map(
      INIT => X"3222"
    )
    port map (
      ADR0 => CHOICE5377,
      ADR1 => a_shift(4),
      ADR2 => a_N86,
      ADR3 => a_shift(1),
      O => a_get_word_1_1471_F_O
    );
  a_Ker1411_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1411_F_O,
      O => N6065
    );
  a_Ker1411_F : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(9),
      ADR2 => N5216,
      ADR3 => N5215,
      O => a_Ker1411_F_O
    );
  a_Mshift_n0002_Sh_3_291_F_LUT3_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_3_291_F_O,
      O => N6067
    );
  a_Mshift_n0002_Sh_3_291_F : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(0),
      ADR1 => a_put_left_word(3),
      ADR2 => a_put_left_word(2),
      O => a_Mshift_n0002_Sh_3_291_F_O
    );
  a_Mshift_n0003_Sh_59_1_F_LUT3_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_59_1_F_O,
      O => N6069
    );
  a_Mshift_n0003_Sh_59_1_F : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_Mshift_n0003_Sh_27_Q,
      ADR2 => a_Mshift_n0003_Sh_29_Q,
      O => a_Mshift_n0003_Sh_59_1_F_O
    );
  a_get_word_13_92_SW01_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_13_92_SW01_F_O,
      O => N6071
    );
  a_get_word_13_92_SW01_F : X_LUT4
    generic map(
      INIT => X"A888"
    )
    port map (
      ADR0 => CHOICE4825,
      ADR1 => N121,
      ADR2 => h_get_word_buf(3),
      ADR3 => N411,
      O => a_get_word_13_92_SW01_F_O
    );
  a_Ker2211_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker2211_F_O,
      O => N6073
    );
  a_Ker2211_F : X_LUT4
    generic map(
      INIT => X"FD75"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => s_get_left_word_buf(25),
      ADR2 => N5137,
      ADR3 => N5138,
      O => a_Ker2211_F_O
    );
  a_get_word_17_83_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_17_83_F_O,
      O => N6075
    );
  a_get_word_17_83_F : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift(2),
      ADR1 => a_shift(0),
      ADR2 => a_N511,
      ADR3 => a_N181,
      O => a_get_word_17_83_F_O
    );
  a_Ker1821_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1821_F_O,
      O => N6077
    );
  a_Ker1821_F : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => N121,
      ADR1 => s_get_left_word_buf(17),
      ADR2 => N5183,
      ADR3 => N5182,
      O => a_Ker1821_F_O
    );
  a_Mshift_n0002_Sh_4_1_F_LUT3_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_4_1_F_O,
      O => N6079
    );
  a_Mshift_n0002_Sh_4_1_F : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(1),
      ADR1 => a_put_left_word(4),
      ADR2 => a_put_left_word(2),
      O => a_Mshift_n0002_Sh_4_1_F_O
    );
  a_Mshift_n0002_Sh_2_SW01_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_2_SW01_F_O,
      O => N6081
    );
  a_Mshift_n0002_Sh_2_SW01_F : X_LUT4
    generic map(
      INIT => X"010B"
    )
    port map (
      ADR0 => s_get_left_word_buf(2),
      ADR1 => N5194,
      ADR2 => N121,
      ADR3 => N5195,
      O => a_Mshift_n0002_Sh_2_SW01_F_O
    );
  a_get_word_30_48_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_30_48_F_O,
      O => N6083
    );
  a_get_word_30_48_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N54,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N123,
      O => a_get_word_30_48_F_O
    );
  a_Ker18229_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker18229_F_O,
      O => N6085
    );
  a_Ker18229_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N191,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N180,
      O => a_Ker18229_F_O
    );
  a_Mshift_n0003_Sh_55_29_F_LUT3_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0003_Sh_55_29_F_O,
      O => N6087
    );
  a_Mshift_n0003_Sh_55_29_F : X_LUT3
    generic map(
      INIT => X"E4"
    )
    port map (
      ADR0 => a_shift(2),
      ADR1 => a_Mshift_n0003_Sh_23_Q,
      ADR2 => a_Mshift_n0003_Sh_27_Q,
      O => a_Mshift_n0003_Sh_55_29_F_O
    );
  a_get_word_16_93_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_16_93_F_O,
      O => N6089
    );
  a_get_word_16_93_F : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => a_shift_2_1,
      ADR1 => a_shift(0),
      ADR2 => a_N171,
      ADR3 => a_N511,
      O => a_get_word_16_93_F_O
    );
  a_get_word_13_155_SW0_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_13_155_SW0_F_O,
      O => N6091
    );
  a_get_word_13_155_SW0_F : X_LUT4
    generic map(
      INIT => X"0A08"
    )
    port map (
      ADR0 => CHOICE4899,
      ADR1 => a_put_right_word(13),
      ADR2 => a_funct(1),
      ADR3 => a_put_left_word(13),
      O => a_get_word_13_155_SW0_F_O
    );
  a_Ker621_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker621_F_O,
      O => N6093
    );
  a_Ker621_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(24),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(20),
      O => a_Ker621_F_O
    );
  a_Ker85_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker85_F_O,
      O => N6095
    );
  a_Ker85_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(6),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(2),
      O => a_Ker85_F_O
    );
  a_get_word_31_110_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_31_110_F_O,
      O => N6097
    );
  a_get_word_31_110_F : X_LUT4
    generic map(
      INIT => X"3010"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => a_shift(0),
      ADR2 => a_shift(1),
      ADR3 => N5149,
      O => a_get_word_31_110_F_O
    );
  a_Ker21_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker21_F_O,
      O => N6099
    );
  a_Ker21_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(17),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(13),
      O => a_Ker21_F_O
    );
  a_Ker25529_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker25529_F_O,
      O => N6101
    );
  a_Ker25529_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N181,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N221,
      O => a_Ker25529_F_O
    );
  a_Ker611_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker611_F_O,
      O => N6103
    );
  a_Ker611_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(23),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(19),
      O => a_Ker611_F_O
    );
  a_Ker25629_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker25629_F_O,
      O => N6105
    );
  a_Ker25629_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N52,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N46,
      O => a_Ker25629_F_O
    );
  a_Ker581_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker581_F_O,
      O => N6107
    );
  a_Ker581_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(16),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(12),
      O => a_Ker581_F_O
    );
  a_Ker91_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker91_F_O,
      O => N6109
    );
  a_Ker91_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(22),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(18),
      O => a_Ker91_F_O
    );
  a_get_word_29_48_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_29_48_F_O,
      O => N6111
    );
  a_get_word_29_48_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N201,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N178,
      O => a_get_word_29_48_F_O
    );
  a_Ker61_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker61_F_O,
      O => N6113
    );
  a_Ker61_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(25),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(21),
      O => a_Ker61_F_O
    );
  a_Ker82_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker82_F_O,
      O => N6115
    );
  a_Ker82_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(26),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(22),
      O => a_Ker82_F_O
    );
  a_get_word_12_173_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_12_173_F_O,
      O => N6117
    );
  a_get_word_12_173_F : X_LUT4
    generic map(
      INIT => X"FFBA"
    )
    port map (
      ADR0 => a_N291,
      ADR1 => N5079,
      ADR2 => CHOICE4734,
      ADR3 => CHOICE4515,
      O => a_get_word_12_173_F_O
    );
  a_Ker11_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker11_F_O,
      O => N6119
    );
  a_Ker11_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(21),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(17),
      O => a_Ker11_F_O
    );
  a_Mshift_n0002_Sh_41_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Mshift_n0002_Sh_41_F_O,
      O => N6121
    );
  a_Mshift_n0002_Sh_41_F : X_LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      ADR0 => N241,
      ADR1 => h_get_word_buf(8),
      ADR2 => a_Mshift_n0002_Sh_5_Q,
      ADR3 => a_Mshift_n0002_Sh_9_Q,
      O => a_Mshift_n0002_Sh_41_F_O
    );
  a_Ker471_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker471_F_O,
      O => N6123
    );
  a_Ker471_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(15),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(11),
      O => a_Ker471_F_O
    );
  a_get_word_21_222_SW1_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_21_222_SW1_F_O,
      O => N6125
    );
  a_get_word_21_222_SW1_F : X_LUT4
    generic map(
      INIT => X"3111"
    )
    port map (
      ADR0 => a_funct(2),
      ADR1 => a_funct(1),
      ADR2 => a_funct(0),
      ADR3 => a_put_left_word(21),
      O => a_get_word_21_222_SW1_F_O
    );
  a_Ker25729_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker25729_F_O,
      O => N6127
    );
  a_Ker25729_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_N511,
      ADR1 => h_get_word_buf(9),
      ADR2 => N241,
      ADR3 => a_N55,
      O => a_Ker25729_F_O
    );
  a_Ker641_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker641_F_O,
      O => N6129
    );
  a_Ker641_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(28),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(24),
      O => a_Ker641_F_O
    );
  a_Ker31_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker31_F_O,
      O => N6131
    );
  a_Ker31_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(14),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(10),
      O => a_Ker31_F_O
    );
  a_Ker1161_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1161_F_O,
      O => N6133
    );
  a_Ker1161_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(12),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(8),
      O => a_Ker1161_F_O
    );
  a_Ker1141_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1141_F_O,
      O => N6135
    );
  a_Ker1141_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(9),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(5),
      O => a_Ker1141_F_O
    );
  a_Ker1261_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1261_F_O,
      O => N6137
    );
  a_Ker1261_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(13),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(9),
      O => a_Ker1261_F_O
    );
  a_get_word_5_190_SW0_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_5_190_SW0_F_O,
      O => N6139
    );
  a_get_word_5_190_SW0_F : X_LUT4
    generic map(
      INIT => X"1131"
    )
    port map (
      ADR0 => a_N372,
      ADR1 => a_funct(0),
      ADR2 => N5402,
      ADR3 => a_Mshift_n0002_Sh_5_Q,
      O => a_get_word_5_190_SW0_F_O
    );
  h_response_buf_1_F_LUT4_L_BUF : X_BUF
    port map (
      I => h_response_buf_1_F_O,
      O => N6141
    );
  h_response_buf_1_F : X_LUT4
    generic map(
      INIT => X"A888"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => h_get_word_buf(29),
      ADR2 => MUX_BLOCK_N1,
      ADR3 => h_get_word_buf(26),
      O => h_response_buf_1_F_O
    );
  a_Ker87_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker87_F_O,
      O => N6143
    );
  a_Ker87_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(10),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(6),
      O => a_Ker87_F_O
    );
  a_get_word_21_222_SW0_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_21_222_SW0_F_O,
      O => N6145
    );
  a_get_word_21_222_SW0_F : X_LUT4
    generic map(
      INIT => X"0800"
    )
    port map (
      ADR0 => a_funct(0),
      ADR1 => a_put_left_word(21),
      ADR2 => a_funct(1),
      ADR3 => a_funct(2),
      O => a_get_word_21_222_SW0_F_O
    );
  a_put_left_word_0_1_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_put_left_word_0_1_F_O,
      O => N6147
    );
  a_put_left_word_0_1_F : X_LUT4
    generic map(
      INIT => X"FBEA"
    )
    port map (
      ADR0 => Ker121,
      ADR1 => s_left_conflict1,
      ADR2 => s_put_word_buf(0),
      ADR3 => s_get_left_word_buf(0),
      O => a_put_left_word_0_1_F_O
    );
  a_Ker86_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker86_F_O,
      O => N6149
    );
  a_Ker86_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(7),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(3),
      O => a_Ker86_F_O
    );
  a_Ker591_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker591_F_O,
      O => N6151
    );
  a_Ker591_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(19),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(15),
      O => a_Ker591_F_O
    );
  a_Ker601_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker601_F_O,
      O => N6153
    );
  a_Ker601_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(20),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(16),
      O => a_Ker601_F_O
    );
  h_response_buf_1_1_F_LUT4_L_BUF : X_BUF
    port map (
      I => h_response_buf_1_1_F_O,
      O => N6155
    );
  h_response_buf_1_1_F : X_LUT4
    generic map(
      INIT => X"A888"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => h_get_word_buf(29),
      ADR2 => MUX_BLOCK_N1,
      ADR3 => h_get_word_buf(26),
      O => h_response_buf_1_1_F_O
    );
  h_response_buf_1_2_F_LUT4_L_BUF : X_BUF
    port map (
      I => h_response_buf_1_2_F_O,
      O => N6157
    );
  h_response_buf_1_2_F : X_LUT4
    generic map(
      INIT => X"A888"
    )
    port map (
      ADR0 => h_response_buf_1,
      ADR1 => h_get_word_buf(29),
      ADR2 => MUX_BLOCK_N1,
      ADR3 => h_get_word_buf(26),
      O => h_response_buf_1_2_F_O
    );
  a_Ker1131_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker1131_F_O,
      O => N6159
    );
  a_Ker1131_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(8),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(4),
      O => a_Ker1131_F_O
    );
  a_Ker179_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_Ker179_F_O,
      O => N6161
    );
  a_Ker179_F : X_LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      ADR0 => a_put_left_word(11),
      ADR1 => h_get_word_buf(8),
      ADR2 => N241,
      ADR3 => a_put_left_word(7),
      O => a_Ker179_F_O
    );
  a_get_word_17_150_SW0_F_LUT4_L_BUF : X_BUF
    port map (
      I => a_get_word_17_150_SW0_F_O,
      O => N6163
    );
  a_get_word_17_150_SW0_F : X_LUT4
    generic map(
      INIT => X"8000"
    )
    port map (
      ADR0 => a_Mshift_n0002_Sh_1_Q,
      ADR1 => a_N373,
      ADR2 => CHOICE5391,
      ADR3 => a_funct(1),
      O => a_get_word_17_150_SW0_F_O
    );
  r_ROC : X_ZERO
    port map (
      O => reset
    );
  IOA_0_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_0_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(0),
      O => IOA(0)
    );
  IOA_0_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(0),
      O => N5003
    );
  IOA_1_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_1_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(1),
      O => IOA(1)
    );
  IOA_1_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(1),
      O => N5004
    );
  IOA_2_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_2_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(2),
      O => IOA(2)
    );
  IOA_2_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(2),
      O => N5005
    );
  IOA_3_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_3_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(3),
      O => IOA(3)
    );
  IOA_3_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(3),
      O => N5006
    );
  IOA_4_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_4_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(4),
      O => IOA(4)
    );
  IOA_4_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(4),
      O => N5007
    );
  IOA_5_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_5_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(5),
      O => IOA(5)
    );
  IOA_5_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(5),
      O => N5009
    );
  IOA_6_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_6_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(6),
      O => IOA(6)
    );
  IOA_6_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(6),
      O => N5011
    );
  IOA_7_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_7_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(7),
      O => IOA(7)
    );
  IOA_7_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(7),
      O => N5013
    );
  IOA_8_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_8_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(8),
      O => IOA(8)
    );
  IOA_8_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(8),
      O => N5015
    );
  IOA_9_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_9_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(9),
      O => IOA(9)
    );
  IOA_9_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(9),
      O => N5017
    );
  IOA_10_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_10_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(10),
      O => IOA(10)
    );
  IOA_10_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(10),
      O => N5008
    );
  IOA_11_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_11_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(11),
      O => IOA(11)
    );
  IOA_11_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(11),
      O => N5010
    );
  IOA_12_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_12_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(12),
      O => IOA(12)
    );
  IOA_12_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(12),
      O => N5012
    );
  IOA_13_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_13_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(13),
      O => IOA(13)
    );
  IOA_13_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(13),
      O => N5014
    );
  IOA_14_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_14_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(14),
      O => IOA(14)
    );
  IOA_14_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(14),
      O => N5016
    );
  IOA_15_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_15_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(15),
      O => IOA(15)
    );
  IOA_15_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(15),
      O => N5018
    );
  IOA_16_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_16_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(16),
      O => IOA(16)
    );
  IOA_16_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(16),
      O => N5020
    );
  IOA_17_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_17_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(17),
      O => IOA(17)
    );
  IOA_17_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(17),
      O => N5022
    );
  IOA_18_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_18_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(18),
      O => IOA(18)
    );
  IOA_18_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(18),
      O => N5024
    );
  IOA_19_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_19_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(19),
      O => IOA(19)
    );
  IOA_19_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(19),
      O => N5026
    );
  IOA_20_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_20_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(20),
      O => IOA(20)
    );
  IOA_20_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(20),
      O => N5019
    );
  IOA_21_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_21_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(21),
      O => IOA(21)
    );
  IOA_21_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(21),
      O => N5021
    );
  IOA_22_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_22_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(22),
      O => IOA(22)
    );
  IOA_22_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(22),
      O => N5023
    );
  IOA_23_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_23_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(23),
      O => IOA(23)
    );
  IOA_23_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(23),
      O => N5025
    );
  IOA_24_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_24_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(24),
      O => IOA(24)
    );
  IOA_24_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(24),
      O => N5027
    );
  IOA_25_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_25_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(25),
      O => IOA(25)
    );
  IOA_25_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(25),
      O => N5028
    );
  IOA_26_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_26_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(26),
      O => IOA(26)
    );
  IOA_26_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(26),
      O => N5029
    );
  IOA_27_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_27_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(27),
      O => IOA(27)
    );
  IOA_27_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(27),
      O => N5030
    );
  IOA_28_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_28_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(28),
      O => IOA(28)
    );
  IOA_28_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(28),
      O => N5031
    );
  IOA_29_IOBUF_OBUFT : X_TRI
    port map (
      CTL => IOA_29_IOBUF_OBUFT_GTS_AND,
      I => h_Mtridata_IOA(29),
      O => IOA(29)
    );
  IOA_29_IOBUF_IBUF : X_BUF
    port map (
      I => IOA(29),
      O => N5032
    );
  CLK_BUFGP_BUFG : X_CKBUF
    port map (
      I => CLK_BUFGP_IBUFG,
      O => CLKMA0_OBUF
    );
  CLK_BUFGP_IBUFG_117 : X_CKBUF
    port map (
      I => CLK,
      O => CLK_BUFGP_IBUFG
    );
  IOA_0_IOBUF_OBUFT_GTS_AND_118 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_0_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_0_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_0_IOBUF_OBUFT_GTS_AND
    );
  IOA_1_IOBUF_OBUFT_GTS_AND_119 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_1_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_1_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_1_IOBUF_OBUFT_GTS_AND
    );
  IOA_2_IOBUF_OBUFT_GTS_AND_120 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_2_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_2_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_2_IOBUF_OBUFT_GTS_AND
    );
  IOA_3_IOBUF_OBUFT_GTS_AND_121 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_3_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_3_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_3_IOBUF_OBUFT_GTS_AND
    );
  IOA_4_IOBUF_OBUFT_GTS_AND_122 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_4_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_4_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_4_IOBUF_OBUFT_GTS_AND
    );
  IOA_10_IOBUF_OBUFT_GTS_AND_123 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_10_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_10_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_10_IOBUF_OBUFT_GTS_AND
    );
  IOA_5_IOBUF_OBUFT_GTS_AND_124 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_5_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_5_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_5_IOBUF_OBUFT_GTS_AND
    );
  IOA_11_IOBUF_OBUFT_GTS_AND_125 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_11_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_11_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_11_IOBUF_OBUFT_GTS_AND
    );
  IOA_6_IOBUF_OBUFT_GTS_AND_126 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_6_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_6_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_6_IOBUF_OBUFT_GTS_AND
    );
  IOA_12_IOBUF_OBUFT_GTS_AND_127 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_12_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_12_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_12_IOBUF_OBUFT_GTS_AND
    );
  IOA_7_IOBUF_OBUFT_GTS_AND_128 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_7_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_7_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_7_IOBUF_OBUFT_GTS_AND
    );
  IOA_13_IOBUF_OBUFT_GTS_AND_129 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_13_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_13_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_13_IOBUF_OBUFT_GTS_AND
    );
  IOA_8_IOBUF_OBUFT_GTS_AND_130 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_8_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_8_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_8_IOBUF_OBUFT_GTS_AND
    );
  IOA_14_IOBUF_OBUFT_GTS_AND_131 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_14_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_14_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_14_IOBUF_OBUFT_GTS_AND
    );
  IOA_9_IOBUF_OBUFT_GTS_AND_132 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_9_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_9_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_9_IOBUF_OBUFT_GTS_AND
    );
  IOA_15_IOBUF_OBUFT_GTS_AND_133 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_15_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_15_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_15_IOBUF_OBUFT_GTS_AND
    );
  IOA_20_IOBUF_OBUFT_GTS_AND_134 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_20_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_20_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_20_IOBUF_OBUFT_GTS_AND
    );
  IOA_16_IOBUF_OBUFT_GTS_AND_135 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_16_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_16_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_16_IOBUF_OBUFT_GTS_AND
    );
  IOA_21_IOBUF_OBUFT_GTS_AND_136 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_21_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_21_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_21_IOBUF_OBUFT_GTS_AND
    );
  IOA_17_IOBUF_OBUFT_GTS_AND_137 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_17_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_17_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_17_IOBUF_OBUFT_GTS_AND
    );
  IOA_22_IOBUF_OBUFT_GTS_AND_138 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_22_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_22_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_22_IOBUF_OBUFT_GTS_AND
    );
  IOA_18_IOBUF_OBUFT_GTS_AND_139 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_18_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_18_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_18_IOBUF_OBUFT_GTS_AND
    );
  IOA_23_IOBUF_OBUFT_GTS_AND_140 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_23_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_23_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_23_IOBUF_OBUFT_GTS_AND
    );
  IOA_19_IOBUF_OBUFT_GTS_AND_141 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_19_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_19_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_19_IOBUF_OBUFT_GTS_AND
    );
  IOA_24_IOBUF_OBUFT_GTS_AND_142 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_24_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_24_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_24_IOBUF_OBUFT_GTS_AND
    );
  IOA_25_IOBUF_OBUFT_GTS_AND_143 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_25_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_25_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_25_IOBUF_OBUFT_GTS_AND
    );
  IOA_30_OBUFT_GTS_AND_144 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_30_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_30_OBUFT_GTS_AND_IN1,
      O => IOA_30_OBUFT_GTS_AND
    );
  IOA_26_IOBUF_OBUFT_GTS_AND_145 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_26_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_26_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_26_IOBUF_OBUFT_GTS_AND
    );
  IOA_31_OBUFT_GTS_AND_146 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_31_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_31_OBUFT_GTS_AND_IN1,
      O => IOA_31_OBUFT_GTS_AND
    );
  IOA_27_IOBUF_OBUFT_GTS_AND_147 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_27_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_27_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_27_IOBUF_OBUFT_GTS_AND
    );
  IOA_28_IOBUF_OBUFT_GTS_AND_148 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_28_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_28_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_28_IOBUF_OBUFT_GTS_AND
    );
  IOA_29_IOBUF_OBUFT_GTS_AND_149 : X_AND2
    port map (
      I0 => NlwInverterSignal_IOA_29_IOBUF_OBUFT_GTS_AND_IN0,
      I1 => NlwInverterSignal_IOA_29_IOBUF_OBUFT_GTS_AND_IN1,
      O => IOA_29_IOBUF_OBUFT_GTS_AND
    );
  LED_4_OBUF_GTS_TRI_150 : X_TRI
    port map (
      I => LED_4_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_LED_4_OBUF_GTS_TRI_CTL,
      O => LED(4)
    );
  LED_5_OBUF_GTS_TRI_151 : X_TRI
    port map (
      I => LED_5_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_LED_5_OBUF_GTS_TRI_CTL,
      O => LED(5)
    );
  LED_7_OBUF_GTS_TRI_152 : X_TRI
    port map (
      I => LED_7_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_LED_7_OBUF_GTS_TRI_CTL,
      O => LED(7)
    );
  LED_6_OBUF_GTS_TRI_153 : X_TRI
    port map (
      I => LED_6_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_LED_6_OBUF_GTS_TRI_CTL,
      O => LED(6)
    );
  LED_0_OBUF_GTS_TRI_154 : X_TRI
    port map (
      I => LED_0_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_LED_0_OBUF_GTS_TRI_CTL,
      O => LED(0)
    );
  BWA_0_OBUF_GTS_TRI_155 : X_TRI
    port map (
      I => BWA_0_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_BWA_0_OBUF_GTS_TRI_CTL,
      O => BWA(0)
    );
  LED_2_OBUF_GTS_TRI_156 : X_TRI
    port map (
      I => LED_2_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_LED_2_OBUF_GTS_TRI_CTL,
      O => LED(2)
    );
  LED_3_OBUF_GTS_TRI_157 : X_TRI
    port map (
      I => LED_3_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_LED_3_OBUF_GTS_TRI_CTL,
      O => LED(3)
    );
  LED_1_OBUF_GTS_TRI_158 : X_TRI
    port map (
      I => LED_1_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_LED_1_OBUF_GTS_TRI_CTL,
      O => LED(1)
    );
  BWA_1_OBUF_GTS_TRI_159 : X_TRI
    port map (
      I => BWA_1_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_BWA_1_OBUF_GTS_TRI_CTL,
      O => BWA(1)
    );
  AA_5_OBUF_GTS_TRI_160 : X_TRI
    port map (
      I => AA_5_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_5_OBUF_GTS_TRI_CTL,
      O => AA(5)
    );
  AA_4_OBUF_GTS_TRI_161 : X_TRI
    port map (
      I => AA_4_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_4_OBUF_GTS_TRI_CTL,
      O => AA(4)
    );
  AA_10_OBUF_GTS_TRI_162 : X_TRI
    port map (
      I => AA_10_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_10_OBUF_GTS_TRI_CTL,
      O => AA(10)
    );
  AA_2_OBUF_GTS_TRI_163 : X_TRI
    port map (
      I => AA_2_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_2_OBUF_GTS_TRI_CTL,
      O => AA(2)
    );
  AA_6_OBUF_GTS_TRI_164 : X_TRI
    port map (
      I => AA_6_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_6_OBUF_GTS_TRI_CTL,
      O => AA(6)
    );
  CEA_OBUF_GTS_TRI_165 : X_TRI
    port map (
      I => CEA_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_CEA_OBUF_GTS_TRI_CTL,
      O => CEA
    );
  AA_8_OBUF_GTS_TRI_166 : X_TRI
    port map (
      I => AA_8_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_8_OBUF_GTS_TRI_CTL,
      O => AA(8)
    );
  AA_15_OBUF_GTS_TRI_167 : X_TRI
    port map (
      I => AA_15_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_15_OBUF_GTS_TRI_CTL,
      O => AA(15)
    );
  AA_9_OBUF_GTS_TRI_168 : X_TRI
    port map (
      I => AA_9_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_9_OBUF_GTS_TRI_CTL,
      O => AA(9)
    );
  AA_1_OBUF_GTS_TRI_169 : X_TRI
    port map (
      I => AA_1_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_1_OBUF_GTS_TRI_CTL,
      O => AA(1)
    );
  AA_3_OBUF_GTS_TRI_170 : X_TRI
    port map (
      I => AA_3_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_3_OBUF_GTS_TRI_CTL,
      O => AA(3)
    );
  AA_7_OBUF_GTS_TRI_171 : X_TRI
    port map (
      I => AA_7_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_7_OBUF_GTS_TRI_CTL,
      O => AA(7)
    );
  AA_11_OBUF_GTS_TRI_172 : X_TRI
    port map (
      I => AA_11_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_11_OBUF_GTS_TRI_CTL,
      O => AA(11)
    );
  AA_17_OBUF_GTS_TRI_173 : X_TRI
    port map (
      I => AA_17_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_17_OBUF_GTS_TRI_CTL,
      O => AA(17)
    );
  CEA2X_OBUF_GTS_TRI_174 : X_TRI
    port map (
      I => CEA2X_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_CEA2X_OBUF_GTS_TRI_CTL,
      O => CEA2X
    );
  AA_18_OBUF_GTS_TRI_175 : X_TRI
    port map (
      I => AA_18_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_18_OBUF_GTS_TRI_CTL,
      O => AA(18)
    );
  CLKMA1_OBUF_GTS_TRI_176 : X_TRI
    port map (
      I => CLKMA1_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_CLKMA1_OBUF_GTS_TRI_CTL,
      O => CLKMA1
    );
  AA_12_OBUF_GTS_TRI_177 : X_TRI
    port map (
      I => AA_12_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_12_OBUF_GTS_TRI_CTL,
      O => AA(12)
    );
  BWA_2_OBUF_GTS_TRI_178 : X_TRI
    port map (
      I => BWA_2_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_BWA_2_OBUF_GTS_TRI_CTL,
      O => BWA(2)
    );
  BWA_3_OBUF_GTS_TRI_179 : X_TRI
    port map (
      I => BWA_3_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_BWA_3_OBUF_GTS_TRI_CTL,
      O => BWA(3)
    );
  CELA1X_OBUF_GTS_TRI_180 : X_TRI
    port map (
      I => CELA1X_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_CELA1X_OBUF_GTS_TRI_CTL,
      O => CELA1X
    );
  ADVLDA_OBUF_GTS_TRI_181 : X_TRI
    port map (
      I => ADVLDA_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_ADVLDA_OBUF_GTS_TRI_CTL,
      O => ADVLDA
    );
  AA_13_OBUF_GTS_TRI_182 : X_TRI
    port map (
      I => AA_13_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_13_OBUF_GTS_TRI_CTL,
      O => AA(13)
    );
  AA_14_OBUF_GTS_TRI_183 : X_TRI
    port map (
      I => AA_14_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_14_OBUF_GTS_TRI_CTL,
      O => AA(14)
    );
  ZZA_OBUF_GTS_TRI_184 : X_TRI
    port map (
      I => ZZA_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_ZZA_OBUF_GTS_TRI_CTL,
      O => ZZA
    );
  AA_16_OBUF_GTS_TRI_185 : X_TRI
    port map (
      I => AA_16_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_16_OBUF_GTS_TRI_CTL,
      O => AA(16)
    );
  AA_19_OBUF_GTS_TRI_186 : X_TRI
    port map (
      I => AA_19_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_19_OBUF_GTS_TRI_CTL,
      O => AA(19)
    );
  AA_0_OBUF_GTS_TRI_187 : X_TRI
    port map (
      I => AA_0_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_AA_0_OBUF_GTS_TRI_CTL,
      O => AA(0)
    );
  CLKMA0_OBUF_GTS_TRI_188 : X_TRI
    port map (
      I => CLKMA0_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_CLKMA0_OBUF_GTS_TRI_CTL,
      O => CLKMA0
    );
  CEHA1X_OBUF_GTS_TRI_189 : X_TRI
    port map (
      I => CEHA1X_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_CEHA1X_OBUF_GTS_TRI_CTL,
      O => CEHA1X
    );
  LBOA_OBUF_GTS_TRI_190 : X_TRI
    port map (
      I => LBOA_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_LBOA_OBUF_GTS_TRI_CTL,
      O => LBOA
    );
  XRWA_OBUF_GTS_TRI_191 : X_TRI
    port map (
      I => XRWA_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_XRWA_OBUF_GTS_TRI_CTL,
      O => XRWA
    );
  OEAX_OBUF_GTS_TRI_192 : X_TRI
    port map (
      I => OEAX_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_OEAX_OBUF_GTS_TRI_CTL,
      O => OEAX
    );
  CEA2_OBUF_GTS_TRI_193 : X_TRI
    port map (
      I => CEA2_OBUF_GTS_TRI,
      CTL => NlwInverterSignal_CEA2_OBUF_GTS_TRI_CTL,
      O => CEA2
    );
  NlwBlock_cpu_VCC : X_ONE
    port map (
      O => VCC
    );
  NlwBlock_cpu_GND : X_ZERO
    port map (
      O => GND
    );
  NlwInverterBlock_IOA_0_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_0_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_0_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_0_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_1_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_1_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_1_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_1_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_2_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_2_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_2_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_2_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_3_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_3_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_3_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_3_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_4_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_4_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_4_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_4_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_10_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_10_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_10_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_10_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_5_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_5_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_5_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_5_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_11_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_11_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_11_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_11_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_6_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_6_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_6_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_6_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_12_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_12_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_12_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_12_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_7_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_7_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_7_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_7_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_13_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_13_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_13_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_13_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_8_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_8_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_8_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_8_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_14_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_14_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_14_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_14_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_9_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_9_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_9_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_9_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_15_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_15_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_15_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_15_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_20_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_20_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_20_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_20_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_16_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_16_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_16_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_16_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_21_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_21_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_21_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_21_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_17_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_17_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_17_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_17_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_22_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_22_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_22_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_22_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_18_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_18_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_18_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_18_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_23_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_23_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_23_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_23_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_19_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_19_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_19_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_19_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_24_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_24_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_24_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_24_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_25_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_25_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_25_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_25_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_30_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_30_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_30_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_30_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_26_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_26_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_26_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_26_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_31_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_31_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_31_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_31_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_27_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_27_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_27_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_27_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_28_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_28_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_28_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_28_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_IOA_29_IOBUF_OBUFT_GTS_AND_IN0 : X_INV
    port map (
      I => h_Mtrien_IOA,
      O => NlwInverterSignal_IOA_29_IOBUF_OBUFT_GTS_AND_IN0
    );
  NlwInverterBlock_IOA_29_IOBUF_OBUFT_GTS_AND_IN1 : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_IOA_29_IOBUF_OBUFT_GTS_AND_IN1
    );
  NlwInverterBlock_LED_4_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_LED_4_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_LED_5_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_LED_5_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_LED_7_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_LED_7_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_LED_6_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_LED_6_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_LED_0_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_LED_0_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_BWA_0_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_BWA_0_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_LED_2_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_LED_2_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_LED_3_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_LED_3_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_LED_1_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_LED_1_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_BWA_1_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_BWA_1_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_5_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_5_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_4_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_4_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_10_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_10_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_2_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_2_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_6_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_6_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_CEA_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_CEA_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_8_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_8_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_15_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_15_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_9_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_9_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_1_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_1_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_3_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_3_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_7_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_7_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_11_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_11_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_17_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_17_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_CEA2X_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_CEA2X_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_18_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_18_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_CLKMA1_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_CLKMA1_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_12_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_12_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_BWA_2_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_BWA_2_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_BWA_3_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_BWA_3_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_CELA1X_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_CELA1X_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_ADVLDA_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_ADVLDA_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_13_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_13_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_14_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_14_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_ZZA_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_ZZA_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_16_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_16_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_19_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_19_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_AA_0_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_AA_0_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_CLKMA0_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_CLKMA0_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_CEHA1X_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_CEHA1X_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_LBOA_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_LBOA_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_XRWA_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_XRWA_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_OEAX_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_OEAX_OBUF_GTS_TRI_CTL
    );
  NlwInverterBlock_CEA2_OBUF_GTS_TRI_CTL : X_INV
    port map (
      I => GTS,
      O => NlwInverterSignal_CEA2_OBUF_GTS_TRI_CTL
    );
  NlwBlockROC : X_ROC
    generic map (ROC_WIDTH => 100 ns)
    port map (O => GSR);
  NlwBlockTOC : X_TOC
    port map (O => GTS);

end Structure;

